/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/base/common/codicons","vs/nls","vs/base/common/errors","vs/base/common/arrays","vs/base/browser/browser","vs/base/common/uri","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/keyboardEvent","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/color","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/objects","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/instantiation/common/instantiation","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/map","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/theme/common/themeService","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/assert","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(Z){for(var t=[],v=0,i=Z.length;v<i;v++)t[v]=pe[Z[v]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function Kt(Z){if(Array.isArray(Z)){for(var t=0,v=Array(Z.length);t<Z.length;t++)v[t]=Z[t];return v}else return Array.from(Z)}var qt=Object.hasOwnProperty,Nt=Object.setPrototypeOf,xt=Object.isFrozen,jt=Object.getPrototypeOf,Gt=Object.getOwnPropertyDescriptor,it=Object.freeze,ot=Object.seal,Yt=Object.create,kt=typeof Reflect!="undefined"&&Reflect,wt=kt.apply,_t=kt.construct;wt||(wt=function(t,v,i){return t.apply(v,i)}),it||(it=function(t){return t}),ot||(ot=function(t){return t}),_t||(_t=function(t,v){return new(Function.prototype.bind.apply(t,[null].concat(Kt(v))))});var Xt=nt(Array.prototype.forEach),Pt=nt(Array.prototype.pop),mt=nt(Array.prototype.push),ct=nt(String.prototype.toLowerCase),Rt=nt(String.prototype.match),lt=nt(String.prototype.replace),Zt=nt(String.prototype.indexOf),Qt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Mt=Jt(TypeError);function nt(Z){return function(t){for(var v=arguments.length,i=Array(v>1?v-1:0),P=1;P<v;P++)i[P-1]=arguments[P];return wt(Z,t,i)}}function Jt(Z){return function(){for(var t=arguments.length,v=Array(t),i=0;i<t;i++)v[i]=arguments[i];return _t(Z,v)}}function Be(Z,t){Nt&&Nt(Z,null);for(var v=t.length;v--;){var i=t[v];if(typeof i=="string"){var P=ct(i);P!==i&&(xt(t)||(t[v]=P),i=P)}Z[i]=!0}return Z}function ht(Z){var t=Yt(null),v=void 0;for(v in Z)wt(qt,Z,[v])&&(t[v]=Z[v]);return t}function vt(Z,t){for(;Z!==null;){var v=Gt(Z,t);if(v){if(v.get)return nt(v.get);if(typeof v.value=="function")return nt(v.value)}Z=jt(Z)}function i(P){return console.warn("fallback value for",P),null}return i}var Ot=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Ct=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),St=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ei=it(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),At=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),ti=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Bt=it(["#text"]),Ht=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Tt=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Wt=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Dt=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ii=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ni=ot(/<%[\s\S]*|[\s\S]*%>/gm),si=ot(/^data-[\-\w.\u00B7-\uFFFF]/),ri=ot(/^aria-[\-\w]+$/),oi=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),ai=ot(/^(?:\w+script|data):/i),li=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),pt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(Z){return typeof Z}:function(Z){return Z&&typeof Symbol=="function"&&Z.constructor===Symbol&&Z!==Symbol.prototype?"symbol":typeof Z};function rt(Z){if(Array.isArray(Z)){for(var t=0,v=Array(Z.length);t<Z.length;t++)v[t]=Z[t];return v}else return Array.from(Z)}var ui=function(){return typeof window=="undefined"?null:window},ci=function(t,v){if((typeof t=="undefined"?"undefined":pt(t))!=="object"||typeof t.createPolicy!="function")return null;var i=null,P="data-tt-policy-suffix";v.currentScript&&v.currentScript.hasAttribute(P)&&(i=v.currentScript.getAttribute(P));var M="dompurify"+(i?"#"+i:"");try{return t.createPolicy(M,{createHTML:function(w){return w}})}catch{return console.warn("TrustedTypes policy "+M+" could not be created."),null}};function zt(){var Z=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ui(),t=function(le){return zt(le)};if(t.version="2.3.1",t.removed=[],!Z||!Z.document||Z.document.nodeType!==9)return t.isSupported=!1,t;var v=Z.document,i=Z.document,P=Z.DocumentFragment,M=Z.HTMLTemplateElement,y=Z.Node,w=Z.Element,p=Z.NodeFilter,f=Z.NamedNodeMap,b=f===void 0?Z.NamedNodeMap||Z.MozNamedAttrMap:f,T=Z.Text,a=Z.Comment,r=Z.DOMParser,e=Z.trustedTypes,c=w.prototype,m=vt(c,"cloneNode"),_=vt(c,"nextSibling"),E=vt(c,"childNodes"),u=vt(c,"parentNode");if(typeof M=="function"){var h=i.createElement("template");h.content&&h.content.ownerDocument&&(i=h.content.ownerDocument)}var D=ci(e,v),C=D&&H?D.createHTML(""):"",N=i,A=N.implementation,o=N.createNodeIterator,l=N.createDocumentFragment,s=N.getElementsByTagName,n=v.importNode,g={};try{g=ht(i).documentMode?i.documentMode:{}}catch{}var S={};t.isSupported=typeof u=="function"&&A&&typeof A.createHTMLDocument!="undefined"&&g!==9;var $=ii,ie=ni,te=si,ge=ri,ae=ai,ve=li,he=oi,me=null,ye=Be({},[].concat(rt(Ot),rt(Ct),rt(St),rt(At),rt(Bt))),J=null,de=Be({},[].concat(rt(Ht),rt(Tt),rt(Wt),rt(Dt))),ne=null,Q=null,re=!0,se=!0,F=!1,K=!1,X=!1,O=!1,d=!1,L=!1,U=!1,q=!0,H=!1,R=!0,W=!0,V=!1,I={},z=null,k=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),B=null,j=Be({},["audio","video","img","source","image","track"]),ee=null,ce=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),fe="http://www.w3.org/1998/Math/MathML",Ee="http://www.w3.org/2000/svg",_e="http://www.w3.org/1999/xhtml",ke=_e,Ie=!1,De=null,Pe=i.createElement("form"),Me=function(le){De&&De===le||((!le||(typeof le=="undefined"?"undefined":pt(le))!=="object")&&(le={}),le=ht(le),me="ALLOWED_TAGS"in le?Be({},le.ALLOWED_TAGS):ye,J="ALLOWED_ATTR"in le?Be({},le.ALLOWED_ATTR):de,ee="ADD_URI_SAFE_ATTR"in le?Be(ht(ce),le.ADD_URI_SAFE_ATTR):ce,B="ADD_DATA_URI_TAGS"in le?Be(ht(j),le.ADD_DATA_URI_TAGS):j,z="FORBID_CONTENTS"in le?Be({},le.FORBID_CONTENTS):k,ne="FORBID_TAGS"in le?Be({},le.FORBID_TAGS):{},Q="FORBID_ATTR"in le?Be({},le.FORBID_ATTR):{},I="USE_PROFILES"in le?le.USE_PROFILES:!1,re=le.ALLOW_ARIA_ATTR!==!1,se=le.ALLOW_DATA_ATTR!==!1,F=le.ALLOW_UNKNOWN_PROTOCOLS||!1,K=le.SAFE_FOR_TEMPLATES||!1,X=le.WHOLE_DOCUMENT||!1,L=le.RETURN_DOM||!1,U=le.RETURN_DOM_FRAGMENT||!1,q=le.RETURN_DOM_IMPORT!==!1,H=le.RETURN_TRUSTED_TYPE||!1,d=le.FORCE_BODY||!1,R=le.SANITIZE_DOM!==!1,W=le.KEEP_CONTENT!==!1,V=le.IN_PLACE||!1,he=le.ALLOWED_URI_REGEXP||he,ke=le.NAMESPACE||_e,K&&(se=!1),U&&(L=!0),I&&(me=Be({},[].concat(rt(Bt))),J=[],I.html===!0&&(Be(me,Ot),Be(J,Ht)),I.svg===!0&&(Be(me,Ct),Be(J,Tt),Be(J,Dt)),I.svgFilters===!0&&(Be(me,St),Be(J,Tt),Be(J,Dt)),I.mathMl===!0&&(Be(me,At),Be(J,Wt),Be(J,Dt))),le.ADD_TAGS&&(me===ye&&(me=ht(me)),Be(me,le.ADD_TAGS)),le.ADD_ATTR&&(J===de&&(J=ht(J)),Be(J,le.ADD_ATTR)),le.ADD_URI_SAFE_ATTR&&Be(ee,le.ADD_URI_SAFE_ATTR),le.FORBID_CONTENTS&&(z===k&&(z=ht(z)),Be(z,le.FORBID_CONTENTS)),W&&(me["#text"]=!0),X&&Be(me,["html","head","body"]),me.table&&(Be(me,["tbody"]),delete ne.tbody),it&&it(le),De=le)},Ge=Be({},["mi","mo","mn","ms","mtext"]),He=Be({},["foreignobject","desc","title","annotation-xml"]),Ue=Be({},Ct);Be(Ue,St),Be(Ue,ei);var Je=Be({},At);Be(Je,ti);var je=function(le){var Se=u(le);(!Se||!Se.tagName)&&(Se={namespaceURI:_e,tagName:"template"});var Ne=ct(le.tagName),$e=ct(Se.tagName);if(le.namespaceURI===Ee)return Se.namespaceURI===_e?Ne==="svg":Se.namespaceURI===fe?Ne==="svg"&&($e==="annotation-xml"||Ge[$e]):Boolean(Ue[Ne]);if(le.namespaceURI===fe)return Se.namespaceURI===_e?Ne==="math":Se.namespaceURI===Ee?Ne==="math"&&He[$e]:Boolean(Je[Ne]);if(le.namespaceURI===_e){if(Se.namespaceURI===Ee&&!He[$e]||Se.namespaceURI===fe&&!Ge[$e])return!1;var Xe=Be({},["title","style","font","a","script"]);return!Je[Ne]&&(Xe[Ne]||!Ue[Ne])}return!1},Oe=function(le){mt(t.removed,{element:le});try{le.parentNode.removeChild(le)}catch{try{le.outerHTML=C}catch{le.remove()}}},x=function(le,Se){try{mt(t.removed,{attribute:Se.getAttributeNode(le),from:Se})}catch{mt(t.removed,{attribute:null,from:Se})}if(Se.removeAttribute(le),le==="is"&&!J[le])if(L||U)try{Oe(Se)}catch{}else try{Se.setAttribute(le,"")}catch{}},oe=function(le){var Se=void 0,Ne=void 0;if(d)le="<remove></remove>"+le;else{var $e=Rt(le,/^[\r\n\t ]+/);Ne=$e&&$e[0]}var Xe=D?D.createHTML(le):le;if(ke===_e)try{Se=new r().parseFromString(Xe,"text/html")}catch{}if(!Se||!Se.documentElement){Se=A.createDocument(ke,"template",null);try{Se.documentElement.innerHTML=Ie?"":Xe}catch{}}var Ze=Se.body||Se.documentElement;return le&&Ne&&Ze.insertBefore(i.createTextNode(Ne),Ze.childNodes[0]||null),ke===_e?s.call(Se,X?"html":"body")[0]:X?Se.documentElement:Ze},we=function(le){return o.call(le.ownerDocument||le,le,p.SHOW_ELEMENT|p.SHOW_COMMENT|p.SHOW_TEXT,null,!1)},Ce=function(le){return le instanceof T||le instanceof a?!1:typeof le.nodeName!="string"||typeof le.textContent!="string"||typeof le.removeChild!="function"||!(le.attributes instanceof b)||typeof le.removeAttribute!="function"||typeof le.setAttribute!="function"||typeof le.namespaceURI!="string"||typeof le.insertBefore!="function"},Fe=function(le){return(typeof y=="undefined"?"undefined":pt(y))==="object"?le instanceof y:le&&(typeof le=="undefined"?"undefined":pt(le))==="object"&&typeof le.nodeType=="number"&&typeof le.nodeName=="string"},Re=function(le,Se,Ne){!S[le]||Xt(S[le],function($e){$e.call(t,Se,Ne,De)})},Ve=function(le){var Se=void 0;if(Re("beforeSanitizeElements",le,null),Ce(le)||Rt(le.nodeName,/[\u0080-\uFFFF]/))return Oe(le),!0;var Ne=ct(le.nodeName);if(Re("uponSanitizeElement",le,{tagName:Ne,allowedTags:me}),!Fe(le.firstElementChild)&&(!Fe(le.content)||!Fe(le.content.firstElementChild))&&at(/<[/\w]/g,le.innerHTML)&&at(/<[/\w]/g,le.textContent)||Ne==="select"&&at(/<template/i,le.innerHTML))return Oe(le),!0;if(!me[Ne]||ne[Ne]){if(W&&!z[Ne]){var $e=u(le)||le.parentNode,Xe=E(le)||le.childNodes;if(Xe&&$e)for(var Ze=Xe.length,et=Ze-1;et>=0;--et)$e.insertBefore(m(Xe[et],!0),_(le))}return Oe(le),!0}return le instanceof w&&!je(le)||(Ne==="noscript"||Ne==="noembed")&&at(/<\/no(script|embed)/i,le.innerHTML)?(Oe(le),!0):(K&&le.nodeType===3&&(Se=le.textContent,Se=lt(Se,$," "),Se=lt(Se,ie," "),le.textContent!==Se&&(mt(t.removed,{element:le.cloneNode()}),le.textContent=Se)),Re("afterSanitizeElements",le,null),!1)},tt=function(le,Se,Ne){if(R&&(Se==="id"||Se==="name")&&(Ne in i||Ne in Pe))return!1;if(!(se&&!Q[Se]&&at(te,Se))){if(!(re&&at(ge,Se))){if(!J[Se]||Q[Se])return!1;if(!ee[Se]){if(!at(he,lt(Ne,ve,""))){if(!((Se==="src"||Se==="xlink:href"||Se==="href")&&le!=="script"&&Zt(Ne,"data:")===0&&B[le])){if(!(F&&!at(ae,lt(Ne,ve,"")))){if(Ne)return!1}}}}}}return!0},Ye=function(le){var Se=void 0,Ne=void 0,$e=void 0,Xe=void 0;Re("beforeSanitizeAttributes",le,null);var Ze=le.attributes;if(!!Ze){var et={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:J};for(Xe=Ze.length;Xe--;){Se=Ze[Xe];var st=Se,dt=st.name,yt=st.namespaceURI;if(Ne=Qt(Se.value),$e=ct(dt),et.attrName=$e,et.attrValue=Ne,et.keepAttr=!0,et.forceKeepAttr=void 0,Re("uponSanitizeAttribute",le,et),Ne=et.attrValue,!et.forceKeepAttr&&(x(dt,le),!!et.keepAttr)){if(at(/\/>/i,Ne)){x(dt,le);continue}K&&(Ne=lt(Ne,$," "),Ne=lt(Ne,ie," "));var It=le.nodeName.toLowerCase();if(!!tt(It,$e,Ne))try{yt?le.setAttributeNS(yt,dt,Ne):le.setAttribute(dt,Ne),Pt(t.removed)}catch{}}}Re("afterSanitizeAttributes",le,null)}},qe=function Le(le){var Se=void 0,Ne=we(le);for(Re("beforeSanitizeShadowDOM",le,null);Se=Ne.nextNode();)Re("uponSanitizeShadowNode",Se,null),!Ve(Se)&&(Se.content instanceof P&&Le(Se.content),Ye(Se));Re("afterSanitizeShadowDOM",le,null)};return t.sanitize=function(Le,le){var Se=void 0,Ne=void 0,$e=void 0,Xe=void 0,Ze=void 0;if(Ie=!Le,Ie&&(Le="<!-->"),typeof Le!="string"&&!Fe(Le)){if(typeof Le.toString!="function")throw Mt("toString is not a function");if(Le=Le.toString(),typeof Le!="string")throw Mt("dirty is not a string, aborting")}if(!t.isSupported){if(pt(Z.toStaticHTML)==="object"||typeof Z.toStaticHTML=="function"){if(typeof Le=="string")return Z.toStaticHTML(Le);if(Fe(Le))return Z.toStaticHTML(Le.outerHTML)}return Le}if(O||Me(le),t.removed=[],typeof Le=="string"&&(V=!1),!V)if(Le instanceof y)Se=oe("<!---->"),Ne=Se.ownerDocument.importNode(Le,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?Se=Ne:Se.appendChild(Ne);else{if(!L&&!K&&!X&&Le.indexOf("<")===-1)return D&&H?D.createHTML(Le):Le;if(Se=oe(Le),!Se)return L?null:C}Se&&d&&Oe(Se.firstChild);for(var et=we(V?Le:Se);$e=et.nextNode();)$e.nodeType===3&&$e===Xe||Ve($e)||($e.content instanceof P&&qe($e.content),Ye($e),Xe=$e);if(Xe=null,V)return Le;if(L){if(U)for(Ze=l.call(Se.ownerDocument);Se.firstChild;)Ze.appendChild(Se.firstChild);else Ze=Se;return q&&(Ze=n.call(v,Ze,!0)),Ze}var st=X?Se.outerHTML:Se.innerHTML;return K&&(st=lt(st,$," "),st=lt(st,ie," ")),D&&H?D.createHTML(st):st},t.setConfig=function(Le){Me(Le),O=!0},t.clearConfig=function(){De=null,O=!1},t.isValidAttribute=function(Le,le,Se){De||Me({});var Ne=ct(Le),$e=ct(le);return tt(Ne,$e,Se)},t.addHook=function(Le,le){typeof le=="function"&&(S[Le]=S[Le]||[],mt(S[Le],le))},t.removeHook=function(Le){S[Le]&&Pt(S[Le])},t.removeHooks=function(Le){S[Le]&&(S[Le]=[])},t.removeAllHooks=function(){S={}},t}var hi=zt();define("vs/base/browser/dompurify/dompurify",function(){return hi}),define(pe[40],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class v{constructor(y){this.domNode=y,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(y){const w=i(y);this._maxWidth!==w&&(this._maxWidth=w,this.domNode.style.maxWidth=this._maxWidth)}setWidth(y){const w=i(y);this._width!==w&&(this._width=w,this.domNode.style.width=this._width)}setHeight(y){const w=i(y);this._height!==w&&(this._height=w,this.domNode.style.height=this._height)}setTop(y){const w=i(y);this._top!==w&&(this._top=w,this.domNode.style.top=this._top)}setLeft(y){const w=i(y);this._left!==w&&(this._left=w,this.domNode.style.left=this._left)}setBottom(y){const w=i(y);this._bottom!==w&&(this._bottom=w,this.domNode.style.bottom=this._bottom)}setRight(y){const w=i(y);this._right!==w&&(this._right=w,this.domNode.style.right=this._right)}setFontFamily(y){this._fontFamily!==y&&(this._fontFamily=y,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(y){this._fontWeight!==y&&(this._fontWeight=y,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(y){const w=i(y);this._fontSize!==w&&(this._fontSize=w,this.domNode.style.fontSize=this._fontSize)}setFontStyle(y){this._fontStyle!==y&&(this._fontStyle=y,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(y){this._fontFeatureSettings!==y&&(this._fontFeatureSettings=y,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setTextDecoration(y){this._textDecoration!==y&&(this._textDecoration=y,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(y){const w=i(y);this._lineHeight!==w&&(this._lineHeight=w,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(y){const w=i(y);this._letterSpacing!==w&&(this._letterSpacing=w,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(y){this._className!==y&&(this._className=y,this.domNode.className=this._className)}toggleClassName(y,w){this.domNode.classList.toggle(y,w),this._className=this.domNode.className}setDisplay(y){this._display!==y&&(this._display=y,this.domNode.style.display=this._display)}setPosition(y){this._position!==y&&(this._position=y,this.domNode.style.position=this._position)}setVisibility(y){this._visibility!==y&&(this._visibility=y,this.domNode.style.visibility=this._visibility)}setColor(y){this._color!==y&&(this._color=y,this.domNode.style.color=this._color)}setBackgroundColor(y){this._backgroundColor!==y&&(this._backgroundColor=y,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(y){this._layerHint!==y&&(this._layerHint=y,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(y){this._boxShadow!==y&&(this._boxShadow=y,this.domNode.style.boxShadow=y)}setContain(y){this._contain!==y&&(this._contain=y,this.domNode.style.contain=this._contain)}setAttribute(y,w){this.domNode.setAttribute(y,w)}removeAttribute(y){this.domNode.removeAttribute(y)}appendChild(y){this.domNode.appendChild(y.domNode)}removeChild(y){this.domNode.removeChild(y.domNode)}}t.FastDomNode=v;function i(M){return typeof M=="number"?`${M}px`:M}function P(M){return new v(M)}t.createFastDomNode=P}),define(pe[65],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let v=!1,i=null;function P(y){if(!y.parent||y.parent===y)return null;try{const w=y.location,p=y.parent.location;if(w.origin!=="null"&&p.origin!=="null"&&w.origin!==p.origin)return v=!0,null}catch{return v=!0,null}return y.parent}class M{static getSameOriginWindowChain(){if(!i){i=[];let w=window,p;do p=P(w),p?i.push({window:w,iframeElement:w.frameElement||null}):i.push({window:w,iframeElement:null}),w=p;while(w)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),v}static getPositionOfChildWindowRelativeToAncestorWindow(w,p){if(!p||w===p)return{top:0,left:0};let f=0,b=0;const T=this.getSameOriginWindowChain();for(const a of T){if(f+=a.window.scrollY,b+=a.window.scrollX,a.window===p||!a.iframeElement)break;const r=a.iframeElement.getBoundingClientRect();f+=r.top,b+=r.left}return{top:f,left:b}}}t.IframeUtils=M}),define(pe[66],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var v;(function(M){M[M.Copy=0]="Copy",M[M.Move=1]="Move"})(v=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class i extends Error{constructor(y,w){super(`ListError [${y}] ${w}`)}}t.ListError=i;class P{constructor(){this.cache=new WeakMap}getHeight(y){return this.cache.get(y)??this.estimateHeight(y)}setDynamicHeight(y,w){w>0&&this.cache.set(y,w)}}t.CachedListVirtualDelegate=P}),define(pe[67],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class v{constructor(P){this.spliceables=P}splice(P,M,y){this.spliceables.forEach(w=>w.splice(P,M,y))}}t.CombinedSpliceable=v}),define(pe[41],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const v=20;class i{constructor(M,y,w,p,f,b){this._scrollbarSize=Math.round(y),this._oppositeScrollbarSize=Math.round(w),this._arrowSize=Math.round(M),this._visibleSize=p,this._scrollSize=f,this._scrollPosition=b,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new i(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(M){const y=Math.round(M);return this._visibleSize!==y?(this._visibleSize=y,this._refreshComputedValues(),!0):!1}setScrollSize(M){const y=Math.round(M);return this._scrollSize!==y?(this._scrollSize=y,this._refreshComputedValues(),!0):!1}setScrollPosition(M){const y=Math.round(M);return this._scrollPosition!==y?(this._scrollPosition=y,this._refreshComputedValues(),!0):!1}setScrollbarSize(M){this._scrollbarSize=Math.round(M)}setOppositeScrollbarSize(M){this._oppositeScrollbarSize=Math.round(M)}static _computeValues(M,y,w,p,f){const b=Math.max(0,w-M),T=Math.max(0,b-2*y),a=p>0&&p>w;if(!a)return{computedAvailableSize:Math.round(b),computedIsNeeded:a,computedSliderSize:Math.round(T),computedSliderRatio:0,computedSliderPosition:0};const r=Math.round(Math.max(v,Math.floor(w*T/p))),e=(T-r)/(p-w),c=f*e;return{computedAvailableSize:Math.round(b),computedIsNeeded:a,computedSliderSize:Math.round(r),computedSliderRatio:e,computedSliderPosition:Math.round(c)}}_refreshComputedValues(){const M=i._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=M.computedAvailableSize,this._computedIsNeeded=M.computedIsNeeded,this._computedSliderSize=M.computedSliderSize,this._computedSliderRatio=M.computedSliderRatio,this._computedSliderPosition=M.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(M){if(!this._computedIsNeeded)return 0;const y=M-this._arrowSize-this._computedSliderSize/2;return Math.round(y/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(M){if(!this._computedIsNeeded)return 0;const y=M-this._arrowSize;let w=this._scrollPosition;return y<this._computedSliderPosition?w-=this._visibleSize:w+=this._visibleSize,w}getDesiredScrollPositionFromDelta(M){if(!this._computedIsNeeded)return 0;const y=this._computedSliderPosition+M;return Math.round(y/this._computedSliderRatio)}}t.ScrollbarState=i}),define(pe[23],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var v;(function(w){w[w.Hidden=0]="Hidden",w[w.Visible=1]="Visible",w[w.Recurse=2]="Recurse"})(v=t.TreeVisibility||(t.TreeVisibility={}));var i;(function(w){w[w.Unknown=0]="Unknown",w[w.Twistie=1]="Twistie",w[w.Element=2]="Element",w[w.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var P;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(P=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(w=!1){return{accept:!0,bubble:0,autoExpand:w}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(w=!1){return{accept:!0,bubble:0,effect:0,autoExpand:w}}};class M extends Error{constructor(p,f){super(`TreeError [${p}] ${f}`)}}t.TreeError=M;class y{constructor(p){this.fn=p,this._map=new WeakMap}map(p){let f=this._map.get(p);return f||(f=this.fn(p),this._map.set(p,f)),f}}t.WeakMapper=y}),define(pe[68],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function v(i,P){if(!i)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}t.ok=v}),define(pe[11],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.getClassNamesArray=t.Codicon=t.getCodiconAriaLabel=void 0;function v(y){return y?y.replace(/\$\((.*?)\)/g,(w,p)=>` ${p} `).trim():""}t.getCodiconAriaLabel=v;class i{constructor(w,p,f){this.id=w,this.definition=p,this.description=f,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}t.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function P(y,w){const p=["codicon","codicon-"+y];return w&&p.push("codicon-modifier-"+w),p}t.getClassNamesArray=P;var M;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function p(T){if(T instanceof i)return["codicon","codicon-"+T.id];const a=w.exec(T.id);if(!a)return p(i.error);const[,r,e]=a,c=["codicon","codicon-"+r];return e&&c.push("codicon-modifier-"+e.substr(1)),c}y.asClassNameArray=p;function f(T){return p(T).join(" ")}y.asClassName=f;function b(T){return"."+p(T).join(".")}y.asCSSSelector=b})(M=t.CSSIcon||(t.CSSIcon={}))}),define(pe[69],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function v(y,w){const p=Object.create(null);for(const f of y){const b=w(f);let T=p[b];T||(T=p[b]=[]),T.push(f)}return p}t.groupBy=v;function i(y,w){const p=[],f=[];for(const b of y)w.has(b)||p.push(b);for(const b of w)y.has(b)||f.push(b);return{removed:p,added:f}}t.diffSets=i;function P(y,w){const p=[],f=[];for(const[b,T]of y)w.has(b)||p.push(T);for(const[b,T]of w)y.has(b)||f.push(T);return{removed:p,added:f}}t.diffMaps=P;class M{constructor(){this.map=new Map}add(w,p){let f=this.map.get(w);f||(f=new Set,this.map.set(w,f)),f.add(p)}delete(w,p){const f=this.map.get(w);!f||(f.delete(p),f.size===0&&this.map.delete(w))}forEach(w,p){const f=this.map.get(w);!f||f.forEach(p)}}t.SetMap=M}),define(pe[24],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function v(w,p){const f=Math.pow(10,p);return Math.round(w*f)/f}class i{constructor(p,f,b,T=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,p))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=v(Math.max(Math.min(1,T),0),3)}static equals(p,f){return p.r===f.r&&p.g===f.g&&p.b===f.b&&p.a===f.a}}t.RGBA=i;class P{constructor(p,f,b,T){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,p),0)|0,this.s=v(Math.max(Math.min(1,f),0),3),this.l=v(Math.max(Math.min(1,b),0),3),this.a=v(Math.max(Math.min(1,T),0),3)}static equals(p,f){return p.h===f.h&&p.s===f.s&&p.l===f.l&&p.a===f.a}static fromRGBA(p){const f=p.r/255,b=p.g/255,T=p.b/255,a=p.a,r=Math.max(f,b,T),e=Math.min(f,b,T);let c=0,m=0;const _=(e+r)/2,E=r-e;if(E>0){switch(m=Math.min(_<=.5?E/(2*_):E/(2-2*_),1),r){case f:c=(b-T)/E+(b<T?6:0);break;case b:c=(T-f)/E+2;break;case T:c=(f-b)/E+4;break}c*=60,c=Math.round(c)}return new P(c,m,_,a)}static _hue2rgb(p,f,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?p+(f-p)*6*b:b<1/2?f:b<2/3?p+(f-p)*(2/3-b)*6:p}static toRGBA(p){const f=p.h/360,{s:b,l:T,a}=p;let r,e,c;if(b===0)r=e=c=T;else{const m=T<.5?T*(1+b):T+b-T*b,_=2*T-m;r=P._hue2rgb(_,m,f+1/3),e=P._hue2rgb(_,m,f),c=P._hue2rgb(_,m,f-1/3)}return new i(Math.round(r*255),Math.round(e*255),Math.round(c*255),a)}}t.HSLA=P;class M{constructor(p,f,b,T){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,p),0)|0,this.s=v(Math.max(Math.min(1,f),0),3),this.v=v(Math.max(Math.min(1,b),0),3),this.a=v(Math.max(Math.min(1,T),0),3)}static equals(p,f){return p.h===f.h&&p.s===f.s&&p.v===f.v&&p.a===f.a}static fromRGBA(p){const f=p.r/255,b=p.g/255,T=p.b/255,a=Math.max(f,b,T),r=Math.min(f,b,T),e=a-r,c=a===0?0:e/a;let m;return e===0?m=0:a===f?m=((b-T)/e%6+6)%6:a===b?m=(T-f)/e+2:m=(f-b)/e+4,new M(Math.round(m*60),c,a,p.a)}static toRGBA(p){const{h:f,s:b,v:T,a}=p,r=T*b,e=r*(1-Math.abs(f/60%2-1)),c=T-r;let[m,_,E]=[0,0,0];return f<60?(m=r,_=e):f<120?(m=e,_=r):f<180?(_=r,E=e):f<240?(_=e,E=r):f<300?(m=e,E=r):f<=360&&(m=r,E=e),m=Math.round((m+c)*255),_=Math.round((_+c)*255),E=Math.round((E+c)*255),new i(m,_,E,a)}}t.HSVA=M;class y{constructor(p){if(p)if(p instanceof i)this.rgba=p;else if(p instanceof P)this._hsla=p,this.rgba=P.toRGBA(p);else if(p instanceof M)this._hsva=p,this.rgba=M.toRGBA(p);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(p){return y.Format.CSS.parseHex(p)||y.red}get hsla(){return this._hsla?this._hsla:P.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:M.fromRGBA(this.rgba)}equals(p){return!!p&&i.equals(this.rgba,p.rgba)&&P.equals(this.hsla,p.hsla)&&M.equals(this.hsva,p.hsva)}getRelativeLuminance(){const p=y._relativeLuminanceForComponent(this.rgba.r),f=y._relativeLuminanceForComponent(this.rgba.g),b=y._relativeLuminanceForComponent(this.rgba.b),T=.2126*p+.7152*f+.0722*b;return v(T,4)}static _relativeLuminanceForComponent(p){const f=p/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(p){const f=this.getRelativeLuminance(),b=p.getRelativeLuminance();return f>b?(f+.05)/(b+.05):(b+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(p){const f=this.getRelativeLuminance(),b=p.getRelativeLuminance();return f>b}isDarkerThan(p){const f=this.getRelativeLuminance(),b=p.getRelativeLuminance();return f<b}lighten(p){return new y(new P(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*p,this.hsla.a))}darken(p){return new y(new P(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*p,this.hsla.a))}transparent(p){const{r:f,g:b,b:T,a}=this.rgba;return new y(new i(f,b,T,a*p))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new y(new i(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(p){const f=p.rgba,b=this.rgba.a,T=f.a,a=b+T*(1-b);if(a<1e-6)return y.transparent;const r=this.rgba.r*b/a+f.r*T*(1-b)/a,e=this.rgba.g*b/a+f.g*T*(1-b)/a,c=this.rgba.b*b/a+f.b*T*(1-b)/a;return new y(new i(r,e,c,a))}makeOpaque(p){if(this.isOpaque()||p.rgba.a!==1)return this;const{r:f,g:b,b:T,a}=this.rgba;return new y(new i(p.rgba.r-a*(p.rgba.r-f),p.rgba.g-a*(p.rgba.g-b),p.rgba.b-a*(p.rgba.b-T),1))}flatten(...p){const f=p.reduceRight((b,T)=>y._flatten(T,b));return y._flatten(this,f)}static _flatten(p,f){const b=1-p.rgba.a;return new y(new i(b*f.rgba.r+p.rgba.a*p.rgba.r,b*f.rgba.g+p.rgba.a*p.rgba.g,b*f.rgba.b+p.rgba.a*p.rgba.b))}toString(){return this._toString||(this._toString=y.Format.CSS.format(this)),this._toString}static getLighterColor(p,f,b){if(p.isLighterThan(f))return p;b=b||.5;const T=p.getRelativeLuminance(),a=f.getRelativeLuminance();return b=b*(a-T)/a,p.lighten(b)}static getDarkerColor(p,f,b){if(p.isDarkerThan(f))return p;b=b||.5;const T=p.getRelativeLuminance(),a=f.getRelativeLuminance();return b=b*(T-a)/T,p.darken(b)}}t.Color=y,y.white=new y(new i(255,255,255,1)),y.black=new y(new i(0,0,0,1)),y.red=new y(new i(255,0,0,1)),y.blue=new y(new i(0,0,255,1)),y.green=new y(new i(0,255,0,1)),y.cyan=new y(new i(0,255,255,1)),y.lightgrey=new y(new i(211,211,211,1)),y.transparent=new y(new i(0,0,0,0)),function(w){let p;(function(f){let b;(function(T){function a(C){return C.rgba.a===1?`rgb(${C.rgba.r}, ${C.rgba.g}, ${C.rgba.b})`:w.Format.CSS.formatRGBA(C)}T.formatRGB=a;function r(C){return`rgba(${C.rgba.r}, ${C.rgba.g}, ${C.rgba.b}, ${+C.rgba.a.toFixed(2)})`}T.formatRGBA=r;function e(C){return C.hsla.a===1?`hsl(${C.hsla.h}, ${(C.hsla.s*100).toFixed(2)}%, ${(C.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(C)}T.formatHSL=e;function c(C){return`hsla(${C.hsla.h}, ${(C.hsla.s*100).toFixed(2)}%, ${(C.hsla.l*100).toFixed(2)}%, ${C.hsla.a.toFixed(2)})`}T.formatHSLA=c;function m(C){const N=C.toString(16);return N.length!==2?"0"+N:N}function _(C){return`#${m(C.rgba.r)}${m(C.rgba.g)}${m(C.rgba.b)}`}T.formatHex=_;function E(C,N=!1){return N&&C.rgba.a===1?w.Format.CSS.formatHex(C):`#${m(C.rgba.r)}${m(C.rgba.g)}${m(C.rgba.b)}${m(Math.round(C.rgba.a*255))}`}T.formatHexA=E;function u(C){return C.isOpaque()?w.Format.CSS.formatHex(C):w.Format.CSS.formatRGBA(C)}T.format=u;function h(C){const N=C.length;if(N===0||C.charCodeAt(0)!==35)return null;if(N===7){const A=16*D(C.charCodeAt(1))+D(C.charCodeAt(2)),o=16*D(C.charCodeAt(3))+D(C.charCodeAt(4)),l=16*D(C.charCodeAt(5))+D(C.charCodeAt(6));return new w(new i(A,o,l,1))}if(N===9){const A=16*D(C.charCodeAt(1))+D(C.charCodeAt(2)),o=16*D(C.charCodeAt(3))+D(C.charCodeAt(4)),l=16*D(C.charCodeAt(5))+D(C.charCodeAt(6)),s=16*D(C.charCodeAt(7))+D(C.charCodeAt(8));return new w(new i(A,o,l,s/255))}if(N===4){const A=D(C.charCodeAt(1)),o=D(C.charCodeAt(2)),l=D(C.charCodeAt(3));return new w(new i(16*A+A,16*o+o,16*l+l))}if(N===5){const A=D(C.charCodeAt(1)),o=D(C.charCodeAt(2)),l=D(C.charCodeAt(3)),s=D(C.charCodeAt(4));return new w(new i(16*A+A,16*o+o,16*l+l,(16*s+s)/255))}return null}T.parseHex=h;function D(C){switch(C){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=f.CSS||(f.CSS={}))})(p=w.Format||(w.Format={}))}(y=t.Color||(t.Color={}))}),define(pe[25],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function v(y){return(w,p,f)=>{let b=null,T=null;if(typeof f.value=="function"?(b="value",T=f.value):typeof f.get=="function"&&(b="get",T=f.get),!T)throw new Error("not supported");f[b]=y(T,p)}}t.createDecorator=v;function i(y,w,p){let f=null,b=null;if(typeof p.value=="function"?(f="value",b=p.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(f="get",b=p.get),!b)throw new Error("not supported");const T=`$memoize$${w}`;p[f]=function(...a){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,a)}),this[T]}}t.memoize=i;function P(y,w,p){return v((f,b)=>{const T=`$debounce$${b}`,a=`$debounce$result$${b}`;return function(...r){this[a]||(this[a]=p?p():void 0),clearTimeout(this[T]),w&&(this[a]=w(this[a],...r),r=[this[a]]),this[T]=setTimeout(()=>{f.apply(this,r),this[a]=p?p():void 0},y)}})}t.debounce=P;function M(y,w,p){return v((f,b)=>{const T=`$throttle$timer$${b}`,a=`$throttle$result$${b}`,r=`$throttle$lastRun$${b}`,e=`$throttle$pending$${b}`;return function(...c){if(this[a]||(this[a]=p?p():void 0),(this[r]===null||this[r]===void 0)&&(this[r]=-Number.MAX_VALUE),w&&(this[a]=w(this[a],...c)),this[e])return;const m=this[r]+y;m<=Date.now()?(this[r]=Date.now(),f.apply(this,[this[a]]),this[a]=p?p():void 0):(this[e]=!0,this[T]=setTimeout(()=>{this[e]=!1,this[r]=Date.now(),f.apply(this,[this[a]]),this[a]=p?p():void 0},m-Date.now()))}})}t.throttle=M}),define(pe[70],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class v{constructor(P,M,y,w){this.originalStart=P,this.originalLength=M,this.modifiedStart=y,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=v}),define(pe[13],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(C){setTimeout(()=>{throw C.stack?u.isErrorNoTelemetry(C)?new u(C.message+`

`+C.stack):new Error(C.message+`

`+C.stack):C},0)}}addListener(C){return this.listeners.push(C),()=>{this._removeListener(C)}}emit(C){this.listeners.forEach(N=>{N(C)})}_removeListener(C){this.listeners.splice(this.listeners.indexOf(C),1)}setUnexpectedErrorHandler(C){this.unexpectedErrorHandler=C}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(C){this.unexpectedErrorHandler(C),this.emit(C)}onUnexpectedExternalError(C){this.unexpectedErrorHandler(C)}}t.ErrorHandler=v,t.errorHandler=new v;function i(D){t.errorHandler.setUnexpectedErrorHandler(D)}t.setUnexpectedErrorHandler=i;function P(D){p(D)||t.errorHandler.onUnexpectedError(D)}t.onUnexpectedError=P;function M(D){p(D)||t.errorHandler.onUnexpectedExternalError(D)}t.onUnexpectedExternalError=M;function y(D){if(D instanceof Error){const{name:C,message:N}=D,A=D.stacktrace||D.stack;return{$isError:!0,name:C,message:N,stack:A,noTelemetry:u.isErrorNoTelemetry(D)}}return D}t.transformErrorForSerialization=y;const w="Canceled";function p(D){return D instanceof f?!0:D instanceof Error&&D.name===w&&D.message===w}t.isCancellationError=p;class f extends Error{constructor(){super(w);this.name=this.message}}t.CancellationError=f;function b(){const D=new Error(w);return D.name=D.message,D}t.canceled=b;function T(D){return D?new Error(`Illegal argument: ${D}`):new Error("Illegal argument")}t.illegalArgument=T;function a(D){return D?new Error(`Illegal state: ${D}`):new Error("Illegal state")}t.illegalState=a;function r(D){return D?new Error(`readonly property '${D} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=r;function e(D){const C=new Error(`${D} has been disposed`);return C.name="DISPOSED",C}t.disposed=e;function c(D){return D?D.message?D.message:D.stack?D.stack.split(`
`)[0]:String(D):"Error"}t.getErrorMessage=c;class m extends Error{constructor(C){super("NotImplemented");C&&(this.message=C)}}t.NotImplementedError=m;class _ extends Error{constructor(C){super("NotSupported");C&&(this.message=C)}}t.NotSupportedError=_;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}t.ExpectedError=E;class u extends Error{constructor(C){super(C);this.name="ErrorNoTelemetry"}static fromError(C){if(C instanceof u)return C;const N=new u;return N.message=C.message,N.stack=C.stack,N}static isErrorNoTelemetry(C){return C.name==="ErrorNoTelemetry"}}t.ErrorNoTelemetry=u;class h extends Error{constructor(C){super(C||"An unexpected bug occurred.");Object.setPrototypeOf(this,h.prototype);debugger}}t.BugIndicatingError=h}),define(pe[14],be([1,0,13]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function i(H,R=0){return H[H.length-(1+R)]}t.tail=i;function P(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}t.tail2=P;function M(H,R,W=(V,I)=>V===I){if(H===R)return!0;if(!H||!R||H.length!==R.length)return!1;for(let V=0,I=H.length;V<I;V++)if(!W(H[V],R[V]))return!1;return!0}t.equals=M;function y(H,R){const W=H.length-1;R<W&&(H[R]=H[W]),H.pop()}t.removeFastWithoutKeepingOrder=y;function w(H,R,W){return p(H.length,V=>W(H[V],R))}t.binarySearch=w;function p(H,R){let W=0,V=H-1;for(;W<=V;){const I=(W+V)/2|0,z=R(I);if(z<0)W=I+1;else if(z>0)V=I-1;else return I}return-(W+1)}t.binarySearch2=p;function f(H,R){let W=0,V=H.length;if(V===0)return 0;for(;W<V;){const I=Math.floor((W+V)/2);R(H[I])?V=I:W=I+1}return W}t.findFirstInSorted=f;function b(H,R,W){if(H=H|0,H>=R.length)throw new TypeError("invalid index");const V=R[Math.floor(R.length*Math.random())],I=[],z=[],k=[];for(const B of R){const j=W(B,V);j<0?I.push(B):j>0?z.push(B):k.push(B)}return H<I.length?b(H,I,W):H<I.length+k.length?k[0]:b(H-(I.length+k.length),z,W)}t.quickSelect=b;function T(H,R){const W=[];let V;for(const I of H.slice(0).sort(R))!V||R(V[0],I)!==0?(V=[I],W.push(V)):V.push(I);return W}t.groupBy=T;function a(H,R,W){const V=[];function I(B,j,ee){if(j===0&&ee.length===0)return;const ce=V[V.length-1];ce&&ce.start+ce.deleteCount===B?(ce.deleteCount+=j,ce.toInsert.push(...ee)):V.push({start:B,deleteCount:j,toInsert:ee})}let z=0,k=0;for(;;){if(z===H.length){I(z,0,R.slice(k));break}if(k===R.length){I(z,H.length-z,[]);break}const B=H[z],j=R[k],ee=W(B,j);ee===0?(z+=1,k+=1):ee<0?(I(z,1,[]),z+=1):ee>0&&(I(z,0,[j]),k+=1)}return V}t.sortedDiff=a;function r(H,R,W){const V=a(H,R,W),I=[],z=[];for(const k of V)I.push(...H.slice(k.start,k.start+k.deleteCount)),z.push(...k.toInsert);return{removed:I,added:z}}t.delta=r;function e(H,R,W){if(W===0)return[];const V=H.slice(0,W).sort(R);return m(H,R,V,W,H.length),V}t.top=e;function c(H,R,W,V,I){return W===0?Promise.resolve([]):new Promise((z,k)=>{(async()=>{const B=H.length,j=H.slice(0,W).sort(R);for(let ee=W,ce=Math.min(W+V,B);ee<B;ee=ce,ce=Math.min(ce+V,B)){if(ee>W&&await new Promise(fe=>setTimeout(fe)),I&&I.isCancellationRequested)throw new v.CancellationError;m(H,R,j,ee,ce)}return j})().then(z,k)})}t.topAsync=c;function m(H,R,W,V,I){for(const z=W.length;V<I;V++){const k=H[V];if(R(k,W[z-1])<0){W.pop();const B=f(W,j=>R(k,j)<0);W.splice(B,0,k)}}}function _(H){return H.filter(R=>!!R)}t.coalesce=_;function E(H){let R=0;for(let W=0;W<H.length;W++)H[W]&&(H[R]=H[W],R+=1);H.length=R}t.coalesceInPlace=E;function u(H,R,W){H.splice(W,0,H.splice(R,1)[0])}t.move=u;function h(H){return!Array.isArray(H)||H.length===0}t.isFalsyOrEmpty=h;function D(H){return Array.isArray(H)&&H.length>0}t.isNonEmptyArray=D;function C(H,R=W=>W){const W=new Set;return H.filter(V=>{const I=R(V);return W.has(I)?!1:(W.add(I),!0)})}t.distinct=C;function N(H){const R=new Set;return W=>{const V=H(W);return R.has(V)?!1:(R.add(V),!0)}}t.uniqueFilter=N;function A(H,R){const W=o(H,R);if(W!==-1)return H[W]}t.findLast=A;function o(H,R){for(let W=H.length-1;W>=0;W--){const V=H[W];if(R(V))return W}return-1}t.lastIndex=o;function l(H,R){return H.length>0?H[0]:R}t.firstOrDefault=l;function s(H,R){return H.length>0?H[H.length-1]:R}t.lastOrDefault=s;function n(H,R,W=(V,I)=>V===I){let V=0;for(let I=0,z=Math.min(H.length,R.length);I<z&&W(H[I],R[I]);I++)V++;return V}t.commonPrefixLength=n;function g(H){return[].concat(...H)}t.flatten=g;function S(H,R){let W=typeof R=="number"?H:0;typeof R=="number"?W=H:(W=0,R=H);const V=[];if(W<=R)for(let I=W;I<R;I++)V.push(I);else for(let I=W;I>R;I--)V.push(I);return V}t.range=S;function $(H,R,W){return H.reduce((V,I)=>(V[R(I)]=W?W(I):I,V),Object.create(null))}t.index=$;function ie(H,R){return H.push(R),()=>te(H,R)}t.insert=ie;function te(H,R){const W=H.indexOf(R);if(W>-1)return H.splice(W,1),R}t.remove=te;function ge(H,R,W){const V=H.slice(0,R),I=H.slice(R);return V.concat(W,I)}t.arrayInsert=ge;function ae(H,R){let W;if(typeof R=="number"){let V=R;W=()=>{const I=Math.sin(V++)*179426549;return I-Math.floor(I)}}else W=Math.random;for(let V=H.length-1;V>0;V-=1){const I=Math.floor(W()*(V+1)),z=H[V];H[V]=H[I],H[I]=z}}t.shuffle=ae;function ve(H,R){const W=H.indexOf(R);W>-1&&(H.splice(W,1),H.unshift(R))}t.pushToStart=ve;function he(H,R){const W=H.indexOf(R);W>-1&&(H.splice(W,1),H.push(R))}t.pushToEnd=he;function me(H,R){for(const W of R)H.push(W)}t.pushMany=me;function ye(H,R){return Array.isArray(H)?H.map(R):R(H)}t.mapArrayOrNot=ye;function J(H){return Array.isArray(H)?H:[H]}t.asArray=J;function de(H){return H[Math.floor(Math.random()*H.length)]}t.getRandomElement=de;function ne(H,R){for(const W of H){const V=R(W);if(V!==void 0)return V}}t.mapFind=ne;function Q(H,R,W){const V=se(H,R),I=H.length,z=W.length;H.length=I+z;for(let k=I-1;k>=V;k--)H[k+z]=H[k];for(let k=0;k<z;k++)H[k+V]=W[k]}t.insertInto=Q;function re(H,R,W,V){const I=se(H,R),z=H.splice(I,W);return Q(H,I,V),z}t.splice=re;function se(H,R){return R<0?Math.max(R+H.length,0):Math.min(R,H.length)}var F;(function(H){function R(I){return I<0}H.isLessThan=R;function W(I){return I>0}H.isGreaterThan=W;function V(I){return I===0}H.isNeitherLessOrGreaterThan=V,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(F=t.CompareResult||(t.CompareResult={}));function K(H,R){return(W,V)=>R(H(W),H(V))}t.compareBy=K;function X(...H){return(R,W)=>{for(const V of H){const I=V(R,W);if(!F.isNeitherLessOrGreaterThan(I))return I}return F.neitherLessOrGreaterThan}}t.tieBreakComparators=X;const O=(H,R)=>H-R;t.numberComparator=O;function d(H,R){if(H.length===0)return;let W=H[0];for(let V=1;V<H.length;V++){const I=H[V];R(I,W)>0&&(W=I)}return W}t.findMaxBy=d;function L(H,R){if(H.length===0)return;let W=H[0];for(let V=1;V<H.length;V++){const I=H[V];R(I,W)>=0&&(W=I)}return W}t.findLastMaxBy=L;function U(H,R){return d(H,(W,V)=>-R(W,V))}t.findMinBy=U;class q{constructor(R){this.items=R,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(R){let W=this.firstIdx;for(;W<this.items.length&&R(this.items[W]);)W++;const V=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,V}takeFromEndWhile(R){let W=this.lastIdx;for(;W>=0&&R(this.items[W]);)W--;const V=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,V}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const R=this.items[this.firstIdx];return this.firstIdx++,R}removeLast(){const R=this.items[this.lastIdx];return this.lastIdx--,R}takeCount(R){const W=this.items.slice(this.firstIdx,this.firstIdx+R);return this.firstIdx+=R,W}}t.ArrayQueue=q}),define(pe[42],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function v(i){const P=this;let M=!1,y;return function(){return M||(M=!0,y=i.apply(P,arguments)),y}}t.once=v}),define(pe[71],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class v{constructor(P){this._prefix=P,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=v,t.defaultGenerator=new v("id#")}),define(pe[26],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var v;(function(i){function P(N){return N&&typeof N=="object"&&typeof N[Symbol.iterator]=="function"}i.is=P;const M=Object.freeze([]);function y(){return M}i.empty=y;function*w(N){yield N}i.single=w;function p(N){return N||M}i.from=p;function f(N){return!N||N[Symbol.iterator]().next().done===!0}i.isEmpty=f;function b(N){return N[Symbol.iterator]().next().value}i.first=b;function T(N,A){for(const o of N)if(A(o))return!0;return!1}i.some=T;function a(N,A){for(const o of N)if(A(o))return o}i.find=a;function*r(N,A){for(const o of N)A(o)&&(yield o)}i.filter=r;function*e(N,A){let o=0;for(const l of N)yield A(l,o++)}i.map=e;function*c(...N){for(const A of N)for(const o of A)yield o}i.concat=c;function*m(N){for(const A of N)for(const o of A)yield o}i.concatNested=m;function _(N,A,o){let l=o;for(const s of N)l=A(l,s);return l}i.reduce=_;function E(N,A){let o=0;for(const l of N)A(l,o++)}i.forEach=E;function*u(N,A,o=N.length){for(A<0&&(A+=N.length),o<0?o+=N.length:o>N.length&&(o=N.length);A<o;A++)yield N[A]}i.slice=u;function h(N,A=Number.POSITIVE_INFINITY){const o=[];if(A===0)return[o,N];const l=N[Symbol.iterator]();for(let s=0;s<A;s++){const n=l.next();if(n.done)return[o,i.empty()];o.push(n.value)}return[o,{[Symbol.iterator](){return l}}]}i.consume=h;function D(N){return h(N)[0]}i.collect=D;function C(N,A,o=(l,s)=>l===s){const l=N[Symbol.iterator](),s=A[Symbol.iterator]();for(;;){const n=l.next(),g=s.next();if(n.done!==g.done)return!1;if(n.done)return!0;if(!o(n.value,g.value))return!1}}i.equals=C})(v=t.Iterable||(t.Iterable={}))}),define(pe[43],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var v;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(v=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i=t.ScanCode||(t.ScanCode={}));class P{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(c,m){this._keyCodeToStr[c]=m,this._strToKeyCode[m.toLowerCase()]=c}keyCodeToStr(c){return this._keyCodeToStr[c]}strToKeyCode(c){return this._strToKeyCode[c.toLowerCase()]||0}}const M=new P,y=new P,w=new P;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const p=[],f=Object.create(null),b=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>b[e]||0,toEnum:e=>f[e]||0,toString:e=>p[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",c=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],m=[],_=[];for(const E of c){const[u,h,D,C,N,A,o,l,s,n]=E;if(_[D]||(_[D]=!0,p[D]=C,f[C]=D,b[C.toLowerCase()]=D,h&&(t.IMMUTABLE_CODE_TO_KEY_CODE[D]=N,N!==0&&N!==3&&N!==5&&N!==4&&N!==6&&N!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[N]=D))),!m[N]){if(m[N]=!0,!A)throw new Error(`String representation missing for key code ${N} around scan code ${C}`);M.define(N,A),y.define(N,s||A),w.define(N,n||s||A)}o&&(t.EVENT_KEY_CODE_MAP[o]=N),l&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[l]=N)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var T;(function(e){function c(D){return M.keyCodeToStr(D)}e.toString=c;function m(D){return M.strToKeyCode(D)}e.fromString=m;function _(D){return y.keyCodeToStr(D)}e.toUserSettingsUS=_;function E(D){return w.keyCodeToStr(D)}e.toUserSettingsGeneral=E;function u(D){return y.strToKeyCode(D)||w.strToKeyCode(D)}e.fromUserSettings=u;function h(D){if(D>=93&&D<=108)return null;switch(D){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(D)}e.toElectronAccelerator=h})(T=t.KeyCodeUtils||(t.KeyCodeUtils={}));var a;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(a=t.KeyMod||(t.KeyMod={}));function r(e,c){const m=(c&65535)<<16>>>0;return(e|m)>>>0}t.KeyChord=r}),define(pe[72],be([1,0,13]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ScanCodeBinding=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=void 0;var i;(function(T){T[T.CtrlCmd=2048]="CtrlCmd",T[T.Shift=1024]="Shift",T[T.Alt=512]="Alt",T[T.WinCtrl=256]="WinCtrl",T[T.KeyCode=255]="KeyCode"})(i||(i={}));function P(T,a){if(T===0)return null;const r=(T&65535)>>>0,e=(T&4294901760)>>>16;return e!==0?new w([M(r,a),M(e,a)]):new w([M(r,a)])}t.createKeybinding=P;function M(T,a){const r=!!(T&2048),e=!!(T&256),c=a===2?e:r,m=!!(T&1024),_=!!(T&512),E=a===2?r:e,u=T&255;return new y(c,m,_,E,u)}t.createSimpleKeybinding=M;class y{constructor(a,r,e,c,m){this.ctrlKey=a,this.shiftKey=r,this.altKey=e,this.metaKey=c,this.keyCode=m}equals(a){return this.ctrlKey===a.ctrlKey&&this.shiftKey===a.shiftKey&&this.altKey===a.altKey&&this.metaKey===a.metaKey&&this.keyCode===a.keyCode}getHashCode(){const a=this.ctrlKey?"1":"0",r=this.shiftKey?"1":"0",e=this.altKey?"1":"0",c=this.metaKey?"1":"0";return`${a}${r}${e}${c}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=y;class w{constructor(a){if(a.length===0)throw(0,v.illegalArgument)("parts");this.parts=a}getHashCode(){let a="";for(let r=0,e=this.parts.length;r<e;r++)r!==0&&(a+=";"),a+=this.parts[r].getHashCode();return a}equals(a){if(a===null||this.parts.length!==a.parts.length)return!1;for(let r=0;r<this.parts.length;r++)if(!this.parts[r].equals(a.parts[r]))return!1;return!0}}t.ChordKeybinding=w;class p{constructor(a,r,e,c,m){this.ctrlKey=a,this.shiftKey=r,this.altKey=e,this.metaKey=c,this.scanCode=m}equals(a){return this.ctrlKey===a.ctrlKey&&this.shiftKey===a.shiftKey&&this.altKey===a.altKey&&this.metaKey===a.metaKey&&this.scanCode===a.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeBinding=p;class f{constructor(a,r,e,c,m,_){this.ctrlKey=a,this.shiftKey=r,this.altKey=e,this.metaKey=c,this.keyLabel=m,this.keyAriaLabel=_}}t.ResolvedKeybindingPart=f;class b{}t.ResolvedKeybinding=b}),define(pe[73],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class v{constructor(P){this.executor=P,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(P){this._error=P}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(P){return new v(()=>P(this.getValue()))}}t.Lazy=v}),define(pe[2],be([1,0,42,26]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.markAsSingleton=t.setDisposableTracker=void 0;const P=!1;let M=null;function y(l){M=l}if(t.setDisposableTracker=y,P){const l="__is_disposable_tracked__";y(new class{trackDisposable(s){const n=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[l]||console.log(n)},3e3)}setParent(s,n){if(s&&s!==E.None)try{s[l]=!0}catch{}}markAsDisposed(s){if(s&&s!==E.None)try{s[l]=!0}catch{}}markAsSingleton(s){}})}function w(l){return M?.trackDisposable(l),l}function p(l){M?.markAsDisposed(l)}function f(l,s){M?.setParent(l,s)}function b(l,s){if(!!M)for(const n of l)M.setParent(n,s)}function T(l){return M?.markAsSingleton(l),l}t.markAsSingleton=T;class a extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}t.MultiDisposeError=a;function r(l){return typeof l.dispose=="function"&&l.dispose.length===0}t.isDisposable=r;function e(l){if(i.Iterable.is(l)){const s=[];for(const n of l)if(n)try{n.dispose()}catch(g){s.push(g)}if(s.length===1)throw s[0];if(s.length>1)throw new a(s);return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}t.dispose=e;function c(...l){const s=m(()=>e(l));return b(l,s),s}t.combinedDisposable=c;function m(l){const s=w({dispose:(0,v.once)(()=>{p(s),l()})});return s}t.toDisposable=m;class _{constructor(){this._toDispose=new Set,this._isDisposed=!1,w(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return f(s,this),this._isDisposed?_.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}t.DisposableStore=_,_.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new _,w(this),f(this._store,this)}dispose(){p(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}t.Disposable=E,E.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&f(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&f(s,null),s}}t.MutableDisposable=u;class h{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}t.RefCountedDisposable=h;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(s){let n=s;return this.unset=()=>n=void 0,this.isset=()=>n!==void 0,this.dispose=()=>{n&&(n(),n=void 0,p(this))},this}}t.SafeDisposable=D;class C{constructor(){this.references=new Map}acquire(s,...n){let g=this.references.get(s);g||(g={counter:0,object:this.createReferencedObject(s,...n)},this.references.set(s,g));const{object:S}=g,$=(0,v.once)(()=>{--g.counter==0&&(this.destroyReferencedObject(s,g.object),this.references.delete(s))});return g.counter++,{object:S,dispose:$}}}t.ReferenceCollection=C;class N{constructor(s){this.referenceCollection=s}async acquire(s,...n){const g=this.referenceCollection.acquire(s,...n);try{return{object:await g.object,dispose:()=>g.dispose()}}catch(S){throw g.dispose(),S}}}t.AsyncReferenceCollection=N;class A{constructor(s){this.object=s}dispose(){}}t.ImmortalReference=A;function o(l){const s=new _;try{l(s)}finally{s.dispose()}}t.disposeOnReturn=o}),define(pe[74],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class v{constructor(M){this.element=M,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class i{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let M=this._first;for(;M!==v.Undefined;){const y=M.next;M.prev=v.Undefined,M.next=v.Undefined,M=y}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,y){const w=new v(M);if(this._first===v.Undefined)this._first=w,this._last=w;else if(y){const f=this._last;this._last=w,w.prev=f,f.next=w}else{const f=this._first;this._first=w,w.next=f,f.prev=w}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(w))}}shift(){if(this._first!==v.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==v.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==v.Undefined&&M.next!==v.Undefined){const y=M.prev;y.next=M.next,M.next.prev=y}else M.prev===v.Undefined&&M.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):M.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):M.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==v.Undefined;)yield M.element,M=M.next}}t.LinkedList=i}),function(Z,t){typeof exports=="object"&&typeof module!="undefined"?t(exports):typeof define=="function"&&define.amd?define(pe[75],be([0]),t):(Z=typeof globalThis!="undefined"?globalThis:Z||self,t(Z.marked={}))}(this,function(Z){"use strict";function t(R,W){for(var V=0;V<W.length;V++){var I=W[V];I.enumerable=I.enumerable||!1,I.configurable=!0,"value"in I&&(I.writable=!0),Object.defineProperty(R,I.key,I)}}function v(R,W,V){return W&&t(R.prototype,W),V&&t(R,V),Object.defineProperty(R,"prototype",{writable:!1}),R}function i(R,W){if(!!R){if(typeof R=="string")return P(R,W);var V=Object.prototype.toString.call(R).slice(8,-1);if(V==="Object"&&R.constructor&&(V=R.constructor.name),V==="Map"||V==="Set")return Array.from(R);if(V==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(V))return P(R,W)}}function P(R,W){(W==null||W>R.length)&&(W=R.length);for(var V=0,I=new Array(W);V<W;V++)I[V]=R[V];return I}function M(R,W){var V=typeof Symbol!="undefined"&&R[Symbol.iterator]||R["@@iterator"];if(V)return(V=V.call(R)).next.bind(V);if(Array.isArray(R)||(V=i(R))||W&&R&&typeof R.length=="number"){V&&(R=V);var I=0;return function(){return I>=R.length?{done:!0}:{done:!1,value:R[I++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Z.defaults=y();function w(R){Z.defaults=R}var p=/[&<>"']/,f=/[&<>"']/g,b=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},r=function(W){return a[W]};function e(R,W){if(W){if(p.test(R))return R.replace(f,r)}else if(b.test(R))return R.replace(T,r);return R}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(R){return R.replace(c,function(W,V){return V=V.toLowerCase(),V==="colon"?":":V.charAt(0)==="#"?V.charAt(1)==="x"?String.fromCharCode(parseInt(V.substring(2),16)):String.fromCharCode(+V.substring(1)):""})}var _=/(^|[^\[])\^/g;function E(R,W){R=typeof R=="string"?R:R.source,W=W||"";var V={replace:function(z,k){return k=k.source||k,k=k.replace(_,"$1"),R=R.replace(z,k),V},getRegex:function(){return new RegExp(R,W)}};return V}var u=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function D(R,W,V){if(R){var I;try{I=decodeURIComponent(m(V)).replace(u,"").toLowerCase()}catch{return null}if(I.indexOf("javascript:")===0||I.indexOf("vbscript:")===0||I.indexOf("data:")===0)return null}W&&!h.test(V)&&(V=l(W,V));try{V=encodeURI(V).replace(/%25/g,"%")}catch{return null}return V}var C={},N=/^[^:]+:\/*[^/]*$/,A=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(R,W){C[" "+R]||(N.test(R)?C[" "+R]=R+"/":C[" "+R]=S(R,"/",!0)),R=C[" "+R];var V=R.indexOf(":")===-1;return W.substring(0,2)==="//"?V?W:R.replace(A,"$1")+W:W.charAt(0)==="/"?V?W:R.replace(o,"$1")+W:R+W}var s={exec:function(){}};function n(R){for(var W=1,V,I;W<arguments.length;W++){V=arguments[W];for(I in V)Object.prototype.hasOwnProperty.call(V,I)&&(R[I]=V[I])}return R}function g(R,W){var V=R.replace(/\|/g,function(k,B,j){for(var ee=!1,ce=B;--ce>=0&&j[ce]==="\\";)ee=!ee;return ee?"|":" |"}),I=V.split(/ \|/),z=0;if(I[0].trim()||I.shift(),I.length>0&&!I[I.length-1].trim()&&I.pop(),I.length>W)I.splice(W);else for(;I.length<W;)I.push("");for(;z<I.length;z++)I[z]=I[z].trim().replace(/\\\|/g,"|");return I}function S(R,W,V){var I=R.length;if(I===0)return"";for(var z=0;z<I;){var k=R.charAt(I-z-1);if(k===W&&!V)z++;else if(k!==W&&V)z++;else break}return R.slice(0,I-z)}function $(R,W){if(R.indexOf(W[1])===-1)return-1;for(var V=R.length,I=0,z=0;z<V;z++)if(R[z]==="\\")z++;else if(R[z]===W[0])I++;else if(R[z]===W[1]&&(I--,I<0))return z;return-1}function ie(R){R&&R.sanitize&&!R.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function te(R,W){if(W<1)return"";for(var V="";W>1;)W&1&&(V+=R),W>>=1,R+=R;return V+R}function ge(R,W,V,I){var z=W.href,k=W.title?e(W.title):null,B=R[1].replace(/\\([\[\]])/g,"$1");if(R[0].charAt(0)!=="!"){I.state.inLink=!0;var j={type:"link",raw:V,href:z,title:k,text:B,tokens:I.inlineTokens(B,[])};return I.state.inLink=!1,j}return{type:"image",raw:V,href:z,title:k,text:e(B)}}function ae(R,W){var V=R.match(/^(\s+)(?:```)/);if(V===null)return W;var I=V[1];return W.split(`
`).map(function(z){var k=z.match(/^\s+/);if(k===null)return z;var B=k[0];return B.length>=I.length?z.slice(I.length):z}).join(`
`)}var ve=function(){function R(V){this.options=V||Z.defaults}var W=R.prototype;return W.space=function(I){var z=this.rules.block.newline.exec(I);if(z&&z[0].length>0)return{type:"space",raw:z[0]}},W.code=function(I){var z=this.rules.block.code.exec(I);if(z){var k=z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:z[0],codeBlockStyle:"indented",text:this.options.pedantic?k:S(k,`
`)}}},W.fences=function(I){var z=this.rules.block.fences.exec(I);if(z){var k=z[0],B=ae(k,z[3]||"");return{type:"code",raw:k,lang:z[2]?z[2].trim():z[2],text:B}}},W.heading=function(I){var z=this.rules.block.heading.exec(I);if(z){var k=z[2].trim();if(/#$/.test(k)){var B=S(k,"#");(this.options.pedantic||!B||/ $/.test(B))&&(k=B.trim())}var j={type:"heading",raw:z[0],depth:z[1].length,text:k,tokens:[]};return this.lexer.inline(j.text,j.tokens),j}},W.hr=function(I){var z=this.rules.block.hr.exec(I);if(z)return{type:"hr",raw:z[0]}},W.blockquote=function(I){var z=this.rules.block.blockquote.exec(I);if(z){var k=z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:z[0],tokens:this.lexer.blockTokens(k,[]),text:k}}},W.list=function(I){var z=this.rules.block.list.exec(I);if(z){var k,B,j,ee,ce,fe,Ee,_e,ke,Ie,De,Pe,Me=z[1].trim(),Ge=Me.length>1,He={type:"list",raw:"",ordered:Ge,start:Ge?+Me.slice(0,-1):"",loose:!1,items:[]};Me=Ge?"\\d{1,9}\\"+Me.slice(-1):"\\"+Me,this.options.pedantic&&(Me=Ge?Me:"[*+-]");for(var Ue=new RegExp("^( {0,3}"+Me+")((?:[	 ][^\\n]*)?(?:\\n|$))");I&&(Pe=!1,!(!(z=Ue.exec(I))||this.rules.block.hr.test(I)));){if(k=z[0],I=I.substring(k.length),_e=z[2].split(`
`,1)[0],ke=I.split(`
`,1)[0],this.options.pedantic?(ee=2,De=_e.trimLeft()):(ee=z[2].search(/[^ ]/),ee=ee>4?1:ee,De=_e.slice(ee),ee+=z[1].length),fe=!1,!_e&&/^ *$/.test(ke)&&(k+=ke+`
`,I=I.substring(ke.length+1),Pe=!0),!Pe)for(var Je=new RegExp("^ {0,"+Math.min(3,ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),je=new RegExp("^ {0,"+Math.min(3,ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");I&&(Ie=I.split(`
`,1)[0],_e=Ie,this.options.pedantic&&(_e=_e.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Je.test(_e)||je.test(I)));){if(_e.search(/[^ ]/)>=ee||!_e.trim())De+=`
`+_e.slice(ee);else if(!fe)De+=`
`+_e;else break;!fe&&!_e.trim()&&(fe=!0),k+=Ie+`
`,I=I.substring(Ie.length+1)}He.loose||(Ee?He.loose=!0:/\n *\n *$/.test(k)&&(Ee=!0)),this.options.gfm&&(B=/^\[[ xX]\] /.exec(De),B&&(j=B[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:k,task:!!B,checked:j,loose:!1,text:De}),He.raw+=k}He.items[He.items.length-1].raw=k.trimRight(),He.items[He.items.length-1].text=De.trimRight(),He.raw=He.raw.trimRight();var Oe=He.items.length;for(ce=0;ce<Oe;ce++){this.lexer.state.top=!1,He.items[ce].tokens=this.lexer.blockTokens(He.items[ce].text,[]);var x=He.items[ce].tokens.filter(function(we){return we.type==="space"}),oe=x.every(function(we){for(var Ce=we.raw.split(""),Fe=0,Re=M(Ce),Ve;!(Ve=Re()).done;){var tt=Ve.value;if(tt===`
`&&(Fe+=1),Fe>1)return!0}return!1});!He.loose&&x.length&&oe&&(He.loose=!0,He.items[ce].loose=!0)}return He}},W.html=function(I){var z=this.rules.block.html.exec(I);if(z){var k={type:"html",raw:z[0],pre:!this.options.sanitizer&&(z[1]==="pre"||z[1]==="script"||z[1]==="style"),text:z[0]};return this.options.sanitize&&(k.type="paragraph",k.text=this.options.sanitizer?this.options.sanitizer(z[0]):e(z[0]),k.tokens=[],this.lexer.inline(k.text,k.tokens)),k}},W.def=function(I){var z=this.rules.block.def.exec(I);if(z){z[3]&&(z[3]=z[3].substring(1,z[3].length-1));var k=z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:k,raw:z[0],href:z[2],title:z[3]}}},W.table=function(I){var z=this.rules.block.table.exec(I);if(z){var k={type:"table",header:g(z[1]).map(function(Ee){return{text:Ee}}),align:z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:z[3]&&z[3].trim()?z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(k.header.length===k.align.length){k.raw=z[0];var B=k.align.length,j,ee,ce,fe;for(j=0;j<B;j++)/^ *-+: *$/.test(k.align[j])?k.align[j]="right":/^ *:-+: *$/.test(k.align[j])?k.align[j]="center":/^ *:-+ *$/.test(k.align[j])?k.align[j]="left":k.align[j]=null;for(B=k.rows.length,j=0;j<B;j++)k.rows[j]=g(k.rows[j],k.header.length).map(function(Ee){return{text:Ee}});for(B=k.header.length,ee=0;ee<B;ee++)k.header[ee].tokens=[],this.lexer.inline(k.header[ee].text,k.header[ee].tokens);for(B=k.rows.length,ee=0;ee<B;ee++)for(fe=k.rows[ee],ce=0;ce<fe.length;ce++)fe[ce].tokens=[],this.lexer.inline(fe[ce].text,fe[ce].tokens);return k}}},W.lheading=function(I){var z=this.rules.block.lheading.exec(I);if(z){var k={type:"heading",raw:z[0],depth:z[2].charAt(0)==="="?1:2,text:z[1],tokens:[]};return this.lexer.inline(k.text,k.tokens),k}},W.paragraph=function(I){var z=this.rules.block.paragraph.exec(I);if(z){var k={type:"paragraph",raw:z[0],text:z[1].charAt(z[1].length-1)===`
`?z[1].slice(0,-1):z[1],tokens:[]};return this.lexer.inline(k.text,k.tokens),k}},W.text=function(I){var z=this.rules.block.text.exec(I);if(z){var k={type:"text",raw:z[0],text:z[0],tokens:[]};return this.lexer.inline(k.text,k.tokens),k}},W.escape=function(I){var z=this.rules.inline.escape.exec(I);if(z)return{type:"escape",raw:z[0],text:e(z[1])}},W.tag=function(I){var z=this.rules.inline.tag.exec(I);if(z)return!this.lexer.state.inLink&&/^<a /i.test(z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(z[0]):e(z[0]):z[0]}},W.link=function(I){var z=this.rules.inline.link.exec(I);if(z){var k=z[2].trim();if(!this.options.pedantic&&/^</.test(k)){if(!/>$/.test(k))return;var B=S(k.slice(0,-1),"\\");if((k.length-B.length)%2==0)return}else{var j=$(z[2],"()");if(j>-1){var ee=z[0].indexOf("!")===0?5:4,ce=ee+z[1].length+j;z[2]=z[2].substring(0,j),z[0]=z[0].substring(0,ce).trim(),z[3]=""}}var fe=z[2],Ee="";if(this.options.pedantic){var _e=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(fe);_e&&(fe=_e[1],Ee=_e[3])}else Ee=z[3]?z[3].slice(1,-1):"";return fe=fe.trim(),/^</.test(fe)&&(this.options.pedantic&&!/>$/.test(k)?fe=fe.slice(1):fe=fe.slice(1,-1)),ge(z,{href:fe&&fe.replace(this.rules.inline._escapes,"$1"),title:Ee&&Ee.replace(this.rules.inline._escapes,"$1")},z[0],this.lexer)}},W.reflink=function(I,z){var k;if((k=this.rules.inline.reflink.exec(I))||(k=this.rules.inline.nolink.exec(I))){var B=(k[2]||k[1]).replace(/\s+/g," ");if(B=z[B.toLowerCase()],!B||!B.href){var j=k[0].charAt(0);return{type:"text",raw:j,text:j}}return ge(k,B,k[0],this.lexer)}},W.emStrong=function(I,z,k){k===void 0&&(k="");var B=this.rules.inline.emStrong.lDelim.exec(I);if(!!B&&!(B[3]&&k.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=B[1]||B[2]||"";if(!j||j&&(k===""||this.rules.inline.punctuation.exec(k))){var ee=B[0].length-1,ce,fe,Ee=ee,_e=0,ke=B[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ke.lastIndex=0,z=z.slice(-1*I.length+ee);(B=ke.exec(z))!=null;)if(ce=B[1]||B[2]||B[3]||B[4]||B[5]||B[6],!!ce){if(fe=ce.length,B[3]||B[4]){Ee+=fe;continue}else if((B[5]||B[6])&&ee%3&&!((ee+fe)%3)){_e+=fe;continue}if(Ee-=fe,!(Ee>0)){if(fe=Math.min(fe,fe+Ee+_e),Math.min(ee,fe)%2){var Ie=I.slice(1,ee+B.index+fe);return{type:"em",raw:I.slice(0,ee+B.index+fe+1),text:Ie,tokens:this.lexer.inlineTokens(Ie,[])}}var De=I.slice(2,ee+B.index+fe-1);return{type:"strong",raw:I.slice(0,ee+B.index+fe+1),text:De,tokens:this.lexer.inlineTokens(De,[])}}}}}},W.codespan=function(I){var z=this.rules.inline.code.exec(I);if(z){var k=z[2].replace(/\n/g," "),B=/[^ ]/.test(k),j=/^ /.test(k)&&/ $/.test(k);return B&&j&&(k=k.substring(1,k.length-1)),k=e(k,!0),{type:"codespan",raw:z[0],text:k}}},W.br=function(I){var z=this.rules.inline.br.exec(I);if(z)return{type:"br",raw:z[0]}},W.del=function(I){var z=this.rules.inline.del.exec(I);if(z)return{type:"del",raw:z[0],text:z[2],tokens:this.lexer.inlineTokens(z[2],[])}},W.autolink=function(I,z){var k=this.rules.inline.autolink.exec(I);if(k){var B,j;return k[2]==="@"?(B=e(this.options.mangle?z(k[1]):k[1]),j="mailto:"+B):(B=e(k[1]),j=B),{type:"link",raw:k[0],text:B,href:j,tokens:[{type:"text",raw:B,text:B}]}}},W.url=function(I,z){var k;if(k=this.rules.inline.url.exec(I)){var B,j;if(k[2]==="@")B=e(this.options.mangle?z(k[0]):k[0]),j="mailto:"+B;else{var ee;do ee=k[0],k[0]=this.rules.inline._backpedal.exec(k[0])[0];while(ee!==k[0]);B=e(k[0]),k[1]==="www."?j="http://"+B:j=B}return{type:"link",raw:k[0],text:B,href:j,tokens:[{type:"text",raw:B,text:B}]}}},W.inlineText=function(I,z){var k=this.rules.inline.text.exec(I);if(k){var B;return this.lexer.state.inRawBlock?B=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(k[0]):e(k[0]):k[0]:B=e(this.options.smartypants?z(k[0]):k[0]),{type:"text",raw:k[0],text:B}}},R}(),he={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:s,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};he._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,he._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,he.def=E(he.def).replace("label",he._label).replace("title",he._title).getRegex(),he.bullet=/(?:[*+-]|\d{1,9}[.)])/,he.listItemStart=E(/^( *)(bull) */).replace("bull",he.bullet).getRegex(),he.list=E(he.list).replace(/bull/g,he.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+he.def.source+")").getRegex(),he._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",he._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,he.html=E(he.html,"i").replace("comment",he._comment).replace("tag",he._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),he.paragraph=E(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.blockquote=E(he.blockquote).replace("paragraph",he.paragraph).getRegex(),he.normal=n({},he),he.gfm=n({},he.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),he.gfm.table=E(he.gfm.table).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.gfm.paragraph=E(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",he.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.pedantic=n({},he.normal,{html:E(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",he._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:s,paragraph:E(he.normal._paragraph).replace("hr",he.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",he.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var me={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:s,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:s,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};me._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",me.punctuation=E(me.punctuation).replace(/punctuation/g,me._punctuation).getRegex(),me.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,me.escapedEmSt=/\\\*|\\_/g,me._comment=E(he._comment).replace("(?:-->|$)","-->").getRegex(),me.emStrong.lDelim=E(me.emStrong.lDelim).replace(/punct/g,me._punctuation).getRegex(),me.emStrong.rDelimAst=E(me.emStrong.rDelimAst,"g").replace(/punct/g,me._punctuation).getRegex(),me.emStrong.rDelimUnd=E(me.emStrong.rDelimUnd,"g").replace(/punct/g,me._punctuation).getRegex(),me._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,me._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,me._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,me.autolink=E(me.autolink).replace("scheme",me._scheme).replace("email",me._email).getRegex(),me._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,me.tag=E(me.tag).replace("comment",me._comment).replace("attribute",me._attribute).getRegex(),me._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,me._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,me._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,me.link=E(me.link).replace("label",me._label).replace("href",me._href).replace("title",me._title).getRegex(),me.reflink=E(me.reflink).replace("label",me._label).replace("ref",he._label).getRegex(),me.nolink=E(me.nolink).replace("ref",he._label).getRegex(),me.reflinkSearch=E(me.reflinkSearch,"g").replace("reflink",me.reflink).replace("nolink",me.nolink).getRegex(),me.normal=n({},me),me.pedantic=n({},me.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:E(/^!?\[(label)\]\((.*?)\)/).replace("label",me._label).getRegex(),reflink:E(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",me._label).getRegex()}),me.gfm=n({},me.normal,{escape:E(me.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),me.gfm.url=E(me.gfm.url,"i").replace("email",me.gfm._extended_email).getRegex(),me.breaks=n({},me.gfm,{br:E(me.br).replace("{2,}","*").getRegex(),text:E(me.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ye(R){return R.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(R){var W="",V,I,z=R.length;for(V=0;V<z;V++)I=R.charCodeAt(V),Math.random()>.5&&(I="x"+I.toString(16)),W+="&#"+I+";";return W}var de=function(){function R(V){this.tokens=[],this.tokens.links=Object.create(null),this.options=V||Z.defaults,this.options.tokenizer=this.options.tokenizer||new ve,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var I={block:he.normal,inline:me.normal};this.options.pedantic?(I.block=he.pedantic,I.inline=me.pedantic):this.options.gfm&&(I.block=he.gfm,this.options.breaks?I.inline=me.breaks:I.inline=me.gfm),this.tokenizer.rules=I}R.lex=function(I,z){var k=new R(z);return k.lex(I)},R.lexInline=function(I,z){var k=new R(z);return k.inlineTokens(I)};var W=R.prototype;return W.lex=function(I){I=I.replace(/\r\n|\r/g,`
`),this.blockTokens(I,this.tokens);for(var z;z=this.inlineQueue.shift();)this.inlineTokens(z.src,z.tokens);return this.tokens},W.blockTokens=function(I,z){var k=this;z===void 0&&(z=[]),this.options.pedantic?I=I.replace(/\t/g,"    ").replace(/^ +$/gm,""):I=I.replace(/^( *)(\t+)/gm,function(Ee,_e,ke){return _e+"    ".repeat(ke.length)});for(var B,j,ee,ce;I;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ee){return(B=Ee.call({lexer:k},I,z))?(I=I.substring(B.raw.length),z.push(B),!0):!1}))){if(B=this.tokenizer.space(I)){I=I.substring(B.raw.length),B.raw.length===1&&z.length>0?z[z.length-1].raw+=`
`:z.push(B);continue}if(B=this.tokenizer.code(I)){I=I.substring(B.raw.length),j=z[z.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+B.raw,j.text+=`
`+B.text,this.inlineQueue[this.inlineQueue.length-1].src=j.text):z.push(B);continue}if(B=this.tokenizer.fences(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.heading(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.hr(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.blockquote(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.list(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.html(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.def(I)){I=I.substring(B.raw.length),j=z[z.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+B.raw,j.text+=`
`+B.raw,this.inlineQueue[this.inlineQueue.length-1].src=j.text):this.tokens.links[B.tag]||(this.tokens.links[B.tag]={href:B.href,title:B.title});continue}if(B=this.tokenizer.table(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.lheading(I)){I=I.substring(B.raw.length),z.push(B);continue}if(ee=I,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ee=1/0,_e=I.slice(1),ke=void 0;k.options.extensions.startBlock.forEach(function(Ie){ke=Ie.call({lexer:this},_e),typeof ke=="number"&&ke>=0&&(Ee=Math.min(Ee,ke))}),Ee<1/0&&Ee>=0&&(ee=I.substring(0,Ee+1))}(),this.state.top&&(B=this.tokenizer.paragraph(ee))){j=z[z.length-1],ce&&j.type==="paragraph"?(j.raw+=`
`+B.raw,j.text+=`
`+B.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):z.push(B),ce=ee.length!==I.length,I=I.substring(B.raw.length);continue}if(B=this.tokenizer.text(I)){I=I.substring(B.raw.length),j=z[z.length-1],j&&j.type==="text"?(j.raw+=`
`+B.raw,j.text+=`
`+B.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):z.push(B);continue}if(I){var fe="Infinite loop on byte: "+I.charCodeAt(0);if(this.options.silent){console.error(fe);break}else throw new Error(fe)}}return this.state.top=!0,z},W.inline=function(I,z){this.inlineQueue.push({src:I,tokens:z})},W.inlineTokens=function(I,z){var k=this;z===void 0&&(z=[]);var B,j,ee,ce=I,fe,Ee,_e;if(this.tokens.links){var ke=Object.keys(this.tokens.links);if(ke.length>0)for(;(fe=this.tokenizer.rules.inline.reflinkSearch.exec(ce))!=null;)ke.includes(fe[0].slice(fe[0].lastIndexOf("[")+1,-1))&&(ce=ce.slice(0,fe.index)+"["+te("a",fe[0].length-2)+"]"+ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(fe=this.tokenizer.rules.inline.blockSkip.exec(ce))!=null;)ce=ce.slice(0,fe.index)+"["+te("a",fe[0].length-2)+"]"+ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(fe=this.tokenizer.rules.inline.escapedEmSt.exec(ce))!=null;)ce=ce.slice(0,fe.index)+"++"+ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;I;)if(Ee||(_e=""),Ee=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(B=De.call({lexer:k},I,z))?(I=I.substring(B.raw.length),z.push(B),!0):!1}))){if(B=this.tokenizer.escape(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.tag(I)){I=I.substring(B.raw.length),j=z[z.length-1],j&&B.type==="text"&&j.type==="text"?(j.raw+=B.raw,j.text+=B.text):z.push(B);continue}if(B=this.tokenizer.link(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.reflink(I,this.tokens.links)){I=I.substring(B.raw.length),j=z[z.length-1],j&&B.type==="text"&&j.type==="text"?(j.raw+=B.raw,j.text+=B.text):z.push(B);continue}if(B=this.tokenizer.emStrong(I,ce,_e)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.codespan(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.br(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.del(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.autolink(I,J)){I=I.substring(B.raw.length),z.push(B);continue}if(!this.state.inLink&&(B=this.tokenizer.url(I,J))){I=I.substring(B.raw.length),z.push(B);continue}if(ee=I,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Pe=I.slice(1),Me=void 0;k.options.extensions.startInline.forEach(function(Ge){Me=Ge.call({lexer:this},Pe),typeof Me=="number"&&Me>=0&&(De=Math.min(De,Me))}),De<1/0&&De>=0&&(ee=I.substring(0,De+1))}(),B=this.tokenizer.inlineText(ee,ye)){I=I.substring(B.raw.length),B.raw.slice(-1)!=="_"&&(_e=B.raw.slice(-1)),Ee=!0,j=z[z.length-1],j&&j.type==="text"?(j.raw+=B.raw,j.text+=B.text):z.push(B);continue}if(I){var Ie="Infinite loop on byte: "+I.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return z},v(R,null,[{key:"rules",get:function(){return{block:he,inline:me}}}]),R}(),ne=function(){function R(V){this.options=V||Z.defaults}var W=R.prototype;return W.code=function(I,z,k){var B=(z||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(I,B);j!=null&&j!==I&&(k=!0,I=j)}return I=I.replace(/\n$/,"")+`
`,B?'<pre><code class="'+this.options.langPrefix+e(B,!0)+'">'+(k?I:e(I,!0))+`</code></pre>
`:"<pre><code>"+(k?I:e(I,!0))+`</code></pre>
`},W.blockquote=function(I){return`<blockquote>
`+I+`</blockquote>
`},W.html=function(I){return I},W.heading=function(I,z,k,B){if(this.options.headerIds){var j=this.options.headerPrefix+B.slug(k);return"<h"+z+' id="'+j+'">'+I+"</h"+z+`>
`}return"<h"+z+">"+I+"</h"+z+`>
`},W.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},W.list=function(I,z,k){var B=z?"ol":"ul",j=z&&k!==1?' start="'+k+'"':"";return"<"+B+j+`>
`+I+"</"+B+`>
`},W.listitem=function(I){return"<li>"+I+`</li>
`},W.checkbox=function(I){return"<input "+(I?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},W.paragraph=function(I){return"<p>"+I+`</p>
`},W.table=function(I,z){return z&&(z="<tbody>"+z+"</tbody>"),`<table>
<thead>
`+I+`</thead>
`+z+`</table>
`},W.tablerow=function(I){return`<tr>
`+I+`</tr>
`},W.tablecell=function(I,z){var k=z.header?"th":"td",B=z.align?"<"+k+' align="'+z.align+'">':"<"+k+">";return B+I+("</"+k+`>
`)},W.strong=function(I){return"<strong>"+I+"</strong>"},W.em=function(I){return"<em>"+I+"</em>"},W.codespan=function(I){return"<code>"+I+"</code>"},W.br=function(){return this.options.xhtml?"<br/>":"<br>"},W.del=function(I){return"<del>"+I+"</del>"},W.link=function(I,z,k){if(I=D(this.options.sanitize,this.options.baseUrl,I),I===null)return k;var B='<a href="'+e(I)+'"';return z&&(B+=' title="'+z+'"'),B+=">"+k+"</a>",B},W.image=function(I,z,k){if(I=D(this.options.sanitize,this.options.baseUrl,I),I===null)return k;var B='<img src="'+I+'" alt="'+k+'"';return z&&(B+=' title="'+z+'"'),B+=this.options.xhtml?"/>":">",B},W.text=function(I){return I},R}(),Q=function(){function R(){}var W=R.prototype;return W.strong=function(I){return I},W.em=function(I){return I},W.codespan=function(I){return I},W.del=function(I){return I},W.html=function(I){return I},W.text=function(I){return I},W.link=function(I,z,k){return""+k},W.image=function(I,z,k){return""+k},W.br=function(){return""},R}(),re=function(){function R(){this.seen={}}var W=R.prototype;return W.serialize=function(I){return I.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},W.getNextSafeSlug=function(I,z){var k=I,B=0;if(this.seen.hasOwnProperty(k)){B=this.seen[I];do B++,k=I+"-"+B;while(this.seen.hasOwnProperty(k))}return z||(this.seen[I]=B,this.seen[k]=0),k},W.slug=function(I,z){z===void 0&&(z={});var k=this.serialize(I);return this.getNextSafeSlug(k,z.dryrun)},R}(),se=function(){function R(V){this.options=V||Z.defaults,this.options.renderer=this.options.renderer||new ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Q,this.slugger=new re}R.parse=function(I,z){var k=new R(z);return k.parse(I)},R.parseInline=function(I,z){var k=new R(z);return k.parseInline(I)};var W=R.prototype;return W.parse=function(I,z){z===void 0&&(z=!0);var k="",B,j,ee,ce,fe,Ee,_e,ke,Ie,De,Pe,Me,Ge,He,Ue,Je,je,Oe,x,oe=I.length;for(B=0;B<oe;B++){if(De=I[B],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(x=this.options.extensions.renderers[De.type].call({parser:this},De),x!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){k+=x||"";continue}switch(De.type){case"space":continue;case"hr":{k+=this.renderer.hr();continue}case"heading":{k+=this.renderer.heading(this.parseInline(De.tokens),De.depth,m(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{k+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(ke="",_e="",ce=De.header.length,j=0;j<ce;j++)_e+=this.renderer.tablecell(this.parseInline(De.header[j].tokens),{header:!0,align:De.align[j]});for(ke+=this.renderer.tablerow(_e),Ie="",ce=De.rows.length,j=0;j<ce;j++){for(Ee=De.rows[j],_e="",fe=Ee.length,ee=0;ee<fe;ee++)_e+=this.renderer.tablecell(this.parseInline(Ee[ee].tokens),{header:!1,align:De.align[ee]});Ie+=this.renderer.tablerow(_e)}k+=this.renderer.table(ke,Ie);continue}case"blockquote":{Ie=this.parse(De.tokens),k+=this.renderer.blockquote(Ie);continue}case"list":{for(Pe=De.ordered,Me=De.start,Ge=De.loose,ce=De.items.length,Ie="",j=0;j<ce;j++)Ue=De.items[j],Je=Ue.checked,je=Ue.task,He="",Ue.task&&(Oe=this.renderer.checkbox(Je),Ge?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=Oe+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=Oe+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:Oe}):He+=Oe),He+=this.parse(Ue.tokens,Ge),Ie+=this.renderer.listitem(He,je,Je);k+=this.renderer.list(Ie,Pe,Me);continue}case"html":{k+=this.renderer.html(De.text);continue}case"paragraph":{k+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Ie=De.tokens?this.parseInline(De.tokens):De.text;B+1<oe&&I[B+1].type==="text";)De=I[++B],Ie+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);k+=z?this.renderer.paragraph(Ie):Ie;continue}default:{var we='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(we);return}else throw new Error(we)}}}return k},W.parseInline=function(I,z){z=z||this.renderer;var k="",B,j,ee,ce=I.length;for(B=0;B<ce;B++){if(j=I[B],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[j.type]&&(ee=this.options.extensions.renderers[j.type].call({parser:this},j),ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(j.type))){k+=ee||"";continue}switch(j.type){case"escape":{k+=z.text(j.text);break}case"html":{k+=z.html(j.text);break}case"link":{k+=z.link(j.href,j.title,this.parseInline(j.tokens,z));break}case"image":{k+=z.image(j.href,j.title,j.text);break}case"strong":{k+=z.strong(this.parseInline(j.tokens,z));break}case"em":{k+=z.em(this.parseInline(j.tokens,z));break}case"codespan":{k+=z.codespan(j.text);break}case"br":{k+=z.br();break}case"del":{k+=z.del(this.parseInline(j.tokens,z));break}case"text":{k+=z.text(j.text);break}default:{var fe='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(fe);return}else throw new Error(fe)}}}return k},R}();function F(R,W,V){if(typeof R=="undefined"||R===null)throw new Error("marked(): input parameter is undefined or null");if(typeof R!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(R)+", string expected");if(typeof W=="function"&&(V=W,W=null),W=n({},F.defaults,W||{}),ie(W),V){var I=W.highlight,z;try{z=de.lex(R,W)}catch(ee){return V(ee)}var k=function(ce){var fe;if(!ce)try{W.walkTokens&&F.walkTokens(z,W.walkTokens),fe=se.parse(z,W)}catch(Ee){ce=Ee}return W.highlight=I,ce?V(ce):V(null,fe)};if(!I||I.length<3||(delete W.highlight,!z.length))return k();var B=0;F.walkTokens(z,function(ee){ee.type==="code"&&(B++,setTimeout(function(){I(ee.text,ee.lang,function(ce,fe){if(ce)return k(ce);fe!=null&&fe!==ee.text&&(ee.text=fe,ee.escaped=!0),B--,B===0&&k()})},0))}),B===0&&k();return}try{var j=de.lex(R,W);return W.walkTokens&&F.walkTokens(j,W.walkTokens),se.parse(j,W)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,W.silent)return"<p>An error occurred:</p><pre>"+e(ee.message+"",!0)+"</pre>";throw ee}}F.options=F.setOptions=function(R){return n(F.defaults,R),w(F.defaults),F},F.getDefaults=y,F.defaults=Z.defaults,F.use=function(){for(var R=arguments.length,W=new Array(R),V=0;V<R;V++)W[V]=arguments[V];var I=n.apply(void 0,[{}].concat(W)),z=F.defaults.extensions||{renderers:{},childTokens:{}},k;W.forEach(function(B){if(B.extensions&&(k=!0,B.extensions.forEach(function(ee){if(!ee.name)throw new Error("extension name required");if(ee.renderer){var ce=z.renderers?z.renderers[ee.name]:null;ce?z.renderers[ee.name]=function(){for(var fe=arguments.length,Ee=new Array(fe),_e=0;_e<fe;_e++)Ee[_e]=arguments[_e];var ke=ee.renderer.apply(this,Ee);return ke===!1&&(ke=ce.apply(this,Ee)),ke}:z.renderers[ee.name]=ee.renderer}if(ee.tokenizer){if(!ee.level||ee.level!=="block"&&ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");z[ee.level]?z[ee.level].unshift(ee.tokenizer):z[ee.level]=[ee.tokenizer],ee.start&&(ee.level==="block"?z.startBlock?z.startBlock.push(ee.start):z.startBlock=[ee.start]:ee.level==="inline"&&(z.startInline?z.startInline.push(ee.start):z.startInline=[ee.start]))}ee.childTokens&&(z.childTokens[ee.name]=ee.childTokens)})),B.renderer&&function(){var ee=F.defaults.renderer||new ne,ce=function(_e){var ke=ee[_e];ee[_e]=function(){for(var Ie=arguments.length,De=new Array(Ie),Pe=0;Pe<Ie;Pe++)De[Pe]=arguments[Pe];var Me=B.renderer[_e].apply(ee,De);return Me===!1&&(Me=ke.apply(ee,De)),Me}};for(var fe in B.renderer)ce(fe);I.renderer=ee}(),B.tokenizer&&function(){var ee=F.defaults.tokenizer||new ve,ce=function(_e){var ke=ee[_e];ee[_e]=function(){for(var Ie=arguments.length,De=new Array(Ie),Pe=0;Pe<Ie;Pe++)De[Pe]=arguments[Pe];var Me=B.tokenizer[_e].apply(ee,De);return Me===!1&&(Me=ke.apply(ee,De)),Me}};for(var fe in B.tokenizer)ce(fe);I.tokenizer=ee}(),B.walkTokens){var j=F.defaults.walkTokens;I.walkTokens=function(ee){B.walkTokens.call(this,ee),j&&j.call(this,ee)}}k&&(I.extensions=z),F.setOptions(I)})},F.walkTokens=function(R,W){for(var V=function(){var B=z.value;switch(W.call(F,B),B.type){case"table":{for(var j=M(B.header),ee;!(ee=j()).done;){var ce=ee.value;F.walkTokens(ce.tokens,W)}for(var fe=M(B.rows),Ee;!(Ee=fe()).done;)for(var _e=Ee.value,ke=M(_e),Ie;!(Ie=ke()).done;){var De=Ie.value;F.walkTokens(De.tokens,W)}break}case"list":{F.walkTokens(B.items,W);break}default:F.defaults.extensions&&F.defaults.extensions.childTokens&&F.defaults.extensions.childTokens[B.type]?F.defaults.extensions.childTokens[B.type].forEach(function(Pe){F.walkTokens(B[Pe],W)}):B.tokens&&F.walkTokens(B.tokens,W)}},I=M(R),z;!(z=I()).done;)V()},F.parseInline=function(R,W){if(typeof R=="undefined"||R===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof R!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(R)+", string expected");W=n({},F.defaults,W||{}),ie(W);try{var V=de.lexInline(R,W);return W.walkTokens&&F.walkTokens(V,W.walkTokens),se.parseInline(V,W)}catch(I){if(I.message+=`
Please report this to https://github.com/markedjs/marked.`,W.silent)return"<p>An error occurred:</p><pre>"+e(I.message+"",!0)+"</pre>";throw I}},F.Parser=se,F.parser=se.parse,F.Renderer=ne,F.TextRenderer=Q,F.Lexer=de,F.lexer=de.lex,F.Tokenizer=ve,F.Slugger=re,F.parse=F;var K=F.options,X=F.setOptions,O=F.use,d=F.walkTokens,L=F.parseInline,U=F,q=se.parse,H=de.lex;Z.Lexer=de,Z.Parser=se,Z.Renderer=ne,Z.Slugger=re,Z.TextRenderer=Q,Z.Tokenizer=ve,Z.getDefaults=y,Z.lexer=H,Z.marked=F,Z.options=K,Z.parse=U,Z.parseInline=L,Z.parser=q,Z.setOptions=X,Z.use=O,Z.walkTokens=d,Object.defineProperty(Z,"__esModule",{value:!0})}),define(pe[76],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class v{constructor(P,M=0,y=P.length,w=M-1){this.items=P,this.start=M,this.end=y,this.index=w}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=v}),define(pe[77],be([1,0,76]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class i{constructor(y=[],w=10){this._initialize(y),this._limit=w,this._onChange()}getHistory(){return this._elements}add(y){this._history.delete(y),this._history.add(y),this._onChange()}next(){return this._currentPosition()!==this._elements.length-1?this._navigator.next():null}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}has(y){return this._history.has(y)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const y=this._elements;this._navigator=new v.ArrayNavigator(y,0,y.length,y.length)}_reduceToLimit(){const y=this._elements;y.length>this._limit&&this._initialize(y.slice(y.length-this._limit))}_currentPosition(){const y=this._navigator.current();return y?this._elements.indexOf(y):-1}_initialize(y){this._history=new Set;for(const w of y)this._history.add(w)}get _elements(){const y=[];return this._history.forEach(w=>y.push(w)),y}}t.HistoryNavigator=i;class P{constructor(y,w=10){if(this.capacity=w,y.length<1)throw new Error("not supported");this.size=1,this.head=this.tail=this.cursor={value:y[0],previous:void 0,next:void 0};for(let p=1;p<y.length;p++)this.add(y[p])}add(y){const w={value:y,previous:this.tail,next:void 0};for(this.tail.next=w,this.tail=w,this.cursor=this.tail,this.size++;this.size>this.capacity;)this.head=this.head.next,this.head.previous=void 0,this.size--}replaceLast(y){const w=this.tail.value;return this.tail.value=y,w}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(y){let w=this.head;for(;w;){if(w.value===y)return!0;w=w.next}return!1}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let y=this.head;for(;y;)yield y.value,y=y.next}}t.HistoryNavigator2=P}),define(pe[44],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function v(w,p,f){return Math.min(Math.max(w,p),f)}t.clamp=v;function i(w,p){return(p+w%p)%p}t.rot=i;class P{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=P;class M{constructor(){this._n=1,this._val=0}update(p){return this._val=this._val+(p-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=M;class y{constructor(p){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(p),this._values.fill(0,0,p)}update(p){const f=this._values[this._index];return this._values[this._index]=p,this._index=(this._index+1)%this._values.length,this._sum-=f,this._sum+=p,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=y}),define(pe[45],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var v;(function(i){function P(p,f){if(p.start>=f.end||f.start>=p.end)return{start:0,end:0};const b=Math.max(p.start,f.start),T=Math.min(p.end,f.end);return T-b<=0?{start:0,end:0}:{start:b,end:T}}i.intersect=P;function M(p){return p.end-p.start<=0}i.isEmpty=M;function y(p,f){return!M(P(p,f))}i.intersects=y;function w(p,f){const b=[],T={start:p.start,end:Math.min(f.start,p.end)},a={start:Math.max(f.end,p.start),end:p.end};return M(T)||b.push(T),M(a)||b.push(a),b}i.relativeComplement=w})(v=t.Range||(t.Range={}))}),define(pe[78],be([1,0,45]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function i(p,f){const b=[];for(const T of f){if(p.start>=T.range.end)continue;if(p.end<T.range.start)break;const a=v.Range.intersect(p,T.range);v.Range.isEmpty(a)||b.push({range:a,size:T.size})}return b}t.groupIntersect=i;function P({start:p,end:f},b){return{start:p+b,end:f+b}}t.shift=P;function M(p){const f=[];let b=null;for(const T of p){const a=T.range.start,r=T.range.end,e=T.size;if(b&&e===b.size){b.range.end=r;continue}b={range:{start:a,end:r},size:e},f.push(b)}return f}t.consolidate=M;function y(...p){return M(p.reduce((f,b)=>f.concat(b),[]))}class w{constructor(){this.groups=[],this._size=0}splice(f,b,T=[]){const a=T.length-b,r=i({start:0,end:f},this.groups),e=i({start:f+b,end:Number.POSITIVE_INFINITY},this.groups).map(m=>({range:P(m.range,a),size:m.size})),c=T.map((m,_)=>({range:{start:f+_,end:f+_+1},size:m.size}));this.groups=y(r,c,e),this._size=this.groups.reduce((m,_)=>m+_.size*(_.range.end-_.range.start),0)}get count(){const f=this.groups.length;return f?this.groups[f-1].range.end:0}get size(){return this._size}indexAt(f){if(f<0)return-1;let b=0,T=0;for(const a of this.groups){const r=a.range.end-a.range.start,e=T+r*a.size;if(f<e)return b+Math.floor((f-T)/a.size);b+=r,T=e}return b}indexAfter(f){return Math.min(this.indexAt(f)+1,this.count)}positionAt(f){if(f<0)return-1;let b=0,T=0;for(const a of this.groups){const r=a.range.end-a.range.start,e=T+r;if(f<e)return b+(f-T)*a.size;b+=r*a.size,T=e}return-1}}t.RangeMap=w}),define(pe[79],be([1,0,13,2]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function P(h){const D=h;return D?typeof D.read=="function":!1}t.isReadable=P;function M(h){const D=h;return D?[D.on,D.pause,D.resume,D.destroy].every(C=>typeof C=="function"):!1}t.isReadableStream=M;function y(h){const D=h;return D?M(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}t.isReadableBufferedStream=y;function w(h,D){return new p(h,D)}t.newWriteableStream=w;class p{constructor(D,C){this.reducer=D,this.options=C,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(D){if(!this.state.destroyed){if(this.state.flowing)this.emitData(D);else if(this.buffer.data.push(D),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(C=>this.pendingWritePromises.push(C))}}error(D){this.state.destroyed||(this.state.flowing?this.emitError(D):this.buffer.error.push(D))}end(D){this.state.destroyed||(typeof D!="undefined"&&this.write(D),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(D){this.listeners.data.slice(0).forEach(C=>C(D))}emitError(D){this.listeners.error.length===0?(0,v.onUnexpectedError)(D):this.listeners.error.slice(0).forEach(C=>C(D))}emitEnd(){this.listeners.end.slice(0).forEach(D=>D())}on(D,C){if(!this.state.destroyed)switch(D){case"data":this.listeners.data.push(C),this.resume();break;case"end":this.listeners.end.push(C),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(C),this.state.flowing&&this.flowErrors();break}}removeListener(D,C){if(this.state.destroyed)return;let N;switch(D){case"data":N=this.listeners.data;break;case"end":N=this.listeners.end;break;case"error":N=this.listeners.error;break}if(N){const A=N.indexOf(C);A>=0&&N.splice(A,1)}}flowData(){if(this.buffer.data.length>0){const D=this.reducer(this.buffer.data);this.emitData(D),this.buffer.data.length=0;const C=[...this.pendingWritePromises];this.pendingWritePromises.length=0,C.forEach(N=>N())}}flowErrors(){if(this.listeners.error.length>0){for(const D of this.buffer.error)this.emitError(D);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(h,D){const C=[];let N;for(;(N=h.read())!==null;)C.push(N);return D(C)}t.consumeReadable=f;function b(h,D,C){const N=[];let A;for(;(A=h.read())!==null&&N.length<C;)N.push(A);return A===null&&N.length>0?D(N):{read:()=>{if(N.length>0)return N.shift();if(typeof A!="undefined"){const o=A;return A=void 0,o}return h.read()}}}t.peekReadable=b;function T(h,D){return new Promise((C,N)=>{const A=[];a(h,{onData:o=>{D&&A.push(o)},onError:o=>{D?N(o):C(void 0)},onEnd:()=>{C(D?D(A):void 0)}})})}t.consumeStream=T;function a(h,D){let C=!1;return h.on("error",N=>{C||D.onError(N)}),h.on("end",()=>{C||D.onEnd()}),h.on("data",N=>{C||D.onData(N)}),(0,i.toDisposable)(()=>C=!0)}t.listenStream=a;function r(h,D){return new Promise((C,N)=>{const A=new i.DisposableStore,o=[],l=g=>{if(o.push(g),o.length>D)return A.dispose(),h.pause(),C({stream:h,buffer:o,ended:!1})},s=g=>N(g),n=()=>C({stream:h,buffer:o,ended:!0});A.add((0,i.toDisposable)(()=>h.removeListener("error",s))),h.on("error",s),A.add((0,i.toDisposable)(()=>h.removeListener("end",n))),h.on("end",n),A.add((0,i.toDisposable)(()=>h.removeListener("data",l))),h.on("data",l)})}t.peekStream=r;function e(h,D){const C=w(D);return C.end(h),C}t.toStream=e;function c(){const h=w(()=>{throw new Error("not supported")});return h.end(),h}t.emptyStream=c;function m(h){let D=!1;return{read:()=>D?null:(D=!0,h)}}t.toReadable=m;function _(h,D,C){const N=w(C);return a(h,{onData:A=>N.write(D.data(A)),onError:A=>N.error(D.error?D.error(A):A),onEnd:()=>N.end()}),N}t.transform=_;function E(h,D,C){let N=!1;return{read:()=>{const A=D.read();return N?A:(N=!0,A!==null?C([h,A]):h)}}}t.prefixedReadable=E;function u(h,D,C){let N=!1;const A=w(C);return a(D,{onData:o=>N?A.write(o):(N=!0,A.write(C([h,o]))),onError:o=>A.error(o),onEnd:()=>{N||(N=!0,A.write(h)),A.end()}}),A}t.prefixedStream=u}),define(pe[31],be([1,0,79]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer!="undefined";let P,M;class y{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return i?new y(Buffer.allocUnsafe(g)):new y(new Uint8Array(g))}static wrap(g){return i&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new y(g)}static fromString(g,S){return!(S?.dontUseNodeBuffer||!1)&&i?new y(Buffer.from(g)):(P||(P=new TextEncoder),new y(P.encode(g)))}static fromByteArray(g){const S=y.alloc(g.length);for(let $=0,ie=g.length;$<ie;$++)S.buffer[$]=g[$];return S}static concat(g,S){if(typeof S=="undefined"){S=0;for(let te=0,ge=g.length;te<ge;te++)S+=g[te].byteLength}const $=y.alloc(S);let ie=0;for(let te=0,ge=g.length;te<ge;te++){const ae=g[te];$.set(ae,ie),ie+=ae.byteLength}return $}clone(){const g=y.alloc(this.byteLength);return g.set(this),g}toString(){return i?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(g,S){return new y(this.buffer.subarray(g,S))}set(g,S){if(g instanceof y)this.buffer.set(g.buffer,S);else if(g instanceof Uint8Array)this.buffer.set(g,S);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),S);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return f(this.buffer,g)}writeUInt32BE(g,S){b(this.buffer,g,S)}readUInt32LE(g){return T(this.buffer,g)}writeUInt32LE(g,S){a(this.buffer,g,S)}readUInt8(g){return r(this.buffer,g)}writeUInt8(g,S){e(this.buffer,g,S)}}t.VSBuffer=y;function w(n,g){return n[g+0]<<0>>>0|n[g+1]<<8>>>0}t.readUInt16LE=w;function p(n,g,S){n[S+0]=g&255,g=g>>>8,n[S+1]=g&255}t.writeUInt16LE=p;function f(n,g){return n[g]*2**24+n[g+1]*2**16+n[g+2]*2**8+n[g+3]}t.readUInt32BE=f;function b(n,g,S){n[S+3]=g,g=g>>>8,n[S+2]=g,g=g>>>8,n[S+1]=g,g=g>>>8,n[S]=g}t.writeUInt32BE=b;function T(n,g){return n[g+0]<<0>>>0|n[g+1]<<8>>>0|n[g+2]<<16>>>0|n[g+3]<<24>>>0}t.readUInt32LE=T;function a(n,g,S){n[S+0]=g&255,g=g>>>8,n[S+1]=g&255,g=g>>>8,n[S+2]=g&255,g=g>>>8,n[S+3]=g&255}t.writeUInt32LE=a;function r(n,g){return n[g]}t.readUInt8=r;function e(n,g,S){n[S]=g}t.writeUInt8=e;function c(n){return v.consumeReadable(n,g=>y.concat(g))}t.readableToBuffer=c;function m(n){return v.toReadable(n)}t.bufferToReadable=m;function _(n){return v.consumeStream(n,g=>y.concat(g))}t.streamToBuffer=_;async function E(n){return n.ended?y.concat(n.buffer):y.concat([...n.buffer,await _(n.stream)])}t.bufferedStreamToBuffer=E;function u(n){return v.toStream(n,g=>y.concat(g))}t.bufferToStream=u;function h(n){return v.transform(n,{data:g=>typeof g=="string"?y.fromString(g):y.wrap(g)},g=>y.concat(g))}t.streamToBufferReadableStream=h;function D(n){return v.newWriteableStream(g=>y.concat(g),n)}t.newWriteableBufferStream=D;function C(n,g){return v.prefixedReadable(n,g,S=>y.concat(S))}t.prefixedBufferReadable=C;function N(n,g){return v.prefixedStream(n,g,S=>y.concat(S))}t.prefixedBufferStream=N;function A(n){let g=0,S=0,$=0;const ie=new Uint8Array(Math.floor(n.length/4*3)),te=ae=>{switch(S){case 3:ie[$++]=g|ae,S=0;break;case 2:ie[$++]=g|ae>>>2,g=ae<<6,S=3;break;case 1:ie[$++]=g|ae>>>4,g=ae<<4,S=2;break;default:g=ae<<2,S=1}};for(let ae=0;ae<n.length;ae++){const ve=n.charCodeAt(ae);if(ve>=65&&ve<=90)te(ve-65);else if(ve>=97&&ve<=122)te(ve-97+26);else if(ve>=48&&ve<=57)te(ve-48+52);else if(ve===43||ve===45)te(62);else if(ve===47||ve===95)te(63);else{if(ve===61)break;throw new SyntaxError(`Unexpected base64 character ${n[ae]}`)}}const ge=$;for(;S>0;)te(0);return y.wrap(ie).slice(0,ge)}t.decodeBase64=A;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:n},g=!0,S=!1){const $=S?l:o;let ie="";const te=n.byteLength%3;let ge=0;for(;ge<n.byteLength-te;ge+=3){const ae=n[ge+0],ve=n[ge+1],he=n[ge+2];ie+=$[ae>>>2],ie+=$[(ae<<4|ve>>>4)&63],ie+=$[(ve<<2|he>>>6)&63],ie+=$[he&63]}if(te===1){const ae=n[ge+0];ie+=$[ae>>>2],ie+=$[ae<<4&63],g&&(ie+="==")}else if(te===2){const ae=n[ge+0],ve=n[ge+1];ie+=$[ae>>>2],ie+=$[(ae<<4|ve>>>4)&63],ie+=$[ve<<2&63],g&&(ie+="=")}return ie}t.encodeBase64=s}),define(pe[6],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.assertNever=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=t.isArray=void 0;function v(n){return Array.isArray(n)}t.isArray=v;function i(n){return typeof n=="string"}t.isString=i;function P(n){return Array.isArray(n)&&n.every(g=>i(g))}t.isStringArray=P;function M(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}t.isObject=M;function y(n){const g=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof g}t.isTypedArray=y;function w(n){return typeof n=="number"&&!isNaN(n)}t.isNumber=w;function p(n){return!!n&&typeof n[Symbol.iterator]=="function"}t.isIterable=p;function f(n){return n===!0||n===!1}t.isBoolean=f;function b(n){return typeof n=="undefined"}t.isUndefined=b;function T(n){return!a(n)}t.isDefined=T;function a(n){return b(n)||n===null}t.isUndefinedOrNull=a;function r(n,g){if(!n)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}t.assertType=r;function e(n){if(a(n))throw new Error("Assertion Failed: argument is undefined or null");return n}t.assertIsDefined=e;function c(...n){const g=[];for(let S=0;S<n.length;S++){const $=n[S];if(a($))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);g.push($)}return g}t.assertAllDefined=c;const m=Object.prototype.hasOwnProperty;function _(n){if(!M(n))return!1;for(const g in n)if(m.call(n,g))return!1;return!0}t.isEmptyObject=_;function E(n){return typeof n=="function"}t.isFunction=E;function u(...n){return n.length>0&&n.every(E)}t.areFunctions=u;function h(n,g){const S=Math.min(n.length,g.length);for(let $=0;$<S;$++)D(n[$],g[$])}t.validateConstraints=h;function D(n,g){if(i(g)){if(typeof n!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(E(g)){try{if(n instanceof g)return}catch{}if(!a(n)&&n.constructor===g||g.length===1&&g.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=D;function C(n){let g=[],S=Object.getPrototypeOf(n);for(;Object.prototype!==S;)g=g.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return g}t.getAllPropertyNames=C;function N(n){const g=[];for(const S of C(n))typeof n[S]=="function"&&g.push(S);return g}t.getAllMethodNames=N;function A(n,g){const S=ie=>function(){const te=Array.prototype.slice.call(arguments,0);return g(ie,te)},$={};for(const ie of n)$[ie]=S(ie);return $}t.createProxyObject=A;function o(n){return n===null?void 0:n}t.withNullAsUndefined=o;function l(n){return typeof n=="undefined"?null:n}t.withUndefinedAsNull=l;function s(n,g="Unreachable"){throw new Error(g)}t.assertNever=s}),define(pe[27],be([1,0,6]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function i(e){if(!e||typeof e!="object"||e instanceof RegExp)return e;const c=Array.isArray(e)?[]:{};return Object.keys(e).forEach(m=>{e[m]&&typeof e[m]=="object"?c[m]=i(e[m]):c[m]=e[m]}),c}t.deepClone=i;function P(e){if(!e||typeof e!="object")return e;const c=[e];for(;c.length>0;){const m=c.shift();Object.freeze(m);for(const _ in m)if(M.call(m,_)){const E=m[_];typeof E=="object"&&!Object.isFrozen(E)&&!(0,v.isTypedArray)(E)&&c.push(E)}}return e}t.deepFreeze=P;const M=Object.prototype.hasOwnProperty;function y(e,c){return w(e,c,new Set)}t.cloneAndChange=y;function w(e,c,m){if((0,v.isUndefinedOrNull)(e))return e;const _=c(e);if(typeof _!="undefined")return _;if((0,v.isArray)(e)){const E=[];for(const u of e)E.push(w(u,c,m));return E}if((0,v.isObject)(e)){if(m.has(e))throw new Error("Cannot clone recursive data-structure");m.add(e);const E={};for(const u in e)M.call(e,u)&&(E[u]=w(e[u],c,m));return m.delete(e),E}return e}function p(e,c,m=!0){return(0,v.isObject)(e)?((0,v.isObject)(c)&&Object.keys(c).forEach(_=>{_ in e?m&&((0,v.isObject)(e[_])&&(0,v.isObject)(c[_])?p(e[_],c[_],m):e[_]=c[_]):e[_]=c[_]}),e):c}t.mixin=p;function f(e,c){if(e===c)return!0;if(e==null||c===null||c===void 0||typeof e!=typeof c||typeof e!="object"||Array.isArray(e)!==Array.isArray(c))return!1;let m,_;if(Array.isArray(e)){if(e.length!==c.length)return!1;for(m=0;m<e.length;m++)if(!f(e[m],c[m]))return!1}else{const E=[];for(_ in e)E.push(_);E.sort();const u=[];for(_ in c)u.push(_);if(u.sort(),!f(E,u))return!1;for(m=0;m<E.length;m++)if(!f(e[E[m]],c[E[m]]))return!1}return!0}t.equals=f;function b(e){const c=new Set;return JSON.stringify(e,(m,_)=>{if((0,v.isObject)(_)||Array.isArray(_)){if(c.has(_))return"[Circular]";c.add(_)}return _})}t.safeStringify=b;function T(e,c){const m=Object.create(null);return!e||!c||Object.keys(c).forEach(E=>{const u=e[E],h=c[E];f(u,h)||(m[E]=h)}),m}t.distinct=T;function a(e,c){const m=c.toLowerCase(),_=Object.keys(e).find(E=>E.toLowerCase()===m);return _?e[_]:e[c]}t.getCaseInsensitive=a;function r(e,c){const m=Object.create(null);for(const[_,E]of Object.entries(e))c(_,E)&&(m[_]=E);return m}t.filter=r}),define(pe[80],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(pe[81],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class v{constructor(P,M){this.sender=P,this.onMessage=M}send(P){try{this.sender.send("vscode:message",P.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=v}),define(pe[46],be([7]),{}),define(pe[82],be([7]),{}),define(pe[83],be([7]),{}),define(pe[84],be([7]),{}),define(pe[85],be([1,0,11,83,84]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatRule=void 0;function i(P){let M=P.definition;for(;M instanceof v.Codicon;)M=M.definition;return`.codicon-${P.id}:before { content: '${M.fontCharacter}'; }`}t.formatRule=i}),define(pe[86],be([7]),{}),define(pe[87],be([7]),{}),define(pe[88],be([7]),{}),define(pe[89],be([7]),{}),define(pe[90],be([7]),{}),define(pe[91],be([7]),{}),define(pe[92],be([7]),{}),define(pe[93],be([7]),{}),define(pe[94],be([7]),{}),define(pe[95],be([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(pe[96],be([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/findinput/findInput",t)}),define(pe[97],be([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(pe[98],be([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(pe[99],be([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(pe[100],be([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(pe[101],be([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/tree/abstractTree",t)}),define(pe[102],be([12,9]),function(Z,t){return Z.create("vs/base/common/actions",t)}),define(pe[103],be([12,9]),function(Z,t){return Z.create("vs/base/common/platform",t)}),define(pe[5],be([1,0,103]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=void 0;const i="en";let P=!1,M=!1,y=!1,w=!1,p=!1,f=!1,b=!1,T=!1,a=!1,r,e=i,c,m;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let _;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?_=t.globals.vscode.process:typeof process!="undefined"&&(_=process);const E=typeof _?.versions?.electron=="string",u=E&&_?.type==="renderer";if(typeof navigator=="object"&&!u)m=navigator.userAgent,P=m.indexOf("Windows")>=0,M=m.indexOf("Macintosh")>=0,T=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=m.indexOf("Linux")>=0,f=!0,r=v.getConfiguredDefaultLocale(v.localize(0,null))||i,e=r;else if(typeof _=="object"){P=_.platform==="win32",M=_.platform==="darwin",y=_.platform==="linux",w=y&&!!_.env.SNAP&&!!_.env.SNAP_REVISION,b=E,a=!!_.env.CI||!!_.env.BUILD_ARTIFACTSTAGINGDIRECTORY,r=i,e=i;const n=_.env.VSCODE_NLS_CONFIG;if(n)try{const g=JSON.parse(n),S=g.availableLanguages["*"];r=g.locale,e=S||i,c=g._translationsConfigFile}catch{}p=!0}else console.error("Unable to resolve platform.");var h;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(h=t.Platform||(t.Platform={}));function D(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=D;let C=0;M?C=1:P?C=3:y&&(C=2),t.isWindows=P,t.isMacintosh=M,t.isLinux=y,t.isLinuxSnap=w,t.isNative=p,t.isElectron=b,t.isWeb=f,t.isWebWorker=f&&typeof t.globals.importScripts=="function",t.isIOS=T,t.isCI=a,t.platform=C,t.userAgent=m,t.language=e;var N;(function(n){function g(){return t.language}n.value=g;function S(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}n.isDefaultVariant=S;function $(){return t.language==="en"}n.isDefault=$})(N=t.Language||(t.Language={})),t.locale=r,t.translationsConfigFile=c,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const n=[];t.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let $=0,ie=n.length;$<ie;$++){const te=n[$];if(te.id===S.data.vscodeScheduleAsyncWork){n.splice($,1),te.callback();return}}});let g=0;return S=>{const $=++g;n.push({id:$,callback:S}),t.globals.postMessage({vscodeScheduleAsyncWork:$},"*")}}return n=>setTimeout(n)})();var A;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(A=t.OperatingSystem||(t.OperatingSystem={})),t.OS=M||T?2:P?1:3;let o=!0,l=!1;function s(){if(!l){l=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,o=new Uint16Array(n.buffer)[0]===(2<<8)+1}return o}t.isLittleEndian=s,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(pe[104],be([1,0,5]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const P=v.globals.vscode.process;i={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),define(pe[21],be([1,0,104]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,P=97,M=90,y=122,w=46,p=47,f=92,b=58,T=63;class a extends Error{constructor(h,D,C){let N;typeof D=="string"&&D.indexOf("not ")===0?(N="must not be",D=D.replace(/^not /,"")):N="must be";const A=h.indexOf(".")!==-1?"property":"argument";let o=`The "${h}" ${A} ${N} of type ${D}`;o+=`. Received type ${typeof C}`;super(o);this.code="ERR_INVALID_ARG_TYPE"}}function r(u,h){if(typeof u!="string")throw new a(h,"string",u)}function e(u){return u===p||u===f}function c(u){return u===p}function m(u){return u>=i&&u<=M||u>=P&&u<=y}function _(u,h,D,C){let N="",A=0,o=-1,l=0,s=0;for(let n=0;n<=u.length;++n){if(n<u.length)s=u.charCodeAt(n);else{if(C(s))break;s=p}if(C(s)){if(!(o===n-1||l===1))if(l===2){if(N.length<2||A!==2||N.charCodeAt(N.length-1)!==w||N.charCodeAt(N.length-2)!==w){if(N.length>2){const g=N.lastIndexOf(D);g===-1?(N="",A=0):(N=N.slice(0,g),A=N.length-1-N.lastIndexOf(D)),o=n,l=0;continue}else if(N.length!==0){N="",A=0,o=n,l=0;continue}}h&&(N+=N.length>0?`${D}..`:"..",A=2)}else N.length>0?N+=`${D}${u.slice(o+1,n)}`:N=u.slice(o+1,n),A=n-o-1;o=n,l=0}else s===w&&l!==-1?++l:l=-1}return N}function E(u,h){if(h===null||typeof h!="object")throw new a("pathObject","Object",h);const D=h.dir||h.root,C=h.base||`${h.name||""}${h.ext||""}`;return D?D===h.root?`${D}${C}`:`${D}${u}${C}`:C}t.win32={resolve(...u){let h="",D="",C=!1;for(let N=u.length-1;N>=-1;N--){let A;if(N>=0){if(A=u[N],r(A,"path"),A.length===0)continue}else h.length===0?A=v.cwd():(A=v.env[`=${h}`]||v.cwd(),(A===void 0||A.slice(0,2).toLowerCase()!==h.toLowerCase()&&A.charCodeAt(2)===f)&&(A=`${h}\\`));const o=A.length;let l=0,s="",n=!1;const g=A.charCodeAt(0);if(o===1)e(g)&&(l=1,n=!0);else if(e(g))if(n=!0,e(A.charCodeAt(1))){let S=2,$=S;for(;S<o&&!e(A.charCodeAt(S));)S++;if(S<o&&S!==$){const ie=A.slice($,S);for($=S;S<o&&e(A.charCodeAt(S));)S++;if(S<o&&S!==$){for($=S;S<o&&!e(A.charCodeAt(S));)S++;(S===o||S!==$)&&(s=`\\\\${ie}\\${A.slice($,S)}`,l=S)}}}else l=1;else m(g)&&A.charCodeAt(1)===b&&(s=A.slice(0,2),l=2,o>2&&e(A.charCodeAt(2))&&(n=!0,l=3));if(s.length>0)if(h.length>0){if(s.toLowerCase()!==h.toLowerCase())continue}else h=s;if(C){if(h.length>0)break}else if(D=`${A.slice(l)}\\${D}`,C=n,n&&h.length>0)break}return D=_(D,!C,"\\",e),C?`${h}\\${D}`:`${h}${D}`||"."},normalize(u){r(u,"path");const h=u.length;if(h===0)return".";let D=0,C,N=!1;const A=u.charCodeAt(0);if(h===1)return c(A)?"\\":u;if(e(A))if(N=!0,e(u.charCodeAt(1))){let l=2,s=l;for(;l<h&&!e(u.charCodeAt(l));)l++;if(l<h&&l!==s){const n=u.slice(s,l);for(s=l;l<h&&e(u.charCodeAt(l));)l++;if(l<h&&l!==s){for(s=l;l<h&&!e(u.charCodeAt(l));)l++;if(l===h)return`\\\\${n}\\${u.slice(s)}\\`;l!==s&&(C=`\\\\${n}\\${u.slice(s,l)}`,D=l)}}}else D=1;else m(A)&&u.charCodeAt(1)===b&&(C=u.slice(0,2),D=2,h>2&&e(u.charCodeAt(2))&&(N=!0,D=3));let o=D<h?_(u.slice(D),!N,"\\",e):"";return o.length===0&&!N&&(o="."),o.length>0&&e(u.charCodeAt(h-1))&&(o+="\\"),C===void 0?N?`\\${o}`:o:N?`${C}\\${o}`:`${C}${o}`},isAbsolute(u){r(u,"path");const h=u.length;if(h===0)return!1;const D=u.charCodeAt(0);return e(D)||h>2&&m(D)&&u.charCodeAt(1)===b&&e(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let h,D;for(let A=0;A<u.length;++A){const o=u[A];r(o,"path"),o.length>0&&(h===void 0?h=D=o:h+=`\\${o}`)}if(h===void 0)return".";let C=!0,N=0;if(typeof D=="string"&&e(D.charCodeAt(0))){++N;const A=D.length;A>1&&e(D.charCodeAt(1))&&(++N,A>2&&(e(D.charCodeAt(2))?++N:C=!1))}if(C){for(;N<h.length&&e(h.charCodeAt(N));)N++;N>=2&&(h=`\\${h.slice(N)}`)}return t.win32.normalize(h)},relative(u,h){if(r(u,"from"),r(h,"to"),u===h)return"";const D=t.win32.resolve(u),C=t.win32.resolve(h);if(D===C||(u=D.toLowerCase(),h=C.toLowerCase(),u===h))return"";let N=0;for(;N<u.length&&u.charCodeAt(N)===f;)N++;let A=u.length;for(;A-1>N&&u.charCodeAt(A-1)===f;)A--;const o=A-N;let l=0;for(;l<h.length&&h.charCodeAt(l)===f;)l++;let s=h.length;for(;s-1>l&&h.charCodeAt(s-1)===f;)s--;const n=s-l,g=o<n?o:n;let S=-1,$=0;for(;$<g;$++){const te=u.charCodeAt(N+$);if(te!==h.charCodeAt(l+$))break;te===f&&(S=$)}if($!==g){if(S===-1)return C}else{if(n>g){if(h.charCodeAt(l+$)===f)return C.slice(l+$+1);if($===2)return C.slice(l+$)}o>g&&(u.charCodeAt(N+$)===f?S=$:$===2&&(S=3)),S===-1&&(S=0)}let ie="";for($=N+S+1;$<=A;++$)($===A||u.charCodeAt($)===f)&&(ie+=ie.length===0?"..":"\\..");return l+=S,ie.length>0?`${ie}${C.slice(l,s)}`:(C.charCodeAt(l)===f&&++l,C.slice(l,s))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const h=t.win32.resolve(u);if(h.length<=2)return u;if(h.charCodeAt(0)===f){if(h.charCodeAt(1)===f){const D=h.charCodeAt(2);if(D!==T&&D!==w)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(m(h.charCodeAt(0))&&h.charCodeAt(1)===b&&h.charCodeAt(2)===f)return`\\\\?\\${h}`;return u},dirname(u){r(u,"path");const h=u.length;if(h===0)return".";let D=-1,C=0;const N=u.charCodeAt(0);if(h===1)return e(N)?u:".";if(e(N)){if(D=C=1,e(u.charCodeAt(1))){let l=2,s=l;for(;l<h&&!e(u.charCodeAt(l));)l++;if(l<h&&l!==s){for(s=l;l<h&&e(u.charCodeAt(l));)l++;if(l<h&&l!==s){for(s=l;l<h&&!e(u.charCodeAt(l));)l++;if(l===h)return u;l!==s&&(D=C=l+1)}}}}else m(N)&&u.charCodeAt(1)===b&&(D=h>2&&e(u.charCodeAt(2))?3:2,C=D);let A=-1,o=!0;for(let l=h-1;l>=C;--l)if(e(u.charCodeAt(l))){if(!o){A=l;break}}else o=!1;if(A===-1){if(D===-1)return".";A=D}return u.slice(0,A)},basename(u,h){h!==void 0&&r(h,"ext"),r(u,"path");let D=0,C=-1,N=!0,A;if(u.length>=2&&m(u.charCodeAt(0))&&u.charCodeAt(1)===b&&(D=2),h!==void 0&&h.length>0&&h.length<=u.length){if(h===u)return"";let o=h.length-1,l=-1;for(A=u.length-1;A>=D;--A){const s=u.charCodeAt(A);if(e(s)){if(!N){D=A+1;break}}else l===-1&&(N=!1,l=A+1),o>=0&&(s===h.charCodeAt(o)?--o==-1&&(C=A):(o=-1,C=l))}return D===C?C=l:C===-1&&(C=u.length),u.slice(D,C)}for(A=u.length-1;A>=D;--A)if(e(u.charCodeAt(A))){if(!N){D=A+1;break}}else C===-1&&(N=!1,C=A+1);return C===-1?"":u.slice(D,C)},extname(u){r(u,"path");let h=0,D=-1,C=0,N=-1,A=!0,o=0;u.length>=2&&u.charCodeAt(1)===b&&m(u.charCodeAt(0))&&(h=C=2);for(let l=u.length-1;l>=h;--l){const s=u.charCodeAt(l);if(e(s)){if(!A){C=l+1;break}continue}N===-1&&(A=!1,N=l+1),s===w?D===-1?D=l:o!==1&&(o=1):D!==-1&&(o=-1)}return D===-1||N===-1||o===0||o===1&&D===N-1&&D===C+1?"":u.slice(D,N)},format:E.bind(null,"\\"),parse(u){r(u,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return h;const D=u.length;let C=0,N=u.charCodeAt(0);if(D===1)return e(N)?(h.root=h.dir=u,h):(h.base=h.name=u,h);if(e(N)){if(C=1,e(u.charCodeAt(1))){let S=2,$=S;for(;S<D&&!e(u.charCodeAt(S));)S++;if(S<D&&S!==$){for($=S;S<D&&e(u.charCodeAt(S));)S++;if(S<D&&S!==$){for($=S;S<D&&!e(u.charCodeAt(S));)S++;S===D?C=S:S!==$&&(C=S+1)}}}}else if(m(N)&&u.charCodeAt(1)===b){if(D<=2)return h.root=h.dir=u,h;if(C=2,e(u.charCodeAt(2))){if(D===3)return h.root=h.dir=u,h;C=3}}C>0&&(h.root=u.slice(0,C));let A=-1,o=C,l=-1,s=!0,n=u.length-1,g=0;for(;n>=C;--n){if(N=u.charCodeAt(n),e(N)){if(!s){o=n+1;break}continue}l===-1&&(s=!1,l=n+1),N===w?A===-1?A=n:g!==1&&(g=1):A!==-1&&(g=-1)}return l!==-1&&(A===-1||g===0||g===1&&A===l-1&&A===o+1?h.base=h.name=u.slice(o,l):(h.name=u.slice(o,A),h.base=u.slice(o,l),h.ext=u.slice(A,l))),o>0&&o!==C?h.dir=u.slice(0,o-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...u){let h="",D=!1;for(let C=u.length-1;C>=-1&&!D;C--){const N=C>=0?u[C]:v.cwd();r(N,"path"),N.length!==0&&(h=`${N}/${h}`,D=N.charCodeAt(0)===p)}return h=_(h,!D,"/",c),D?`/${h}`:h.length>0?h:"."},normalize(u){if(r(u,"path"),u.length===0)return".";const h=u.charCodeAt(0)===p,D=u.charCodeAt(u.length-1)===p;return u=_(u,!h,"/",c),u.length===0?h?"/":D?"./":".":(D&&(u+="/"),h?`/${u}`:u)},isAbsolute(u){return r(u,"path"),u.length>0&&u.charCodeAt(0)===p},join(...u){if(u.length===0)return".";let h;for(let D=0;D<u.length;++D){const C=u[D];r(C,"path"),C.length>0&&(h===void 0?h=C:h+=`/${C}`)}return h===void 0?".":t.posix.normalize(h)},relative(u,h){if(r(u,"from"),r(h,"to"),u===h||(u=t.posix.resolve(u),h=t.posix.resolve(h),u===h))return"";const D=1,C=u.length,N=C-D,A=1,o=h.length-A,l=N<o?N:o;let s=-1,n=0;for(;n<l;n++){const S=u.charCodeAt(D+n);if(S!==h.charCodeAt(A+n))break;S===p&&(s=n)}if(n===l)if(o>l){if(h.charCodeAt(A+n)===p)return h.slice(A+n+1);if(n===0)return h.slice(A+n)}else N>l&&(u.charCodeAt(D+n)===p?s=n:n===0&&(s=0));let g="";for(n=D+s+1;n<=C;++n)(n===C||u.charCodeAt(n)===p)&&(g+=g.length===0?"..":"/..");return`${g}${h.slice(A+s)}`},toNamespacedPath(u){return u},dirname(u){if(r(u,"path"),u.length===0)return".";const h=u.charCodeAt(0)===p;let D=-1,C=!0;for(let N=u.length-1;N>=1;--N)if(u.charCodeAt(N)===p){if(!C){D=N;break}}else C=!1;return D===-1?h?"/":".":h&&D===1?"//":u.slice(0,D)},basename(u,h){h!==void 0&&r(h,"ext"),r(u,"path");let D=0,C=-1,N=!0,A;if(h!==void 0&&h.length>0&&h.length<=u.length){if(h===u)return"";let o=h.length-1,l=-1;for(A=u.length-1;A>=0;--A){const s=u.charCodeAt(A);if(s===p){if(!N){D=A+1;break}}else l===-1&&(N=!1,l=A+1),o>=0&&(s===h.charCodeAt(o)?--o==-1&&(C=A):(o=-1,C=l))}return D===C?C=l:C===-1&&(C=u.length),u.slice(D,C)}for(A=u.length-1;A>=0;--A)if(u.charCodeAt(A)===p){if(!N){D=A+1;break}}else C===-1&&(N=!1,C=A+1);return C===-1?"":u.slice(D,C)},extname(u){r(u,"path");let h=-1,D=0,C=-1,N=!0,A=0;for(let o=u.length-1;o>=0;--o){const l=u.charCodeAt(o);if(l===p){if(!N){D=o+1;break}continue}C===-1&&(N=!1,C=o+1),l===w?h===-1?h=o:A!==1&&(A=1):h!==-1&&(A=-1)}return h===-1||C===-1||A===0||A===1&&h===C-1&&h===D+1?"":u.slice(h,C)},format:E.bind(null,"/"),parse(u){r(u,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return h;const D=u.charCodeAt(0)===p;let C;D?(h.root="/",C=1):C=0;let N=-1,A=0,o=-1,l=!0,s=u.length-1,n=0;for(;s>=C;--s){const g=u.charCodeAt(s);if(g===p){if(!l){A=s+1;break}continue}o===-1&&(l=!1,o=s+1),g===w?N===-1?N=s:n!==1&&(n=1):N!==-1&&(n=-1)}if(o!==-1){const g=A===0&&D?1:A;N===-1||n===0||n===1&&N===o-1&&N===A+1?h.base=h.name=u.slice(g,o):(h.name=u.slice(g,N),h.base=u.slice(g,o),h.ext=u.slice(N,o))}return A>0?h.dir=u.slice(0,A-1):D&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=v.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=v.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=v.platform==="win32"?t.win32.join:t.posix.join,t.resolve=v.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=v.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=v.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=v.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=v.platform==="win32"?t.win32.extname:t.posix.extname,t.format=v.platform==="win32"?t.win32.format:t.posix.format,t.parse=v.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=v.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=v.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=v.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),define(pe[105],be([1,0,21]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(b){const T=(0,v.extname)(b),a=i[T.toLowerCase()];return a!==void 0?a:y(b)}t.getMediaOrTextMime=M;function y(b){const T=(0,v.extname)(b);return P[T.toLowerCase()]}t.getMediaMime=y;function w(b){for(const T in P)if(P[T]===b)return T}t.getExtensionForMimeType=w;const p=/^(.+)\/(.+?)(;.+)?$/;function f(b,T){const a=p.exec(b);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:T?void 0:b}t.normalizeMimeType=f}),define(pe[106],be([1,0,5]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=v.globals.performance&&typeof v.globals.performance.now=="function";class P{constructor(y){this._highResolution=i&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new P(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}t.StopWatch=P}),define(pe[3],be([1,0,13,42,2,74,106]),function(Z,t,v,i,P,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;const w=!1,p=!1;var f;(function(s){s.None=()=>P.Disposable.None;function n(d){if(p){const{onListenerDidAdd:L}=d,U=e.create();let q=0;d.onListenerDidAdd=()=>{++q==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),L?.()}}}function g(d){return(L,U=null,q)=>{let H=!1,R;return R=d(W=>{if(!H)return R?R.dispose():H=!0,L.call(U,W)},null,q),H&&R.dispose(),R}}s.once=g;function S(d,L,U){return ve((q,H=null,R)=>d(W=>q.call(H,L(W)),null,R),U)}s.map=S;function $(d,L,U){return ve((q,H=null,R)=>d(W=>{L(W),q.call(H,W)},null,R),U)}s.forEach=$;function ie(d,L,U){return ve((q,H=null,R)=>d(W=>L(W)&&q.call(H,W),null,R),U)}s.filter=ie;function te(d){return d}s.signal=te;function ge(...d){return(L,U=null,q)=>(0,P.combinedDisposable)(...d.map(H=>H(R=>L.call(U,R),null,q)))}s.any=ge;function ae(d,L,U,q){let H=U;return S(d,R=>(H=L(H,R),H),q)}s.reduce=ae;function ve(d,L){let U;const q={onFirstListenerAdd(){U=d(H.fire,H)},onLastListenerRemove(){U?.dispose()}};L||n(q);const H=new m(q);return L?.add(H),H.event}function he(d,L,U=100,q=!1,H,R){let W,V,I,z=0;const k={leakWarningThreshold:H,onFirstListenerAdd(){W=d(j=>{z++,V=L(V,j),q&&!I&&(B.fire(V),V=void 0),clearTimeout(I),I=setTimeout(()=>{const ee=V;V=void 0,I=void 0,(!q||z>1)&&B.fire(ee),z=0},U)})},onLastListenerRemove(){W.dispose()}};R||n(k);const B=new m(k);return R?.add(B),B.event}s.debounce=he;function me(d,L=(q,H)=>q===H,U){let q=!0,H;return ie(d,R=>{const W=q||!L(R,H);return q=!1,H=R,W},U)}s.latch=me;function ye(d,L,U){return[s.filter(d,L,U),s.filter(d,q=>!L(q),U)]}s.split=ye;function J(d,L=!1,U=[]){let q=U.slice(),H=d(V=>{q?q.push(V):W.fire(V)});const R=()=>{q?.forEach(V=>W.fire(V)),q=null},W=new m({onFirstListenerAdd(){H||(H=d(V=>W.fire(V)))},onFirstListenerDidAdd(){q&&(L?setTimeout(R):R())},onLastListenerRemove(){H&&H.dispose(),H=null}});return W.event}s.buffer=J;class de{constructor(L){this.event=L,this.disposables=new P.DisposableStore}map(L){return new de(S(this.event,L,this.disposables))}forEach(L){return new de($(this.event,L,this.disposables))}filter(L){return new de(ie(this.event,L,this.disposables))}reduce(L,U){return new de(ae(this.event,L,U,this.disposables))}latch(){return new de(me(this.event,void 0,this.disposables))}debounce(L,U=100,q=!1,H){return new de(he(this.event,L,U,q,H,this.disposables))}on(L,U,q){return this.event(L,U,q)}once(L,U,q){return g(this.event)(L,U,q)}dispose(){this.disposables.dispose()}}function ne(d){return new de(d)}s.chain=ne;function Q(d,L,U=q=>q){const q=(...V)=>W.fire(U(...V)),H=()=>d.on(L,q),R=()=>d.removeListener(L,q),W=new m({onFirstListenerAdd:H,onLastListenerRemove:R});return W.event}s.fromNodeEventEmitter=Q;function re(d,L,U=q=>q){const q=(...V)=>W.fire(U(...V)),H=()=>d.addEventListener(L,q),R=()=>d.removeEventListener(L,q),W=new m({onFirstListenerAdd:H,onLastListenerRemove:R});return W.event}s.fromDOMEventEmitter=re;function se(d){return new Promise(L=>g(d)(L))}s.toPromise=se;function F(d,L){return L(void 0),d(U=>L(U))}s.runAndSubscribe=F;function K(d,L){let U=null;function q(R){U?.dispose(),U=new P.DisposableStore,L(R,U)}q(void 0);const H=d(R=>q(R));return(0,P.toDisposable)(()=>{H.dispose(),U?.dispose()})}s.runAndSubscribeWithStore=K;class X{constructor(L,U){this.obs=L,this._counter=0,this._hasChanged=!1;const q={onFirstListenerAdd:()=>{L.addObserver(this)},onLastListenerRemove:()=>{L.removeObserver(this)}};U||n(q),this.emitter=new m(q),U&&U.add(this.emitter)}beginUpdate(L){this._counter++}handleChange(L,U){this._hasChanged=!0}endUpdate(L){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function O(d,L){return new X(d,L).emitter.event}s.fromObservable=O})(f=t.Event||(t.Event={}));class b{constructor(n){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${n}_${b._idPool++}`}start(n){this._stopWatch=new y.StopWatch(!0),this._listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this._elapsedOverall+=n,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${n.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}b._idPool=0;let T=-1;function a(s){const n=T;return T=s,{dispose(){T=n}}}t.setGlobalLeakWarningThreshold=a;class r{constructor(n,g=Math.random().toString(18).slice(2,5)){this.customThreshold=n,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(n,g){let S=T;if(typeof this.customThreshold=="number"&&(S=this.customThreshold),S<=0||g<S)return;this._stacks||(this._stacks=new Map);const $=this._stacks.get(n.value)||0;if(this._stacks.set(n.value,$+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=S*.5;let ie,te=0;for(const[ge,ae]of this._stacks)(!ie||te<ae)&&(ie=ge,te=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${te}):`),console.warn(ie)}return()=>{const ie=this._stacks.get(n.value)||0;this._stacks.set(n.value,ie-1)}}}class e{constructor(n){this.value=n}static create(){return new e(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class c{constructor(n,g,S){this.callback=n,this.callbackThis=g,this.stack=S,this.subscription=new P.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class m{constructor(n){this._disposed=!1,this._options=n,this._leakageMon=T>0?new r(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(w){const n=Array.from(this._listeners);queueMicrotask(()=>{for(const g of n)g.subscription.isset()&&(g.subscription.unset(),g.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(n,g,S)=>{this._listeners||(this._listeners=new M.LinkedList);const $=this._listeners.isEmpty();$&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let ie,te;this._leakageMon&&this._listeners.size>=30&&(te=e.create(),ie=this._leakageMon.check(te,this._listeners.size+1)),w&&(te=te??e.create());const ge=new c(n,g,te),ae=this._listeners.push(ge);$&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,n,g);const ve=ge.subscription.set(()=>{ie?.(),this._disposed||(ae(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof P.DisposableStore?S.add(ve):Array.isArray(S)&&S.push(ve),ve}),this._event}fire(n){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E);for(const g of this._listeners)this._deliveryQueue.push(this,g,n);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}t.Emitter=m;class _{constructor(){this._queue=new M.LinkedList}get size(){return this._queue.size}push(n,g,S){this._queue.push(new u(n,g,S))}clear(n){const g=new M.LinkedList;for(const S of this._queue)S.emitter!==n&&g.push(S);this._queue=g}deliver(){for(;this._queue.size>0;){const n=this._queue.shift();try{n.listener.invoke(n.event)}catch(g){(0,v.onUnexpectedError)(g)}}}}t.EventDeliveryQueue=_;class E extends _{clear(n){this._queue.clear()}}class u{constructor(n,g,S){this.emitter=n,this.listener=g,this.event=S}}class h extends m{async fireAsync(n,g,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const $ of this._listeners)this._asyncDeliveryQueue.push([$,n]);for(;this._asyncDeliveryQueue.size>0&&!g.isCancellationRequested;){const[$,ie]=this._asyncDeliveryQueue.shift(),te=[],ge={...ie,token:g,waitUntil:ae=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");S&&(ae=S(ae,$.callback)),te.push(ae)}};try{$.invoke(ge)}catch(ae){(0,v.onUnexpectedError)(ae);continue}Object.freeze(te),await Promise.allSettled(te).then(ae=>{for(const ve of ae)ve.status==="rejected"&&(0,v.onUnexpectedError)(ve.reason)})}}}}t.AsyncEmitter=h;class D extends m{constructor(n){super(n);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=n?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}t.PauseableEmitter=D;class C extends D{constructor(n){super(n);this._delay=n.delay??100}fire(n){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(n)}}t.DebounceEmitter=C;class N extends m{constructor(n){super(n);this._queuedEvents=[],this._mergeFn=n?.merge}fire(n){this._queuedEvents.push(n),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(g=>super.fire(g)),this._queuedEvents=[]})}}t.MicrotaskEmitter=N;class A{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const g={event:n,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const S=()=>{this.hasListeners&&this.unhook(g);const $=this.events.indexOf(g);this.events.splice($,1)};return(0,P.toDisposable)((0,i.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(g=>this.emitter.fire(g))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=A;class o{constructor(){this.buffers=[]}wrapEvent(n){return(g,S,$)=>n(ie=>{const te=this.buffers[this.buffers.length-1];te?te.push(()=>g.call(S,ie)):g.call(S,ie)},void 0,$)}bufferEvents(n){const g=[];this.buffers.push(g);const S=n();return this.buffers.pop(),g.forEach($=>$()),S}}t.EventBufferer=o;class l{constructor(){this.listening=!1,this.inputEvent=f.None,this.inputEventListener=P.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=l}),define(pe[15],be([1,0,3,2]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class P{constructor(){this._zoomLevel=0,this._zoomFactor=1,this._fullscreen=!1,this._onDidChangeFullscreen=new v.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event}getZoomLevel(){return this._zoomLevel}setZoomLevel(u,h){this._zoomLevel!==u&&(this._zoomLevel=u)}getZoomFactor(){return this._zoomFactor}setZoomFactor(u){this._zoomFactor=u}setFullscreen(u){this._fullscreen!==u&&(this._fullscreen=u,this._onDidChangeFullscreen.fire())}isFullscreen(){return this._fullscreen}}P.INSTANCE=new P;class M extends i.Disposable{constructor(){super();this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this._listener=()=>this._handleChange(!0),this._mediaQueryList=null,this._handleChange(!1)}_handleChange(u){this._mediaQueryList?.removeEventListener("change",this._listener),this._mediaQueryList=matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this._mediaQueryList.addEventListener("change",this._listener),u&&this._onDidChange.fire()}}class y extends i.Disposable{constructor(){super();this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this._value=this._getPixelRatio();const u=this._register(new M);this._register(u.onDidChange(()=>{this._value=this._getPixelRatio(),this._onDidChange.fire(this._value)}))}get value(){return this._value}_getPixelRatio(){const u=document.createElement("canvas").getContext("2d"),h=window.devicePixelRatio||1,D=u.webkitBackingStorePixelRatio||u.mozBackingStorePixelRatio||u.msBackingStorePixelRatio||u.oBackingStorePixelRatio||u.backingStorePixelRatio||1;return h/D}}class w{constructor(){this._pixelRatioMonitor=null}_getOrCreatePixelRatioMonitor(){return this._pixelRatioMonitor||(this._pixelRatioMonitor=(0,i.markAsSingleton)(new y)),this._pixelRatioMonitor}get value(){return this._getOrCreatePixelRatioMonitor().value}get onDidChange(){return this._getOrCreatePixelRatioMonitor().onDidChange}}function p(E,u){typeof E=="string"&&(E=window.matchMedia(E)),E.addEventListener("change",u)}t.addMatchMediaChangeListener=p,t.PixelRatio=new w;function f(E,u){P.INSTANCE.setZoomLevel(E,u)}t.setZoomLevel=f;function b(){return P.INSTANCE.getZoomLevel()}t.getZoomLevel=b;function T(){return P.INSTANCE.getZoomFactor()}t.getZoomFactor=T;function a(E){P.INSTANCE.setZoomFactor(E)}t.setZoomFactor=a;function r(E){P.INSTANCE.setFullscreen(E)}t.setFullscreen=r;function e(){return P.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=P.INSTANCE.onDidChangeFullscreen;const c=navigator.userAgent;t.isFirefox=c.indexOf("Firefox")>=0,t.isWebKit=c.indexOf("AppleWebKit")>=0,t.isChrome=c.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&c.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=c.indexOf("Electron/")>=0,t.isAndroid=c.indexOf("Android")>=0;let m=!1;if(window.matchMedia){const E=window.matchMedia("(display-mode: standalone)");m=E.matches,p(E,({matches:u})=>{m=u})}function _(){return m}t.isStandalone=_}),define(pe[107],be([1,0,15,5]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var P;(function(M){M[M.Always=0]="Always",M[M.FullScreen=1]="FullScreen",M[M.None=2]="None"})(P=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:i.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.isNative||v.isStandalone()?0:navigator.keyboard||v.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(pe[18],be([1,0,3]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.stop=t.stopEvent=t.DomEmitter=void 0;class i{constructor(w,p,f){const b=T=>this.emitter.fire(T);this.emitter=new v.Emitter({onFirstListenerAdd:()=>w.addEventListener(p,b,f),onLastListenerRemove:()=>w.removeEventListener(p,b,f)})}get event(){return this.emitter.event}dispose(){this.emitter.dispose()}}t.DomEmitter=i;function P(y){return y.preventDefault(),y.stopPropagation(),y}t.stopEvent=P;function M(y){return v.Event.map(y,P)}t.stop=M}),define(pe[19],be([1,0,15,43,72,5]),function(Z,t,v,i,P,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function y(e){if(e.charCode){const m=String.fromCharCode(e.charCode).toUpperCase();return i.KeyCodeUtils.fromString(m)}const c=e.keyCode;if(c===3)return 7;if(v.isFirefox){if(c===59)return 80;if(c===107)return 81;if(c===109)return 83;if(M.isMacintosh&&c===224)return 57}else if(v.isWebKit){if(c===91)return 57;if(M.isMacintosh&&c===93)return 57;if(!M.isMacintosh&&c===92)return 57}return i.EVENT_KEY_CODE_MAP[c]||0}const w=M.isMacintosh?256:2048,p=512,f=1024,b=M.isMacintosh?2048:256;function T(e){const c=[];return e.ctrlKey&&c.push("ctrl"),e.shiftKey&&c.push("shift"),e.altKey&&c.push("alt"),e.metaKey&&c.push("meta"),`modifiers: [${c.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=T;function a(e){const c=[];return e.ctrlKey&&c.push("ctrl"),e.shiftKey&&c.push("shift"),e.altKey&&c.push("alt"),e.metaKey&&c.push("meta"),`modifiers: [${c.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${i.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=a;class r{constructor(c){this._standardKeyboardEventBrand=!0;const m=c;this.browserEvent=m,this.target=m.target,this.ctrlKey=m.ctrlKey,this.shiftKey=m.shiftKey,this.altKey=m.altKey,this.metaKey=m.metaKey,this.keyCode=y(m),this.code=m.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asRuntimeKeybinding=this._computeRuntimeKeybinding()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeybinding(){return this._asRuntimeKeybinding}equals(c){return this._asKeybinding===c}_computeKeybinding(){let c=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(c=this.keyCode);let m=0;return this.ctrlKey&&(m|=w),this.altKey&&(m|=p),this.shiftKey&&(m|=f),this.metaKey&&(m|=b),m|=c,m}_computeRuntimeKeybinding(){let c=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(c=this.keyCode),new P.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,c)}}t.StandardKeyboardEvent=r}),define(pe[20],be([1,0,15,65,5]),function(Z,t,v,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class M{constructor(f){this.timestamp=Date.now(),this.browserEvent=f,this.leftButton=f.button===0,this.middleButton=f.button===1,this.rightButton=f.button===2,this.buttons=f.buttons,this.target=f.target,this.detail=f.detail||1,f.type==="dblclick"&&(this.detail=2),this.ctrlKey=f.ctrlKey,this.shiftKey=f.shiftKey,this.altKey=f.altKey,this.metaKey=f.metaKey,typeof f.pageX=="number"?(this.posx=f.pageX,this.posy=f.pageY):(this.posx=f.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=f.clientY+document.body.scrollTop+document.documentElement.scrollTop);const b=i.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,f.view);this.posx-=b.left,this.posy-=b.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=M;class y extends M{constructor(f){super(f);this.dataTransfer=f.dataTransfer}}t.DragMouseEvent=y;class w{constructor(f,b=0,T=0){if(this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=T,this.deltaX=b,f){const a=f,r=f;if(typeof a.wheelDeltaY!="undefined")this.deltaY=a.wheelDeltaY/120;else if(typeof r.VERTICAL_AXIS!="undefined"&&r.axis===r.VERTICAL_AXIS)this.deltaY=-r.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?v.isFirefox&&!P.isMacintosh?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof a.wheelDeltaX!="undefined")v.isSafari&&P.isWindows?this.deltaX=-(a.wheelDeltaX/120):this.deltaX=a.wheelDeltaX/120;else if(typeof r.HORIZONTAL_AXIS!="undefined"&&r.axis===r.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?v.isFirefox&&!P.isMacintosh?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&(this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation()}}t.StandardWheelEvent=w}),define(pe[32],be([1,0,3,2,102]),function(Z,t,v,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class M extends i.Disposable{constructor(a,r="",e="",c=!0,m){super();this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=a,this._label=r,this._cssClass=e,this._enabled=c,this._actionCallback=m}get id(){return this._id}get label(){return this._label}set label(a){this._setLabel(a)}_setLabel(a){this._label!==a&&(this._label=a,this._onDidChange.fire({label:a}))}get tooltip(){return this._tooltip||""}set tooltip(a){this._setTooltip(a)}_setTooltip(a){this._tooltip!==a&&(this._tooltip=a,this._onDidChange.fire({tooltip:a}))}get class(){return this._cssClass}set class(a){this._setClass(a)}_setClass(a){this._cssClass!==a&&(this._cssClass=a,this._onDidChange.fire({class:a}))}get enabled(){return this._enabled}set enabled(a){this._setEnabled(a)}_setEnabled(a){this._enabled!==a&&(this._enabled=a,this._onDidChange.fire({enabled:a}))}get checked(){return this._checked}set checked(a){this._setChecked(a)}_setChecked(a){this._checked!==a&&(this._checked=a,this._onDidChange.fire({checked:a}))}async run(a,r){this._actionCallback&&await this._actionCallback(a)}}t.Action=M;class y extends i.Disposable{constructor(){super(...arguments);this._onBeforeRun=this._register(new v.Emitter),this.onBeforeRun=this._onBeforeRun.event,this._onDidRun=this._register(new v.Emitter),this.onDidRun=this._onDidRun.event}async run(a,r){if(!a.enabled)return;this._onBeforeRun.fire({action:a});let e;try{await this.runAction(a,r)}catch(c){e=c}this._onDidRun.fire({action:a,error:e})}async runAction(a,r){await a.run(r)}}t.ActionRunner=y;class w extends M{constructor(a){super(w.ID,a,a?"separator text":"separator");this.checked=!1,this.enabled=!1}static join(...a){let r=[];for(const e of a)e.length&&(r.length?r=[...r,new w,...e]:r=e);return r}}t.Separator=w,w.ID="vs.actions.separator";class p{constructor(a,r,e,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=r,this.class=c,this._actions=e}get actions(){return this._actions}dispose(){}async run(){}}t.SubmenuAction=p;class f extends M{constructor(){super(f.ID,P.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=f,f.ID="vs.actions.empty";function b(T){return{id:T.id,label:T.label,class:void 0,enabled:T.enabled??!0,checked:T.checked??!1,run:async()=>T.run(),tooltip:T.label,dispose:()=>{}}}t.toAction=b}),define(pe[28],be([1,0,3]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze(function(w,p){const f=setTimeout(w.bind(p),0);return{dispose(){clearTimeout(f)}}});var P;(function(w){function p(f){return f===w.None||f===w.Cancelled||f instanceof M?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}w.isCancellationToken=p,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(P=t.CancellationToken||(t.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=P.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=P.None}}t.CancellationTokenSource=y}),define(pe[108],be([1,0,28]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class i{constructor(w){this.task=w,this.result=null}get(){if(this.result)return this.result;const w=new v.CancellationTokenSource,p=this.task(w.token);return this.result={promise:p,dispose:()=>{this.result=null,w.cancel(),w.dispose()}},this.result}}t.Cache=i;class P{constructor(w){this.fn=w,this.lastCache=void 0,this.lastArgKey=void 0}get(w){const p=JSON.stringify(w);return this.lastArgKey!==p&&(this.lastArgKey=p,this.lastCache=this.fn(w)),this.lastCache}}t.LRUCachedFunction=P;class M{constructor(w){this.fn=w,this._map=new Map}get cachedValues(){return this._map}get(w){if(this._map.has(w))return this._map.get(w);const p=this.fn(w);return this._map.set(w,p),p}}t.CachedFunction=M}),define(pe[47],be([1,0,3,2]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var P;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(P=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class M{constructor(e,c,m,_,E,u,h){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(c=c|0,m=m|0,_=_|0,E=E|0,u=u|0,h=h|0),this.rawScrollLeft=_,this.rawScrollTop=h,c<0&&(c=0),_+c>m&&(_=m-c),_<0&&(_=0),E<0&&(E=0),h+E>u&&(h=u-E),h<0&&(h=0),this.width=c,this.scrollWidth=m,this.scrollLeft=_,this.height=E,this.scrollHeight=u,this.scrollTop=h}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,c){return new M(this._forceIntegerValues,typeof e.width!="undefined"?e.width:this.width,typeof e.scrollWidth!="undefined"?e.scrollWidth:this.scrollWidth,c?this.rawScrollLeft:this.scrollLeft,typeof e.height!="undefined"?e.height:this.height,typeof e.scrollHeight!="undefined"?e.scrollHeight:this.scrollHeight,c?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new M(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft!="undefined"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop!="undefined"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,c){const m=this.width!==e.width,_=this.scrollWidth!==e.scrollWidth,E=this.scrollLeft!==e.scrollLeft,u=this.height!==e.height,h=this.scrollHeight!==e.scrollHeight,D=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:c,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:_,scrollLeftChanged:E,heightChanged:u,scrollHeightChanged:h,scrollTopChanged:D}}}t.ScrollState=M;class y extends i.Disposable{constructor(e){super();this._scrollableBrand=void 0,this._onScroll=this._register(new v.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new M(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,c){const m=this._state.withScrollDimensions(e,c);this._setState(m,Boolean(this._smoothScrolling)),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const c=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(c,!1)}setScrollPositionSmooth(e,c){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft=="undefined"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop=="undefined"?this._smoothScrolling.to.scrollTop:e.scrollTop};const m=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===m.scrollLeft&&this._smoothScrolling.to.scrollTop===m.scrollTop)return;let _;c?_=new b(this._smoothScrolling.from,m,this._smoothScrolling.startTime,this._smoothScrolling.duration):_=this._smoothScrolling.combine(this._state,m,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=_}else{const m=this._state.withScrollPosition(e);this._smoothScrolling=b.start(this._state,m,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),c=this._state.withScrollPosition(e);if(this._setState(c,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,c){const m=this._state;m.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(m,c)))}}t.Scrollable=y;class w{constructor(e,c,m){this.scrollLeft=e,this.scrollTop=c,this.isDone=m}}t.SmoothScrollingUpdate=w;function p(r,e){const c=e-r;return function(m){return r+c*a(m)}}function f(r,e,c){return function(m){return m<c?r(m/c):e((m-c)/(1-c))}}class b{constructor(e,c,m,_){this.from=e,this.to=c,this.duration=_,this.startTime=m,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,c,m){if(Math.abs(e-c)>2.5*m){let E,u;return e<c?(E=e+.75*m,u=c-.75*m):(E=e-.75*m,u=c+.75*m),f(p(e,E),p(u,c),.33)}return p(e,c)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const c=(e-this.startTime)/this.duration;if(c<1){const m=this.scrollLeft(c),_=this.scrollTop(c);return new w(m,_,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,c,m){return b.start(e,c,m)}static start(e,c,m){m=m+10;const _=Date.now()-10;return new b(e,c,_,m)}}t.SmoothScrollingOperation=b;function T(r){return Math.pow(r,3)}function a(r){return 1-T(1-r)}}),define(pe[10],be([1,0,108,73]),function(Z,t,v,i){"use strict";var P;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function M(x){return!x||typeof x!="string"?!0:x.trim().length===0}t.isFalsyOrWhitespace=M;const y=/{(\d+)}/g;function w(x,...oe){return oe.length===0?x:x.replace(y,function(we,Ce){const Fe=parseInt(Ce,10);return isNaN(Fe)||Fe<0||Fe>=oe.length?we:oe[Fe]})}t.format=w;const p=/{([^}]+)}/g;function f(x,oe){return x.replace(p,(we,Ce)=>oe[Ce]??we)}t.format2=f;function b(x){return x.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}t.escape=b;function T(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=T;function a(x,oe){let we=0;const Ce=oe.charCodeAt(0);for(let Fe=x.length-1;Fe>=0;Fe--)x.charCodeAt(Fe)===Ce&&we++;return we}t.count=a;function r(x,oe,we="\u2026"){return x.length<=oe?x:`${x.substr(0,oe)}${we}`}t.truncate=r;function e(x,oe=" "){const we=c(x,oe);return m(we,oe)}t.trim=e;function c(x,oe){if(!x||!oe)return x;const we=oe.length;if(we===0||x.length===0)return x;let Ce=0;for(;x.indexOf(oe,Ce)===Ce;)Ce=Ce+we;return x.substring(Ce)}t.ltrim=c;function m(x,oe){if(!x||!oe)return x;const we=oe.length,Ce=x.length;if(we===0||Ce===0)return x;let Fe=Ce,Re=-1;for(;Re=x.lastIndexOf(oe,Fe-1),!(Re===-1||Re+we!==Fe);){if(Re===0)return"";Fe=Re}return x.substring(0,Fe)}t.rtrim=m;function _(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=_;function E(x){return x.replace(/\*/g,"")}t.stripWildcards=E;function u(x,oe,we={}){if(!x)throw new Error("Cannot create regex from empty string");oe||(x=T(x)),we.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ce="";return we.global&&(Ce+="g"),we.matchCase||(Ce+="i"),we.multiline&&(Ce+="m"),we.unicode&&(Ce+="u"),new RegExp(x,Ce)}t.createRegExp=u;function h(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}t.regExpLeadsToEndlessLoop=h;function D(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=D;function C(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}t.regExpFlags=C;function N(x){return x.split(/\r\n|\r|\n/)}t.splitLines=N;function A(x){for(let oe=0,we=x.length;oe<we;oe++){const Ce=x.charCodeAt(oe);if(Ce!==32&&Ce!==9)return oe}return-1}t.firstNonWhitespaceIndex=A;function o(x,oe=0,we=x.length){for(let Ce=oe;Ce<we;Ce++){const Fe=x.charCodeAt(Ce);if(Fe!==32&&Fe!==9)return x.substring(oe,Ce)}return x.substring(oe,we)}t.getLeadingWhitespace=o;function l(x,oe=x.length-1){for(let we=oe;we>=0;we--){const Ce=x.charCodeAt(we);if(Ce!==32&&Ce!==9)return we}return-1}t.lastNonWhitespaceIndex=l;function s(x,oe,we){const Ce=[];let Fe=0;for(const Re of x.matchAll(oe)){if(Ce.push(x.slice(Fe,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Fe=Re.index+Re[0].length,Ce.push(we(Re[0],...Re.slice(1),Re.index,x,Re.groups))}return Ce.push(x.slice(Fe)),Promise.all(Ce).then(Re=>Re.join(""))}t.replaceAsync=s;function n(x,oe){return x<oe?-1:x>oe?1:0}t.compare=n;function g(x,oe,we=0,Ce=x.length,Fe=0,Re=oe.length){for(;we<Ce&&Fe<Re;we++,Fe++){const Ye=x.charCodeAt(we),qe=oe.charCodeAt(Fe);if(Ye<qe)return-1;if(Ye>qe)return 1}const Ve=Ce-we,tt=Re-Fe;return Ve<tt?-1:Ve>tt?1:0}t.compareSubstring=g;function S(x,oe){return $(x,oe,0,x.length,0,oe.length)}t.compareIgnoreCase=S;function $(x,oe,we=0,Ce=x.length,Fe=0,Re=oe.length){for(;we<Ce&&Fe<Re;we++,Fe++){let Ye=x.charCodeAt(we),qe=oe.charCodeAt(Fe);if(Ye===qe)continue;if(Ye>=128||qe>=128)return g(x.toLowerCase(),oe.toLowerCase(),we,Ce,Fe,Re);te(Ye)&&(Ye-=32),te(qe)&&(qe-=32);const Le=Ye-qe;if(Le!==0)return Le}const Ve=Ce-we,tt=Re-Fe;return Ve<tt?-1:Ve>tt?1:0}t.compareSubstringIgnoreCase=$;function ie(x){return x>=48&&x<=57}t.isAsciiDigit=ie;function te(x){return x>=97&&x<=122}t.isLowerAsciiLetter=te;function ge(x){return x>=65&&x<=90}t.isUpperAsciiLetter=ge;function ae(x,oe){return x.length===oe.length&&$(x,oe)===0}t.equalsIgnoreCase=ae;function ve(x,oe){const we=oe.length;return oe.length>x.length?!1:$(x,oe,0,we)===0}t.startsWithIgnoreCase=ve;function he(x,oe){const we=Math.min(x.length,oe.length);let Ce;for(Ce=0;Ce<we;Ce++)if(x.charCodeAt(Ce)!==oe.charCodeAt(Ce))return Ce;return we}t.commonPrefixLength=he;function me(x,oe){const we=Math.min(x.length,oe.length);let Ce;const Fe=x.length-1,Re=oe.length-1;for(Ce=0;Ce<we;Ce++)if(x.charCodeAt(Fe-Ce)!==oe.charCodeAt(Re-Ce))return Ce;return we}t.commonSuffixLength=me;function ye(x){return 55296<=x&&x<=56319}t.isHighSurrogate=ye;function J(x){return 56320<=x&&x<=57343}t.isLowSurrogate=J;function de(x,oe){return(x-55296<<10)+(oe-56320)+65536}t.computeCodePoint=de;function ne(x,oe,we){const Ce=x.charCodeAt(we);if(ye(Ce)&&we+1<oe){const Fe=x.charCodeAt(we+1);if(J(Fe))return de(Ce,Fe)}return Ce}t.getNextCodePoint=ne;function Q(x,oe){const we=x.charCodeAt(oe-1);if(J(we)&&oe>1){const Ce=x.charCodeAt(oe-2);if(ye(Ce))return de(Ce,we)}return we}class re{constructor(oe,we=0){this._str=oe,this._len=oe.length,this._offset=we}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=Q(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=ne(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}t.CodePointIterator=re;class se{constructor(oe,we=0){this._iterator=new re(oe,we)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=Pe.getInstance(),we=this._iterator,Ce=we.offset;let Fe=oe.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Re=we.offset,Ve=oe.getGraphemeBreakType(we.nextCodePoint());if(Ie(Fe,Ve)){we.setOffset(Re);break}Fe=Ve}return we.offset-Ce}prevGraphemeLength(){const oe=Pe.getInstance(),we=this._iterator,Ce=we.offset;let Fe=oe.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Re=we.offset,Ve=oe.getGraphemeBreakType(we.prevCodePoint());if(Ie(Ve,Fe)){we.setOffset(Re);break}Fe=Ve}return Ce-we.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=se;function F(x,oe){return new se(x,oe).nextGraphemeLength()}t.nextCharLength=F;function K(x,oe){return new se(x,oe).prevGraphemeLength()}t.prevCharLength=K;function X(x,oe){oe>0&&J(x.charCodeAt(oe))&&oe--;const we=oe+F(x,oe);return[we-K(x,we),we]}t.getCharContainingOffset=X;const O=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function d(x){return O.test(x)}t.containsRTL=d;const L=/^[\t\n\r\x20-\x7E]*$/;function U(x){return L.test(x)}t.isBasicASCII=U,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(x){return t.UNUSUAL_LINE_TERMINATORS.test(x)}t.containsUnusualLineTerminators=q;function H(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}t.isFullWidthCharacter=H;function R(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}t.isEmojiImprecise=R;function W(x,oe){if(x.length<oe)return x;const we=/\b/g;let Ce=0;for(;we.test(x)&&!(x.length-we.lastIndex<oe);)Ce=we.lastIndex,we.lastIndex+=1;return x.substring(Ce).replace(/^\s/,"")}t.lcut=W;const V=/\x1B\x5B[12]?K/g,I=/\x1b\[\d+m/g,z=/\x1b\[0?m/g;function k(x){return x&&(x=x.replace(V,""),x=x.replace(I,""),x=x.replace(z,"")),x}t.removeAnsiEscapeCodes=k,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function B(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}t.startsWithUTF8BOM=B;function j(x){return B(x)?x.substr(1):x}t.stripUTF8BOM=j;function ee(x,oe){if(!x||!oe||x.length<oe.length)return!1;const we=oe.length,Ce=x.toLowerCase();let Fe=0,Re=-1;for(;Fe<we;){const Ve=Ce.indexOf(oe[Fe],Re+1);if(Ve<0)return!1;Re=Ve,Fe++}return!0}t.fuzzyContains=ee;function ce(x,oe=!1){return x?(oe&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}t.containsUppercaseCharacter=ce;function fe(x){return x.charAt(0).toUpperCase()+x.slice(1)}t.uppercaseFirstLetter=fe;function Ee(x,oe=1){if(oe===0)return"";let we=-1;do we=x.indexOf(`
`,we+1),oe--;while(oe>0&&we>=0);return we===-1?x:(x[we-1]==="\r"&&we--,x.substr(0,we))}t.getNLines=Ee;function _e(x){const oe=90-65+1;return x=x%(2*oe),x<oe?String.fromCharCode(97+x):String.fromCharCode(65+x-oe)}t.singleLetterHash=_e;function ke(x){return Pe.getInstance().getGraphemeBreakType(x)}t.getGraphemeBreakType=ke;function Ie(x,oe){return x===0?oe!==5&&oe!==7:x===2&&oe===3?!1:x===4||x===2||x===3||oe===4||oe===2||oe===3?!0:!(x===8&&(oe===8||oe===9||oe===11||oe===12)||(x===11||x===9)&&(oe===9||oe===10)||(x===12||x===10)&&oe===10||oe===5||oe===13||oe===7||x===1||x===13&&oe===14||x===6&&oe===6)}var De;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(De=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Pe{constructor(){this._data=Me()}static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const we=this._data,Ce=we.length/3;let Fe=1;for(;Fe<=Ce;)if(oe<we[3*Fe])Fe=2*Fe;else if(oe>we[3*Fe+1])Fe=2*Fe+1;else return we[3*Fe+2];return 0}}Pe._INSTANCE=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(x,oe){if(x===0)return 0;const we=He(x,oe);if(we!==void 0)return we;const Ce=new re(oe,x);return Ce.prevCodePoint(),Ce.offset}t.getLeftDeleteOffset=Ge;function He(x,oe){const we=new re(oe,x);let Ce=we.prevCodePoint();for(;Ue(Ce)||Ce===65039||Ce===8419;){if(we.offset===0)return;Ce=we.prevCodePoint()}if(!R(Ce))return;let Fe=we.offset;return Fe>0&&we.prevCodePoint()===8205&&(Fe=we.offset),Fe}function Ue(x){return 127995<=x&&x<=127999}var Je;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(Je||(Je={})),t.noBreakWhitespace="\xA0";class je{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return je.cache.get(Array.from(oe))}static getLocales(){return je._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=je,P=je,je.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.cache=new v.LRUCachedFunction(x=>{function oe(qe){const Le=new Map;for(let le=0;le<qe.length;le+=2)Le.set(qe[le],qe[le+1]);return Le}function we(qe,Le){const le=new Map(qe);for(const[Se,Ne]of Le)le.set(Se,Ne);return le}function Ce(qe,Le){if(!qe)return Le;const le=new Map;for(const[Se,Ne]of qe)Le.has(Se)&&le.set(Se,Ne);return le}const Fe=P.ambiguousCharacterData.getValue();let Re=x.filter(qe=>!qe.startsWith("_")&&qe in Fe);Re.length===0&&(Re=["_default"]);let Ve;for(const qe of Re){const Le=oe(Fe[qe]);Ve=Ce(Ve,Le)}const tt=oe(Fe._common),Ye=we(tt,Ve);return new je(Ye)}),je._locales=new i.Lazy(()=>Object.keys(je.ambiguousCharacterData.getValue()).filter(x=>!x.startsWith("_")));class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(oe){return Oe.getData().has(oe)}static get codePoints(){return Oe.getData()}}t.InvisibleCharacters=Oe,Oe._data=void 0}),define(pe[109],be([1,0,21,5,10,6]),function(Z,t,v,i,P,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function y(l){return l===47||l===92}t.isPathSeparator=y;function w(l){return l.replace(/[\\/]/g,v.posix.sep)}t.toSlashes=w;function p(l){return l.indexOf("/")===-1&&(l=w(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}t.toPosixPath=p;function f(l,s=v.posix.sep){if(!l)return"";const n=l.length,g=l.charCodeAt(0);if(y(g)){if(y(l.charCodeAt(1))&&!y(l.charCodeAt(2))){let $=3;const ie=$;for(;$<n&&!y(l.charCodeAt($));$++);if(ie!==$&&!y(l.charCodeAt($+1))){for($+=1;$<n;$++)if(y(l.charCodeAt($)))return l.slice(0,$+1).replace(/[\\/]/g,s)}}return s}else if(_(g)&&l.charCodeAt(1)===58)return y(l.charCodeAt(2))?l.slice(0,2)+s:l.slice(0,2);let S=l.indexOf("://");if(S!==-1){for(S+=3;S<n;S++)if(y(l.charCodeAt(S)))return l.slice(0,S+1)}return""}t.getRoot=f;function b(l){if(!i.isWindows||!l||l.length<5)return!1;let s=l.charCodeAt(0);if(s!==92||(s=l.charCodeAt(1),s!==92))return!1;let n=2;const g=n;for(;n<l.length&&(s=l.charCodeAt(n),s!==92);n++);return!(g===n||(s=l.charCodeAt(n+1),isNaN(s)||s===92))}t.isUNC=b;const T=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,r=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(l,s=i.isWindows){const n=s?T:a;return!(!l||l.length===0||/^\s+$/.test(l)||(n.lastIndex=0,n.test(l))||s&&r.test(l)||l==="."||l===".."||s&&l[l.length-1]==="."||s&&l.length!==l.trim().length||l.length>255)}t.isValidBasename=e;function c(l,s,n){const g=l===s;return!n||g?g:!l||!s?!1:(0,P.equalsIgnoreCase)(l,s)}t.isEqual=c;function m(l,s,n,g=v.sep){if(l===s)return!0;if(!l||!s||s.length>l.length)return!1;if(n){if(!(0,P.startsWithIgnoreCase)(l,s))return!1;if(s.length===l.length)return!0;let $=s.length;return s.charAt(s.length-1)===g&&$--,l.charAt($)===g}return s.charAt(s.length-1)!==g&&(s+=g),l.indexOf(s)===0}t.isEqualOrParent=m;function _(l){return l>=65&&l<=90||l>=97&&l<=122}t.isWindowsDriveLetter=_;function E(l,s){return i.isWindows&&l.endsWith(":")&&(l+=v.sep),(0,v.isAbsolute)(l)||(l=(0,v.join)(s,l)),l=(0,v.normalize)(l),i.isWindows?(l=(0,P.rtrim)(l,v.sep),l.endsWith(":")&&(l+=v.sep)):(l=(0,P.rtrim)(l,v.sep),l||(l=v.sep)),l}t.sanitizeFilePath=E;function u(l){const s=(0,v.normalize)(l);return i.isWindows?l.length>3?!1:h(s)&&(l.length===2||s.charCodeAt(2)===92):s===v.posix.sep}t.isRootOrDriveLetter=u;function h(l,s=i.isWindows){return s?_(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}t.hasDriveLetter=h;function D(l){return h(l)?l[0]:void 0}t.getDriveLetter=D;function C(l,s,n){return s.length>l.length?-1:l===s?0:(n&&(l=l.toLowerCase(),s=s.toLowerCase()),l.indexOf(s))}t.indexOfPath=C;function N(l){const s=l.split(":");let n,g,S;for(const $ of s){const ie=Number($);(0,M.isNumber)(ie)?g===void 0?g=ie:S===void 0&&(S=ie):n=n?[n,$].join(":"):$}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:g!==void 0?g:void 0,column:S!==void 0?S:g!==void 0?1:void 0}}t.parseLineAndColumnAware=N;const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(l,s,n=8){let g="";for(let $=0;$<n;$++)g+=A.charAt(Math.floor(Math.random()*A.length));let S;return s?S=`${s}-${g}`:S=g,l?(0,v.join)(l,S):S}t.randomPath=o}),define(pe[110],be([1,0,10]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function i(_){return P(_,0)}t.hash=i;function P(_,E){switch(typeof _){case"object":return _===null?M(349,E):Array.isArray(_)?p(_,E):f(_,E);case"string":return w(_,E);case"boolean":return y(_,E);case"number":return M(_,E);case"undefined":return M(937,E);default:return M(617,E)}}t.doHash=P;function M(_,E){return(E<<5)-E+_|0}t.numberHash=M;function y(_,E){return M(_?433:863,E)}function w(_,E){E=M(149417,E);for(let u=0,h=_.length;u<h;u++)E=M(_.charCodeAt(u),E);return E}t.stringHash=w;function p(_,E){return E=M(104579,E),_.reduce((u,h)=>P(h,u),E)}function f(_,E){return E=M(181387,E),Object.keys(_).sort().reduce((u,h)=>(u=w(h,u),P(_[h],u)),E)}class b{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=P(E,this._value),this._value}}t.Hasher=b;var T;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function a(_,E,u=32){const h=u-E,D=~((1<<h)-1);return(_<<E|(D&_)>>>h)>>>0}function r(_,E=0,u=_.byteLength,h=0){for(let D=0;D<u;D++)_[E+D]=h}function e(_,E,u="0"){for(;_.length<E;)_=u+_;return _}function c(_,E=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(u=>u.toString(16).padStart(2,"0")).join(""):e((_>>>0).toString(16),E/4)}t.toHexString=c;class m{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const u=E.length;if(u===0)return;const h=this._buff;let D=this._buffLen,C=this._leftoverHighSurrogate,N,A;for(C!==0?(N=C,A=-1,C=0):(N=E.charCodeAt(0),A=0);;){let o=N;if(v.isHighSurrogate(N))if(A+1<u){const l=E.charCodeAt(A+1);v.isLowSurrogate(l)?(A++,o=v.computeCodePoint(N,l)):o=65533}else{C=N;break}else v.isLowSurrogate(N)&&(o=65533);if(D=this._push(h,D,o),A++,A<u)N=E.charCodeAt(A);else break}this._buffLen=D,this._leftoverHighSurrogate=C}_push(E,u,h){return h<128?E[u++]=h:h<2048?(E[u++]=192|(h&1984)>>>6,E[u++]=128|(h&63)>>>0):h<65536?(E[u++]=224|(h&61440)>>>12,E[u++]=128|(h&4032)>>>6,E[u++]=128|(h&63)>>>0):(E[u++]=240|(h&1835008)>>>18,E[u++]=128|(h&258048)>>>12,E[u++]=128|(h&4032)>>>6,E[u++]=128|(h&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),c(this._h0)+c(this._h1)+c(this._h2)+c(this._h3)+c(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,r(this._buff,this._buffLen),this._buffLen>56&&(this._step(),r(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=m._bigBlock32,u=this._buffDV;for(let n=0;n<64;n+=4)E.setUint32(n,u.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)E.setUint32(n,a(E.getUint32(n-12,!1)^E.getUint32(n-32,!1)^E.getUint32(n-56,!1)^E.getUint32(n-64,!1),1),!1);let h=this._h0,D=this._h1,C=this._h2,N=this._h3,A=this._h4,o,l,s;for(let n=0;n<80;n++)n<20?(o=D&C|~D&N,l=1518500249):n<40?(o=D^C^N,l=1859775393):n<60?(o=D&C|D&N|C&N,l=2400959708):(o=D^C^N,l=3395469782),s=a(h,5)+o+A+l+E.getUint32(n*4,!1)&4294967295,A=N,N=C,C=a(D,30),D=h,h=s;this._h0=this._h0+h&4294967295,this._h1=this._h1+D&4294967295,this._h2=this._h2+C&4294967295,this._h3=this._h3+N&4294967295,this._h4=this._h4+A&4294967295}}t.StringSHA1=m,m._bigBlock32=new DataView(new ArrayBuffer(320))}),define(pe[111],be([1,0,70,110]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class P{constructor(a){this.source=a}getElements(){const a=this.source,r=new Int32Array(a.length);for(let e=0,c=a.length;e<c;e++)r[e]=a.charCodeAt(e);return r}}t.StringDiffSequence=P;function M(T,a,r){return new b(new P(T),new P(a)).ComputeDiff(r).changes}t.stringDiff=M;class y{static Assert(a,r){if(!a)throw new Error(r)}}t.Debug=y;class w{static Copy(a,r,e,c,m){for(let _=0;_<m;_++)e[c+_]=a[r+_]}static Copy2(a,r,e,c,m){for(let _=0;_<m;_++)e[c+_]=a[r+_]}}t.MyArray=w;var p;(function(T){T[T.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(p||(p={}));class f{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new v.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(a,r){this.m_originalStart=Math.min(this.m_originalStart,a),this.m_modifiedStart=Math.min(this.m_modifiedStart,r),this.m_originalCount++}AddModifiedElement(a,r){this.m_originalStart=Math.min(this.m_originalStart,a),this.m_modifiedStart=Math.min(this.m_modifiedStart,r),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class b{constructor(a,r,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=a,this._modifiedSequence=r;const[c,m,_]=b._getElements(a),[E,u,h]=b._getElements(r);this._hasStrings=_&&h,this._originalStringElements=c,this._originalElementsOrHash=m,this._modifiedStringElements=E,this._modifiedElementsOrHash=u,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(a){return a.length>0&&typeof a[0]=="string"}static _getElements(a){const r=a.getElements();if(b._isStringArray(r)){const e=new Int32Array(r.length);for(let c=0,m=r.length;c<m;c++)e[c]=(0,i.stringHash)(r[c],0);return[r,e,!0]}return r instanceof Int32Array?[[],r,!1]:[[],new Int32Array(r),!1]}ElementsAreEqual(a,r){return this._originalElementsOrHash[a]!==this._modifiedElementsOrHash[r]?!1:this._hasStrings?this._originalStringElements[a]===this._modifiedStringElements[r]:!0}ElementsAreStrictEqual(a,r){if(!this.ElementsAreEqual(a,r))return!1;const e=b._getStrictElement(this._originalSequence,a),c=b._getStrictElement(this._modifiedSequence,r);return e===c}static _getStrictElement(a,r){return typeof a.getStrictElement=="function"?a.getStrictElement(r):null}OriginalElementsAreEqual(a,r){return this._originalElementsOrHash[a]!==this._originalElementsOrHash[r]?!1:this._hasStrings?this._originalStringElements[a]===this._originalStringElements[r]:!0}ModifiedElementsAreEqual(a,r){return this._modifiedElementsOrHash[a]!==this._modifiedElementsOrHash[r]?!1:this._hasStrings?this._modifiedStringElements[a]===this._modifiedStringElements[r]:!0}ComputeDiff(a){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,a)}_ComputeDiff(a,r,e,c,m){const _=[!1];let E=this.ComputeDiffRecursive(a,r,e,c,_);return m&&(E=this.PrettifyChanges(E)),{quitEarly:_[0],changes:E}}ComputeDiffRecursive(a,r,e,c,m){for(m[0]=!1;a<=r&&e<=c&&this.ElementsAreEqual(a,e);)a++,e++;for(;r>=a&&c>=e&&this.ElementsAreEqual(r,c);)r--,c--;if(a>r||e>c){let C;return e<=c?(y.Assert(a===r+1,"originalStart should only be one more than originalEnd"),C=[new v.DiffChange(a,0,e,c-e+1)]):a<=r?(y.Assert(e===c+1,"modifiedStart should only be one more than modifiedEnd"),C=[new v.DiffChange(a,r-a+1,e,0)]):(y.Assert(a===r+1,"originalStart should only be one more than originalEnd"),y.Assert(e===c+1,"modifiedStart should only be one more than modifiedEnd"),C=[]),C}const _=[0],E=[0],u=this.ComputeRecursionPoint(a,r,e,c,_,E,m),h=_[0],D=E[0];if(u!==null)return u;if(!m[0]){const C=this.ComputeDiffRecursive(a,h,e,D,m);let N=[];return m[0]?N=[new v.DiffChange(h+1,r-(h+1)+1,D+1,c-(D+1)+1)]:N=this.ComputeDiffRecursive(h+1,r,D+1,c,m),this.ConcatenateChanges(C,N)}return[new v.DiffChange(a,r-a+1,e,c-e+1)]}WALKTRACE(a,r,e,c,m,_,E,u,h,D,C,N,A,o,l,s,n,g){let S=null,$=null,ie=new f,te=r,ge=e,ae=A[0]-s[0]-c,ve=-1073741824,he=this.m_forwardHistory.length-1;do{const me=ae+a;me===te||me<ge&&h[me-1]<h[me+1]?(C=h[me+1],o=C-ae-c,C<ve&&ie.MarkNextChange(),ve=C,ie.AddModifiedElement(C+1,o),ae=me+1-a):(C=h[me-1]+1,o=C-ae-c,C<ve&&ie.MarkNextChange(),ve=C-1,ie.AddOriginalElement(C,o+1),ae=me-1-a),he>=0&&(h=this.m_forwardHistory[he],a=h[0],te=1,ge=h.length-1)}while(--he>=-1);if(S=ie.getReverseChanges(),g[0]){let me=A[0]+1,ye=s[0]+1;if(S!==null&&S.length>0){const J=S[S.length-1];me=Math.max(me,J.getOriginalEnd()),ye=Math.max(ye,J.getModifiedEnd())}$=[new v.DiffChange(me,N-me+1,ye,l-ye+1)]}else{ie=new f,te=_,ge=E,ae=A[0]-s[0]-u,ve=1073741824,he=n?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const me=ae+m;me===te||me<ge&&D[me-1]>=D[me+1]?(C=D[me+1]-1,o=C-ae-u,C>ve&&ie.MarkNextChange(),ve=C+1,ie.AddOriginalElement(C+1,o+1),ae=me+1-m):(C=D[me-1],o=C-ae-u,C>ve&&ie.MarkNextChange(),ve=C,ie.AddModifiedElement(C+1,o+1),ae=me-1-m),he>=0&&(D=this.m_reverseHistory[he],m=D[0],te=1,ge=D.length-1)}while(--he>=-1);$=ie.getChanges()}return this.ConcatenateChanges(S,$)}ComputeRecursionPoint(a,r,e,c,m,_,E){let u=0,h=0,D=0,C=0,N=0,A=0;a--,e--,m[0]=0,_[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const o=r-a+(c-e),l=o+1,s=new Int32Array(l),n=new Int32Array(l),g=c-e,S=r-a,$=a-e,ie=r-c,ge=(S-g)%2==0;s[g]=a,n[S]=r,E[0]=!1;for(let ae=1;ae<=o/2+1;ae++){let ve=0,he=0;D=this.ClipDiagonalBound(g-ae,ae,g,l),C=this.ClipDiagonalBound(g+ae,ae,g,l);for(let ye=D;ye<=C;ye+=2){ye===D||ye<C&&s[ye-1]<s[ye+1]?u=s[ye+1]:u=s[ye-1]+1,h=u-(ye-g)-$;const J=u;for(;u<r&&h<c&&this.ElementsAreEqual(u+1,h+1);)u++,h++;if(s[ye]=u,u+h>ve+he&&(ve=u,he=h),!ge&&Math.abs(ye-S)<=ae-1&&u>=n[ye])return m[0]=u,_[0]=h,J<=n[ye]&&1447>0&&ae<=1447+1?this.WALKTRACE(g,D,C,$,S,N,A,ie,s,n,u,r,m,h,c,_,ge,E):null}const me=(ve-a+(he-e)-ae)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(ve,me))return E[0]=!0,m[0]=ve,_[0]=he,me>0&&1447>0&&ae<=1447+1?this.WALKTRACE(g,D,C,$,S,N,A,ie,s,n,u,r,m,h,c,_,ge,E):(a++,e++,[new v.DiffChange(a,r-a+1,e,c-e+1)]);N=this.ClipDiagonalBound(S-ae,ae,S,l),A=this.ClipDiagonalBound(S+ae,ae,S,l);for(let ye=N;ye<=A;ye+=2){ye===N||ye<A&&n[ye-1]>=n[ye+1]?u=n[ye+1]-1:u=n[ye-1],h=u-(ye-S)-ie;const J=u;for(;u>a&&h>e&&this.ElementsAreEqual(u,h);)u--,h--;if(n[ye]=u,ge&&Math.abs(ye-g)<=ae&&u<=s[ye])return m[0]=u,_[0]=h,J>=s[ye]&&1447>0&&ae<=1447+1?this.WALKTRACE(g,D,C,$,S,N,A,ie,s,n,u,r,m,h,c,_,ge,E):null}if(ae<=1447){let ye=new Int32Array(C-D+2);ye[0]=g-D+1,w.Copy2(s,D,ye,1,C-D+1),this.m_forwardHistory.push(ye),ye=new Int32Array(A-N+2),ye[0]=S-N+1,w.Copy2(n,N,ye,1,A-N+1),this.m_reverseHistory.push(ye)}}return this.WALKTRACE(g,D,C,$,S,N,A,ie,s,n,u,r,m,h,c,_,ge,E)}PrettifyChanges(a){for(let r=0;r<a.length;r++){const e=a[r],c=r<a.length-1?a[r+1].originalStart:this._originalElementsOrHash.length,m=r<a.length-1?a[r+1].modifiedStart:this._modifiedElementsOrHash.length,_=e.originalLength>0,E=e.modifiedLength>0;for(;e.originalStart+e.originalLength<c&&e.modifiedStart+e.modifiedLength<m&&(!_||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!E||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const h=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!h)break;e.originalStart++,e.modifiedStart++}const u=[null];if(r<a.length-1&&this.ChangesOverlap(a[r],a[r+1],u)){a[r]=u[0],a.splice(r+1,1),r--;continue}}for(let r=a.length-1;r>=0;r--){const e=a[r];let c=0,m=0;if(r>0){const C=a[r-1];c=C.originalStart+C.originalLength,m=C.modifiedStart+C.modifiedLength}const _=e.originalLength>0,E=e.modifiedLength>0;let u=0,h=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let C=1;;C++){const N=e.originalStart-C,A=e.modifiedStart-C;if(N<c||A<m||_&&!this.OriginalElementsAreEqual(N,N+e.originalLength)||E&&!this.ModifiedElementsAreEqual(A,A+e.modifiedLength))break;const l=(N===c&&A===m?5:0)+this._boundaryScore(N,e.originalLength,A,e.modifiedLength);l>h&&(h=l,u=C)}e.originalStart-=u,e.modifiedStart-=u;const D=[null];if(r>0&&this.ChangesOverlap(a[r-1],a[r],D)){a[r-1]=D[0],a.splice(r,1),r++;continue}}if(this._hasStrings)for(let r=1,e=a.length;r<e;r++){const c=a[r-1],m=a[r],_=m.originalStart-c.originalStart-c.originalLength,E=c.originalStart,u=m.originalStart+m.originalLength,h=u-E,D=c.modifiedStart,C=m.modifiedStart+m.modifiedLength,N=C-D;if(_<5&&h<20&&N<20){const A=this._findBetterContiguousSequence(E,h,D,N,_);if(A){const[o,l]=A;(o!==c.originalStart+c.originalLength||l!==c.modifiedStart+c.modifiedLength)&&(c.originalLength=o-c.originalStart,c.modifiedLength=l-c.modifiedStart,m.originalStart=o+_,m.modifiedStart=l+_,m.originalLength=u-m.originalStart,m.modifiedLength=C-m.modifiedStart)}}}return a}_findBetterContiguousSequence(a,r,e,c,m){if(r<m||c<m)return null;const _=a+r-m+1,E=e+c-m+1;let u=0,h=0,D=0;for(let C=a;C<_;C++)for(let N=e;N<E;N++){const A=this._contiguousSequenceScore(C,N,m);A>0&&A>u&&(u=A,h=C,D=N)}return u>0?[h,D]:null}_contiguousSequenceScore(a,r,e){let c=0;for(let m=0;m<e;m++){if(!this.ElementsAreEqual(a+m,r+m))return 0;c+=this._originalStringElements[a+m].length}return c}_OriginalIsBoundary(a){return a<=0||a>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[a])}_OriginalRegionIsBoundary(a,r){if(this._OriginalIsBoundary(a)||this._OriginalIsBoundary(a-1))return!0;if(r>0){const e=a+r;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(a){return a<=0||a>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[a])}_ModifiedRegionIsBoundary(a,r){if(this._ModifiedIsBoundary(a)||this._ModifiedIsBoundary(a-1))return!0;if(r>0){const e=a+r;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(a,r,e,c){const m=this._OriginalRegionIsBoundary(a,r)?1:0,_=this._ModifiedRegionIsBoundary(e,c)?1:0;return m+_}ConcatenateChanges(a,r){const e=[];if(a.length===0||r.length===0)return r.length>0?r:a;if(this.ChangesOverlap(a[a.length-1],r[0],e)){const c=new Array(a.length+r.length-1);return w.Copy(a,0,c,0,a.length-1),c[a.length-1]=e[0],w.Copy(r,1,c,a.length,r.length-1),c}else{const c=new Array(a.length+r.length);return w.Copy(a,0,c,0,a.length),w.Copy(r,0,c,a.length,r.length),c}}ChangesOverlap(a,r,e){if(y.Assert(a.originalStart<=r.originalStart,"Left change is not less than or equal to right change"),y.Assert(a.modifiedStart<=r.modifiedStart,"Left change is not less than or equal to right change"),a.originalStart+a.originalLength>=r.originalStart||a.modifiedStart+a.modifiedLength>=r.modifiedStart){const c=a.originalStart;let m=a.originalLength;const _=a.modifiedStart;let E=a.modifiedLength;return a.originalStart+a.originalLength>=r.originalStart&&(m=r.originalStart+r.originalLength-a.originalStart),a.modifiedStart+a.modifiedLength>=r.modifiedStart&&(E=r.modifiedStart+r.modifiedLength-a.modifiedStart),e[0]=new v.DiffChange(c,m,_,E),!0}else return e[0]=null,!1}ClipDiagonalBound(a,r,e,c){if(a>=0&&a<c)return a;const m=e,_=c-e-1,E=r%2==0;if(a<0){const u=m%2==0;return E===u?0:1}else{const u=_%2==0;return E===u?c-1:c-2}}}t.LcsDiff=b});var di=this&&this.__classPrivateFieldSet||function(Z,t,v,i,P){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof t=="function"?Z!==t||!P:!t.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?P.call(Z,v):P?P.value=v:t.set(Z,v),v},ut=this&&this.__classPrivateFieldGet||function(Z,t,v,i){if(v==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof t=="function"?Z!==t||!i:!t.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?i:v==="a"?i.call(Z):i?i.value:t.get(Z)};define(pe[48],be([1,0,14,10]),function(Z,t,v,i){"use strict";var P,M,y,w;Object.defineProperty(t,"__esModule",{value:!0}),t.ReadonlyMapView=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=t.setToString=t.mapToString=t.getOrSet=void 0;function p(l,s,n){let g=l.get(s);return g===void 0&&(g=n,l.set(s,g)),g}t.getOrSet=p;function f(l){const s=[];return l.forEach((n,g)=>{s.push(`${g} => ${n}`)}),`Map(${l.size}) {${s.join(", ")}}`}t.mapToString=f;function b(l){const s=[];return l.forEach(n=>{s.push(n)}),`Set(${l.size}) {${s.join(", ")}}`}t.setToString=b;class T{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const n=s.charCodeAt(0),g=this._value.charCodeAt(this._pos);return n-g}value(){return this._value[this._pos]}}t.StringIterator=T;class a{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,i.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=a;class r{constructor(s=!0,n=!0){this._splitOnBackslash=s,this._caseSensitive=n}reset(s){this._from=0,this._to=0,this._value=s,this._valueLen=s.length;for(let n=s.length-1;n>=0;n--,this._valueLen--){const g=this._value.charCodeAt(n);if(!(g===47||this._splitOnBackslash&&g===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let s=!0;for(;this._to<this._valueLen;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,i.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=r;var e;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(e||(e={}));class c{constructor(s,n){this._ignorePathCasing=s,this._ignoreQueryAndFragment=n,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new r(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(s)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,i.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=c;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const s=this.right;return this.right=s.left,s.left=this,this.updateHeight(),s.updateHeight(),s}rotateRight(){const s=this.left;return this.left=s.right,s.right=this,this.updateHeight(),s.updateHeight(),s}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var _;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(_||(_={}));class E{constructor(s){this._iter=s}static forUris(s=()=>!1,n=()=>!1){return new E(new c(s,n))}static forPaths(s=!1){return new E(new r(void 0,!s))}static forStrings(){return new E(new T)}static forConfigKeys(){return new E(new a)}clear(){this._root=void 0}fill(s,n){if(n){const g=n.slice(0);(0,v.shuffle)(g);for(const S of g)this.set(S,s)}else{const g=s.slice(0);(0,v.shuffle)(g);for(const S of g)this.set(S[0],S[1])}}set(s,n){const g=this._iter.reset(s);let S;this._root||(this._root=new m,this._root.segment=g.value());const $=[];for(S=this._root;;){const te=g.cmp(S.segment);if(te>0)S.left||(S.left=new m,S.left.segment=g.value()),$.push([-1,S]),S=S.left;else if(te<0)S.right||(S.right=new m,S.right.segment=g.value()),$.push([1,S]),S=S.right;else if(g.hasNext())g.next(),S.mid||(S.mid=new m,S.mid.segment=g.value()),$.push([0,S]),S=S.mid;else break}const ie=S.value;S.value=n,S.key=s;for(let te=$.length-1;te>=0;te--){const ge=$[te][1];ge.updateHeight();const ae=ge.balanceFactor();if(ae<-1||ae>1){const ve=$[te][0],he=$[te+1][0];if(ve===1&&he===1)$[te][1]=ge.rotateLeft();else if(ve===-1&&he===-1)$[te][1]=ge.rotateRight();else if(ve===1&&he===-1)ge.right=$[te+1][1]=$[te+1][1].rotateRight(),$[te][1]=ge.rotateLeft();else if(ve===-1&&he===1)ge.left=$[te+1][1]=$[te+1][1].rotateLeft(),$[te][1]=ge.rotateRight();else throw new Error;if(te>0)switch($[te-1][0]){case-1:$[te-1][1].left=$[te][1];break;case 1:$[te-1][1].right=$[te][1];break;case 0:$[te-1][1].mid=$[te][1];break}else this._root=$[0][1]}}return ie}get(s){return this._getNode(s)?.value}_getNode(s){const n=this._iter.reset(s);let g=this._root;for(;g;){const S=n.cmp(g.segment);if(S>0)g=g.left;else if(S<0)g=g.right;else if(n.hasNext())n.next(),g=g.mid;else break}return g}has(s){const n=this._getNode(s);return!(n?.value===void 0&&n?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,n){const g=this._iter.reset(s),S=[];let $=this._root;for(;$;){const ie=g.cmp($.segment);if(ie>0)S.push([-1,$]),$=$.left;else if(ie<0)S.push([1,$]),$=$.right;else if(g.hasNext())g.next(),S.push([0,$]),$=$.mid;else break}if(!!$){if(n?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const ie=this._min($.right),{key:te,value:ge,segment:ae}=ie;this._delete(ie.key,!1),$.key=te,$.value=ge,$.segment=ae}else{const ie=$.left??$.right;if(S.length>0){const[te,ge]=S[S.length-1];switch(te){case-1:ge.left=ie;break;case 0:ge.mid=ie;break;case 1:ge.right=ie;break}}else this._root=ie}for(let ie=S.length-1;ie>=0;ie--){const te=S[ie][1];te.updateHeight();const ge=te.balanceFactor();if(ge>1?(te.right.balanceFactor()>=0||(te.right=te.right.rotateRight()),S[ie][1]=te.rotateLeft()):ge<-1&&(te.left.balanceFactor()<=0||(te.left=te.left.rotateLeft()),S[ie][1]=te.rotateRight()),ie>0)switch(S[ie-1][0]){case-1:S[ie-1][1].left=S[ie][1];break;case 1:S[ie-1][1].right=S[ie][1];break;case 0:S[ie-1][1].mid=S[ie][1];break}else this._root=S[0][1]}}}_min(s){for(;s.left;)s=s.left;return s}findSubstr(s){const n=this._iter.reset(s);let g=this._root,S;for(;g;){const $=n.cmp(g.segment);if($>0)g=g.left;else if($<0)g=g.right;else if(n.hasNext())n.next(),S=g.value||S,g=g.mid;else break}return g&&g.value||S}findSuperstr(s){const n=this._iter.reset(s);let g=this._root;for(;g;){const S=n.cmp(g.segment);if(S>0)g=g.left;else if(S<0)g=g.right;else if(n.hasNext())n.next(),g=g.mid;else return g.mid?this._entries(g.mid):void 0}}forEach(s){for(const[n,g]of this)s(g,n)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(s){const n=[];return this._dfsEntries(s,n),n[Symbol.iterator]()}_dfsEntries(s,n){!s||(s.left&&this._dfsEntries(s.left,n),s.value&&n.push([s.key,s.value]),s.mid&&this._dfsEntries(s.mid,n),s.right&&this._dfsEntries(s.right,n))}_isBalanced(){const s=n=>{if(!n)return!0;const g=n.balanceFactor();return g<-1||g>1?!1:s(n.left)&&s(n.right)};return s(this._root)}}t.TernarySearchTree=E;class u{constructor(s,n){this.uri=s,this.value=n}}class h{constructor(s,n){this[P]="ResourceMap",s instanceof h?(this.map=new Map(s.map),this.toKey=n??h.defaultToKey):(this.map=new Map,this.toKey=s??h.defaultToKey)}set(s,n){return this.map.set(this.toKey(s),new u(s,n)),this}get(s){return this.map.get(this.toKey(s))?.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,n){typeof n!="undefined"&&(s=s.bind(n));for(const[g,S]of this.map)s(S.value,S.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}t.ResourceMap=h,h.defaultToKey=l=>l.toString();class D{constructor(s,n){this[M]="ResourceSet",!s||typeof s=="function"?this._map=new h(s):(this._map=new h(n),s.forEach(this.add,this))}get size(){return this._map.size}add(s){return this._map.set(s,s),this}clear(){this._map.clear()}delete(s){return this._map.delete(s)}forEach(s,n){this._map.forEach((g,S)=>s.call(n,S,S,this))}has(s){return this._map.has(s)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=D;var C;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(C=t.Touch||(t.Touch={}));class N{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,n=0){const g=this._map.get(s);if(!!g)return n!==0&&this.touch(g,n),g.value}set(s,n,g=0){let S=this._map.get(s);if(S)S.value=n,g!==0&&this.touch(S,g);else{switch(S={key:s,value:n,next:void 0,previous:void 0},g){case 0:this.addItemLast(S);break;case 1:this.addItemFirst(S);break;case 2:this.addItemLast(S);break;default:this.addItemLast(S);break}this._map.set(s,S),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const n=this._map.get(s);if(!!n)return this._map.delete(s),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,n){const g=this._state;let S=this._head;for(;S;){if(n?s.bind(n)(S.value,S.key,this):s(S.value,S.key,this),this._state!==g)throw new Error("LinkedMap got modified during iteration.");S=S.next}}keys(){const s=this,n=this._state;let g=this._head;const S={[Symbol.iterator](){return S},next(){if(s._state!==n)throw new Error("LinkedMap got modified during iteration.");if(g){const $={value:g.key,done:!1};return g=g.next,$}else return{value:void 0,done:!0}}};return S}values(){const s=this,n=this._state;let g=this._head;const S={[Symbol.iterator](){return S},next(){if(s._state!==n)throw new Error("LinkedMap got modified during iteration.");if(g){const $={value:g.value,done:!1};return g=g.next,$}else return{value:void 0,done:!0}}};return S}entries(){const s=this,n=this._state;let g=this._head;const S={[Symbol.iterator](){return S},next(){if(s._state!==n)throw new Error("LinkedMap got modified during iteration.");if(g){const $={value:[g.key,g.value],done:!1};return g=g.next,$}else return{value:void 0,done:!0}}};return S}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let n=this._head,g=this.size;for(;n&&g>s;)this._map.delete(n.key),n=n.next,g--;this._head=n,this._size=g,n&&(n.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const n=s.next,g=s.previous;if(!n||!g)throw new Error("Invalid list");n.previous=g,g.next=n}s.next=void 0,s.previous=void 0,this._state++}touch(s,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(s===this._head)return;const g=s.next,S=s.previous;s===this._tail?(S.next=void 0,this._tail=S):(g.previous=S,S.next=g),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(n===2){if(s===this._tail)return;const g=s.next,S=s.previous;s===this._head?(g.previous=void 0,this._head=g):(g.previous=S,S.next=g),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((n,g)=>{s.push([g,n])}),s}fromJSON(s){this.clear();for(const[n,g]of s)this.set(n,g)}}t.LinkedMap=N;class A extends N{constructor(s,n=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,n=2){return super.get(s,n)}peek(s){return super.get(s,0)}set(s,n){return super.set(s,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=A;class o{constructor(s){w.set(this,void 0),di(this,w,s,"f")}get size(){return ut(this,w,"f").size}forEach(s,n){ut(this,w,"f").forEach(s,n)}get(s){return ut(this,w,"f").get(s)}has(s){return ut(this,w,"f").has(s)}entries(){return ut(this,w,"f").entries()}keys(){return ut(this,w,"f").keys()}values(){return ut(this,w,"f").values()}[(w=new WeakMap,Symbol.iterator)](){return ut(this,w,"f").entries()}}t.ReadonlyMapView=o}),define(pe[33],be([1,0,48,10]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function P(...k){return function(B,j){for(let ee=0,ce=k.length;ee<ce;ee++){const fe=k[ee](B,j);if(fe)return fe}return null}}t.or=P,t.matchesStrictPrefix=M.bind(void 0,!1),t.matchesPrefix=M.bind(void 0,!0);function M(k,B,j){if(!j||j.length<B.length)return null;let ee;return k?ee=i.startsWithIgnoreCase(j,B):ee=j.indexOf(B)===0,ee?B.length>0?[{start:0,end:B.length}]:[]:null}function y(k,B){const j=B.toLowerCase().indexOf(k.toLowerCase());return j===-1?null:[{start:j,end:j+k.length}]}t.matchesContiguousSubString=y;function w(k,B){return p(k.toLowerCase(),B.toLowerCase(),0,0)}t.matchesSubString=w;function p(k,B,j,ee){if(j===k.length)return[];if(ee===B.length)return null;if(k[j]===B[ee]){let ce=null;return(ce=p(k,B,j+1,ee+1))?_({start:ee,end:ee+1},ce):null}return p(k,B,j,ee+1)}function f(k){return 97<=k&&k<=122}function b(k){return 65<=k&&k<=90}t.isUpper=b;function T(k){return 48<=k&&k<=57}function a(k){return k===32||k===9||k===10||k===13}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(k=>r.add(k.charCodeAt(0)));function e(k){return a(k)||r.has(k)}function c(k,B){return k===B||e(k)&&e(B)}function m(k){return f(k)||b(k)||T(k)}function _(k,B){return B.length===0?B=[k]:k.end===B[0].start?B[0].start=k.start:B.unshift(k),B}function E(k,B){for(let j=B;j<k.length;j++){const ee=k.charCodeAt(j);if(b(ee)||T(ee)||j>0&&!m(k.charCodeAt(j-1)))return j}return k.length}function u(k,B,j,ee){if(j===k.length)return[];if(ee===B.length)return null;if(k[j]!==B[ee].toLowerCase())return null;{let ce=null,fe=ee+1;for(ce=u(k,B,j+1,ee+1);!ce&&(fe=E(B,fe))<B.length;)ce=u(k,B,j+1,fe),fe++;return ce===null?null:_({start:ee,end:ee+1},ce)}}function h(k){let B=0,j=0,ee=0,ce=0,fe=0;for(let De=0;De<k.length;De++)fe=k.charCodeAt(De),b(fe)&&B++,f(fe)&&j++,m(fe)&&ee++,T(fe)&&ce++;const Ee=B/k.length,_e=j/k.length,ke=ee/k.length,Ie=ce/k.length;return{upperPercent:Ee,lowerPercent:_e,alphaPercent:ke,numericPercent:Ie}}function D(k){const{upperPercent:B,lowerPercent:j}=k;return j===0&&B>.6}function C(k){const{upperPercent:B,lowerPercent:j,alphaPercent:ee,numericPercent:ce}=k;return j>.2&&B<.8&&ee>.6&&ce<.2}function N(k){let B=0,j=0,ee=0,ce=0;for(let fe=0;fe<k.length;fe++)ee=k.charCodeAt(fe),b(ee)&&B++,f(ee)&&j++,a(ee)&&ce++;return(B===0||j===0)&&ce===0?k.length<=30:B<=5}function A(k,B){if(!B||(B=B.trim(),B.length===0)||!N(k)||B.length>60)return null;const j=h(B);if(!C(j)){if(!D(j))return null;B=B.toLowerCase()}let ee=null,ce=0;for(k=k.toLowerCase();ce<B.length&&(ee=u(k,B,0,ce))===null;)ce=E(B,ce+1);return ee}t.matchesCamelCase=A;function o(k,B,j=!1){if(!B||B.length===0)return null;let ee=null,ce=0;for(k=k.toLowerCase(),B=B.toLowerCase();ce<B.length&&(ee=l(k,B,0,ce,j))===null;)ce=s(B,ce+1);return ee}t.matchesWords=o;function l(k,B,j,ee,ce){if(j===k.length)return[];if(ee===B.length)return null;if(c(k.charCodeAt(j),B.charCodeAt(ee))){let fe=null,Ee=ee+1;if(fe=l(k,B,j+1,ee+1,ce),!ce)for(;!fe&&(Ee=s(B,Ee))<B.length;)fe=l(k,B,j+1,Ee,ce),Ee++;return fe===null?null:_({start:ee,end:ee+1},fe)}else return null}function s(k,B){for(let j=B;j<k.length;j++)if(e(k.charCodeAt(j))||j>0&&e(k.charCodeAt(j-1)))return j;return k.length}const n=P(t.matchesPrefix,A,y),g=P(t.matchesPrefix,A,w),S=new v.LRUCache(1e4);function $(k,B,j=!1){if(typeof k!="string"||typeof B!="string")return null;let ee=S.get(k);ee||(ee=new RegExp(i.convertSimple2RegExpPattern(k),"i"),S.set(k,ee));const ce=ee.exec(B);return ce?[{start:ce.index,end:ce.index+ce[0].length}]:j?g(k,B):n(k,B)}t.matchesFuzzy=$;function ie(k,B){const j=q(k,k.toLowerCase(),0,B,B.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?ge(j):null}t.matchesFuzzy2=ie;function te(k,B,j,ee,ce,fe){const Ee=Math.min(13,k.length);for(;j<Ee;j++){const _e=q(k,B,j,ee,ce,fe,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(_e)return _e}return[0,fe]}t.anyScore=te;function ge(k){if(typeof k=="undefined")return[];const B=[],j=k[1];for(let ee=k.length-1;ee>1;ee--){const ce=k[ee]+j,fe=B[B.length-1];fe&&fe.end===ce?fe.end=ce+1:B.push({start:ce,end:ce+1})}return B}t.createMatches=ge;const ae=128;function ve(){const k=[],B=[];for(let j=0;j<=ae;j++)B[j]=0;for(let j=0;j<=ae;j++)k.push(B.slice(0));return k}function he(k){const B=[];for(let j=0;j<=k;j++)B[j]=0;return B}const me=he(2*ae),ye=he(2*ae),J=ve(),de=ve(),ne=ve(),Q=!1;function re(k,B,j,ee,ce){function fe(_e,ke,Ie=" "){for(;_e.length<ke;)_e=Ie+_e;return _e}let Ee=` |   |${ee.split("").map(_e=>fe(_e,3)).join("|")}
`;for(let _e=0;_e<=j;_e++)_e===0?Ee+=" |":Ee+=`${B[_e-1]}|`,Ee+=k[_e].slice(0,ce+1).map(ke=>fe(ke.toString(),3)).join("|")+`
`;return Ee}function se(k,B,j,ee){k=k.substr(B),j=j.substr(ee),console.log(re(de,k,k.length,j,j.length)),console.log(re(ne,k,k.length,j,j.length)),console.log(re(J,k,k.length,j,j.length))}function F(k,B){if(B<0||B>=k.length)return!1;const j=k.codePointAt(B);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(j)}}function K(k,B){if(B<0||B>=k.length)return!1;switch(k.charCodeAt(B)){case 32:case 9:return!0;default:return!1}}function X(k,B,j){return B[k]!==j[k]}function O(k,B,j,ee,ce,fe,Ee=!1){for(;B<j&&ce<fe;)k[B]===ee[ce]&&(Ee&&(me[B]=ce),B+=1),ce+=1;return B===j}t.isPatternInWord=O;var d;(function(k){k[k.Diag=1]="Diag",k[k.Left=2]="Left",k[k.LeftLeft=3]="LeftLeft"})(d||(d={}));var L;(function(k){k.Default=[-100,0];function B(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}k.isDefault=B})(L=t.FuzzyScore||(t.FuzzyScore={}));class U{constructor(B,j){this.firstMatchCanBeWeak=B,this.boostFullMatch=j}}t.FuzzyScoreOptions=U,U.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function q(k,B,j,ee,ce,fe,Ee=U.default){const _e=k.length>ae?ae:k.length,ke=ee.length>ae?ae:ee.length;if(j>=_e||fe>=ke||_e-j>ke-fe||!O(B,j,_e,ce,fe,ke,!0))return;H(_e,ke,j,fe,B,ce);let Ie=1,De=1,Pe=j,Me=fe;const Ge=[!1];for(Ie=1,Pe=j;Pe<_e;Ie++,Pe++){const Oe=me[Pe],x=ye[Pe],oe=Pe+1<_e?ye[Pe+1]:ke;for(De=Oe-fe+1,Me=Oe;Me<oe;De++,Me++){let we=Number.MIN_SAFE_INTEGER,Ce=!1;Me<=x&&(we=R(k,B,Pe,j,ee,ce,Me,ke,fe,J[Ie-1][De-1]===0,Ge));let Fe=0;we!==Number.MAX_SAFE_INTEGER&&(Ce=!0,Fe=we+de[Ie-1][De-1]);const Re=Me>Oe,Ve=Re?de[Ie][De-1]+(J[Ie][De-1]>0?-5:0):0,tt=Me>Oe+1&&J[Ie][De-1]>0,Ye=tt?de[Ie][De-2]+(J[Ie][De-2]>0?-5:0):0;if(tt&&(!Re||Ye>=Ve)&&(!Ce||Ye>=Fe))de[Ie][De]=Ye,ne[Ie][De]=3,J[Ie][De]=0;else if(Re&&(!Ce||Ve>=Fe))de[Ie][De]=Ve,ne[Ie][De]=2,J[Ie][De]=0;else if(Ce)de[Ie][De]=Fe,ne[Ie][De]=1,J[Ie][De]=J[Ie-1][De-1]+1;else throw new Error("not possible")}}if(Q&&se(k,j,ee,fe),!Ge[0]&&!Ee.firstMatchCanBeWeak)return;Ie--,De--;const He=[de[Ie][De],fe];let Ue=0,Je=0;for(;Ie>=1;){let Oe=De;do{const x=ne[Ie][Oe];if(x===3)Oe=Oe-2;else if(x===2)Oe=Oe-1;else break}while(Oe>=1);Ue>1&&B[j+Ie-1]===ce[fe+De-1]&&!X(Oe+fe-1,ee,ce)&&Ue+1>J[Ie][Oe]&&(Oe=De),Oe===De?Ue++:Ue=1,Je||(Je=Oe),Ie--,De=Oe-1,He.push(De)}ke===_e&&Ee.boostFullMatch&&(He[0]+=2);const je=Je-_e;return He[0]-=je,He}t.fuzzyScore=q;function H(k,B,j,ee,ce,fe){let Ee=k-1,_e=B-1;for(;Ee>=j&&_e>=ee;)ce[Ee]===fe[_e]&&(ye[Ee]=_e,Ee--),_e--}function R(k,B,j,ee,ce,fe,Ee,_e,ke,Ie,De){if(B[j]!==fe[Ee])return Number.MIN_SAFE_INTEGER;let Pe=1,Me=!1;return Ee===j-ee?Pe=k[j]===ce[Ee]?7:5:X(Ee,ce,fe)&&(Ee===0||!X(Ee-1,ce,fe))?(Pe=k[j]===ce[Ee]?7:5,Me=!0):F(fe,Ee)&&(Ee===0||!F(fe,Ee-1))?Pe=5:(F(fe,Ee-1)||K(fe,Ee-1))&&(Pe=5,Me=!0),Pe>1&&j===ee&&(De[0]=!0),Me||(Me=X(Ee,ce,fe)||F(fe,Ee-1)||K(fe,Ee-1)),j===ee?Ee>ke&&(Pe-=Me?3:5):Ie?Pe+=Me?2:0:Pe+=Me?0:1,Ee+1===_e&&(Pe-=Me?3:5),Pe}function W(k,B,j,ee,ce,fe,Ee){return I(k,B,j,ee,ce,fe,!0,Ee)}t.fuzzyScoreGracefulAggressive=W;function V(k,B,j,ee,ce,fe,Ee){return I(k,B,j,ee,ce,fe,!1,Ee)}t.fuzzyScoreGraceful=V;function I(k,B,j,ee,ce,fe,Ee,_e){let ke=q(k,B,j,ee,ce,fe,_e);if(ke&&!Ee)return ke;if(k.length>=3){const Ie=Math.min(7,k.length-1);for(let De=j+1;De<Ie;De++){const Pe=z(k,De);if(Pe){const Me=q(Pe,Pe.toLowerCase(),j,ee,ce,fe,_e);Me&&(Me[0]-=3,(!ke||Me[0]>ke[0])&&(ke=Me))}}}return ke}function z(k,B){if(B+1>=k.length)return;const j=k[B],ee=k[B+1];if(j!==ee)return k.slice(0,B)+ee+j+k.slice(B+2)}}),define(pe[34],be([1,0,11,33,10]),function(Z,t,v,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=t.iconStartMarker=void 0,t.iconStartMarker="$(";const M=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(v.CSSIcon.iconNameCharacter),w=new RegExp(`(\\\\)?${M.source}`,"g");function p(m){return m.replace(w,(_,E)=>E?_:`\\${_}`)}t.escapeIcons=p;const f=new RegExp(`\\\\${M.source}`,"g");function b(m){return m.replace(f,_=>`\\${_}`)}t.markdownEscapeEscapedIcons=b;const T=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function a(m){return m.indexOf(t.iconStartMarker)===-1?m:m.replace(T,(_,E,u,h)=>u?_:E||h||"")}t.stripIcons=a;function r(m){const _=m.indexOf(t.iconStartMarker);return _===-1?{text:m}:e(m,_)}t.parseLabelWithIcons=r;function e(m,_){const E=[];let u="";function h(n){if(n){u+=n;for(const g of n)E.push(N)}}let D=-1,C="",N=0,A,o,l=_;const s=m.length;for(h(m.substr(0,_));l<s;)A=m[l],o=m[l+1],A===t.iconStartMarker[0]&&o===t.iconStartMarker[1]?(D=l,h(C),C=t.iconStartMarker,l++):A===")"&&D!==-1?(N+=l-D+1,D=-1,C=""):D!==-1?y.test(A)?C+=A:(h(C),D=-1,C=""):h(A),l++;return h(C),{text:u,iconOffsets:E}}function c(m,_,E=!1){const{text:u,iconOffsets:h}=_;if(!h||h.length===0)return(0,i.matchesFuzzy)(m,u,E);const D=(0,P.ltrim)(u," "),C=u.length-D.length,N=(0,i.matchesFuzzy)(m,D,E);if(N)for(const A of N){const o=h[A.start+C]+C;A.start+=o,A.end+=o}return N}t.matchesFuzzyIconAware=c}),define(pe[16],be([1,0,21,5]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const P=/^\w[\w\d+.-]*$/,M=/^\//,y=/^\/\//;function w(A,o){if(!A.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${A.authority}", path: "${A.path}", query: "${A.query}", fragment: "${A.fragment}"}`);if(A.scheme&&!P.test(A.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(A.path){if(A.authority){if(!M.test(A.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(A.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(A,o){return!A&&!o?"file":A}function f(A,o){switch(A){case"https":case"http":case"file":o?o[0]!==T&&(o=T+o):o=T;break}return o}const b="",T="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class r{constructor(o,l,s,n,g,S=!1){typeof o=="object"?(this.scheme=o.scheme||b,this.authority=o.authority||b,this.path=o.path||b,this.query=o.query||b,this.fragment=o.fragment||b):(this.scheme=p(o,S),this.authority=l||b,this.path=f(this.scheme,s||b),this.query=n||b,this.fragment=g||b,w(this,S))}static isUri(o){return o instanceof r?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return u(this,!1)}with(o){if(!o)return this;let{scheme:l,authority:s,path:n,query:g,fragment:S}=o;return l===void 0?l=this.scheme:l===null&&(l=b),s===void 0?s=this.authority:s===null&&(s=b),n===void 0?n=this.path:n===null&&(n=b),g===void 0?g=this.query:g===null&&(g=b),S===void 0?S=this.fragment:S===null&&(S=b),l===this.scheme&&s===this.authority&&n===this.path&&g===this.query&&S===this.fragment?this:new c(l,s,n,g,S)}static parse(o,l=!1){const s=a.exec(o);return s?new c(s[2]||b,N(s[4]||b),N(s[5]||b),N(s[7]||b),N(s[9]||b),l):new c(b,b,b,b,b)}static file(o){let l=b;if(i.isWindows&&(o=o.replace(/\\/g,T)),o[0]===T&&o[1]===T){const s=o.indexOf(T,2);s===-1?(l=o.substring(2),o=T):(l=o.substring(2,s),o=o.substring(s)||T)}return new c("file",l,o,b,b)}static from(o){const l=new c(o.scheme,o.authority,o.path,o.query,o.fragment);return w(l,!0),l}static joinPath(o,...l){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return i.isWindows&&o.scheme==="file"?s=r.file(v.win32.join(u(o,!0),...l)).path:s=v.posix.join(o.path,...l),o.with({path:s})}toString(o=!1){return h(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof r)return o;{const l=new c(o);return l._formatted=o.external,l._fsPath=o._sep===e?o.fsPath:null,l}}else return o}}t.URI=r;const e=i.isWindows?1:void 0;class c extends r{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(o=!1){return o?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=e),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(A,o){let l,s=-1;for(let n=0;n<A.length;n++){const g=A.charCodeAt(n);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||o&&g===47)s!==-1&&(l+=encodeURIComponent(A.substring(s,n)),s=-1),l!==void 0&&(l+=A.charAt(n));else{l===void 0&&(l=A.substr(0,n));const S=m[g];S!==void 0?(s!==-1&&(l+=encodeURIComponent(A.substring(s,n)),s=-1),l+=S):s===-1&&(s=n)}}return s!==-1&&(l+=encodeURIComponent(A.substring(s))),l!==void 0?l:A}function E(A){let o;for(let l=0;l<A.length;l++){const s=A.charCodeAt(l);s===35||s===63?(o===void 0&&(o=A.substr(0,l)),o+=m[s]):o!==void 0&&(o+=A[l])}return o!==void 0?o:A}function u(A,o){let l;return A.authority&&A.path.length>1&&A.scheme==="file"?l=`//${A.authority}${A.path}`:A.path.charCodeAt(0)===47&&(A.path.charCodeAt(1)>=65&&A.path.charCodeAt(1)<=90||A.path.charCodeAt(1)>=97&&A.path.charCodeAt(1)<=122)&&A.path.charCodeAt(2)===58?o?l=A.path.substr(1):l=A.path[1].toLowerCase()+A.path.substr(2):l=A.path,i.isWindows&&(l=l.replace(/\//g,"\\")),l}t.uriToFsPath=u;function h(A,o){const l=o?E:_;let s="",{scheme:n,authority:g,path:S,query:$,fragment:ie}=A;if(n&&(s+=n,s+=":"),(g||n==="file")&&(s+=T,s+=T),g){let te=g.indexOf("@");if(te!==-1){const ge=g.substr(0,te);g=g.substr(te+1),te=ge.indexOf(":"),te===-1?s+=l(ge,!1):(s+=l(ge.substr(0,te),!1),s+=":",s+=l(ge.substr(te+1),!1)),s+="@"}g=g.toLowerCase(),te=g.indexOf(":"),te===-1?s+=l(g,!1):(s+=l(g.substr(0,te),!1),s+=g.substr(te))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const te=S.charCodeAt(1);te>=65&&te<=90&&(S=`/${String.fromCharCode(te+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const te=S.charCodeAt(0);te>=65&&te<=90&&(S=`${String.fromCharCode(te+32)}:${S.substr(2)}`)}s+=l(S,!0)}return $&&(s+="?",s+=l($,!1)),ie&&(s+="#",s+=o?ie:_(ie,!1)),s}function D(A){try{return decodeURIComponent(A)}catch{return A.length>3?A.substr(0,3)+D(A.substr(3)):A}}const C=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(A){return A.match(C)?A.replace(C,o=>D(o)):A}}),define(pe[49],be([1,0,31,10,16]),function(Z,t,v,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function M(f){return JSON.stringify(f,w)}t.stringify=M;function y(f){let b=JSON.parse(f);return b=p(b),b}t.parse=y;function w(f,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,i.regExpFlags)(b)}:b}function p(f,b=0){if(!f||b>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return P.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 14:return new Date(f.source)}if(f instanceof v.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let T=0;T<f.length;++T)f[T]=p(f[T],b+1);else for(const T in f)Object.hasOwnProperty.call(f,T)&&(f[T]=p(f[T],b+1))}return f}t.revive=p}),define(pe[35],be([1,0,5,16]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileAccess=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var P;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls"})(P=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${P.vscodeRemoteResource}`}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}setServerRootPath(p){this._remoteResourcesPath=`${p}/${P.vscodeRemoteResource}`}set(p,f,b){this._hosts[p]=f,this._ports[p]=b}setConnectionToken(p,f){this._connectionTokens[p]=f}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(p){if(this._delegate)return this._delegate(p);const f=p.authority;let b=this._hosts[f];b&&b.indexOf(":")!==-1&&(b=`[${b}]`);const T=this._ports[f],a=this._connectionTokens[f];let r=`path=${encodeURIComponent(p.path)}`;return typeof a=="string"&&(r+=`&${t.connectionTokenQueryName}=${encodeURIComponent(a)}`),i.URI.from({scheme:v.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${b}:${T}`,path:this._remoteResourcesPath,query:r})}}t.RemoteAuthorities=new M;class y{asBrowserUri(p,f){const b=this.toUri(p,f);return b.scheme===P.vscodeRemote?t.RemoteAuthorities.rewrite(b):b.scheme===P.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${P.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?b.with({scheme:P.vscodeFileResource,authority:b.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(p,f){const b=this.toUri(p,f);return b.scheme===P.vscodeFileResource?b.with({scheme:P.file,authority:b.authority!==y.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(p,f){return i.URI.isUri(p)?p:i.URI.parse(f.toUrl(p))}}y.FALLBACK_AUTHORITY="vscode-app",t.FileAccess=new y}),define(pe[36],be([1,0,109,35,21,5,10,16]),function(Z,t,v,i,P,M,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function p(r){return(0,w.uriToFsPath)(r,!0)}t.originalFSPath=p;class f{constructor(e){this._ignorePathCasing=e}compare(e,c,m=!1){return e===c?0:(0,y.compare)(this.getComparisonKey(e,m),this.getComparisonKey(c,m))}isEqual(e,c,m=!1){return e===c?!0:!e||!c?!1:this.getComparisonKey(e,m)===this.getComparisonKey(c,m)}getComparisonKey(e,c=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,c,m=!1){if(e.scheme===c.scheme){if(e.scheme===i.Schemas.file)return v.isEqualOrParent(p(e),p(c),this._ignorePathCasing(e))&&e.query===c.query&&(m||e.fragment===c.fragment);if((0,t.isEqualAuthority)(e.authority,c.authority))return v.isEqualOrParent(e.path,c.path,this._ignorePathCasing(e),"/")&&e.query===c.query&&(m||e.fragment===c.fragment)}return!1}joinPath(e,...c){return w.URI.joinPath(e,...c)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return P.posix.basename(e.path)}extname(e){return P.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let c;return e.scheme===i.Schemas.file?c=w.URI.file(P.dirname(p(e))).path:(c=P.posix.dirname(e.path),e.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),c="/")),e.with({path:c})}normalizePath(e){if(!e.path.length)return e;let c;return e.scheme===i.Schemas.file?c=w.URI.file(P.normalize(p(e))).path:c=P.posix.normalize(e.path),e.with({path:c})}relativePath(e,c){if(e.scheme!==c.scheme||!(0,t.isEqualAuthority)(e.authority,c.authority))return;if(e.scheme===i.Schemas.file){const E=P.relative(p(e),p(c));return M.isWindows?v.toSlashes(E):E}let m=e.path||"/";const _=c.path||"/";if(this._ignorePathCasing(e)){let E=0;for(const u=Math.min(m.length,_.length);E<u&&!(m.charCodeAt(E)!==_.charCodeAt(E)&&m.charAt(E).toLowerCase()!==_.charAt(E).toLowerCase());E++);m=_.substr(0,E)+m.substr(E)}return P.posix.relative(m,_)}resolvePath(e,c){if(e.scheme===i.Schemas.file){const m=w.URI.file(P.resolve(p(e),c));return e.with({authority:m.authority,path:m.path})}return c=v.toPosixPath(c),e.with({path:P.posix.resolve(e.path,c)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,c){return e===c||e!==void 0&&c!==void 0&&(0,y.equalsIgnoreCase)(e,c)}hasTrailingPathSeparator(e,c=P.sep){if(e.scheme===i.Schemas.file){const m=p(e);return m.length>v.getRoot(m).length&&m[m.length-1]===c}else{const m=e.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,c=P.sep){return(0,t.hasTrailingPathSeparator)(e,c)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,c=P.sep){let m=!1;if(e.scheme===i.Schemas.file){const _=p(e);m=_!==void 0&&_.length===v.getRoot(_).length&&_[_.length-1]===c}else{c="/";const _=e.path;m=_.length===1&&_.charCodeAt(_.length-1)===47}return!m&&!(0,t.hasTrailingPathSeparator)(e,c)?e.with({path:e.path+"/"}):e}}t.ExtUri=f,t.extUri=new f(()=>!1),t.extUriBiasedIgnorePathCase=new f(r=>r.scheme===i.Schemas.file?!M.isLinux:!0),t.extUriIgnorePathCase=new f(r=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function b(r,e){const c=[];for(let m=0;m<r.length;m++){const _=e(r[m]);r.some((E,u)=>u===m?!1:(0,t.isEqualOrParent)(_,e(E)))||c.push(r[m])}return c}t.distinctParents=b;var T;(function(r){r.META_DATA_LABEL="label",r.META_DATA_DESCRIPTION="description",r.META_DATA_SIZE="size",r.META_DATA_MIME="mime";function e(c){const m=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(u=>{const[h,D]=u.split(":");h&&D&&m.set(h,D)});const E=c.path.substring(0,c.path.indexOf(";"));return E&&m.set(r.META_DATA_MIME,E),m}r.parseMetaData=e})(T=t.DataUri||(t.DataUri={}));function a(r,e,c){if(e){let m=r.path;return m&&m[0]!==P.posix.sep&&(m=P.posix.sep+m),r.with({scheme:c,authority:e,path:m})}return r.with({scheme:c})}t.toLocalResource=a}),define(pe[8],be([1,0,28,13,3,2,36,5]),function(Z,t,v,i,P,M,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function p(X){return!!X&&typeof X.then=="function"}t.isThenable=p;function f(X){const O=new v.CancellationTokenSource,d=X(O.token),L=new Promise((U,q)=>{const H=O.token.onCancellationRequested(()=>{H.dispose(),O.dispose(),q(new i.CancellationError)});Promise.resolve(d).then(R=>{H.dispose(),O.dispose(),U(R)},R=>{H.dispose(),O.dispose(),q(R)})});return new class{cancel(){O.cancel()}then(U,q){return L.then(U,q)}catch(U){return this.then(void 0,U)}finally(U){return L.finally(U)}}}t.createCancelablePromise=f;function b(X,O,d){return new Promise((L,U)=>{const q=O.onCancellationRequested(()=>{q.dispose(),L(d)});X.then(L,U).finally(()=>q.dispose())})}t.raceCancellation=b;function T(X,O){return new Promise((d,L)=>{const U=O.onCancellationRequested(()=>{U.dispose(),L(new i.CancellationError)});X.then(d,L).finally(()=>U.dispose())})}t.raceCancellationError=T;async function a(X){let O=-1;const d=X.map((U,q)=>U.then(H=>(O=q,H))),L=await Promise.race(d);return X.forEach((U,q)=>{q!==O&&U.cancel()}),L}t.raceCancellablePromises=a;function r(X,O,d){let L;const U=setTimeout(()=>{L?.(void 0),d?.()},O);return Promise.race([X.finally(()=>clearTimeout(U)),new Promise(q=>L=q)])}t.raceTimeout=r;function e(X){return new Promise((O,d)=>{const L=X();p(L)?L.then(O,d):O(L)})}t.asPromise=e;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const d=()=>{this.queuedPromise=null;const L=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,L};this.queuedPromise=new Promise(L=>{this.activePromise.then(d,d).then(L)})}return new Promise((d,L)=>{this.queuedPromise.then(d,L)})}return this.activePromise=O(),new Promise((d,L)=>{this.activePromise.then(U=>{this.activePromise=null,d(U)},U=>{this.activePromise=null,L(U)})})}}t.Throttler=c;class m{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}t.Sequencer=m;class _{constructor(){this.promiseMap=new Map}queue(O,d){const U=(this.promiseMap.get(O)??Promise.resolve()).catch(()=>{}).then(d).finally(()=>{this.promiseMap.get(O)===U&&this.promiseMap.delete(O)});return this.promiseMap.set(O,U),U}}t.SequencerByKey=_;const E=(X,O)=>{let d=!0;const L=setTimeout(()=>{d=!1,O()},X);return{isTriggered:()=>d,dispose:()=>{clearTimeout(L),d=!1}}},u=X=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,X())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(O){this.defaultDelay=O,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,d=this.defaultDelay){this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,q)=>{this.doResolve=U,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}}));const L=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=d===t.MicrotaskDelay?u(L):E(d,L),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=h;class D{constructor(O){this.delayer=new h(O),this.throttler=new c}trigger(O,d){return this.delayer.trigger(()=>this.throttler.queue(O),d)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}t.ThrottledDelayer=D;class C{constructor(){this._isOpen=!1,this._promise=new Promise((O,d)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=C;class N extends C{constructor(O){super();this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=N;function A(X,O){return O?new Promise((d,L)=>{const U=setTimeout(()=>{q.dispose(),d()},X),q=O.onCancellationRequested(()=>{clearTimeout(U),q.dispose(),L(new i.CancellationError)})}):f(d=>A(X,d))}t.timeout=A;function o(X,O=0){const d=setTimeout(X,O);return(0,M.toDisposable)(()=>clearTimeout(d))}t.disposableTimeout=o;function l(X){const O=[];let d=0;const L=X.length;function U(){return d<L?X[d++]():null}function q(H){H!=null&&O.push(H);const R=U();return R?R.then(q):Promise.resolve(O)}return Promise.resolve(null).then(q)}t.sequence=l;function s(X,O=L=>!!L,d=null){let L=0;const U=X.length,q=()=>{if(L>=U)return Promise.resolve(d);const H=X[L++];return Promise.resolve(H()).then(W=>O(W)?Promise.resolve(W):q())};return q()}t.first=s;function n(X,O=L=>!!L,d=null){if(X.length===0)return Promise.resolve(d);let L=X.length;const U=()=>{L=-1;for(const q of X)q.cancel?.()};return new Promise((q,H)=>{for(const R of X)R.then(W=>{--L>=0&&O(W)?(U(),q(W)):L===0&&q(d)}).catch(W=>{--L>=0&&(U(),H(W))})})}t.firstParallel=n;class g{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new P.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(O){return this._size++,new Promise((d,L)=>{this.outstandingPromises.push({factory:O,c:d,e:L}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const d=O.factory();d.then(O.c,O.e),d.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}t.Limiter=g;class S extends g{constructor(){super(1)}}t.Queue=S;class ${constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const O=new ne;return this.drainers.add(O),O.p}isDrained(){for(const[,O]of this.queues)if(O.size>0)return!1;return!0}queueFor(O,d=y.extUri){const L=d.getComparisonKey(O);let U=this.queues.get(L);return U||(U=new S,P.Event.once(U.onDrained)(()=>{U?.dispose(),this.queues.delete(L),this.onDidQueueDrain()}),this.queues.set(L,U)),U}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const O of this.drainers)O.complete();this.drainers.clear()}dispose(){for(const[,O]of this.queues)O.dispose();this.queues.clear(),this.releaseDrainers()}}t.ResourceQueue=$;class ie{constructor(O,d){this._token=-1,typeof O=="function"&&typeof d=="number"&&this.setIfNotSet(O,d)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,d){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},d)}setIfNotSet(O,d){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},d))}}t.TimeoutTimer=ie;class te{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,d){this.cancel(),this._token=setInterval(()=>{O()},d)}}t.IntervalTimer=te;class ge{constructor(O,d){this.timeoutToken=-1,this.runner=O,this.timeout=d,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=ge;class ae{constructor(O,d){d%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${d}ms is not a multiple of 1000ms.`),this.runner=O,this.timeout=d,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(O=this.timeout){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(O/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=ae;class ve extends ge{constructor(O,d){super(O,d);this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner?.(O)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=ve;class he extends M.Disposable{constructor(O,d){super();this.options=O,this.handler=d,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.options.maxBufferedWork)return!1}else if(this.pending+O.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...O),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ge(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=he,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=X=>{(0,w.setTimeout0)(()=>{if(O)return;const d=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,d-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:t.runWhenIdle=(X,O)=>{const d=requestIdleCallback(X,typeof O=="number"?{timeout:O}:void 0);let L=!1;return{dispose(){L||(L=!0,cancelIdleCallback(d))}}}}();class me{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch(d){this._error=d}finally{this._didRun=!0}},this._handle=(0,t.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.IdleValue=me;async function ye(X,O,d){let L;for(let U=0;U<d;U++)try{return await X()}catch(q){L=q,await A(O)}throw L}t.retry=ye;class J{hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(O,d,L){return this._pending={taskId:O,cancel:()=>L?.(),promise:d},d.then(()=>this.donePending(O),()=>this.donePending(O)),d}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let d,L;const U=new Promise((q,H)=>{d=q,L=H});this._next={run:O,promise:U,promiseResolve:d,promiseReject:L}}return this._next.promise}}t.TaskSequentializer=J;class de{constructor(O,d=()=>Date.now()){this.interval=O,this.nowFn=d,this.lastIncrementTime=0,this.value=0}increment(){const O=this.nowFn();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}t.IntervalCounter=de;class ne{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((O,d)=>{this.completeCallback=O,this.errorCallback=d})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(O){return new Promise(d=>{this.completeCallback(O),this.resolved=!0,d()})}error(O){return new Promise(d=>{this.errorCallback(O),this.rejected=!0,d()})}cancel(){new Promise(O=>{this.errorCallback(new i.CancellationError),this.rejected=!0,O()})}}t.DeferredPromise=ne;var Q;(function(X){async function O(L){let U;const q=await Promise.all(L.map(H=>H.then(R=>R,R=>{U||(U=R)})));if(typeof U!="undefined")throw U;return q}X.settled=O;function d(L){return new Promise(async(U,q)=>{try{await L(U,q)}catch(H){q(H)}})}X.withAsyncBody=d})(Q=t.Promises||(t.Promises={}));var re;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(re||(re={}));class se{constructor(O){this._state=0,this._results=[],this._error=null,this._onStateChanged=new P.Emitter,queueMicrotask(async()=>{const d={emitOne:L=>this.emitOne(L),emitMany:L=>this.emitMany(L),reject:L=>this.reject(L)};try{await Promise.resolve(O(d)),this.resolve()}catch(L){this.reject(L)}finally{d.emitOne=void 0,d.emitMany=void 0,d.reject=void 0}})}static fromArray(O){return new se(d=>{d.emitMany(O)})}static fromPromise(O){return new se(async d=>{d.emitMany(await O)})}static fromPromises(O){return new se(async d=>{await Promise.all(O.map(async L=>d.emitOne(await L)))})}static merge(O){return new se(async d=>{await Promise.all(O.map(async L=>{for await(const U of L)d.emitOne(U)}))})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(O<this._results.length)return{done:!1,value:this._results[O++]};if(this._state===1)return{done:!0,value:void 0};await P.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(O,d){return new se(async L=>{for await(const U of O)L.emitOne(d(U))})}map(O){return se.map(this,O)}static filter(O,d){return new se(async L=>{for await(const U of O)d(U)&&L.emitOne(U)})}filter(O){return se.filter(this,O)}static coalesce(O){return se.filter(O,d=>!!d)}coalesce(){return se.coalesce(this)}static async toPromise(O){const d=[];for await(const L of O)d.push(L);return d}toPromise(){return se.toPromise(this)}emitOne(O){this._state===0&&(this._results.push(O),this._onStateChanged.fire())}emitMany(O){this._state===0&&(this._results=this._results.concat(O),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(O){this._state===0&&(this._state=2,this._error=O,this._onStateChanged.fire())}}t.AsyncIterableObject=se,se.EMPTY=se.fromArray([]);class F extends se{constructor(O,d){super(d);this._source=O}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=F;function K(X){const O=new v.CancellationTokenSource,d=X(O.token);return new F(O,async L=>{const U=O.token.onCancellationRequested(()=>{U.dispose(),O.dispose(),L.reject(new i.CancellationError)});try{for await(const q of d){if(O.token.isCancellationRequested)return;L.emitOne(q)}U.dispose(),O.dispose()}catch(q){U.dispose(),O.dispose(),L.reject(q)}})}t.createCancelableAsyncIterable=K}),define(pe[4],be([1,0,15,107,19,20,8,13,3,112,2,35,5,6,16]),function(Z,t,v,i,P,M,y,w,p,f,b,T,a,r,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.computeClippingRect=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.getElementsByTagName=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.StandardWindow=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.createEventEmitter=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function c(Y){for(;Y.firstChild;)Y.firstChild.remove()}t.clearNode=c;function m(Y){return Y?.isConnected??!1}t.isInDOM=m;class _{constructor(G,ue,Ae,Te){this._node=G,this._type=ue,this._handler=Ae,this._options=Te||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){!this._handler||(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function E(Y,G,ue,Ae){return new _(Y,G,ue,Ae)}t.addDisposableListener=E;function u(Y){return function(G){return Y(new M.StandardMouseEvent(G))}}function h(Y){return function(G){return Y(new P.StandardKeyboardEvent(G))}}const D=function(G,ue,Ae,Te){let We=Ae;return ue==="click"||ue==="mousedown"?We=u(Ae):(ue==="keydown"||ue==="keypress"||ue==="keyup")&&(We=h(Ae)),E(G,ue,We,Te)};t.addStandardDisposableListener=D;const C=function(G,ue,Ae){const Te=u(ue);return A(G,Te,Ae)};t.addStandardDisposableGenericMouseDownListener=C;const N=function(G,ue,Ae){const Te=u(ue);return l(G,Te,Ae)};t.addStandardDisposableGenericMouseUpListener=N;function A(Y,G,ue){return E(Y,a.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,G,ue)}t.addDisposableGenericMouseDownListener=A;function o(Y,G,ue){return E(Y,a.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,G,ue)}t.addDisposableGenericMouseMoveListener=o;function l(Y,G,ue){return E(Y,a.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,G,ue)}t.addDisposableGenericMouseUpListener=l;function s(Y,G,ue){let Ae=null;const Te=Qe=>xe.fire(Qe),We=()=>{Ae||(Ae=new _(Y,G,Te,ue))},ze=()=>{Ae&&(Ae.dispose(),Ae=null)},xe=new p.Emitter({onFirstListenerAdd:We,onLastListenerRemove:ze});return xe}t.createEventEmitter=s;let n=null;function g(Y){if(!n){const G=ue=>setTimeout(()=>ue(new Date().getTime()),0);n=self.requestAnimationFrame||self.msRequestAnimationFrame||self.webkitRequestAnimationFrame||self.mozRequestAnimationFrame||self.oRequestAnimationFrame||G}return n.call(self,Y)}class S{constructor(G,ue=0){this._runner=G,this.priority=ue,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(G){(0,w.onUnexpectedError)(G)}}static sort(G,ue){return ue.priority-G.priority}}(function(){let Y=[],G=null,ue=!1,Ae=!1;const Te=()=>{for(ue=!1,G=Y,Y=[],Ae=!0;G.length>0;)G.sort(S.sort),G.shift().execute();Ae=!1};t.scheduleAtNextAnimationFrame=(We,ze=0)=>{const xe=new S(We,ze);return Y.push(xe),ue||(ue=!0,g(Te)),xe},t.runAtThisOrScheduleAtNextAnimationFrame=(We,ze)=>{if(Ae){const xe=new S(We,ze);return G.push(xe),xe}else return(0,t.scheduleAtNextAnimationFrame)(We,ze)}})();function $(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,1e4)}t.measure=$;function ie(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,-1e4)}t.modify=ie;const te=8,ge=function(Y,G){return G};class ae extends b.Disposable{constructor(G,ue,Ae,Te=ge,We=te){super();let ze=null,xe=0;const Qe=this._register(new y.TimeoutTimer),bt=()=>{xe=new Date().getTime(),Ae(ze),ze=null};this._register(E(G,ue,Lt=>{ze=Te(ze,Lt);const gt=new Date().getTime()-xe;gt>=We?(Qe.cancel(),bt()):Qe.setIfNotSet(bt,We-gt)}))}}function ve(Y,G,ue,Ae,Te){return new ae(Y,G,ue,Ae,Te)}t.addDisposableThrottledListener=ve;function he(Y){return document.defaultView.getComputedStyle(Y,null)}t.getComputedStyle=he;function me(Y){if(Y!==document.body)return new J(Y.clientWidth,Y.clientHeight);if(a.isIOS&&window.visualViewport)return new J(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new J(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new J(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new J(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=me;class ye{static convertToPixels(G,ue){return parseFloat(ue)||0}static getDimension(G,ue,Ae){const Te=he(G);let We="0";return Te&&(Te.getPropertyValue?We=Te.getPropertyValue(ue):We=Te.getAttribute(Ae)),ye.convertToPixels(G,We)}static getBorderLeftWidth(G){return ye.getDimension(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return ye.getDimension(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return ye.getDimension(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return ye.getDimension(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return ye.getDimension(G,"padding-left","paddingLeft")}static getPaddingRight(G){return ye.getDimension(G,"padding-right","paddingRight")}static getPaddingTop(G){return ye.getDimension(G,"padding-top","paddingTop")}static getPaddingBottom(G){return ye.getDimension(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return ye.getDimension(G,"margin-left","marginLeft")}static getMarginTop(G){return ye.getDimension(G,"margin-top","marginTop")}static getMarginRight(G){return ye.getDimension(G,"margin-right","marginRight")}static getMarginBottom(G){return ye.getDimension(G,"margin-bottom","marginBottom")}}class J{constructor(G,ue){this.width=G,this.height=ue}with(G=this.width,ue=this.height){return G!==this.width||ue!==this.height?new J(G,ue):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof J?G:new J(G.width,G.height)}static equals(G,ue){return G===ue?!0:!G||!ue?!1:G.width===ue.width&&G.height===ue.height}}t.Dimension=J,J.None=new J(0,0);function de(Y){let G=Y.offsetParent,ue=Y.offsetTop,Ae=Y.offsetLeft;for(;(Y=Y.parentNode)!==null&&Y!==document.body&&Y!==document.documentElement;){ue-=Y.scrollTop;const Te=k(Y)?null:he(Y);Te&&(Ae-=Te.direction!=="rtl"?Y.scrollLeft:-Y.scrollLeft),Y===G&&(Ae+=ye.getBorderLeftWidth(Y),ue+=ye.getBorderTopWidth(Y),ue+=Y.offsetTop,Ae+=Y.offsetLeft,G=Y.offsetParent)}return{left:Ae,top:ue}}t.getTopLeftOffset=de;function ne(Y,G,ue){typeof G=="number"&&(Y.style.width=`${G}px`),typeof ue=="number"&&(Y.style.height=`${ue}px`)}t.size=ne;function Q(Y,G,ue,Ae,Te,We="absolute"){typeof G=="number"&&(Y.style.top=`${G}px`),typeof ue=="number"&&(Y.style.right=`${ue}px`),typeof Ae=="number"&&(Y.style.bottom=`${Ae}px`),typeof Te=="number"&&(Y.style.left=`${Te}px`),Y.style.position=We}t.position=Q;function re(Y){const G=Y.getBoundingClientRect();return{left:G.left+t.StandardWindow.scrollX,top:G.top+t.StandardWindow.scrollY,width:G.width,height:G.height}}t.getDomNodePagePosition=re;function se(Y){let G=Y,ue=1;do{const Ae=he(G).zoom;Ae!=null&&Ae!=="1"&&(ue*=Ae),G=G.parentElement}while(G!==null&&G!==document.documentElement);return ue}t.getDomNodeZoomLevel=se,t.StandardWindow=new class{get scrollX(){return typeof window.scrollX=="number"?window.scrollX:document.body.scrollLeft+document.documentElement.scrollLeft}get scrollY(){return typeof window.scrollY=="number"?window.scrollY:document.body.scrollTop+document.documentElement.scrollTop}};function F(Y){const G=ye.getMarginLeft(Y)+ye.getMarginRight(Y);return Y.offsetWidth+G}t.getTotalWidth=F;function K(Y){const G=ye.getBorderLeftWidth(Y)+ye.getBorderRightWidth(Y),ue=ye.getPaddingLeft(Y)+ye.getPaddingRight(Y);return Y.offsetWidth-G-ue}t.getContentWidth=K;function X(Y){const G=ye.getMarginLeft(Y)+ye.getMarginRight(Y);return Y.scrollWidth+G}t.getTotalScrollWidth=X;function O(Y){const G=ye.getBorderTopWidth(Y)+ye.getBorderBottomWidth(Y),ue=ye.getPaddingTop(Y)+ye.getPaddingBottom(Y);return Y.offsetHeight-G-ue}t.getContentHeight=O;function d(Y){const G=ye.getMarginTop(Y)+ye.getMarginBottom(Y);return Y.offsetHeight+G}t.getTotalHeight=d;function L(Y,G){if(Y===null)return 0;const ue=de(Y),Ae=de(G);return ue.left-Ae.left}function U(Y,G){const ue=G.map(Te=>Math.max(X(Te),F(Te))+L(Te,Y)||0);return Math.max(...ue)}t.getLargestChildWidth=U;function q(Y,G){for(;Y;){if(Y===G)return!0;Y=Y.parentNode}return!1}t.isAncestor=q;const H="parentFlowToElementId";function R(Y,G){Y.dataset[H]=G.id}t.setParentFlowTo=R;function W(Y){const G=Y.dataset[H];return typeof G=="string"?document.getElementById(G):null}function V(Y,G){let ue=Y;for(;ue;){if(ue===G)return!0;if(ue instanceof HTMLElement){const Ae=W(ue);if(Ae){ue=Ae;continue}}ue=ue.parentNode}return!1}t.isAncestorUsingFlowTo=V;function I(Y,G,ue){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y.classList.contains(G))return Y;if(ue){if(typeof ue=="string"){if(Y.classList.contains(ue))return null}else if(Y===ue)return null}Y=Y.parentNode}return null}t.findParentWithClass=I;function z(Y,G,ue){return!!I(Y,G,ue)}t.hasParentWithClass=z;function k(Y){return Y&&!!Y.host&&!!Y.mode}t.isShadowRoot=k;function B(Y){return!!j(Y)}t.isInShadowDOM=B;function j(Y){for(;Y.parentNode;){if(Y===document.body)return null;Y=Y.parentNode}return k(Y)?Y:null}t.getShadowRoot=j;function ee(){let Y=document.activeElement;for(;Y?.shadowRoot;)Y=Y.shadowRoot.activeElement;return Y}t.getActiveElement=ee;function ce(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("style");return G.type="text/css",G.media="screen",Y.appendChild(G),G}t.createStyleSheet=ce;function fe(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("meta");return Y.appendChild(G),G}t.createMetaElement=fe;let Ee=null;function _e(){return Ee||(Ee=ce()),Ee}function ke(Y){return Y?.sheet?.rules?Y.sheet.rules:Y?.sheet?.cssRules?Y.sheet.cssRules:[]}function Ie(Y,G,ue=_e()){!ue||!G||ue.sheet.insertRule(Y+"{"+G+"}",0)}t.createCSSRule=Ie;function De(Y,G=_e()){if(!G)return;const ue=ke(G),Ae=[];for(let Te=0;Te<ue.length;Te++)ue[Te].selectorText.indexOf(Y)!==-1&&Ae.push(Te);for(let Te=Ae.length-1;Te>=0;Te--)G.sheet.deleteRule(Ae[Te])}t.removeCSSRulesContainingSelector=De;function Pe(Y){return typeof HTMLElement=="object"?Y instanceof HTMLElement:Y&&typeof Y=="object"&&Y.nodeType===1&&typeof Y.nodeName=="string"}t.isHTMLElement=Pe,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:v.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:v.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:v.isWebKit?"webkitAnimationIteration":"animationiteration"},t.EventHelper={stop:function(Y,G){Y.preventDefault?Y.preventDefault():Y.returnValue=!1,G&&(Y.stopPropagation?Y.stopPropagation():Y.cancelBubble=!0)}};function Me(Y){const G=[];for(let ue=0;Y&&Y.nodeType===Y.ELEMENT_NODE;ue++)G[ue]=Y.scrollTop,Y=Y.parentNode;return G}t.saveParentsScrollTop=Me;function Ge(Y,G){for(let ue=0;Y&&Y.nodeType===Y.ELEMENT_NODE;ue++)Y.scrollTop!==G[ue]&&(Y.scrollTop=G[ue]),Y=Y.parentNode}t.restoreParentsScrollTop=Ge;class He extends b.Disposable{constructor(G){super();this._onDidFocus=this._register(new p.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new p.Emitter),this.onDidBlur=this._onDidBlur.event;let ue=He.hasFocusWithin(G),Ae=!1;const Te=()=>{Ae=!1,ue||(ue=!0,this._onDidFocus.fire())},We=()=>{ue&&(Ae=!0,window.setTimeout(()=>{Ae&&(Ae=!1,ue=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{He.hasFocusWithin(G)!==ue&&(ue?We():Te())},this._register(E(G,t.EventType.FOCUS,Te,!0)),this._register(E(G,t.EventType.BLUR,We,!0)),this._register(E(G,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(E(G,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler()))}static hasFocusWithin(G){const ue=j(G),Ae=ue?ue.activeElement:document.activeElement;return q(Ae,G)}refreshState(){this._refreshStateHandler()}}function Ue(Y){return new He(Y)}t.trackFocus=Ue;function Je(Y,G){return Y.after(G),G}t.after=Je;function je(Y,...G){if(Y.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}t.append=je;function Oe(Y,G){return Y.insertBefore(G,Y.firstChild),G}t.prepend=Oe;function x(Y,...G){Y.innerText="",je(Y,...G)}t.reset=x;const oe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var we;(function(Y){Y.HTML="http://www.w3.org/1999/xhtml",Y.SVG="http://www.w3.org/2000/svg"})(we=t.Namespace||(t.Namespace={}));function Ce(Y,G,ue,...Ae){const Te=oe.exec(G);if(!Te)throw new Error("Bad use of emmet");ue={...ue||{}};const We=Te[1]||"div";let ze;return Y!==we.HTML?ze=document.createElementNS(Y,We):ze=document.createElement(We),Te[3]&&(ze.id=Te[3]),Te[4]&&(ze.className=Te[4].replace(/\./g," ").trim()),Object.keys(ue).forEach(xe=>{const Qe=ue[xe];typeof Qe!="undefined"&&(/^on\w+$/.test(xe)?ze[xe]=Qe:xe==="selected"?Qe&&ze.setAttribute(xe,"true"):ze.setAttribute(xe,Qe))}),ze.append(...Ae),ze}function Fe(Y,G,...ue){return Ce(we.HTML,Y,G,...ue)}t.$=Fe,Fe.SVG=function(Y,G,...ue){return Ce(we.SVG,Y,G,...ue)};function Re(Y,G){const ue=[];return Y.forEach((Ae,Te)=>{Te>0&&(G instanceof Node?ue.push(G.cloneNode()):ue.push(document.createTextNode(G))),ue.push(Ae)}),ue}t.join=Re;function Ve(...Y){for(const G of Y)G.style.display="",G.removeAttribute("aria-hidden")}t.show=Ve;function tt(...Y){for(const G of Y)G.style.display="none",G.setAttribute("aria-hidden","true")}t.hide=tt;function Ye(Y,G){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y instanceof HTMLElement&&Y.hasAttribute(G))return Y;Y=Y.parentNode}return null}function qe(Y){if(!(!Y||!Y.hasAttribute("tabIndex"))){if(document.activeElement===Y){const G=Ye(Y.parentElement,"tabIndex");G&&G.focus()}Y.removeAttribute("tabindex")}}t.removeTabIndexAndUpdateFocus=qe;function Le(Y){return Array.prototype.slice.call(document.getElementsByTagName(Y),0)}t.getElementsByTagName=Le;function le(Y){return G=>{G.preventDefault(),G.stopPropagation(),Y(G)}}t.finalHandler=le;function Se(){return new Promise(Y=>{document.readyState==="complete"||document&&document.body!==null?Y(void 0):window.addEventListener("DOMContentLoaded",Y,!1)})}t.domContentLoaded=Se;function Ne(Y){const G=window.devicePixelRatio*Y;return Math.max(1,Math.floor(G))/window.devicePixelRatio}t.computeScreenAwareSize=Ne;function $e(Y){window.open(Y,"_blank","noopener")}t.windowOpenNoOpener=$e;const Xe=780,Ze=640;function et(Y){const G=Math.floor(window.screenLeft+window.innerWidth/2-Xe/2),ue=Math.floor(window.screenTop+window.innerHeight/2-Ze/2);window.open(Y,"_blank",`width=${Xe},height=${Ze},top=${ue},left=${G}`)}t.windowOpenPopup=et;function st(Y,G=!0){const ue=window.open();return ue?(G&&(ue.opener=null),ue.location.href=Y,!0):!1}t.windowOpenWithSuccess=st;function dt(Y){const G=()=>{Y(),ue=(0,t.scheduleAtNextAnimationFrame)(G)};let ue=(0,t.scheduleAtNextAnimationFrame)(G);return(0,b.toDisposable)(()=>ue.dispose())}t.animate=dt,T.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function yt(Y){return Y?`url('${T.FileAccess.asBrowserUri(Y).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=yt;function It(Y){return`'${Y.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=It;function Ut(Y,G){let ue;if(e.URI.isUri(Y))ue=Y.toString(!0);else{const Te=new Blob([Y]);ue=URL.createObjectURL(Te),setTimeout(()=>URL.revokeObjectURL(ue))}const Ae=document.createElement("a");document.body.appendChild(Ae),Ae.download=G,Ae.href=ue,Ae.click(),setTimeout(()=>document.body.removeChild(Ae))}t.triggerDownload=Ut;function fi(){return new Promise(Y=>{const G=document.createElement("input");document.body.appendChild(G),G.type="file",G.multiple=!0,p.Event.once(p.Event.fromDOMEventEmitter(G,"input"))(()=>{Y((0,r.withNullAsUndefined)(G.files))}),G.click(),setTimeout(()=>document.body.removeChild(G))})}t.triggerUpload=fi;var Et;(function(Y){Y[Y.DOCUMENT=1]="DOCUMENT",Y[Y.BROWSER=2]="BROWSER"})(Et=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function gi(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:Et.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:Et.BROWSER,guess:!1}:(a.isMacintosh||a.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:Et.BROWSER,guess:!0}:null}t.detectFullscreen=gi;function Vt(Y,G=!1){const ue=document.createElement("a");return f.addHook("afterSanitizeAttributes",Ae=>{for(const Te of["href","src"])if(Ae.hasAttribute(Te)){const We=Ae.getAttribute(Te);if(Te==="href"&&We.startsWith("#"))continue;if(ue.href=We,!Y.includes(ue.protocol.replace(/:$/,""))){if(G&&Te==="src"&&ue.href.startsWith("data:"))continue;Ae.removeAttribute(Te)}}}),(0,b.toDisposable)(()=>{f.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Vt;const mi=[T.Schemas.http,T.Schemas.https,T.Schemas.command];function pi(Y,G){const ue={ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1},Ae=Vt(mi);try{const Te=f.sanitize(G,{...ue,RETURN_TRUSTED_TYPE:!0});Y.innerHTML=Te}finally{Ae.dispose()}}t.safeInnerHtml=pi;function bi(Y){const G=new Uint16Array(Y.length);for(let Te=0;Te<G.length;Te++)G[Te]=Y.charCodeAt(Te);let ue="";const Ae=new Uint8Array(G.buffer);for(let Te=0;Te<Ae.length;Te++)ue+=String.fromCharCode(Ae[Te]);return ue}function wi(Y){return btoa(bi(Y))}t.multibyteAwareBtoa=wi;class ft extends p.Emitter{constructor(){super();this._subscriptions=new b.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(E(window,"keydown",G=>{if(G.defaultPrevented)return;const ue=new P.StandardKeyboardEvent(G);if(!(ue.keyCode===6&&G.repeat)){if(G.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(G.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(G.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(G.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(ue.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=G.altKey,this._keyStatus.ctrlKey=G.ctrlKey,this._keyStatus.metaKey=G.metaKey,this._keyStatus.shiftKey=G.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=G,this.fire(this._keyStatus))}},!0)),this._subscriptions.add(E(window,"keyup",G=>{G.defaultPrevented||(!G.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!G.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!G.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!G.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=G.altKey,this._keyStatus.ctrlKey=G.ctrlKey,this._keyStatus.metaKey=G.metaKey,this._keyStatus.shiftKey=G.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=G,this.fire(this._keyStatus)))},!0)),this._subscriptions.add(E(document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(E(document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(E(document.body,"mousemove",G=>{G.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),this._subscriptions.add(E(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.instance||(ft.instance=new ft),ft.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=ft;function vi(Y){const G=document.cookie.match("(^|[^;]+)\\s*"+Y+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}t.getCookieValue=vi;class Di extends b.Disposable{constructor(G,ue){super();this.element=G,this.callbacks=ue,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this._register(E(this.element,t.EventType.DRAG_ENTER,G=>{this.counter++,this.dragStartTime=G.timeStamp,this.callbacks.onDragEnter(G)})),this._register(E(this.element,t.EventType.DRAG_OVER,G=>{G.preventDefault(),this.callbacks.onDragOver?.(G,G.timeStamp-this.dragStartTime)})),this._register(E(this.element,t.EventType.DRAG_LEAVE,G=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave(G))})),this._register(E(this.element,t.EventType.DRAG_END,G=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd(G)})),this._register(E(this.element,t.EventType.DROP,G=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop(G)}))}}t.DragAndDropObserver=Di;function yi(Y,G){const ue=Y instanceof HTMLElement?Y.getBoundingClientRect():Y,Ae=G.getBoundingClientRect(),Te=Math.max(Ae.top-ue.top,0),We=Math.max(ue.width-(ue.right-Ae.right),0),ze=Math.max(ue.height-(ue.bottom-Ae.bottom),0),xe=Math.max(Ae.left-ue.left,0);return{top:Te,right:We,bottom:ze,left:xe}}t.computeClippingRect=yi;const Ei=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function _i(Y,...G){let ue,Ae;Array.isArray(G[0])?(ue={},Ae=G[0]):(ue=G[0]||{},Ae=G[1]);const Te=Ei.exec(Y);if(!Te||!Te.groups)throw new Error("Bad use of h");const We=Te.groups.tag||"div",ze=document.createElement(We);Te.groups.id&&(ze.id=Te.groups.id),Te.groups.class&&(ze.className=Te.groups.class.replace(/\./g," ").trim());const xe={};if(Te.groups.name&&(xe[Te.groups.name]=ze),Ae)for(const Qe of Ae)Qe instanceof HTMLElement?ze.appendChild(Qe):typeof Qe=="string"?ze.append(Qe):(Object.assign(xe,Qe),ze.appendChild(Qe.root));for(const[Qe,bt]of Object.entries(ue)){if(Qe==="style"){for(const[Lt,gt]of Object.entries(bt))ze.style.setProperty($t(Lt),typeof gt=="number"?gt+"px":""+gt);continue}ze.setAttribute($t(Qe),bt.toString())}return xe.root=ze,xe}t.h=_i;function $t(Y){return Y.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(pe[50],be([1,0,4,2,105]),function(Z,t,v,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StaticDND=t.DragAndDropData=t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class M extends i.Disposable{constructor(f,b){super();this._register((0,v.addDisposableListener)(f,"dragover",T=>{T.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{b(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(T=>{this._register((0,v.addDisposableListener)(f,T,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=M,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:P.Mimes.text};function y(p,f,b){const T=document.createElement("div");T.className=b,T.textContent=f,p.dataTransfer&&(document.body.appendChild(T),p.dataTransfer.setDragImage(T,-10,-10),setTimeout(()=>document.body.removeChild(T),0))}t.applyDragImage=y;class w{constructor(f){this.data=f}update(){}getData(){return this.data}}t.DragAndDropData=w,t.StaticDND={CurrentDragAndDropData:void 0}}),define(pe[51],be([1,0,4]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function i(a,r={}){const e=M(r);return e.textContent=a,e}t.renderText=i;function P(a,r={}){const e=M(r);return p(e,f(a,!!r.renderCodeSegments),r.actionHandler,r.renderCodeSegments),e}t.renderFormattedText=P;function M(a){const r=a.inline?"span":"div",e=document.createElement(r);return a.className&&(e.className=a.className),e}t.createElement=M;class y{constructor(r){this.source=r,this.index=0}eos(){return this.index>=this.source.length}next(){const r=this.peek();return this.advance(),r}peek(){return this.source[this.index]}advance(){this.index++}}var w;(function(a){a[a.Invalid=0]="Invalid",a[a.Root=1]="Root",a[a.Text=2]="Text",a[a.Bold=3]="Bold",a[a.Italics=4]="Italics",a[a.Action=5]="Action",a[a.ActionClose=6]="ActionClose",a[a.Code=7]="Code",a[a.NewLine=8]="NewLine"})(w||(w={}));function p(a,r,e,c){let m;if(r.type===2)m=document.createTextNode(r.content||"");else if(r.type===3)m=document.createElement("b");else if(r.type===4)m=document.createElement("i");else if(r.type===7&&c)m=document.createElement("code");else if(r.type===5&&e){const _=document.createElement("a");e.disposables.add(v.addStandardDisposableListener(_,"click",E=>{e.callback(String(r.index),E)})),m=_}else r.type===8?m=document.createElement("br"):r.type===1&&(m=a);m&&a!==m&&a.appendChild(m),m&&Array.isArray(r.children)&&r.children.forEach(_=>{p(m,_,e,c)})}function f(a,r){const e={type:1,children:[]};let c=0,m=e;const _=[],E=new y(a);for(;!E.eos();){let u=E.next();const h=u==="\\"&&T(E.peek(),r)!==0;if(h&&(u=E.next()),!h&&b(u,r)&&u===E.peek()){E.advance(),m.type===2&&(m=_.pop());const D=T(u,r);if(m.type===D||m.type===5&&D===6)m=_.pop();else{const C={type:D,children:[]};D===5&&(C.index=c,c++),m.children.push(C),_.push(m),m=C}}else if(u===`
`)m.type===2&&(m=_.pop()),m.children.push({type:8});else if(m.type!==2){const D={type:2,content:u};m.children.push(D),_.push(m),m=D}else m.content+=u}return m.type===2&&(m=_.pop()),_.length,e}function b(a,r){return T(a,r)!==0}function T(a,r){switch(a){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return r?7:0;default:return 0}}}),define(pe[52],be([1,0,4,2]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class P{constructor(){this._hooks=new i.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(y,w){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const p=this._onStopCallback;this._onStopCallback=null,y&&p&&p(w)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(y,w,p,f,b){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=f,this._onStopCallback=b;let T=y;try{y.setPointerCapture(w),this._hooks.add((0,i.toDisposable)(()=>{y.releasePointerCapture(w)}))}catch{T=window}this._hooks.add(v.addDisposableListener(T,v.EventType.POINTER_MOVE,a=>{if(a.buttons!==p){this.stopMonitoring(!0);return}a.preventDefault(),this._pointerMoveCallback(a)})),this._hooks.add(v.addDisposableListener(T,v.EventType.POINTER_UP,a=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=P});var Ke=this&&this.__decorate||function(Z,t,v,i){var P=arguments.length,M=P<3?t:i===null?i=Object.getOwnPropertyDescriptor(t,v):i,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(Z,t,v,i);else for(var w=Z.length-1;w>=0;w--)(y=Z[w])&&(M=(P<3?y(M):P>3?y(t,v,M):y(t,v))||M);return P>3&&M&&Object.defineProperty(t,v,M),M};define(pe[22],be([1,0,4,14,25,2]),function(Z,t,v,i,P,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var y;(function(p){p.Tap="-monaco-gesturetap",p.Change="-monaco-gesturechange",p.Start="-monaco-gesturestart",p.End="-monaco-gesturesend",p.Contextmenu="-monaco-gesturecontextmenu"})(y=t.EventType||(t.EventType={}));class w extends M.Disposable{constructor(){super();this.dispatched=!1,this.activeTouches={},this.handle=null,this.targets=[],this.ignoreTargets=[],this._lastSetTapCountTime=0,this._register(v.addDisposableListener(document,"touchstart",f=>this.onTouchStart(f),{passive:!1})),this._register(v.addDisposableListener(document,"touchend",f=>this.onTouchEnd(f))),this._register(v.addDisposableListener(document,"touchmove",f=>this.onTouchMove(f),{passive:!1}))}static addTarget(f){return w.isTouchDevice()?(w.INSTANCE||(w.INSTANCE=new w),w.INSTANCE.targets.push(f),{dispose:()=>{w.INSTANCE.targets=w.INSTANCE.targets.filter(b=>b!==f)}}):M.Disposable.None}static ignoreTarget(f){return w.isTouchDevice()?(w.INSTANCE||(w.INSTANCE=new w),w.INSTANCE.ignoreTargets.push(f),{dispose:()=>{w.INSTANCE.ignoreTargets=w.INSTANCE.ignoreTargets.filter(b=>b!==f)}}):M.Disposable.None}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(f){const b=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let T=0,a=f.targetTouches.length;T<a;T++){const r=f.targetTouches.item(T);this.activeTouches[r.identifier]={id:r.identifier,initialTarget:r.target,initialTimeStamp:b,initialPageX:r.pageX,initialPageY:r.pageY,rollingTimestamps:[b],rollingPageX:[r.pageX],rollingPageY:[r.pageY]};const e=this.newGestureEvent(y.Start,r.target);e.pageX=r.pageX,e.pageY=r.pageY,this.dispatchEvent(e)}this.dispatched&&(f.preventDefault(),f.stopPropagation(),this.dispatched=!1)}onTouchEnd(f){const b=Date.now(),T=Object.keys(this.activeTouches).length;for(let a=0,r=f.changedTouches.length;a<r;a++){const e=f.changedTouches.item(a);if(!this.activeTouches.hasOwnProperty(String(e.identifier))){console.warn("move of an UNKNOWN touch",e);continue}const c=this.activeTouches[e.identifier],m=Date.now()-c.initialTimeStamp;if(m<w.HOLD_DELAY&&Math.abs(c.initialPageX-i.tail(c.rollingPageX))<30&&Math.abs(c.initialPageY-i.tail(c.rollingPageY))<30){const _=this.newGestureEvent(y.Tap,c.initialTarget);_.pageX=i.tail(c.rollingPageX),_.pageY=i.tail(c.rollingPageY),this.dispatchEvent(_)}else if(m>=w.HOLD_DELAY&&Math.abs(c.initialPageX-i.tail(c.rollingPageX))<30&&Math.abs(c.initialPageY-i.tail(c.rollingPageY))<30){const _=this.newGestureEvent(y.Contextmenu,c.initialTarget);_.pageX=i.tail(c.rollingPageX),_.pageY=i.tail(c.rollingPageY),this.dispatchEvent(_)}else if(T===1){const _=i.tail(c.rollingPageX),E=i.tail(c.rollingPageY),u=i.tail(c.rollingTimestamps)-c.rollingTimestamps[0],h=_-c.rollingPageX[0],D=E-c.rollingPageY[0],C=this.targets.filter(N=>c.initialTarget instanceof Node&&N.contains(c.initialTarget));this.inertia(C,b,Math.abs(h)/u,h>0?1:-1,_,Math.abs(D)/u,D>0?1:-1,E)}this.dispatchEvent(this.newGestureEvent(y.End,c.initialTarget)),delete this.activeTouches[e.identifier]}this.dispatched&&(f.preventDefault(),f.stopPropagation(),this.dispatched=!1)}newGestureEvent(f,b){const T=document.createEvent("CustomEvent");return T.initEvent(f,!1,!0),T.initialTarget=b,T.tapCount=0,T}dispatchEvent(f){if(f.type===y.Tap){const b=new Date().getTime();let T=0;b-this._lastSetTapCountTime>w.CLEAR_TAP_COUNT_TIME?T=1:T=2,this._lastSetTapCountTime=b,f.tapCount=T}else(f.type===y.Change||f.type===y.Contextmenu)&&(this._lastSetTapCountTime=0);for(let b=0;b<this.ignoreTargets.length;b++)if(f.initialTarget instanceof Node&&this.ignoreTargets[b].contains(f.initialTarget))return;this.targets.forEach(b=>{f.initialTarget instanceof Node&&b.contains(f.initialTarget)&&(b.dispatchEvent(f),this.dispatched=!0)})}inertia(f,b,T,a,r,e,c,m){this.handle=v.scheduleAtNextAnimationFrame(()=>{const _=Date.now(),E=_-b;let u=0,h=0,D=!0;T+=w.SCROLL_FRICTION*E,e+=w.SCROLL_FRICTION*E,T>0&&(D=!1,u=a*T*E),e>0&&(D=!1,h=c*e*E);const C=this.newGestureEvent(y.Change);C.translationX=u,C.translationY=h,f.forEach(N=>N.dispatchEvent(C)),D||this.inertia(f,_,T,a,r+u,e,c,m+h)})}onTouchMove(f){const b=Date.now();for(let T=0,a=f.changedTouches.length;T<a;T++){const r=f.changedTouches.item(T);if(!this.activeTouches.hasOwnProperty(String(r.identifier))){console.warn("end of an UNKNOWN touch",r);continue}const e=this.activeTouches[r.identifier],c=this.newGestureEvent(y.Change,e.initialTarget);c.translationX=r.pageX-i.tail(e.rollingPageX),c.translationY=r.pageY-i.tail(e.rollingPageY),c.pageX=r.pageX,c.pageY=r.pageY,this.dispatchEvent(c),e.rollingPageX.length>3&&(e.rollingPageX.shift(),e.rollingPageY.shift(),e.rollingTimestamps.shift()),e.rollingPageX.push(r.pageX),e.rollingPageY.push(r.pageY),e.rollingTimestamps.push(b)}this.dispatched&&(f.preventDefault(),f.stopPropagation(),this.dispatched=!1)}}w.SCROLL_FRICTION=-.005,w.HOLD_DELAY=700,w.CLEAR_TAP_COUNT_TIME=400,Ke([P.memoize],w,"isTouchDevice",null),t.Gesture=w}),define(pe[53],be([1,0,4,5,82]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const P=2e4;let M,y,w,p,f;function b(e){M=document.createElement("div"),M.className="monaco-aria-container";const c=()=>{const _=document.createElement("div");return _.className="monaco-alert",_.setAttribute("role","alert"),_.setAttribute("aria-atomic","true"),M.appendChild(_),_};y=c(),w=c();const m=()=>{const _=document.createElement("div");return _.className="monaco-status",_.setAttribute("role","complementary"),_.setAttribute("aria-live","polite"),_.setAttribute("aria-atomic","true"),M.appendChild(_),_};p=m(),f=m(),e.appendChild(M)}t.setARIAContainer=b;function T(e){!M||(y.textContent!==e?(v.clearNode(w),r(y,e)):(v.clearNode(y),r(w,e)))}t.alert=T;function a(e){!M||(i.isMacintosh?T(e):p.textContent!==e?(v.clearNode(f),r(p,e)):(v.clearNode(p),r(f,e)))}t.status=a;function r(e,c){v.clearNode(e),c.length>P&&(c=c.substr(0,P)),e.textContent=c,e.style.visibility="hidden",e.style.visibility="visible"}}),define(pe[113],be([1,0,4,11]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const P=new RegExp(`(\\\\)?\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)`,"g");function M(w){const p=new Array;let f,b=0,T=0;for(;(f=P.exec(w))!==null;){T=f.index||0,p.push(w.substring(b,T)),b=(f.index||0)+f[0].length;const[,a,r]=f;p.push(a?`$(${r})`:y({id:r}))}return b<w.length&&p.push(w.substring(b)),p}t.renderLabelWithIcons=M;function y(w){const p=v.$("span");return p.classList.add(...i.CSSIcon.asClassNameArray(w)),p}t.renderIcon=y}),define(pe[114],be([1,0,4]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function i(M){try{M.parentElement?.removeChild(M)}catch{}}class P{constructor(y){this.renderers=y,this.cache=new Map}alloc(y){let w=this.getTemplateCache(y).pop();if(!w){const p=(0,v.$)(".monaco-list-row"),b=this.getRenderer(y).renderTemplate(p);w={domNode:p,templateId:y,templateData:b}}return w}release(y){!y||this.releaseRow(y)}releaseRow(y){const{domNode:w,templateId:p}=y;w&&(w.classList.remove("scrolling"),i(w)),this.getTemplateCache(p).push(y)}getTemplateCache(y){let w=this.cache.get(y);return w||(w=[],this.cache.set(y,w)),w}dispose(){this.cache.forEach((y,w)=>{for(const p of y)this.getRenderer(w).disposeTemplate(p.templateData),p.templateData=null}),this.cache.clear()}getRenderer(y){const w=this.renderers.get(y);if(!w)throw new Error(`No renderer found for ${y}`);return w}}t.RowCache=P}),define(pe[115],be([1,0,8,2]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class P extends i.Disposable{constructor(y,w,p){super();this._visibility=y,this._visibleClassName=w,this._invisibleClassName=p,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new v.TimeoutTimer)}setVisibility(y){this._visibility!==y&&(this._visibility=y,this._updateShouldBeVisible())}setShouldBeVisible(y){this._rawShouldBeVisible=y,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const y=this._applyVisibilitySetting();this._shouldBeVisible!==y&&(this._shouldBeVisible=y,this.ensureVisibility())}setIsNeeded(y){this._isNeeded!==y&&(this._isNeeded=y,this.ensureVisibility())}setDomNode(y){this._domNode=y,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(y){this._revealTimer.cancel(),!!this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(y?" fade":"")))}}t.ScrollbarVisibilityController=P}),define(pe[116],be([1,0,4,22,14,3,2,5]),function(Z,t,v,i,P,M,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class p extends y.Disposable{constructor(b,T,a,r){super();this.selected=0,this.selectBoxOptions=r||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new M.Emitter),this.styles=a,this.registerListeners(),this.setOptions(b,T)}registerListeners(){this._register(i.Gesture.addTarget(this.selectElement)),[i.EventType.Tap].forEach(b=>{this._register(v.addDisposableListener(this.selectElement,b,T=>{this.selectElement.focus()}))}),this._register(v.addStandardDisposableListener(this.selectElement,"click",b=>{v.EventHelper.stop(b,!0)})),this._register(v.addStandardDisposableListener(this.selectElement,"change",b=>{this.selectElement.title=b.target.value,this._onDidSelect.fire({index:b.target.selectedIndex,selected:b.target.value})})),this._register(v.addStandardDisposableListener(this.selectElement,"keydown",b=>{let T=!1;w.isMacintosh?(b.keyCode===18||b.keyCode===16||b.keyCode===10)&&(T=!0):(b.keyCode===18&&b.altKey||b.keyCode===10||b.keyCode===3)&&(T=!0),T&&b.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(b,T){(!this.options||!P.equals(this.options,b))&&(this.options=b,this.selectElement.options.length=0,this.options.forEach((a,r)=>{this.selectElement.add(this.createOption(a.text,r,a.isDisabled))})),T!==void 0&&this.select(T)}select(b){this.options.length===0?this.selected=0:b>=0&&b<this.options.length?this.selected=b:b>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(b){this.selectBoxOptions.ariaLabel=b,this.selectElement.setAttribute("aria-label",b)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(b){this.selectElement.tabIndex=b?0:-1}render(b){b.classList.add("select-container"),b.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(b){this.styles=b,this.applyStyles()}applyStyles(){if(this.selectElement){const b=this.styles.selectBackground?this.styles.selectBackground.toString():"",T=this.styles.selectForeground?this.styles.selectForeground.toString():"",a=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=b,this.selectElement.style.color=T,this.selectElement.style.borderColor=a}}createOption(b,T,a){const r=document.createElement("option");return r.value=b,r.text=b,r.disabled=!!a,r}}t.SelectBoxNative=p}),define(pe[54],be([1,0,23,14,8,111,3,26]),function(Z,t,v,i,P,M,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function p(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.isFilterResult=p;function f(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.getVisibleState=f;function b(a){return typeof a.collapsible=="boolean"}class T{constructor(r,e,c,m={}){this.user=r,this.list=e,this.rootRef=[],this.eventBufferer=new y.EventBufferer,this._onDidChangeCollapseState=new y.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new y.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new y.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new P.Delayer(P.MicrotaskDelay),this.collapseByDefault=typeof m.collapseByDefault=="undefined"?!1:m.collapseByDefault,this.filter=m.filter,this.autoExpandSingleChildren=typeof m.autoExpandSingleChildren=="undefined"?!1:m.autoExpandSingleChildren,this.root={parent:void 0,element:c,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(r,e,c=w.Iterable.empty(),m={}){if(r.length===0)throw new v.TreeError(this.user,"Invalid tree location");m.diffIdentityProvider?this.spliceSmart(m.diffIdentityProvider,r,e,c,m):this.spliceSimple(r,e,c,m)}spliceSmart(r,e,c,m=w.Iterable.empty(),_,E=_.diffDepth??0){const{parentNode:u}=this.getParentNodeWithListIndex(e);if(!u.lastDiffIds)return this.spliceSimple(e,c,m,_);const h=[...m],D=e[e.length-1],C=new M.LcsDiff({getElements:()=>u.lastDiffIds},{getElements:()=>[...u.children.slice(0,D),...h,...u.children.slice(D+c)].map(s=>r.getId(s.element).toString())}).ComputeDiff(!1);if(C.quitEarly)return u.lastDiffIds=void 0,this.spliceSimple(e,c,h,_);const N=e.slice(0,-1),A=(s,n,g)=>{if(E>0)for(let S=0;S<g;S++)s--,n--,this.spliceSmart(r,[...N,s,0],Number.MAX_SAFE_INTEGER,h[n].children,_,E-1)};let o=Math.min(u.children.length,D+c),l=h.length;for(const s of C.changes.sort((n,g)=>g.originalStart-n.originalStart))A(o,l,o-(s.originalStart+s.originalLength)),o=s.originalStart,l=s.modifiedStart-D,this.spliceSimple([...N,o],s.originalLength,w.Iterable.slice(h,l,l+s.modifiedLength),_);A(o,l,o)}spliceSimple(r,e,c=w.Iterable.empty(),{onDidCreateNode:m,onDidDeleteNode:_,diffIdentityProvider:E}){const{parentNode:u,listIndex:h,revealed:D,visible:C}=this.getParentNodeWithListIndex(r),N=[],A=w.Iterable.map(c,ae=>this.createTreeNode(ae,u,u.visible?1:0,D,N,m)),o=r[r.length-1],l=u.children.length>0;let s=0;for(let ae=o;ae>=0&&ae<u.children.length;ae--){const ve=u.children[ae];if(ve.visible){s=ve.visibleChildIndex;break}}const n=[];let g=0,S=0;for(const ae of A)n.push(ae),S+=ae.renderNodeCount,ae.visible&&(ae.visibleChildIndex=s+g++);const $=(0,i.splice)(u.children,o,e,n);E?u.lastDiffIds?(0,i.splice)(u.lastDiffIds,o,e,n.map(ae=>E.getId(ae.element).toString())):u.lastDiffIds=u.children.map(ae=>E.getId(ae.element).toString()):u.lastDiffIds=void 0;let ie=0;for(const ae of $)ae.visible&&ie++;if(ie!==0)for(let ae=o+n.length;ae<u.children.length;ae++){const ve=u.children[ae];ve.visible&&(ve.visibleChildIndex-=ie)}if(u.visibleChildrenCount+=g-ie,D&&C){const ae=$.reduce((ve,he)=>ve+(he.visible?he.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(u,S-ae),this.list.splice(h,ae,N)}if($.length>0&&_){const ae=ve=>{_(ve),ve.children.forEach(ae)};$.forEach(ae)}this._onDidSplice.fire({insertedNodes:n,deletedNodes:$});const te=u.children.length>0;l!==te&&this.setCollapsible(r.slice(0,-1),te);let ge=u;for(;ge;){if(ge.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}ge=ge.parent}}rerender(r){if(r.length===0)throw new v.TreeError(this.user,"Invalid tree location");const{node:e,listIndex:c,revealed:m}=this.getTreeNodeWithListIndex(r);e.visible&&m&&this.list.splice(c,1,[e])}updateElementHeight(r,e){if(r.length===0)throw new v.TreeError(this.user,"Invalid tree location");const{listIndex:c}=this.getTreeNodeWithListIndex(r);this.list.updateElementHeight(c,e)}has(r){return this.hasTreeNode(r)}getListIndex(r){const{listIndex:e,visible:c,revealed:m}=this.getTreeNodeWithListIndex(r);return c&&m?e:-1}getListRenderCount(r){return this.getTreeNode(r).renderNodeCount}isCollapsible(r){return this.getTreeNode(r).collapsible}setCollapsible(r,e){const c=this.getTreeNode(r);typeof e=="undefined"&&(e=!c.collapsible);const m={collapsible:e};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(r,m))}isCollapsed(r){return this.getTreeNode(r).collapsed}setCollapsed(r,e,c){const m=this.getTreeNode(r);typeof e=="undefined"&&(e=!m.collapsed);const _={collapsed:e,recursive:c||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(r,_))}_setCollapseState(r,e){const{node:c,listIndex:m,revealed:_}=this.getTreeNodeWithListIndex(r),E=this._setListNodeCollapseState(c,m,_,e);if(c!==this.root&&this.autoExpandSingleChildren&&E&&!b(e)&&c.collapsible&&!c.collapsed&&!e.recursive){let u=-1;for(let h=0;h<c.children.length;h++)if(c.children[h].visible)if(u>-1){u=-1;break}else u=h;u>-1&&this._setCollapseState([...r,u],e)}return E}_setListNodeCollapseState(r,e,c,m){const _=this._setNodeCollapseState(r,m,!1);if(!c||!r.visible||!_)return _;const E=r.renderNodeCount,u=this.updateNodeAfterCollapseChange(r),h=E-(e===-1?0:1);return this.list.splice(e+1,h,u.slice(1)),_}_setNodeCollapseState(r,e,c){let m;if(r===this.root?m=!1:(b(e)?(m=r.collapsible!==e.collapsible,r.collapsible=e.collapsible):r.collapsible?(m=r.collapsed!==e.collapsed,r.collapsed=e.collapsed):m=!1,m&&this._onDidChangeCollapseState.fire({node:r,deep:c})),!b(e)&&e.recursive)for(const _ of r.children)m=this._setNodeCollapseState(_,e,!0)||m;return m}expandTo(r){this.eventBufferer.bufferEvents(()=>{let e=this.getTreeNode(r);for(;e.parent;)e=e.parent,r=r.slice(0,r.length-1),e.collapsed&&this._setCollapseState(r,{collapsed:!1,recursive:!1})})}refilter(){const r=this.root.renderNodeCount,e=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,r,e),this.refilterDelayer.cancel()}createTreeNode(r,e,c,m,_,E){const u={parent:e,element:r.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof r.collapsible=="boolean"?r.collapsible:typeof r.collapsed!="undefined",collapsed:typeof r.collapsed=="undefined"?this.collapseByDefault:r.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},h=this._filterNode(u,c);u.visibility=h,m&&_.push(u);const D=r.children||w.Iterable.empty(),C=m&&h!==0&&!u.collapsed,N=w.Iterable.map(D,l=>this.createTreeNode(l,u,h,C,_,E));let A=0,o=1;for(const l of N)u.children.push(l),o+=l.renderNodeCount,l.visible&&(l.visibleChildIndex=A++);return u.collapsible=u.collapsible||u.children.length>0,u.visibleChildrenCount=A,u.visible=h===2?A>0:h===1,u.visible?u.collapsed||(u.renderNodeCount=o):(u.renderNodeCount=0,m&&_.pop()),E?.(u),u}updateNodeAfterCollapseChange(r){const e=r.renderNodeCount,c=[];return this._updateNodeAfterCollapseChange(r,c),this._updateAncestorsRenderNodeCount(r.parent,c.length-e),c}_updateNodeAfterCollapseChange(r,e){if(r.visible===!1)return 0;if(e.push(r),r.renderNodeCount=1,!r.collapsed)for(const c of r.children)r.renderNodeCount+=this._updateNodeAfterCollapseChange(c,e);return this._onDidChangeRenderNodeCount.fire(r),r.renderNodeCount}updateNodeAfterFilterChange(r){const e=r.renderNodeCount,c=[];return this._updateNodeAfterFilterChange(r,r.visible?1:0,c),this._updateAncestorsRenderNodeCount(r.parent,c.length-e),c}_updateNodeAfterFilterChange(r,e,c,m=!0){let _;if(r!==this.root){if(_=this._filterNode(r,e),_===0)return r.visible=!1,r.renderNodeCount=0,!1;m&&c.push(r)}const E=c.length;r.renderNodeCount=r===this.root?0:1;let u=!1;if(!r.collapsed||_!==0){let h=0;for(const D of r.children)u=this._updateNodeAfterFilterChange(D,_,c,m&&!r.collapsed)||u,D.visible&&(D.visibleChildIndex=h++);r.visibleChildrenCount=h}else r.visibleChildrenCount=0;return r!==this.root&&(r.visible=_===2?u:_===1,r.visibility=_),r.visible?r.collapsed||(r.renderNodeCount+=c.length-E):(r.renderNodeCount=0,m&&c.pop()),this._onDidChangeRenderNodeCount.fire(r),r.visible}_updateAncestorsRenderNodeCount(r,e){if(e!==0)for(;r;)r.renderNodeCount+=e,this._onDidChangeRenderNodeCount.fire(r),r=r.parent}_filterNode(r,e){const c=this.filter?this.filter.filter(r.element,e):1;return typeof c=="boolean"?(r.filterData=void 0,c?1:0):p(c)?(r.filterData=c.data,f(c.visibility)):(r.filterData=void 0,f(c))}hasTreeNode(r,e=this.root){if(!r||r.length===0)return!0;const[c,...m]=r;return c<0||c>e.children.length?!1:this.hasTreeNode(m,e.children[c])}getTreeNode(r,e=this.root){if(!r||r.length===0)return e;const[c,...m]=r;if(c<0||c>e.children.length)throw new v.TreeError(this.user,"Invalid tree location");return this.getTreeNode(m,e.children[c])}getTreeNodeWithListIndex(r){if(r.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:c,revealed:m,visible:_}=this.getParentNodeWithListIndex(r),E=r[r.length-1];if(E<0||E>e.children.length)throw new v.TreeError(this.user,"Invalid tree location");const u=e.children[E];return{node:u,listIndex:c,revealed:m,visible:_&&u.visible}}getParentNodeWithListIndex(r,e=this.root,c=0,m=!0,_=!0){const[E,...u]=r;if(E<0||E>e.children.length)throw new v.TreeError(this.user,"Invalid tree location");for(let h=0;h<E;h++)c+=e.children[h].renderNodeCount;return m=m&&!e.collapsed,_=_&&e.visible,u.length===0?{parentNode:e,listIndex:c,revealed:m,visible:_}:this.getParentNodeWithListIndex(u,e.children[E],c+1,m,_)}getNode(r=[]){return this.getTreeNode(r)}getNodeLocation(r){const e=[];let c=r;for(;c.parent;)e.push(c.parent.children.indexOf(c)),c=c.parent;return e.reverse()}getParentNodeLocation(r){if(r.length!==0)return r.length===1?[]:(0,i.tail2)(r)[0]}getFirstElementChild(r){const e=this.getTreeNode(r);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(r=[]){const e=this.getTreeNode(r);if(e.children.length!==0)return this._getLastElementAncestor(e)}_getLastElementAncestor(r){return r.children.length===0?r.element:this._getLastElementAncestor(r.children[r.children.length-1])}}t.IndexTreeModel=T}),define(pe[117],be([1,0,54,23,26]),function(Z,t,v,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class M{constructor(w,p,f={}){this.user=w,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new v.IndexTreeModel(w,p,null,f),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,f.sorter&&(this.sorter={compare(b,T){return f.sorter.compare(b.element,T.element)}}),this.identityProvider=f.identityProvider}get size(){return this.nodes.size}setChildren(w,p=P.Iterable.empty(),f={}){const b=this.getElementLocation(w);this._setChildren(b,this.preserveCollapseState(p),f)}_setChildren(w,p=P.Iterable.empty(),f){const b=new Set,T=new Set,a=e=>{if(e.element===null)return;const c=e;if(b.add(c.element),this.nodes.set(c.element,c),this.identityProvider){const m=this.identityProvider.getId(c.element).toString();T.add(m),this.nodesByIdentity.set(m,c)}f.onDidCreateNode?.(c)},r=e=>{if(e.element===null)return;const c=e;if(b.has(c.element)||this.nodes.delete(c.element),this.identityProvider){const m=this.identityProvider.getId(c.element).toString();T.has(m)||this.nodesByIdentity.delete(m)}f.onDidDeleteNode?.(c)};this.model.splice([...w,0],Number.MAX_VALUE,p,{...f,onDidCreateNode:a,onDidDeleteNode:r})}preserveCollapseState(w=P.Iterable.empty()){return this.sorter&&(w=[...w].sort(this.sorter.compare.bind(this.sorter))),P.Iterable.map(w,p=>{let f=this.nodes.get(p.element);if(!f&&this.identityProvider){const a=this.identityProvider.getId(p.element).toString();f=this.nodesByIdentity.get(a)}if(!f)return{...p,children:this.preserveCollapseState(p.children)};const b=typeof p.collapsible=="boolean"?p.collapsible:f.collapsible,T=typeof p.collapsed!="undefined"?p.collapsed:f.collapsed;return{...p,collapsible:b,collapsed:T,children:this.preserveCollapseState(p.children)}})}rerender(w){const p=this.getElementLocation(w);this.model.rerender(p)}updateElementHeight(w,p){const f=this.getElementLocation(w);this.model.updateElementHeight(f,p)}resort(w=null,p=!0){if(!this.sorter)return;const f=this.getElementLocation(w),b=this.model.getNode(f);this._setChildren(f,this.resortChildren(b,p),{})}resortChildren(w,p,f=!0){let b=[...w.children];return(p||f)&&(b=b.sort(this.sorter.compare.bind(this.sorter))),P.Iterable.map(b,T=>({element:T.element,collapsible:T.collapsible,collapsed:T.collapsed,children:this.resortChildren(T,p,!1)}))}getFirstElementChild(w=null){const p=this.getElementLocation(w);return this.model.getFirstElementChild(p)}getLastElementAncestor(w=null){const p=this.getElementLocation(w);return this.model.getLastElementAncestor(p)}has(w){return this.nodes.has(w)}getListIndex(w){const p=this.getElementLocation(w);return this.model.getListIndex(p)}getListRenderCount(w){const p=this.getElementLocation(w);return this.model.getListRenderCount(p)}isCollapsible(w){const p=this.getElementLocation(w);return this.model.isCollapsible(p)}setCollapsible(w,p){const f=this.getElementLocation(w);return this.model.setCollapsible(f,p)}isCollapsed(w){const p=this.getElementLocation(w);return this.model.isCollapsed(p)}setCollapsed(w,p,f){const b=this.getElementLocation(w);return this.model.setCollapsed(b,p,f)}expandTo(w){const p=this.getElementLocation(w);this.model.expandTo(p)}refilter(){this.model.refilter()}getNode(w=null){if(w===null)return this.model.getNode(this.model.rootRef);const p=this.nodes.get(w);if(!p)throw new i.TreeError(this.user,`Tree element not found: ${w}`);return p}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new i.TreeError(this.user,"Invalid getParentNodeLocation call");const p=this.nodes.get(w);if(!p)throw new i.TreeError(this.user,`Tree element not found: ${w}`);const f=this.model.getNodeLocation(p),b=this.model.getParentNodeLocation(f);return this.model.getNode(b).element}getElementLocation(w){if(w===null)return[];const p=this.nodes.get(w);if(!p)throw new i.TreeError(this.user,`Tree element not found: ${w}`);return this.model.getNodeLocation(p)}}t.ObjectTreeModel=M}),define(pe[17],be([1,0,4,19,20,22,2]),function(Z,t,v,i,P,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class w extends y.Disposable{onclick(f,b){this._register(v.addDisposableListener(f,v.EventType.CLICK,T=>b(new P.StandardMouseEvent(T))))}onmousedown(f,b){this._register(v.addDisposableListener(f,v.EventType.MOUSE_DOWN,T=>b(new P.StandardMouseEvent(T))))}onmouseover(f,b){this._register(v.addDisposableListener(f,v.EventType.MOUSE_OVER,T=>b(new P.StandardMouseEvent(T))))}onmouseleave(f,b){this._register(v.addDisposableListener(f,v.EventType.MOUSE_LEAVE,T=>b(new P.StandardMouseEvent(T))))}onkeydown(f,b){this._register(v.addDisposableListener(f,v.EventType.KEY_DOWN,T=>b(new i.StandardKeyboardEvent(T))))}onkeyup(f,b){this._register(v.addDisposableListener(f,v.EventType.KEY_UP,T=>b(new i.StandardKeyboardEvent(T))))}oninput(f,b){this._register(v.addDisposableListener(f,v.EventType.INPUT,b))}onblur(f,b){this._register(v.addDisposableListener(f,v.EventType.BLUR,b))}onfocus(f,b){this._register(v.addDisposableListener(f,v.EventType.FOCUS,b))}onchange(f,b){this._register(v.addDisposableListener(f,v.EventType.CHANGE,b))}ignoreGesture(f){M.Gesture.ignoreTarget(f)}}t.Widget=w}),define(pe[37],be([1,0,52,17,8,4]),function(Z,t,v,i,P,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class y extends i.Widget{constructor(p){super();this._onActivate=p.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=p.bgWidth+"px",this.bgDomNode.style.height=p.bgHeight+"px",typeof p.top!="undefined"&&(this.bgDomNode.style.top="0px"),typeof p.left!="undefined"&&(this.bgDomNode.style.left="0px"),typeof p.bottom!="undefined"&&(this.bgDomNode.style.bottom="0px"),typeof p.right!="undefined"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=p.className,this.domNode.classList.add(...p.icon.classNamesArray),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof p.top!="undefined"&&(this.domNode.style.top=p.top+"px"),typeof p.left!="undefined"&&(this.domNode.style.left=p.left+"px"),typeof p.bottom!="undefined"&&(this.domNode.style.bottom=p.bottom+"px"),typeof p.right!="undefined"&&(this.domNode.style.right=p.right+"px"),this._pointerMoveMonitor=this._register(new v.GlobalPointerMoveMonitor),this._register(M.addStandardDisposableListener(this.bgDomNode,M.EventType.POINTER_DOWN,f=>this._arrowPointerDown(f))),this._register(M.addStandardDisposableListener(this.domNode,M.EventType.POINTER_DOWN,f=>this._arrowPointerDown(f))),this._pointerdownRepeatTimer=this._register(new P.IntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new P.TimeoutTimer)}_arrowPointerDown(p){if(!p.target||!(p.target instanceof Element))return;const f=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24)};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(f,200),this._pointerMoveMonitor.startMonitoring(p.target,p.pointerId,p.buttons,b=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),p.preventDefault()}}t.ScrollbarArrow=y}),define(pe[55],be([1,0,4,40,52,37,115,17,5]),function(Z,t,v,i,P,M,y,w,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const f=140;class b extends w.Widget{constructor(a){super();this._lazyRender=a.lazyRender,this._host=a.host,this._scrollable=a.scrollable,this._scrollByPage=a.scrollByPage,this._scrollbarState=a.scrollbarState,this._visibilityController=this._register(new y.ScrollbarVisibilityController(a.visibility,"visible scrollbar "+a.extraScrollbarClassName,"invisible scrollbar "+a.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new P.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,i.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(v.addDisposableListener(this.domNode.domNode,v.EventType.POINTER_DOWN,r=>this._domNodePointerDown(r)))}_createArrow(a){const r=this._register(new M.ScrollbarArrow(a));this.domNode.domNode.appendChild(r.bgDomNode),this.domNode.domNode.appendChild(r.domNode)}_createSlider(a,r,e,c){this.slider=(0,i.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(a),this.slider.setLeft(r),typeof e=="number"&&this.slider.setWidth(e),typeof c=="number"&&this.slider.setHeight(c),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(v.addDisposableListener(this.slider.domNode,v.EventType.POINTER_DOWN,m=>{m.button===0&&(m.preventDefault(),this._sliderPointerDown(m))})),this.onclick(this.slider.domNode,m=>{m.leftButton&&m.stopPropagation()})}_onElementSize(a){return this._scrollbarState.setVisibleSize(a)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(a){return this._scrollbarState.setScrollSize(a)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(a){return this._scrollbarState.setScrollPosition(a)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){!this._shouldRender||(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(a){a.target===this.domNode.domNode&&this._onPointerDown(a)}delegatePointerDown(a){const r=this.domNode.domNode.getClientRects()[0].top,e=r+this._scrollbarState.getSliderPosition(),c=r+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),m=this._sliderPointerPosition(a);e<=m&&m<=c?a.button===0&&(a.preventDefault(),this._sliderPointerDown(a)):this._onPointerDown(a)}_onPointerDown(a){let r,e;if(a.target===this.domNode.domNode&&typeof a.offsetX=="number"&&typeof a.offsetY=="number")r=a.offsetX,e=a.offsetY;else{const m=v.getDomNodePagePosition(this.domNode.domNode);r=a.pageX-m.left,e=a.pageY-m.top}const c=this._pointerDownRelativePosition(r,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(c):this._scrollbarState.getDesiredScrollPositionFromOffset(c)),a.button===0&&(a.preventDefault(),this._sliderPointerDown(a))}_sliderPointerDown(a){if(!a.target||!(a.target instanceof Element))return;const r=this._sliderPointerPosition(a),e=this._sliderOrthogonalPointerPosition(a),c=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(a.target,a.pointerId,a.buttons,m=>{const _=this._sliderOrthogonalPointerPosition(m),E=Math.abs(_-e);if(p.isWindows&&E>f){this._setDesiredScrollPositionNow(c.getScrollPosition());return}const h=this._sliderPointerPosition(m)-r;this._setDesiredScrollPositionNow(c.getDesiredScrollPositionFromDelta(h))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(a){const r={};this.writeScrollPosition(r,a),this._scrollable.setScrollPositionNow(r)}updateScrollbarSize(a){this._updateScrollbarSize(a),this._scrollbarState.setScrollbarSize(a),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=b}),define(pe[118],be([1,0,20,55,37,41,11]),function(Z,t,v,i,P,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(f,b,T){const a=f.getScrollDimensions(),r=f.getCurrentScrollPosition();super({lazyRender:b.lazyRender,host:T,scrollbarState:new M.ScrollbarState(b.horizontalHasArrows?b.arrowSize:0,b.horizontal===2?0:b.horizontalScrollbarSize,b.vertical===2?0:b.verticalScrollbarSize,a.width,a.scrollWidth,r.scrollLeft),visibility:b.horizontal,extraScrollbarClassName:"horizontal",scrollable:f,scrollByPage:b.scrollByPage});if(b.horizontalHasArrows){const e=(b.arrowSize-P.ARROW_IMG_SIZE)/2,c=(b.horizontalScrollbarSize-P.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonLeft,top:c,left:e,bottom:void 0,right:void 0,bgWidth:b.arrowSize,bgHeight:b.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new v.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonRight,top:c,left:void 0,bottom:void 0,right:e,bgWidth:b.arrowSize,bgHeight:b.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new v.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((b.horizontalScrollbarSize-b.horizontalSliderSize)/2),0,void 0,b.horizontalSliderSize)}_updateSlider(f,b){this.slider.setWidth(f),this.slider.setLeft(b)}_renderDomNode(f,b){this.domNode.setWidth(f),this.domNode.setHeight(b),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(f){return this._shouldRender=this._onElementScrollSize(f.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(f.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(f.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(f,b){return f}_sliderPointerPosition(f){return f.pageX}_sliderOrthogonalPointerPosition(f){return f.pageY}_updateScrollbarSize(f){this.slider.setHeight(f)}writeScrollPosition(f,b){f.scrollLeft=b}updateOptions(f){this.updateScrollbarSize(f.horizontal===2?0:f.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this._visibilityController.setVisibility(f.horizontal),this._scrollByPage=f.scrollByPage}}t.HorizontalScrollbar=w}),define(pe[119],be([1,0,20,55,37,41,11]),function(Z,t,v,i,P,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(f,b,T){const a=f.getScrollDimensions(),r=f.getCurrentScrollPosition();super({lazyRender:b.lazyRender,host:T,scrollbarState:new M.ScrollbarState(b.verticalHasArrows?b.arrowSize:0,b.vertical===2?0:b.verticalScrollbarSize,0,a.height,a.scrollHeight,r.scrollTop),visibility:b.vertical,extraScrollbarClassName:"vertical",scrollable:f,scrollByPage:b.scrollByPage});if(b.verticalHasArrows){const e=(b.arrowSize-P.ARROW_IMG_SIZE)/2,c=(b.verticalScrollbarSize-P.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonUp,top:e,left:c,bottom:void 0,right:void 0,bgWidth:b.verticalScrollbarSize,bgHeight:b.arrowSize,onActivate:()=>this._host.onMouseWheel(new v.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonDown,top:void 0,left:c,bottom:e,right:void 0,bgWidth:b.verticalScrollbarSize,bgHeight:b.arrowSize,onActivate:()=>this._host.onMouseWheel(new v.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((b.verticalScrollbarSize-b.verticalSliderSize)/2),b.verticalSliderSize,void 0)}_updateSlider(f,b){this.slider.setHeight(f),this.slider.setTop(b)}_renderDomNode(f,b){this.domNode.setWidth(b),this.domNode.setHeight(f),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(f){return this._shouldRender=this._onElementScrollSize(f.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(f.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(f.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(f,b){return b}_sliderPointerPosition(f){return f.pageY}_sliderOrthogonalPointerPosition(f){return f.pageX}_updateScrollbarSize(f){this.slider.setWidth(f)}writeScrollPosition(f,b){f.scrollTop=b}updateOptions(f){this.updateScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(f.vertical),this._scrollByPage=f.scrollByPage}}t.VerticalScrollbar=w}),define(pe[56],be([1,0,15,4,40,20,118,119,17,8,3,2,5,47,89]),function(Z,t,v,i,P,M,y,w,p,f,b,T,a,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,c=50,m=!0;class _{constructor(o,l,s){this.timestamp=o,this.deltaX=l,this.deltaY=s,this.score=0}}class E{constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let o=1,l=0,s=1,n=this._rear;do{const g=n===this._front?o:Math.pow(2,-s);if(o-=g,l+=this._memory[n].score*g,n===this._front)break;n=(this._capacity+n-1)%this._capacity,s++}while(!0);return l<=.5}accept(o,l,s){const n=new _(o,l,s);n.score=this._computeScore(n),this._front===-1&&this._rear===-1?(this._memory[0]=n,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=n)}_computeScore(o){if(Math.abs(o.deltaX)>0&&Math.abs(o.deltaY)>0)return 1;let l=.5;const s=this._front===-1&&this._rear===-1?null:this._memory[this._rear];return(!this._isAlmostInt(o.deltaX)||!this._isAlmostInt(o.deltaY))&&(l+=.25),Math.min(Math.max(l,0),1)}_isAlmostInt(o){return Math.abs(Math.round(o)-o)<.01}}t.MouseWheelClassifier=E,E.INSTANCE=new E;class u extends p.Widget{constructor(o,l,s){super();this._onScroll=this._register(new b.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new b.Emitter),this.onWillScroll=this._onWillScroll.event,o.style.overflow="hidden",this._options=N(l),this._scrollable=s,this._register(this._scrollable.onScroll(g=>{this._onWillScroll.fire(g),this._onDidScroll(g),this._onScroll.fire(g)}));const n={onMouseWheel:g=>this._onMouseWheel(g),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new w.VerticalScrollbar(this._scrollable,this._options,n)),this._horizontalScrollbar=this._register(new y.HorizontalScrollbar(this._scrollable,this._options,n)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(o),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,P.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,P.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,P.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,g=>this._onMouseOver(g)),this.onmouseleave(this._listenOnDomNode,g=>this._onMouseLeave(g)),this._hideTimeout=this._register(new f.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}get options(){return this._options}dispose(){this._mouseWheelToDispose=(0,T.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(o){this._verticalScrollbar.delegatePointerDown(o)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(o){this._scrollable.setScrollDimensions(o,!1)}updateClassName(o){this._options.className=o,a.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(o){typeof o.handleMouseWheel!="undefined"&&(this._options.handleMouseWheel=o.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof o.mouseWheelScrollSensitivity!="undefined"&&(this._options.mouseWheelScrollSensitivity=o.mouseWheelScrollSensitivity),typeof o.fastScrollSensitivity!="undefined"&&(this._options.fastScrollSensitivity=o.fastScrollSensitivity),typeof o.scrollPredominantAxis!="undefined"&&(this._options.scrollPredominantAxis=o.scrollPredominantAxis),typeof o.horizontal!="undefined"&&(this._options.horizontal=o.horizontal),typeof o.vertical!="undefined"&&(this._options.vertical=o.vertical),typeof o.horizontalScrollbarSize!="undefined"&&(this._options.horizontalScrollbarSize=o.horizontalScrollbarSize),typeof o.verticalScrollbarSize!="undefined"&&(this._options.verticalScrollbarSize=o.verticalScrollbarSize),typeof o.scrollByPage!="undefined"&&(this._options.scrollByPage=o.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(o){this._revealOnScroll=o}triggerScrollFromMouseWheelEvent(o){this._onMouseWheel(new M.StandardWheelEvent(o))}_setListeningToMouseWheel(o){if(this._mouseWheelToDispose.length>0!==o&&(this._mouseWheelToDispose=(0,T.dispose)(this._mouseWheelToDispose),o)){const s=n=>{this._onMouseWheel(new M.StandardWheelEvent(n))};this._mouseWheelToDispose.push(i.addDisposableListener(this._listenOnDomNode,i.EventType.MOUSE_WHEEL,s,{passive:!1}))}}_onMouseWheel(o){const l=E.INSTANCE;if(m){const g=window.devicePixelRatio/(0,v.getZoomFactor)();a.isWindows||a.isLinux?l.accept(Date.now(),o.deltaX/g,o.deltaY/g):l.accept(Date.now(),o.deltaX,o.deltaY)}let s=!1;if(o.deltaY||o.deltaX){let g=o.deltaY*this._options.mouseWheelScrollSensitivity,S=o.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(Math.abs(g)>=Math.abs(S)?S=0:g=0),this._options.flipAxes&&([g,S]=[S,g]);const $=!a.isMacintosh&&o.browserEvent&&o.browserEvent.shiftKey;(this._options.scrollYToX||$)&&!S&&(S=g,g=0),o.browserEvent&&o.browserEvent.altKey&&(S=S*this._options.fastScrollSensitivity,g=g*this._options.fastScrollSensitivity);const ie=this._scrollable.getFutureScrollPosition();let te={};if(g){const ge=c*g,ae=ie.scrollTop-(ge<0?Math.floor(ge):Math.ceil(ge));this._verticalScrollbar.writeScrollPosition(te,ae)}if(S){const ge=c*S,ae=ie.scrollLeft-(ge<0?Math.floor(ge):Math.ceil(ge));this._horizontalScrollbar.writeScrollPosition(te,ae)}te=this._scrollable.validateScrollPosition(te),(ie.scrollLeft!==te.scrollLeft||ie.scrollTop!==te.scrollTop)&&(m&&this._options.mouseWheelSmoothScroll&&l.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(te):this._scrollable.setScrollPositionNow(te),s=!0)}let n=s;!n&&this._options.alwaysConsumeMouseWheel&&(n=!0),!n&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(n=!0),n&&(o.preventDefault(),o.stopPropagation())}_onDidScroll(o){this._shouldRender=this._horizontalScrollbar.onDidScroll(o)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(o)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(!!this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const o=this._scrollable.getCurrentScrollPosition(),l=o.scrollTop>0,s=o.scrollLeft>0,n=s?" left":"",g=l?" top":"",S=s||l?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${n}`),this._topShadowDomNode.setClassName(`shadow${g}`),this._topLeftShadowDomNode.setClassName(`shadow${S}${g}${n}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(o){this._mouseIsOver=!1,this._hide()}_onMouseOver(o){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=u;class h extends u{constructor(o,l){l=l||{},l.mouseWheelSmoothScroll=!1;const s=new r.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:n=>i.scheduleAtNextAnimationFrame(n)});super(o,l,s);this._register(s)}setScrollPosition(o){this._scrollable.setScrollPositionNow(o)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=h;class D extends u{constructor(o,l,s){super(o,l,s)}setScrollPosition(o){o.reuseAnimation?this._scrollable.setScrollPositionSmooth(o,o.reuseAnimation):this._scrollable.setScrollPositionNow(o)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=D;class C extends u{constructor(o,l){l=l||{},l.mouseWheelSmoothScroll=!1;const s=new r.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:n=>i.scheduleAtNextAnimationFrame(n)});super(o,l,s);this._register(s),this._element=o,this.onScroll(n=>{n.scrollTopChanged&&(this._element.scrollTop=n.scrollTop),n.scrollLeftChanged&&(this._element.scrollLeft=n.scrollLeft)}),this.scanDomNode()}setScrollPosition(o){this._scrollable.setScrollPositionNow(o)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=C;function N(A){const o={lazyRender:typeof A.lazyRender!="undefined"?A.lazyRender:!1,className:typeof A.className!="undefined"?A.className:"",useShadows:typeof A.useShadows!="undefined"?A.useShadows:!0,handleMouseWheel:typeof A.handleMouseWheel!="undefined"?A.handleMouseWheel:!0,flipAxes:typeof A.flipAxes!="undefined"?A.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof A.consumeMouseWheelIfScrollbarIsNeeded!="undefined"?A.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof A.alwaysConsumeMouseWheel!="undefined"?A.alwaysConsumeMouseWheel:!1,scrollYToX:typeof A.scrollYToX!="undefined"?A.scrollYToX:!1,mouseWheelScrollSensitivity:typeof A.mouseWheelScrollSensitivity!="undefined"?A.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof A.fastScrollSensitivity!="undefined"?A.fastScrollSensitivity:5,scrollPredominantAxis:typeof A.scrollPredominantAxis!="undefined"?A.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof A.mouseWheelSmoothScroll!="undefined"?A.mouseWheelSmoothScroll:!0,arrowSize:typeof A.arrowSize!="undefined"?A.arrowSize:11,listenOnDomNode:typeof A.listenOnDomNode!="undefined"?A.listenOnDomNode:null,horizontal:typeof A.horizontal!="undefined"?A.horizontal:1,horizontalScrollbarSize:typeof A.horizontalScrollbarSize!="undefined"?A.horizontalScrollbarSize:10,horizontalSliderSize:typeof A.horizontalSliderSize!="undefined"?A.horizontalSliderSize:0,horizontalHasArrows:typeof A.horizontalHasArrows!="undefined"?A.horizontalHasArrows:!1,vertical:typeof A.vertical!="undefined"?A.vertical:1,verticalScrollbarSize:typeof A.verticalScrollbarSize!="undefined"?A.verticalScrollbarSize:10,verticalHasArrows:typeof A.verticalHasArrows!="undefined"?A.verticalHasArrows:!1,verticalSliderSize:typeof A.verticalSliderSize!="undefined"?A.verticalSliderSize:0,scrollByPage:typeof A.scrollByPage!="undefined"?A.scrollByPage:!1};return o.horizontalSliderSize=typeof A.horizontalSliderSize!="undefined"?A.horizontalSliderSize:o.horizontalScrollbarSize,o.verticalSliderSize=typeof A.verticalSliderSize!="undefined"?A.verticalSliderSize:o.verticalScrollbarSize,a.isMacintosh&&(o.className+=" mac"),o}}),define(pe[57],be([1,0,15,50,4,18,22,56,14,8,25,3,2,45,47,78,114]),function(Z,t,v,i,P,M,y,w,p,f,b,T,a,r,e,c,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const _={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(A){return[A]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class E{constructor(o){this.elements=o}get context(){return this._context}set context(o){this._context=o}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=E;class u{constructor(o){this.elements=o}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=u;class h{constructor(){this.types=[],this.files=[]}update(o){if(o.types&&this.types.splice(0,this.types.length,...o.types),o.files){this.files.splice(0,this.files.length);for(let l=0;l<o.files.length;l++){const s=o.files.item(l);s&&(s.size||s.type)&&this.files.push(s)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=h;function D(A,o){return Array.isArray(A)&&Array.isArray(o)?(0,p.equals)(A,o):A===o}class C{constructor(o){o?.getSetSize?this.getSetSize=o.getSetSize.bind(o):this.getSetSize=(l,s,n)=>n,o?.getPosInSet?this.getPosInSet=o.getPosInSet.bind(o):this.getPosInSet=(l,s)=>s+1,o?.getRole?this.getRole=o.getRole.bind(o):this.getRole=l=>"listitem",o?.isChecked?this.isChecked=o.isChecked.bind(o):this.isChecked=l=>{}}}class N{constructor(o,l,s,n=_){if(this.virtualDelegate=l,this.domId=`list_id_${++N.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new f.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=a.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=a.Disposable.None,this.onDragLeaveTimeout=a.Disposable.None,this.disposables=new a.DisposableStore,this._onDidChangeContentHeight=new T.Emitter,this.onDidChangeContentHeight=T.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this._horizontalScrolling=!1,n.horizontalScrolling&&n.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=new c.RangeMap;for(const S of s)this.renderers.set(S.templateId,S);this.cache=this.disposables.add(new m.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof n.mouseSupport=="boolean"?n.mouseSupport:!0),this._horizontalScrolling=n.horizontalScrolling??_.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.additionalScrollHeight=typeof n.additionalScrollHeight=="undefined"?0:n.additionalScrollHeight,this.accessibilityProvider=new C(n.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(n.transformOptimization??_.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)"),this.disposables.add(y.Gesture.addTarget(this.rowsContainer)),this.scrollable=new e.Scrollable({forceIntegerValues:!0,smoothScrollDuration:n.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:S=>(0,P.scheduleAtNextAnimationFrame)(S)}),this.scrollableElement=this.disposables.add(new w.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:n.alwaysConsumeMouseWheel??_.alwaysConsumeMouseWheel,horizontal:1,vertical:n.verticalScrollMode??_.verticalScrollMode,useShadows:n.useShadows??_.useShadows,mouseWheelScrollSensitivity:n.mouseWheelScrollSensitivity,fastScrollSensitivity:n.fastScrollSensitivity},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),o.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,P.addDisposableListener)(this.rowsContainer,y.EventType.Change,S=>this.onTouchChange(S))),this.disposables.add((0,P.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",S=>S.target.scrollTop=0)),this.disposables.add((0,P.addDisposableListener)(this.domNode,"dragover",S=>this.onDragOver(this.toDragEvent(S)))),this.disposables.add((0,P.addDisposableListener)(this.domNode,"drop",S=>this.onDrop(this.toDragEvent(S)))),this.disposables.add((0,P.addDisposableListener)(this.domNode,"dragleave",S=>this.onDragLeave(this.toDragEvent(S)))),this.disposables.add((0,P.addDisposableListener)(this.domNode,"dragend",S=>this.onDragEnd(S))),this.setRowLineHeight=n.setRowLineHeight??_.setRowLineHeight,this.setRowHeight=n.setRowHeight??_.setRowHeight,this.supportDynamicHeights=n.supportDynamicHeights??_.supportDynamicHeights,this.dnd=n.dnd??_.dnd,this.layout()}get contentHeight(){return this.rangeMap.size}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(o){if(o!==this._horizontalScrolling){if(o&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=o,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const l of this.items)this.measureItemWidth(l);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,P.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}updateOptions(o){o.additionalScrollHeight!==void 0&&(this.additionalScrollHeight=o.additionalScrollHeight,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),o.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(o.smoothScrolling?125:0),o.horizontalScrolling!==void 0&&(this.horizontalScrolling=o.horizontalScrolling),o.mouseWheelScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({mouseWheelScrollSensitivity:o.mouseWheelScrollSensitivity}),o.fastScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({fastScrollSensitivity:o.fastScrollSensitivity})}triggerScrollFromMouseWheelEvent(o){this.scrollableElement.triggerScrollFromMouseWheelEvent(o)}updateElementHeight(o,l,s){if(o<0||o>=this.items.length)return;const n=this.items[o].size;if(typeof l=="undefined"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[o].lastDynamicHeightWidth=void 0,l=n+this.probeDynamicHeight(o)}if(n===l)return;const g=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let S=0;o<g.start||s!==null&&s>o&&s<=g.end?S=l-n:S=0,this.rangeMap.splice(o,1,[{size:l}]),this.items[o].size=l,this.render(g,Math.max(0,this.lastRenderTop+S),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}splice(o,l,s=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(o,l,s)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(o,l,s=[]){const n=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),g={start:o,end:o+l},S=r.Range.intersect(n,g),$=new Map;for(let F=S.end-1;F>=S.start;F--){const K=this.items[F];if(K.dragStartDisposable.dispose(),K.checkedDisposable.dispose(),K.row){let X=$.get(K.templateId);X||(X=[],$.set(K.templateId,X));const O=this.renderers.get(K.templateId);O&&O.disposeElement&&O.disposeElement(K.element,F,K.row.templateData,K.size),X.push(K.row)}K.row=null}const ie={start:o+l,end:this.items.length},te=r.Range.intersect(ie,n),ge=r.Range.relativeComplement(ie,n),ae=s.map(F=>({id:String(this.itemId++),element:F,templateId:this.virtualDelegate.getTemplateId(F),size:this.virtualDelegate.getHeight(F),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(F),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:a.Disposable.None,checkedDisposable:a.Disposable.None}));let ve;o===0&&l>=this.items.length?(this.rangeMap=new c.RangeMap,this.rangeMap.splice(0,0,ae),ve=this.items,this.items=ae):(this.rangeMap.splice(o,l,ae),ve=this.items.splice(o,l,...ae));const he=s.length-l,me=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),ye=(0,c.shift)(te,he),J=r.Range.intersect(me,ye);for(let F=J.start;F<J.end;F++)this.updateItemInDOM(this.items[F],F);const de=r.Range.relativeComplement(ye,me);for(const F of de)for(let K=F.start;K<F.end;K++)this.removeItemFromDOM(K);const ne=ge.map(F=>(0,c.shift)(F,he)),re=[{start:o,end:o+s.length},...ne].map(F=>r.Range.intersect(me,F)),se=this.getNextToLastElement(re);for(const F of re)for(let K=F.start;K<F.end;K++){const X=this.items[K],d=$.get(X.templateId)?.pop();this.insertItemInDOM(K,se,d)}for(const F of $.values())for(const K of F)this.cache.release(K);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),ve.map(F=>F.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,P.scheduleAtNextAnimationFrame)(()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let o=0;for(const l of this.items)typeof l.width!="undefined"&&(o=Math.max(o,l.width));this.scrollWidth=o,this.scrollableElement.setScrollDimensions({scrollWidth:o===0?0:o+10})}updateWidth(o){if(!this.horizontalScrolling||typeof this.scrollWidth=="undefined")return;const l=this.items[o];this.measureItemWidth(l),typeof l.width!="undefined"&&l.width>this.scrollWidth&&(this.scrollWidth=l.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}))}rerender(){if(!!this.supportDynamicHeights){for(const o of this.items)o.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){const o=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),l=this.rangeMap.positionAt(o.start),s=this.rangeMap.positionAt(o.start+1);return s!==-1&&(s-l)/2+l<this.scrollTop?o.start+1:o.start}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(o){return this.items[o].element}indexOf(o){return this.items.findIndex(l=>l.element===o)}domElement(o){const l=this.items[o].row;return l&&l.domNode}elementHeight(o){return this.items[o].size}elementTop(o){return this.rangeMap.positionAt(o)}indexAt(o){return this.rangeMap.indexAt(o)}indexAfter(o){return this.rangeMap.indexAfter(o)}layout(o,l){const s={height:typeof o=="number"?o:(0,P.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,s.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(s),typeof l!="undefined"&&(this.renderWidth=l,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof l=="number"?l:(0,P.getContentWidth)(this.domNode)})}render(o,l,s,n,g,S=!1){const $=this.getRenderRange(l,s),ie=r.Range.relativeComplement($,o),te=r.Range.relativeComplement(o,$),ge=this.getNextToLastElement(ie);if(S){const ae=r.Range.intersect(o,$);for(let ve=ae.start;ve<ae.end;ve++)this.updateItemInDOM(this.items[ve],ve)}for(const ae of ie)for(let ve=ae.start;ve<ae.end;ve++)this.insertItemInDOM(ve,ge);for(const ae of te)for(let ve=ae.start;ve<ae.end;ve++)this.removeItemFromDOM(ve);n!==void 0&&(this.rowsContainer.style.left=`-${n}px`),this.rowsContainer.style.top=`-${l}px`,this.horizontalScrolling&&g!==void 0&&(this.rowsContainer.style.width=`${Math.max(g,this.renderWidth)}px`),this.lastRenderTop=l,this.lastRenderHeight=s}insertItemInDOM(o,l,s){const n=this.items[o];n.row||(n.row=s??this.cache.alloc(n.templateId));const g=this.accessibilityProvider.getRole(n.element)||"listitem";n.row.domNode.setAttribute("role",g);const S=this.accessibilityProvider.isChecked(n.element);if(typeof S=="boolean")n.row.domNode.setAttribute("aria-checked",String(!!S));else if(S){const te=ge=>n.row.domNode.setAttribute("aria-checked",String(!!ge));te(S.value),n.checkedDisposable=S.onDidChange(te)}n.row.domNode.parentElement||(l?this.rowsContainer.insertBefore(n.row.domNode,l):this.rowsContainer.appendChild(n.row.domNode)),this.updateItemInDOM(n,o);const $=this.renderers.get(n.templateId);if(!$)throw new Error(`No renderer found for template id ${n.templateId}`);$?.renderElement(n.element,o,n.row.templateData,n.size);const ie=this.dnd.getDragURI(n.element);n.dragStartDisposable.dispose(),n.row.domNode.draggable=!!ie,ie&&(n.dragStartDisposable=(0,P.addDisposableListener)(n.row.domNode,"dragstart",te=>this.onDragStart(n.element,ie,te))),this.horizontalScrolling&&(this.measureItemWidth(n),this.eventuallyUpdateScrollWidth())}measureItemWidth(o){if(!o.row||!o.row.domNode)return;o.row.domNode.style.width=v.isFirefox?"-moz-fit-content":"fit-content",o.width=(0,P.getContentWidth)(o.row.domNode);const l=window.getComputedStyle(o.row.domNode);l.paddingLeft&&(o.width+=parseFloat(l.paddingLeft)),l.paddingRight&&(o.width+=parseFloat(l.paddingRight)),o.row.domNode.style.width=""}updateItemInDOM(o,l){o.row.domNode.style.top=`${this.elementTop(l)}px`,this.setRowHeight&&(o.row.domNode.style.height=`${o.size}px`),this.setRowLineHeight&&(o.row.domNode.style.lineHeight=`${o.size}px`),o.row.domNode.setAttribute("data-index",`${l}`),o.row.domNode.setAttribute("data-last-element",l===this.length-1?"true":"false"),o.row.domNode.setAttribute("data-parity",l%2==0?"even":"odd"),o.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(o.element,l,this.length))),o.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(o.element,l))),o.row.domNode.setAttribute("id",this.getElementDomId(l)),o.row.domNode.classList.toggle("drop-target",o.dropTarget)}removeItemFromDOM(o){const l=this.items[o];if(l.dragStartDisposable.dispose(),l.checkedDisposable.dispose(),l.row){const s=this.renderers.get(l.templateId);s&&s.disposeElement&&s.disposeElement(l.element,o,l.row.templateData,l.size),this.cache.release(l.row),l.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(o,l){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:o,reuseAnimation:l})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(o){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:o})}get scrollTop(){return this.getScrollTop()}set scrollTop(o){this.setScrollTop(o)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.additionalScrollHeight}get onMouseClick(){return T.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"click")).event,o=>this.toMouseEvent(o),this.disposables)}get onMouseDblClick(){return T.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"dblclick")).event,o=>this.toMouseEvent(o),this.disposables)}get onMouseMiddleClick(){return T.Event.filter(T.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"auxclick")).event,o=>this.toMouseEvent(o),this.disposables),o=>o.browserEvent.button===1,this.disposables)}get onMouseUp(){return T.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mouseup")).event,o=>this.toMouseEvent(o),this.disposables)}get onMouseDown(){return T.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mousedown")).event,o=>this.toMouseEvent(o),this.disposables)}get onMouseOver(){return T.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mouseover")).event,o=>this.toMouseEvent(o),this.disposables)}get onMouseMove(){return T.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mousemove")).event,o=>this.toMouseEvent(o),this.disposables)}get onMouseOut(){return T.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mouseout")).event,o=>this.toMouseEvent(o),this.disposables)}get onContextMenu(){return T.Event.any(T.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"contextmenu")).event,o=>this.toMouseEvent(o),this.disposables),T.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,y.EventType.Contextmenu)).event,o=>this.toGestureEvent(o),this.disposables))}get onTouchStart(){return T.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"touchstart")).event,o=>this.toTouchEvent(o),this.disposables)}get onTap(){return T.Event.map(this.disposables.add(new M.DomEmitter(this.rowsContainer,y.EventType.Tap)).event,o=>this.toGestureEvent(o),this.disposables)}toMouseEvent(o){const l=this.getItemIndexFromEventTarget(o.target||null),s=typeof l=="undefined"?void 0:this.items[l],n=s&&s.element;return{browserEvent:o,index:l,element:n}}toTouchEvent(o){const l=this.getItemIndexFromEventTarget(o.target||null),s=typeof l=="undefined"?void 0:this.items[l],n=s&&s.element;return{browserEvent:o,index:l,element:n}}toGestureEvent(o){const l=this.getItemIndexFromEventTarget(o.initialTarget||null),s=typeof l=="undefined"?void 0:this.items[l],n=s&&s.element;return{browserEvent:o,index:l,element:n}}toDragEvent(o){const l=this.getItemIndexFromEventTarget(o.target||null),s=typeof l=="undefined"?void 0:this.items[l],n=s&&s.element;return{browserEvent:o,index:l,element:n}}onScroll(o){try{const l=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(l,o.scrollTop,o.height,o.scrollLeft,o.scrollWidth),this.supportDynamicHeights&&this._rerender(o.scrollTop,o.height,o.inSmoothScrolling)}catch(l){throw console.error("Got bad scroll event:",o),l}}onTouchChange(o){o.preventDefault(),o.stopPropagation(),this.scrollTop-=o.translationY}onDragStart(o,l,s){if(!s.dataTransfer)return;const n=this.dnd.getDragElements(o);if(s.dataTransfer.effectAllowed="copyMove",s.dataTransfer.setData(i.DataTransfers.TEXT,l),s.dataTransfer.setDragImage){let g;this.dnd.getDragLabel&&(g=this.dnd.getDragLabel(n,s)),typeof g=="undefined"&&(g=String(n.length));const S=(0,P.$)(".monaco-drag-image");S.textContent=g,document.body.appendChild(S),s.dataTransfer.setDragImage(S,-10,-10),setTimeout(()=>document.body.removeChild(S),0)}this.currentDragData=new E(n),i.StaticDND.CurrentDragAndDropData=new u(n),this.dnd.onDragStart?.(this.currentDragData,s)}onDragOver(o){if(o.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),i.StaticDND.CurrentDragAndDropData&&i.StaticDND.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(o.browserEvent),!o.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(i.StaticDND.CurrentDragAndDropData)this.currentDragData=i.StaticDND.CurrentDragAndDropData;else{if(!o.browserEvent.dataTransfer.types)return!1;this.currentDragData=new h}const l=this.dnd.onDragOver(this.currentDragData,o.element,o.index,o.browserEvent);if(this.canDrop=typeof l=="boolean"?l:l.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;o.browserEvent.dataTransfer.dropEffect=typeof l!="boolean"&&l.effect===0?"copy":"move";let s;if(typeof l!="boolean"&&l.feedback?s=l.feedback:typeof o.index=="undefined"?s=[-1]:s=[o.index],s=(0,p.distinct)(s).filter(n=>n>=-1&&n<this.length).sort((n,g)=>n-g),s=s[0]===-1?[-1]:s,D(this.currentDragFeedback,s))return!0;if(this.currentDragFeedback=s,this.currentDragFeedbackDisposable.dispose(),s[0]===-1)this.domNode.classList.add("drop-target"),this.rowsContainer.classList.add("drop-target"),this.currentDragFeedbackDisposable=(0,a.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.rowsContainer.classList.remove("drop-target")});else{for(const n of s){const g=this.items[n];g.dropTarget=!0,g.row?.domNode.classList.add("drop-target")}this.currentDragFeedbackDisposable=(0,a.toDisposable)(()=>{for(const n of s){const g=this.items[n];g.dropTarget=!1,g.row?.domNode.classList.remove("drop-target")}})}return!0}onDragLeave(o){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,f.disposableTimeout)(()=>this.clearDragOverFeedback(),100),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,o.element,o.index,o.browserEvent)}onDrop(o){if(!this.canDrop)return;const l=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,i.StaticDND.CurrentDragAndDropData=void 0,!(!l||!o.browserEvent.dataTransfer)&&(o.browserEvent.preventDefault(),l.update(o.browserEvent.dataTransfer),this.dnd.drop(l,o.element,o.index,o.browserEvent))}onDragEnd(o){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,i.StaticDND.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(o)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=a.Disposable.None}setupDragAndDropScrollTopAnimation(o){if(!this.dragOverAnimationDisposable){const l=(0,P.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,P.animate)(this.animateDragAndDropScrollTop.bind(this,l))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,f.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3),this.dragOverMouseY=o.pageY}animateDragAndDropScrollTop(o){if(this.dragOverMouseY===void 0)return;const l=this.dragOverMouseY-o,s=this.renderHeight-35;l<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(l-35))):l>s&&(this.scrollTop+=Math.min(14,Math.floor(.3*(l-s))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getItemIndexFromEventTarget(o){const l=this.scrollableElement.getDomNode();let s=o;for(;s instanceof HTMLElement&&s!==this.rowsContainer&&l.contains(s);){const n=s.getAttribute("data-index");if(n){const g=Number(n);if(!isNaN(g))return g}s=s.parentElement}}getRenderRange(o,l){return{start:this.rangeMap.indexAt(o),end:this.rangeMap.indexAfter(o+l-1)}}_rerender(o,l,s){const n=this.getRenderRange(o,l);let g,S;o===this.elementTop(n.start)?(g=n.start,S=0):n.end-n.start>1&&(g=n.start+1,S=this.elementTop(g)-o);let $=0;for(;;){const ie=this.getRenderRange(o,l);let te=!1;for(let ge=ie.start;ge<ie.end;ge++){const ae=this.probeDynamicHeight(ge);ae!==0&&this.rangeMap.splice(ge,1,[this.items[ge]]),$+=ae,te=te||ae!==0}if(!te){$!==0&&this.eventuallyUpdateScrollDimensions();const ge=r.Range.relativeComplement(n,ie);for(const ve of ge)for(let he=ve.start;he<ve.end;he++)this.items[he].row&&this.removeItemFromDOM(he);const ae=r.Range.relativeComplement(ie,n);for(const ve of ae)for(let he=ve.start;he<ve.end;he++){const me=he+1,ye=me<this.items.length?this.items[me].row:null,J=ye?ye.domNode:null;this.insertItemInDOM(he,J)}for(let ve=ie.start;ve<ie.end;ve++)this.items[ve].row&&this.updateItemInDOM(this.items[ve],ve);if(typeof g=="number"){const ve=this.scrollable.getFutureScrollPosition().scrollTop-o,he=this.elementTop(g)-S+ve;this.setScrollTop(he,s)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(o){const l=this.items[o];if(this.virtualDelegate.getDynamicHeight){const S=this.virtualDelegate.getDynamicHeight(l.element);if(S!==null){const $=l.size;return l.size=S,l.lastDynamicHeightWidth=this.renderWidth,S-$}}if(!l.hasDynamicHeight||l.lastDynamicHeightWidth===this.renderWidth||!!this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(l.element))return 0;const s=l.size;if(!this.setRowHeight&&l.row){const S=l.row.domNode.offsetHeight;return l.size=S,l.lastDynamicHeightWidth=this.renderWidth,S-s}const n=this.cache.alloc(l.templateId);n.domNode.style.height="",this.rowsContainer.appendChild(n.domNode);const g=this.renderers.get(l.templateId);return g&&(g.renderElement(l.element,o,n.templateData,void 0),g.disposeElement?.(l.element,o,n.templateData,void 0)),l.size=n.domNode.offsetHeight,this.virtualDelegate.setDynamicHeight?.(l.element,l.size),l.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(n.domNode),this.cache.release(n),l.size-s}getNextToLastElement(o){const l=o[o.length-1];if(!l)return null;const s=this.items[l.end];return!s||!s.row?null:s.row.domNode}getElementDomId(o){return`${this.domId}_${o}`}dispose(){if(this.items){for(const o of this.items)if(o.row){const l=this.renderers.get(o.row.templateId);l&&(l.disposeElement?.(o.element,-1,o.row.templateData,void 0),l.disposeTemplate(o.row.templateData))}this.items=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,a.dispose)(this.disposables)}}N.InstanceCount=0,Ke([b.memoize],N.prototype,"onMouseClick",null),Ke([b.memoize],N.prototype,"onMouseDblClick",null),Ke([b.memoize],N.prototype,"onMouseMiddleClick",null),Ke([b.memoize],N.prototype,"onMouseUp",null),Ke([b.memoize],N.prototype,"onMouseDown",null),Ke([b.memoize],N.prototype,"onMouseOver",null),Ke([b.memoize],N.prototype,"onMouseMove",null),Ke([b.memoize],N.prototype,"onMouseOut",null),Ke([b.memoize],N.prototype,"onContextMenu",null),Ke([b.memoize],N.prototype,"onTouchStart",null),Ke([b.memoize],N.prototype,"onTap",null),t.ListView=N}),define(pe[58],be([1,0,4,18,19,22,53,67,14,8,24,25,3,33,2,44,27,5,6,66,57,88]),function(Z,t,v,i,P,M,y,w,p,f,b,T,a,r,e,c,m,_,E,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class D{constructor(d){this.trait=d,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(d){return d}renderElement(d,L,U){const q=this.renderedElements.findIndex(H=>H.templateData===U);if(q>=0){const H=this.renderedElements[q];this.trait.unrender(U),H.index=L}else{const H={index:L,templateData:U};this.renderedElements.push(H)}this.trait.renderIndex(L,U)}splice(d,L,U){const q=[];for(const H of this.renderedElements)H.index<d?q.push(H):H.index>=d+L&&q.push({index:H.index+U-L,templateData:H.templateData});this.renderedElements=q}renderIndexes(d){for(const{index:L,templateData:U}of this.renderedElements)d.indexOf(L)>-1&&this.trait.renderIndex(L,U)}disposeTemplate(d){const L=this.renderedElements.findIndex(U=>U.templateData===d);L<0||this.renderedElements.splice(L,1)}}class C{constructor(d){this._trait=d,this.length=0,this.indexes=[],this.sortedIndexes=[],this._onChange=new a.Emitter,this.onChange=this._onChange.event}get name(){return this._trait}get renderer(){return new D(this)}splice(d,L,U){L=Math.max(0,Math.min(L,this.length-d));const q=U.length-L,H=d+L,R=[...this.sortedIndexes.filter(V=>V<d),...U.map((V,I)=>V?I+d:-1).filter(V=>V!==-1),...this.sortedIndexes.filter(V=>V>=H).map(V=>V+q)],W=this.length+q;if(this.sortedIndexes.length>0&&R.length===0&&W>0){const V=this.sortedIndexes.find(I=>I>=d)??W-1;R.push(Math.min(V,W-1))}this.renderer.splice(d,L,U.length),this._set(R,R),this.length=W}renderIndex(d,L){L.classList.toggle(this._trait,this.contains(d))}unrender(d){d.classList.remove(this._trait)}set(d,L){return this._set(d,[...d].sort(re),L)}_set(d,L,U){const q=this.indexes,H=this.sortedIndexes;this.indexes=d,this.sortedIndexes=L;const R=ne(H,d);return this.renderer.renderIndexes(R),this._onChange.fire({indexes:d,browserEvent:U}),q}get(){return this.indexes}contains(d){return(0,p.binarySearch)(this.sortedIndexes,d,re)>=0}dispose(){(0,e.dispose)(this._onChange)}}Ke([T.memoize],C.prototype,"renderer",null);class N extends C{constructor(d){super("selected");this.setAriaSelected=d}renderIndex(d,L){super.renderIndex(d,L),this.setAriaSelected&&(this.contains(d)?L.setAttribute("aria-selected","true"):L.setAttribute("aria-selected","false"))}}class A{constructor(d,L,U){this.trait=d,this.view=L,this.identityProvider=U}splice(d,L,U){if(!this.identityProvider)return this.trait.splice(d,L,U.map(()=>!1));const q=this.trait.get().map(R=>this.identityProvider.getId(this.view.element(R)).toString()),H=U.map(R=>q.indexOf(this.identityProvider.getId(R).toString())>-1);this.trait.splice(d,L,H)}}function o(O){return O.tagName==="INPUT"||O.tagName==="TEXTAREA"}t.isInputElement=o;function l(O){return O.classList.contains("monaco-editor")?!0:O.classList.contains("monaco-list")||!O.parentElement?!1:l(O.parentElement)}t.isMonacoEditor=l;function s(O){return O.tagName==="A"&&O.classList.contains("monaco-button")||O.tagName==="DIV"&&O.classList.contains("monaco-button-dropdown")?!0:O.classList.contains("monaco-list")||!O.parentElement?!1:s(O.parentElement)}t.isButton=s;class n{constructor(d,L,U){this.list=d,this.view=L,this.disposables=new e.DisposableStore,this.multipleSelectionDisposables=new e.DisposableStore,this.onKeyDown.filter(q=>q.keyCode===3).on(this.onEnter,this,this.disposables),this.onKeyDown.filter(q=>q.keyCode===16).on(this.onUpArrow,this,this.disposables),this.onKeyDown.filter(q=>q.keyCode===18).on(this.onDownArrow,this,this.disposables),this.onKeyDown.filter(q=>q.keyCode===11).on(this.onPageUpArrow,this,this.disposables),this.onKeyDown.filter(q=>q.keyCode===12).on(this.onPageDownArrow,this,this.disposables),this.onKeyDown.filter(q=>q.keyCode===9).on(this.onEscape,this,this.disposables),U.multipleSelectionSupport!==!1&&this.onKeyDown.filter(q=>(_.isMacintosh?q.metaKey:q.ctrlKey)&&q.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables)}get onKeyDown(){return this.disposables.add(a.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event).filter(d=>!o(d.target)).map(d=>new P.StandardKeyboardEvent(d)))}updateOptions(d){d.multipleSelectionSupport!==void 0&&(this.multipleSelectionDisposables.clear(),d.multipleSelectionSupport&&this.onKeyDown.filter(L=>(_.isMacintosh?L.metaKey:L.ctrlKey)&&L.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables))}onEnter(d){d.preventDefault(),d.stopPropagation(),this.list.setSelection(this.list.getFocus(),d.browserEvent)}onUpArrow(d){d.preventDefault(),d.stopPropagation(),this.list.focusPrevious(1,!1,d.browserEvent);const L=this.list.getFocus()[0];this.list.setAnchor(L),this.list.reveal(L),this.view.domNode.focus()}onDownArrow(d){d.preventDefault(),d.stopPropagation(),this.list.focusNext(1,!1,d.browserEvent);const L=this.list.getFocus()[0];this.list.setAnchor(L),this.list.reveal(L),this.view.domNode.focus()}onPageUpArrow(d){d.preventDefault(),d.stopPropagation(),this.list.focusPreviousPage(d.browserEvent);const L=this.list.getFocus()[0];this.list.setAnchor(L),this.list.reveal(L),this.view.domNode.focus()}onPageDownArrow(d){d.preventDefault(),d.stopPropagation(),this.list.focusNextPage(d.browserEvent);const L=this.list.getFocus()[0];this.list.setAnchor(L),this.list.reveal(L),this.view.domNode.focus()}onCtrlA(d){d.preventDefault(),d.stopPropagation(),this.list.setSelection((0,p.range)(this.list.length),d.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(d){this.list.getSelection().length&&(d.preventDefault(),d.stopPropagation(),this.list.setSelection([],d.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}Ke([T.memoize],n.prototype,"onKeyDown",null);var g;(function(O){O[O.Automatic=0]="Automatic",O[O.Trigger=1]="Trigger"})(g=t.TypeNavigationMode||(t.TypeNavigationMode={}));var S;(function(O){O[O.Idle=0]="Idle",O[O.Typing=1]="Typing"})(S||(S={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(O){return O.ctrlKey||O.metaKey||O.altKey?!1:O.keyCode>=31&&O.keyCode<=56||O.keyCode>=21&&O.keyCode<=30||O.keyCode>=93&&O.keyCode<=102||O.keyCode>=80&&O.keyCode<=90}};class ${constructor(d,L,U,q,H){this.list=d,this.view=L,this.keyboardNavigationLabelProvider=U,this.keyboardNavigationEventFilter=q,this.delegate=H,this.enabled=!1,this.state=S.Idle,this.mode=g.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new e.DisposableStore,this.disposables=new e.DisposableStore,this.updateOptions(d.options)}updateOptions(d){d.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=d.typeNavigationMode??g.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let d=!1;const L=this.enabledDisposables.add(a.Event.chain(this.enabledDisposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).filter(H=>!o(H.target)).filter(()=>this.mode===g.Automatic||this.triggered).map(H=>new P.StandardKeyboardEvent(H)).filter(H=>d||this.keyboardNavigationEventFilter(H)).filter(H=>this.delegate.mightProducePrintableCharacter(H)).forEach(i.stopEvent).map(H=>H.browserEvent.key).event,U=a.Event.debounce(L,()=>null,800,void 0,void 0,this.enabledDisposables);a.Event.reduce(a.Event.any(L,U),(H,R)=>R===null?null:(H||"")+R,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),U(this.onClear,this,this.enabledDisposables),L(()=>d=!0,void 0,this.enabledDisposables),U(()=>d=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){!this.enabled||(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const d=this.list.getFocus();if(d.length>0&&d[0]===this.previouslyFocused){const L=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(d[0]));L&&(0,y.alert)(L)}this.previouslyFocused=-1}onInput(d){if(!d){this.state=S.Idle,this.triggered=!1;return}const L=this.list.getFocus(),U=L.length>0?L[0]:0,q=this.state===S.Idle?1:0;this.state=S.Typing;for(let H=0;H<this.list.length;H++){const R=(U+H+q)%this.list.length,W=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(R)),V=W&&W.toString();if(typeof V=="undefined"||(0,r.matchesPrefix)(d,V)){this.previouslyFocused=U,this.list.setFocus([R]),this.list.reveal(R);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class ie{constructor(d,L){this.list=d,this.view=L,this.disposables=new e.DisposableStore,this.disposables.add(a.Event.chain(this.disposables.add(new i.DomEmitter(L.domNode,"keydown")).event)).filter(q=>!o(q.target)).map(q=>new P.StandardKeyboardEvent(q)).filter(q=>q.keyCode===2&&!q.ctrlKey&&!q.metaKey&&!q.shiftKey&&!q.altKey).on(this.onTab,this,this.disposables)}onTab(d){if(d.target!==this.view.domNode)return;const L=this.list.getFocus();if(L.length===0)return;const U=this.view.domElement(L[0]);if(!U)return;const q=U.querySelector("[tabIndex]");if(!q||!(q instanceof HTMLElement)||q.tabIndex===-1)return;const H=window.getComputedStyle(q);H.visibility==="hidden"||H.display==="none"||(d.preventDefault(),d.stopPropagation(),q.focus())}dispose(){this.disposables.dispose()}}function te(O){return _.isMacintosh?O.browserEvent.metaKey:O.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=te;function ge(O){return O.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=ge;function ae(O){return O instanceof MouseEvent&&O.button===2}const ve={isSelectionSingleChangeEvent:te,isSelectionRangeChangeEvent:ge};class he{constructor(d){this.list=d,this.disposables=new e.DisposableStore,this._onPointer=new a.Emitter,this.onPointer=this._onPointer.event,d.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ve),this.mouseSupport=typeof d.options.mouseSupport=="undefined"||!!d.options.mouseSupport,this.mouseSupport&&(d.onMouseDown(this.onMouseDown,this,this.disposables),d.onContextMenu(this.onContextMenu,this,this.disposables),d.onMouseDblClick(this.onDoubleClick,this,this.disposables),d.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(M.Gesture.addTarget(d.getHTMLElement()))),a.Event.any(d.onMouseClick,d.onMouseMiddleClick,d.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(d){d.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,d.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ve))}isSelectionSingleChangeEvent(d){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(d):!1}isSelectionRangeChangeEvent(d){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(d):!1}isSelectionChangeEvent(d){return this.isSelectionSingleChangeEvent(d)||this.isSelectionRangeChangeEvent(d)}onMouseDown(d){l(d.browserEvent.target)||document.activeElement!==d.browserEvent.target&&this.list.domFocus()}onContextMenu(d){if(l(d.browserEvent.target))return;const L=typeof d.index=="undefined"?[]:[d.index];this.list.setFocus(L,d.browserEvent)}onViewPointer(d){if(!this.mouseSupport||o(d.browserEvent.target)||l(d.browserEvent.target))return;const L=d.index;if(typeof L=="undefined"){this.list.setFocus([],d.browserEvent),this.list.setSelection([],d.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionRangeChangeEvent(d))return this.changeSelection(d);if(this.isSelectionChangeEvent(d))return this.changeSelection(d);this.list.setFocus([L],d.browserEvent),this.list.setAnchor(L),ae(d.browserEvent)||this.list.setSelection([L],d.browserEvent),this._onPointer.fire(d)}onDoubleClick(d){if(o(d.browserEvent.target)||l(d.browserEvent.target)||this.isSelectionChangeEvent(d))return;const L=this.list.getFocus();this.list.setSelection(L,d.browserEvent)}changeSelection(d){const L=d.index;let U=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(d)){typeof U=="undefined"&&(U=this.list.getFocus()[0]??L,this.list.setAnchor(U));const q=Math.min(U,L),H=Math.max(U,L),R=(0,p.range)(q,H+1),W=this.list.getSelection(),V=de(ne(W,[U]),U);if(V.length===0)return;const I=ne(R,Q(W,V));this.list.setSelection(I,d.browserEvent),this.list.setFocus([L],d.browserEvent)}else if(this.isSelectionSingleChangeEvent(d)){const q=this.list.getSelection(),H=q.filter(R=>R!==L);this.list.setFocus([L]),this.list.setAnchor(L),q.length===H.length?this.list.setSelection([...H,L],d.browserEvent):this.list.setSelection(H,d.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=he;class me{constructor(d,L){this.styleElement=d,this.selectorSuffix=L}style(d){const L=this.selectorSuffix&&`.${this.selectorSuffix}`,U=[];d.listBackground&&(d.listBackground.isOpaque()?U.push(`.monaco-list${L} .monaco-list-rows { background: ${d.listBackground}; }`):_.isMacintosh||console.warn(`List with id '${this.selectorSuffix}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),d.listFocusBackground&&(U.push(`.monaco-list${L}:focus .monaco-list-row.focused { background-color: ${d.listFocusBackground}; }`),U.push(`.monaco-list${L}:focus .monaco-list-row.focused:hover { background-color: ${d.listFocusBackground}; }`)),d.listFocusForeground&&U.push(`.monaco-list${L}:focus .monaco-list-row.focused { color: ${d.listFocusForeground}; }`),d.listActiveSelectionBackground&&(U.push(`.monaco-list${L}:focus .monaco-list-row.selected { background-color: ${d.listActiveSelectionBackground}; }`),U.push(`.monaco-list${L}:focus .monaco-list-row.selected:hover { background-color: ${d.listActiveSelectionBackground}; }`)),d.listActiveSelectionForeground&&U.push(`.monaco-list${L}:focus .monaco-list-row.selected { color: ${d.listActiveSelectionForeground}; }`),d.listActiveSelectionIconForeground&&U.push(`.monaco-list${L}:focus .monaco-list-row.selected .codicon { color: ${d.listActiveSelectionIconForeground}; }`),d.listFocusAndSelectionOutline&&U.push(`.monaco-list${L}:focus .monaco-list-row.selected { outline-color: ${d.listFocusAndSelectionOutline} !important; }`),d.listFocusAndSelectionBackground&&U.push(`
				.monaco-drag-image,
				.monaco-list${L}:focus .monaco-list-row.selected.focused { background-color: ${d.listFocusAndSelectionBackground}; }
			`),d.listFocusAndSelectionForeground&&U.push(`
				.monaco-drag-image,
				.monaco-list${L}:focus .monaco-list-row.selected.focused { color: ${d.listFocusAndSelectionForeground}; }
			`),d.listInactiveFocusForeground&&(U.push(`.monaco-list${L} .monaco-list-row.focused { color:  ${d.listInactiveFocusForeground}; }`),U.push(`.monaco-list${L} .monaco-list-row.focused:hover { color:  ${d.listInactiveFocusForeground}; }`)),d.listInactiveSelectionIconForeground&&U.push(`.monaco-list${L} .monaco-list-row.focused .codicon { color:  ${d.listInactiveSelectionIconForeground}; }`),d.listInactiveFocusBackground&&(U.push(`.monaco-list${L} .monaco-list-row.focused { background-color:  ${d.listInactiveFocusBackground}; }`),U.push(`.monaco-list${L} .monaco-list-row.focused:hover { background-color:  ${d.listInactiveFocusBackground}; }`)),d.listInactiveSelectionBackground&&(U.push(`.monaco-list${L} .monaco-list-row.selected { background-color:  ${d.listInactiveSelectionBackground}; }`),U.push(`.monaco-list${L} .monaco-list-row.selected:hover { background-color:  ${d.listInactiveSelectionBackground}; }`)),d.listInactiveSelectionForeground&&U.push(`.monaco-list${L} .monaco-list-row.selected { color: ${d.listInactiveSelectionForeground}; }`),d.listHoverBackground&&U.push(`.monaco-list${L}:not(.drop-target) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${d.listHoverBackground}; }`),d.listHoverForeground&&U.push(`.monaco-list${L} .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${d.listHoverForeground}; }`),d.listSelectionOutline&&U.push(`.monaco-list${L} .monaco-list-row.selected { outline: 1px dotted ${d.listSelectionOutline}; outline-offset: -1px; }`),d.listFocusOutline&&U.push(`
				.monaco-drag-image,
				.monaco-list${L}:focus .monaco-list-row.focused { outline: 1px solid ${d.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused .monaco-list-row.focused { outline: 1px solid ${d.listFocusOutline}; outline-offset: -1px; }
			`),d.listInactiveFocusOutline&&U.push(`.monaco-list${L} .monaco-list-row.focused { outline: 1px dotted ${d.listInactiveFocusOutline}; outline-offset: -1px; }`),d.listHoverOutline&&U.push(`.monaco-list${L} .monaco-list-row:hover { outline: 1px dashed ${d.listHoverOutline}; outline-offset: -1px; }`),d.listDropBackground&&U.push(`
				.monaco-list${L}.drop-target,
				.monaco-list${L} .monaco-list-rows.drop-target,
				.monaco-list${L} .monaco-list-row.drop-target { background-color: ${d.listDropBackground} !important; color: inherit !important; }
			`),d.tableColumnsBorder&&U.push(`
				.monaco-table:hover > .monaco-split-view2,
				.monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${d.tableColumnsBorder};
			}`),d.tableOddRowsBackgroundColor&&U.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${d.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=U.join(`
`)}}t.DefaultStyleController=me;const ye={listFocusBackground:b.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:b.Color.fromHex("#0E639C"),listActiveSelectionForeground:b.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:b.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:b.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:b.Color.fromHex("#094771"),listFocusAndSelectionForeground:b.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:b.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:b.Color.fromHex("#FFFFFF"),listHoverBackground:b.Color.fromHex("#2A2D2E"),listDropBackground:b.Color.fromHex("#383B3D"),treeIndentGuidesStroke:b.Color.fromHex("#a9a9a9"),tableColumnsBorder:b.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:b.Color.fromHex("#cccccc").transparent(.04)},J={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function de(O,d){const L=O.indexOf(d);if(L===-1)return[];const U=[];let q=L-1;for(;q>=0&&O[q]===d-(L-q);)U.push(O[q--]);for(U.reverse(),q=L;q<O.length&&O[q]===d+(q-L);)U.push(O[q++]);return U}function ne(O,d){const L=[];let U=0,q=0;for(;U<O.length||q<d.length;)if(U>=O.length)L.push(d[q++]);else if(q>=d.length)L.push(O[U++]);else if(O[U]===d[q]){L.push(O[U]),U++,q++;continue}else O[U]<d[q]?L.push(O[U++]):L.push(d[q++]);return L}function Q(O,d){const L=[];let U=0,q=0;for(;U<O.length||q<d.length;)if(U>=O.length)L.push(d[q++]);else if(q>=d.length)L.push(O[U++]);else if(O[U]===d[q]){U++,q++;continue}else O[U]<d[q]?L.push(O[U++]):q++;return L}const re=(O,d)=>O-d;class se{constructor(d,L){this._templateId=d,this.renderers=L}get templateId(){return this._templateId}renderTemplate(d){return this.renderers.map(L=>L.renderTemplate(d))}renderElement(d,L,U,q){let H=0;for(const R of this.renderers)R.renderElement(d,L,U[H++],q)}disposeElement(d,L,U,q){let H=0;for(const R of this.renderers)R.disposeElement?.(d,L,U[H],q),H+=1}disposeTemplate(d){let L=0;for(const U of this.renderers)U.disposeTemplate(d[L++])}}class F{constructor(d){this.accessibilityProvider=d,this.templateId="a18n"}renderTemplate(d){return d}renderElement(d,L,U){const q=this.accessibilityProvider.getAriaLabel(d);q?U.setAttribute("aria-label",q):U.removeAttribute("aria-label");const H=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(d);typeof H=="number"?U.setAttribute("aria-level",`${H}`):U.removeAttribute("aria-level")}disposeTemplate(d){}}class K{constructor(d,L){this.list=d,this.dnd=L}getDragElements(d){const L=this.list.getSelectedElements();return L.indexOf(d)>-1?L:[d]}getDragURI(d){return this.dnd.getDragURI(d)}getDragLabel(d,L){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(d,L)}onDragStart(d,L){this.dnd.onDragStart?.(d,L)}onDragOver(d,L,U,q){return this.dnd.onDragOver(d,L,U,q)}onDragLeave(d,L,U,q){this.dnd.onDragLeave?.(d,L,U,q)}onDragEnd(d){this.dnd.onDragEnd?.(d)}drop(d,L,U,q){this.dnd.drop(d,L,U,q)}}class X{constructor(d,L,U,q,H=J){this.user=d,this._options=H,this.focus=new C("focused"),this.anchor=new C("anchor"),this.eventBufferer=new a.EventBufferer,this._ariaLabel="",this.disposables=new e.DisposableStore,this._onDidDispose=new a.Emitter,this.onDidDispose=this._onDidDispose.event;const R=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new N(R!=="listbox"),(0,m.mixin)(H,ye,!1);const W=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=H.accessibilityProvider,this.accessibilityProvider&&(W.push(new F(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),q=q.map(I=>new se(I.templateId,[...W,I]));const V={...H,dnd:H.dnd&&new K(this,H.dnd)};if(this.view=new h.ListView(L,U,q,V),this.view.domNode.setAttribute("role",R),H.styleController)this.styleController=H.styleController(this.view.domId);else{const I=(0,v.createStyleSheet)(this.view.domNode);this.styleController=new me(I,this.view.domId)}if(this.spliceable=new w.CombinedSpliceable([new A(this.focus,this.view,H.identityProvider),new A(this.selection,this.view,H.identityProvider),new A(this.anchor,this.view,H.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new ie(this,this.view)),(typeof H.keyboardSupport!="boolean"||H.keyboardSupport)&&(this.keyboardController=new n(this,this.view,H),this.disposables.add(this.keyboardController)),H.keyboardNavigationLabelProvider){const I=H.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new $(this,this.view,H.keyboardNavigationLabelProvider,H.keyboardNavigationEventFilter??(()=>!0),I),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(H),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}get onDidChangeFocus(){return a.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),d=>this.toListEvent(d),this.disposables)}get onDidChangeSelection(){return a.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),d=>this.toListEvent(d),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let d=!1;const L=this.disposables.add(a.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).map(H=>new P.StandardKeyboardEvent(H)).filter(H=>d=H.keyCode===58||H.shiftKey&&H.keyCode===68).map(i.stopEvent).filter(()=>!1).event,U=this.disposables.add(a.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event)).forEach(()=>d=!1).map(H=>new P.StandardKeyboardEvent(H)).filter(H=>H.keyCode===58||H.shiftKey&&H.keyCode===68).map(i.stopEvent).map(({browserEvent:H})=>{const R=this.getFocus(),W=R.length?R[0]:void 0,V=typeof W!="undefined"?this.view.element(W):void 0,I=typeof W!="undefined"?this.view.domElement(W):this.view.domNode;return{index:W,element:V,anchor:I,browserEvent:H}}).event,q=this.disposables.add(a.Event.chain(this.view.onContextMenu)).filter(H=>!d).map(({element:H,index:R,browserEvent:W})=>({element:H,index:R,anchor:{x:W.pageX+1,y:W.pageY},browserEvent:W})).event;return a.Event.any(L,U,q)}get onKeyDown(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return a.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return a.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"blur",!0)).event)}createMouseController(d){return new he(this)}updateOptions(d={}){this._options={...this._options,...d},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(d),this.keyboardController?.updateOptions(d),this.view.updateOptions(d)}get options(){return this._options}splice(d,L,U=[]){if(d<0||d>this.view.length)throw new u.ListError(this.user,`Invalid start index: ${d}`);if(L<0)throw new u.ListError(this.user,`Invalid delete count: ${L}`);L===0&&U.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(d,L,U))}updateWidth(d){this.view.updateWidth(d)}updateElementHeight(d,L){this.view.updateElementHeight(d,L,null)}rerender(){this.view.rerender()}element(d){return this.view.element(d)}indexOf(d){return this.view.indexOf(d)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.getScrollTop()}set scrollTop(d){this.view.setScrollTop(d)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(d){this.view.setScrollLeft(d)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(d){this._ariaLabel=d,this.view.domNode.setAttribute("aria-label",d)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(d,L){this.view.layout(d,L)}triggerTypeNavigation(){this.typeNavigationController&&this.typeNavigationController.trigger()}setSelection(d,L){for(const U of d)if(U<0||U>=this.length)throw new u.ListError(this.user,`Invalid index ${U}`);this.selection.set(d,L)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(d=>this.view.element(d))}setAnchor(d){if(typeof d=="undefined"){this.anchor.set([]);return}if(d<0||d>=this.length)throw new u.ListError(this.user,`Invalid index ${d}`);this.anchor.set([d])}getAnchor(){return(0,p.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const d=this.getAnchor();return typeof d=="undefined"?void 0:this.element(d)}setFocus(d,L){for(const U of d)if(U<0||U>=this.length)throw new u.ListError(this.user,`Invalid index ${U}`);this.focus.set(d,L)}focusNext(d=1,L=!1,U,q){if(this.length===0)return;const H=this.focus.get(),R=this.findNextIndex(H.length>0?H[0]+d:0,L,q);R>-1&&this.setFocus([R],U)}focusPrevious(d=1,L=!1,U,q){if(this.length===0)return;const H=this.focus.get(),R=this.findPreviousIndex(H.length>0?H[0]-d:0,L,q);R>-1&&this.setFocus([R],U)}async focusNextPage(d,L){let U=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);U=U===0?0:U-1;const q=this.getFocus()[0];if(q!==U&&(q===void 0||U>q)){const H=this.findPreviousIndex(U,!1,L);H>-1&&q!==H?this.setFocus([H],d):this.setFocus([U],d)}else{const H=this.view.getScrollTop();let R=H+this.view.renderHeight;U>q&&(R-=this.view.elementHeight(U)),this.view.setScrollTop(R),this.view.getScrollTop()!==H&&(this.setFocus([]),await(0,f.timeout)(0),await this.focusNextPage(d,L))}}async focusPreviousPage(d,L){let U;const q=this.view.getScrollTop();q===0?U=this.view.indexAt(q):U=this.view.indexAfter(q-1);const H=this.getFocus()[0];if(H!==U&&(H===void 0||H>=U)){const R=this.findNextIndex(U,!1,L);R>-1&&H!==R?this.setFocus([R],d):this.setFocus([U],d)}else{const R=q;this.view.setScrollTop(q-this.view.renderHeight),this.view.getScrollTop()!==R&&(this.setFocus([]),await(0,f.timeout)(0),await this.focusPreviousPage(d,L))}}focusLast(d,L){if(this.length===0)return;const U=this.findPreviousIndex(this.length-1,!1,L);U>-1&&this.setFocus([U],d)}focusFirst(d,L){this.focusNth(0,d,L)}focusNth(d,L,U){if(this.length===0)return;const q=this.findNextIndex(d,!1,U);q>-1&&this.setFocus([q],L)}findNextIndex(d,L=!1,U){for(let q=0;q<this.length;q++){if(d>=this.length&&!L)return-1;if(d=d%this.length,!U||U(this.element(d)))return d;d++}return-1}findPreviousIndex(d,L=!1,U){for(let q=0;q<this.length;q++){if(d<0&&!L)return-1;if(d=(this.length+d%this.length)%this.length,!U||U(this.element(d)))return d;d--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(d=>this.view.element(d))}reveal(d,L){if(d<0||d>=this.length)throw new u.ListError(this.user,`Invalid index ${d}`);const U=this.view.getScrollTop(),q=this.view.elementTop(d),H=this.view.elementHeight(d);if((0,E.isNumber)(L)){const R=H-this.view.renderHeight;this.view.setScrollTop(R*(0,c.clamp)(L,0,1)+q)}else{const R=q+H,W=U+this.view.renderHeight;q<U&&R>=W||(q<U||R>=W&&H>=this.view.renderHeight?this.view.setScrollTop(q):R>=W&&this.view.setScrollTop(R-this.view.renderHeight))}}getRelativeTop(d){if(d<0||d>=this.length)throw new u.ListError(this.user,`Invalid index ${d}`);const L=this.view.getScrollTop(),U=this.view.elementTop(d),q=this.view.elementHeight(d);if(U<L||U+q>L+this.view.renderHeight)return null;const H=q-this.view.renderHeight;return Math.abs((L-U)/H)}isDOMFocused(){return this.view.domNode===document.activeElement}getHTMLElement(){return this.view.domNode}getElementID(d){return this.view.getElementDomId(d)}style(d){this.styleController.style(d)}toListEvent({indexes:d,browserEvent:L}){return{indexes:d,elements:d.map(U=>this.view.element(U)),browserEvent:L}}_onFocusChange(){const d=this.focus.get();this.view.domNode.classList.toggle("element-focused",d.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const d=this.focus.get();if(d.length>0){let L;this.accessibilityProvider?.getActiveDescendantId&&(L=this.accessibilityProvider.getActiveDescendantId(this.view.element(d[0]))),this.view.domNode.setAttribute("aria-activedescendant",L||this.view.getElementDomId(d[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const d=this.selection.get();this.view.domNode.classList.toggle("selection-none",d.length===0),this.view.domNode.classList.toggle("selection-single",d.length===1),this.view.domNode.classList.toggle("selection-multiple",d.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}Ke([T.memoize],X.prototype,"onDidChangeFocus",null),Ke([T.memoize],X.prototype,"onDidChangeSelection",null),Ke([T.memoize],X.prototype,"onContextMenu",null),Ke([T.memoize],X.prototype,"onKeyDown",null),Ke([T.memoize],X.prototype,"onKeyUp",null),Ke([T.memoize],X.prototype,"onKeyPress",null),Ke([T.memoize],X.prototype,"onDidFocus",null),Ke([T.memoize],X.prototype,"onDidBlur",null),t.List=X}),define(pe[59],be([1,0,13,34,36,10,16]),function(Z,t,v,i,P,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var w;(function(m){m[m.Paragraph=0]="Paragraph",m[m.Break=1]="Break"})(w=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class p{constructor(_="",E=!1){if(this.value=_,typeof this.value!="string")throw(0,v.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=E.isTrusted??void 0,this.supportThemeIcons=E.supportThemeIcons??!1,this.supportHtml=E.supportHtml??!1)}appendText(_,E=0){return this.value+=a(this.supportThemeIcons?(0,i.escapeIcons)(_):_).replace(/([ \t]+)/g,(u,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(_){return this.value+=_,this}appendCodeblock(_,E){return this.value+="\n```",this.value+=_,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}appendLink(_,E,u){return this.value+="[",this.value+=this._escape(E,"]"),this.value+="](",this.value+=this._escape(String(_),")"),u&&(this.value+=` "${this._escape(this._escape(u,'"'),")")}"`),this.value+=")",this}_escape(_,E){const u=new RegExp((0,M.escapeRegExpCharacters)(E),"g");return _.replace(u,(h,D)=>_.charAt(D-1)!=="\\"?`\\${h}`:h)}}t.MarkdownString=p;function f(m){return b(m)?!m.value:Array.isArray(m)?m.every(f):!0}t.isEmptyMarkdownString=f;function b(m){return m instanceof p?!0:m&&typeof m=="object"?typeof m.value=="string"&&(typeof m.isTrusted=="boolean"||m.isTrusted===void 0)&&(typeof m.supportThemeIcons=="boolean"||m.supportThemeIcons===void 0):!1}t.isMarkdownString=b;function T(m,_){return m===_?!0:!m||!_?!1:m.value===_.value&&m.isTrusted===_.isTrusted&&m.supportThemeIcons===_.supportThemeIcons&&m.supportHtml===_.supportHtml&&(m.baseUri===_.baseUri||!!m.baseUri&&!!_.baseUri&&(0,P.isEqual)(y.URI.from(m.baseUri),y.URI.from(_.baseUri)))}t.markdownStringEqual=T;function a(m){return m.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=a;function r(m){return m.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=r;function e(m){return m&&m.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}t.removeMarkdownEscapes=e;function c(m){const _=[],E=m.split("|").map(h=>h.trim());m=E[0];const u=E[1];if(u){const h=/height=(\d+)/.exec(u),D=/width=(\d+)/.exec(u),C=h?h[1]:"",N=D?D[1]:"",A=isFinite(parseInt(N)),o=isFinite(parseInt(C));A&&_.push(`width="${N}"`),o&&_.push(`height="${C}"`)}return{href:m,dimensions:_}}t.parseHrefAndDimensions=c}),define(pe[120],be([1,0,4,112,18,51,20,113,13,3,59,34,71,2,75,49,35,27,36,10,16]),function(Z,t,v,i,P,M,y,w,p,f,b,T,a,r,e,c,m,_,E,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.renderMarkdown=void 0;function D(s,n={},g={}){const S=new r.DisposableStore;let $=!1;const ie=(0,M.createElement)(n),te=function(de){let ne;try{ne=(0,c.parse)(decodeURIComponent(de))}catch{}return ne?(ne=(0,_.cloneAndChange)(ne,Q=>{if(s.uris&&s.uris[Q])return h.URI.revive(s.uris[Q])}),encodeURIComponent(JSON.stringify(ne))):de},ge=function(de,ne){const Q=s.uris&&s.uris[de];let re=h.URI.revive(Q);return ne?de.startsWith(m.Schemas.data+":")?de:(re||(re=h.URI.parse(de)),m.FileAccess.asBrowserUri(re).toString(!0)):!re||h.URI.parse(de).toString()===re.toString()?de:(re.query&&(re=re.with({query:te(re.query)})),re.toString())},ae=new e.marked.Renderer;ae.image=(de,ne,Q)=>{let re=[],se=[];return de&&({href:de,dimensions:re}=(0,b.parseHrefAndDimensions)(de),se.push(`src="${(0,b.escapeDoubleQuotes)(de)}"`)),Q&&se.push(`alt="${(0,b.escapeDoubleQuotes)(Q)}"`),ne&&se.push(`title="${(0,b.escapeDoubleQuotes)(ne)}"`),re.length&&(se=se.concat(re)),"<img "+se.join(" ")+">"},ae.link=(de,ne,Q)=>typeof de!="string"?"":(de===Q&&(Q=(0,b.removeMarkdownEscapes)(Q)),ne=typeof ne=="string"?(0,b.escapeDoubleQuotes)((0,b.removeMarkdownEscapes)(ne)):"",de=(0,b.removeMarkdownEscapes)(de),de=de.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${de}" title="${ne||de}">${Q}</a>`),ae.paragraph=de=>`<p>${de}</p>`;const ve=[];if(n.codeBlockRenderer&&(ae.code=(de,ne)=>{const Q=a.defaultGenerator.nextId(),re=n.codeBlockRenderer(ne??"",de);return ve.push(re.then(se=>[Q,se])),`<div class="code" data-code="${Q}">${(0,u.escape)(de)}</div>`}),n.actionHandler){const de=n.actionHandler.disposables.add(new P.DomEmitter(ie,"click")),ne=n.actionHandler.disposables.add(new P.DomEmitter(ie,"auxclick"));n.actionHandler.disposables.add(f.Event.any(de.event,ne.event)(Q=>{const re=new y.StandardMouseEvent(Q);if(!re.leftButton&&!re.middleButton)return;let se=re.target;if(!(se.tagName!=="A"&&(se=se.parentElement,!se||se.tagName!=="A")))try{let F=se.dataset.href;F&&(s.baseUri&&(F=C(h.URI.from(s.baseUri),F)),n.actionHandler.callback(F,re))}catch(F){(0,p.onUnexpectedError)(F)}finally{re.preventDefault()}}))}s.supportHtml||(g.sanitizer=de=>(s.isTrusted?de.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?de:"",g.sanitize=!0,g.silent=!0),g.renderer=ae;let he=s.value??"";he.length>1e5&&(he=`${he.substr(0,1e5)}\u2026`),s.supportThemeIcons&&(he=(0,T.markdownEscapeEscapedIcons)(he));let me=e.marked.parse(he,g);s.supportThemeIcons&&(me=(0,w.renderLabelWithIcons)(me).map(ne=>typeof ne=="string"?ne:ne.outerHTML).join(""));const J=new DOMParser().parseFromString(N(s,me),"text/html");if(J.body.querySelectorAll("img").forEach(de=>{const ne=de.getAttribute("src");if(ne){let Q=ne;try{s.baseUri&&(Q=C(h.URI.from(s.baseUri),Q))}catch{}de.src=ge(Q,!0)}}),J.body.querySelectorAll("a").forEach(de=>{const ne=de.getAttribute("href");if(de.setAttribute("href",""),!ne||/^data:|javascript:/i.test(ne)||/^command:/i.test(ne)&&!s.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(ne))de.replaceWith(...de.childNodes);else{let Q=ge(ne,!1);s.baseUri&&(Q=C(h.URI.from(s.baseUri),ne)),de.dataset.href=Q}}),ie.innerHTML=N(s,J.body.innerHTML),ve.length>0&&Promise.all(ve).then(de=>{if($)return;const ne=new Map(de),Q=ie.querySelectorAll("div[data-code]");for(const re of Q){const se=ne.get(re.dataset.code??"");se&&v.reset(re,se)}n.asyncRenderCallback?.()}),n.asyncRenderCallback)for(const de of ie.getElementsByTagName("img")){const ne=S.add(v.addDisposableListener(de,"load",()=>{ne.dispose(),n.asyncRenderCallback()}))}return{element:ie,dispose:()=>{$=!0,S.dispose()}}}t.renderMarkdown=D;function C(s,n){return/^\w[\w\d+.-]*:/.test(n)?n:s.path.endsWith("/")?(0,E.resolvePath)(s,n).toString():(0,E.resolvePath)((0,E.dirname)(s),n).toString()}function N(s,n){const{config:g,allowedSchemes:S}=A(s);i.addHook("uponSanitizeAttribute",(ie,te)=>{if(te.attrName==="style"||te.attrName==="class"){if(ie.tagName==="SPAN"){if(te.attrName==="style"){te.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(te.attrValue);return}else if(te.attrName==="class"){te.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(te.attrValue);return}}te.keepAttr=!1;return}});const $=v.hookDomPurifyHrefAndSrcSanitizer(S);try{return i.sanitize(n,{...g,RETURN_TRUSTED_TYPE:!0})}finally{i.removeHook("uponSanitizeAttribute"),$.dispose()}}function A(s){const n=[m.Schemas.http,m.Schemas.https,m.Schemas.mailto,m.Schemas.data,m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemote,m.Schemas.vscodeRemoteResource];return s.isTrusted&&n.push(m.Schemas.command),{config:{ALLOWED_TAGS:["ul","li","p","b","i","code","blockquote","ol","h1","h2","h3","h4","h5","h6","hr","em","pre","table","thead","tbody","tr","th","td","div","del","a","strong","br","img","span"],ALLOWED_ATTR:["href","data-href","target","title","src","alt","class","style","data-code","width","height","align"],ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:n}}function o(s){return typeof s=="string"?s:l(s)}t.renderStringAsPlaintext=o;function l(s){const n=new e.marked.Renderer;n.code=ie=>ie,n.blockquote=ie=>ie,n.html=ie=>"",n.heading=(ie,te,ge)=>ie+`
`,n.hr=()=>"",n.list=(ie,te)=>ie,n.listitem=ie=>ie+`
`,n.paragraph=ie=>ie+`
`,n.table=(ie,te)=>ie+te+`
`,n.tablerow=ie=>ie,n.tablecell=(ie,te)=>ie+" ",n.strong=ie=>ie,n.em=ie=>ie,n.codespan=ie=>ie,n.br=()=>`
`,n.del=ie=>ie,n.image=(ie,te,ge)=>"",n.text=ie=>ie,n.link=(ie,te,ge)=>ge;let g=s.value??"";g.length>1e5&&(g=`${g.substr(0,1e5)}\u2026`);const S=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),$=e.marked.parse(g,{renderer:n}).replace(/&(#\d+|[a-zA-Z]+);/g,ie=>S.get(ie)??ie);return N({isTrusted:!1},$).toString()}t.renderMarkdownAsPlaintext=l}),define(pe[121],be([1,0,4,8,28,59,34,2,6,98]),function(Z,t,v,i,P,M,y,w,p,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function b(r,e){(0,p.isString)(e)?r.title=(0,y.stripIcons)(e):e?.markdownNotSupportedFallback?r.title=e.markdownNotSupportedFallback:r.removeAttribute("title")}t.setupNativeHover=b;class T{constructor(e,c,m){this.hoverDelegate=e,this.target=c,this.fadeInAnimation=m}async update(e,c,m){if(this._cancellationTokenSource&&(this._cancellationTokenSource.dispose(!0),this._cancellationTokenSource=void 0),this.isDisposed)return;let _;if(e===void 0||(0,p.isString)(e)||e instanceof HTMLElement)_=e;else if(!(0,p.isFunction)(e.markdown))_=e.markdown??e.markdownNotSupportedFallback;else{this._hoverWidget||this.show((0,f.localize)(0,null),c),this._cancellationTokenSource=new P.CancellationTokenSource;const E=this._cancellationTokenSource.token;if(_=await e.markdown(E),_===void 0&&(_=e.markdownNotSupportedFallback),this.isDisposed||E.isCancellationRequested)return}this.show(_,c,m)}show(e,c,m){const _=this._hoverWidget;if(this.hasContent(e)){const E={content:e,target:this.target,showPointer:this.hoverDelegate.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.fadeInAnimation||!!_,...m};this._hoverWidget=this.hoverDelegate.showHover(E,c)}_?.dispose()}hasContent(e){return e?(0,M.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this._hoverWidget?.isDisposed}dispose(){this._hoverWidget?.dispose(),this._cancellationTokenSource?.dispose(!0),this._cancellationTokenSource=void 0}}function a(r,e,c,m){let _,E;const u=(A,o)=>{A&&(E?.dispose(),E=void 0),o&&(_?.dispose(),_=void 0),r.onDidHideHover?.()},h=(A,o,l)=>new i.TimeoutTimer(async()=>{(!E||E.isDisposed)&&(E=new T(r,l||e,A>0),await E.update(c,o,m))},A),D=()=>{if(_)return;const A=new w.DisposableStore,o=n=>u(!1,n.fromElement===e);A.add(v.addDisposableListener(e,v.EventType.MOUSE_LEAVE,o,!0));const l=()=>u(!0,!0);A.add(v.addDisposableListener(e,v.EventType.MOUSE_DOWN,l,!0));const s={targetElements:[e],dispose:()=>{}};if(r.placement===void 0||r.placement==="mouse"){const n=g=>{s.x=g.x+10,g.target instanceof HTMLElement&&g.target.classList.contains("action-label")&&u(!0,!0)};A.add(v.addDisposableListener(e,v.EventType.MOUSE_MOVE,n,!0))}A.add(h(r.delay,!1,s)),_=A},C=v.addDisposableListener(e,v.EventType.MOUSE_OVER,D,!0);return{show:A=>{u(!1,!0),h(0,A)},hide:()=>{u(!0,!0)},update:async(A,o)=>{c=A,await E?.update(c,void 0,o)},dispose:()=>{C.dispose(),u(!0,!0)}}}t.setupCustomHover=a}),define(pe[122],be([1,0,4,18,19,120,58,14,3,43,2,5,100,91]),function(Z,t,v,i,P,M,y,w,p,f,b,T,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const r=v.$,e="selectOption.entry.template";class c{get templateId(){return e}renderTemplate(E){const u=Object.create(null);return u.disposables=[],u.root=E,u.text=v.append(E,r(".option-text")),u.detail=v.append(E,r(".option-detail")),u.decoratorRight=v.append(E,r(".option-decorator-right")),u}renderElement(E,u,h){const D=h,C=E.text,N=E.detail,A=E.decoratorRight,o=E.isDisabled;D.text.textContent=C,D.detail.textContent=N||"",D.decoratorRight.innerText=A||"",o?D.root.classList.add("option-disabled"):D.root.classList.remove("option-disabled")}disposeTemplate(E){E.disposables=(0,b.dispose)(E.disposables)}}class m extends b.Disposable{constructor(E,u,h,D,C){super();this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.selectBoxOptions=C||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=m.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new p.Emitter,this._register(this._onDidSelect),this.styles=D,this.registerListeners(),this.constructSelectDropDown(h),this.selected=u||0,E&&this.setOptions(E,u)}getHeight(){return 18}getTemplateId(){return e}constructSelectDropDown(E){this.contextViewProvider=E,this.selectDropDownContainer=v.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=v.append(this.selectDropDownContainer,r(".select-box-details-pane"));const u=v.append(this.selectDropDownContainer,r(".select-box-dropdown-container-width-control")),h=v.append(u,r(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",v.append(h,this.widthControlElement),this._dropDownPosition=0,this.styleElement=v.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(v.addDisposableListener(this.selectDropDownContainer,v.EventType.DRAG_START,D=>{v.EventHelper.stop(D,!0)}))}registerListeners(){this._register(v.addStandardDisposableListener(this.selectElement,"change",u=>{this.selected=u.target.selectedIndex,this._onDidSelect.fire({index:u.target.selectedIndex,selected:u.target.value}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)})),this._register(v.addDisposableListener(this.selectElement,v.EventType.CLICK,u=>{v.EventHelper.stop(u),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(v.addDisposableListener(this.selectElement,v.EventType.MOUSE_DOWN,u=>{v.EventHelper.stop(u)}));let E;this._register(v.addDisposableListener(this.selectElement,"touchstart",u=>{E=this._isVisible})),this._register(v.addDisposableListener(this.selectElement,"touchend",u=>{v.EventHelper.stop(u),E?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(v.addDisposableListener(this.selectElement,v.EventType.KEY_DOWN,u=>{const h=new P.StandardKeyboardEvent(u);let D=!1;T.isMacintosh?(h.keyCode===18||h.keyCode===16||h.keyCode===10||h.keyCode===3)&&(D=!0):(h.keyCode===18&&h.altKey||h.keyCode===16&&h.altKey||h.keyCode===10||h.keyCode===3)&&(D=!0),D&&(this.showSelectDropDown(),v.EventHelper.stop(u,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(E,u){w.equals(this.options,E)||(this.options=E,this.selectElement.options.length=0,this._hasDetails=!1,this.options.forEach((h,D)=>{this.selectElement.add(this.createOption(h.text,D,h.isDisabled)),typeof h.description=="string"&&(this._hasDetails=!0)})),u!==void 0&&(this.select(u),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(E){E>=0&&E<this.options.length?this.selected=E:E>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)}setAriaLabel(E){this.selectBoxOptions.ariaLabel=E,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(E){this.selectElement.tabIndex=E?0:-1}render(E){this.container=E,E.classList.add("select-container"),E.appendChild(this.selectElement),this.applyStyles()}style(E){const u=[];this.styles=E,this.styles.listFocusBackground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&!this.styles.selectBorder.equals(this.styles.selectBackground)?(u.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),u.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),u.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=u.join(`
`),this.applyStyles()}applyStyles(){if(this.selectElement){const E=this.styles.selectBackground?this.styles.selectBackground.toString():"",u=this.styles.selectForeground?this.styles.selectForeground.toString():"",h=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=E,this.selectElement.style.color=u,this.selectElement.style.borderColor=h}this.selectList&&this.styleList()}styleList(){if(this.selectList){const E=this.styles.selectBackground?this.styles.selectBackground.toString():"";this.selectList.style({});const u=this.styles.selectListBackground?this.styles.selectListBackground.toString():E;this.selectDropDownListContainer.style.backgroundColor=u,this.selectionDetailsPane.style.backgroundColor=u;const h=this.styles.focusBorder?this.styles.focusBorder.toString():"";this.selectDropDownContainer.style.outlineColor=h,this.selectDropDownContainer.style.outlineOffset="-1px"}}createOption(E,u,h){const D=document.createElement("option");return D.value=E,D.text=E,D.disabled=!!h,D}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:E=>this.renderSelectDropDown(E,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:E=>this.renderSelectDropDown(E),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(E){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),E&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(E,u){return E.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(u),{dispose:()=>{try{E.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let E=0;return this.options.forEach((u,h)=>{this.updateDetail(h),this.selectionDetailsPane.offsetHeight>E&&(E=this.selectionDetailsPane.offsetHeight)}),E}layoutSelectDropDown(E){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const u=v.getDomNodePagePosition(this.selectElement),h=getComputedStyle(this.selectElement),D=parseFloat(h.getPropertyValue("--dropdown-padding-top"))+parseFloat(h.getPropertyValue("--dropdown-padding-bottom")),C=window.innerHeight-u.top-u.height-(this.selectBoxOptions.minBottomMargin||0),N=u.top-m.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,A=this.selectElement.offsetWidth,o=this.setWidthControlElement(this.widthControlElement),l=Math.max(o,Math.round(A)).toString()+"px";this.selectDropDownContainer.style.width=l,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let s=this.selectList.contentHeight;const n=this._hasDetails?this.measureMaxDetailsHeight():0,g=s+D+n,S=Math.floor((C-D-n)/this.getHeight()),$=Math.floor((N-D-n)/this.getHeight());if(E)return u.top+u.height>window.innerHeight-22||u.top<m.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||S<1&&$<1?!1:(S<m.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&$>S&&this.options.length>S?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(u.top+u.height>window.innerHeight-22||u.top<m.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&S<1||this._dropDownPosition===1&&$<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&S+$<1)return this.hideSelectDropDown(!0),!1;g>C&&(s=S*this.getHeight())}else g>N&&(s=$*this.getHeight());return this.selectList.layout(s),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=s+D+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=s+D+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=l,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(E){let u=0;if(E){let h=0,D=0;this.options.forEach((C,N)=>{const A=C.detail?C.detail.length:0,o=C.decoratorRight?C.decoratorRight.length:0,l=C.text.length+A+o;l>D&&(h=N,D=l)}),E.textContent=this.options[h].text+(this.options[h].decoratorRight?this.options[h].decoratorRight+" ":""),u=v.getTotalWidth(E)}return u}createSelectList(E){if(this.selectList)return;this.selectDropDownListContainer=v.append(E,r(".select-box-dropdown-list-container")),this.listRenderer=new c,this.selectList=new y.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:D=>{let C=D.text;return D.detail&&(C+=`. ${D.detail}`),D.decoratorRight&&(C+=`. ${D.decoratorRight}`),D.description&&(C+=`. ${D.description}`),C},getWidgetAriaLabel:()=>(0,a.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const u=this._register(new i.DomEmitter(this.selectDropDownListContainer,"keydown")),h=p.Event.chain(u.event).filter(()=>this.selectList.length>0).map(D=>new P.StandardKeyboardEvent(D));this._register(h.filter(D=>D.keyCode===3).on(D=>this.onEnter(D),this)),this._register(h.filter(D=>D.keyCode===2).on(D=>this.onEnter(D),this)),this._register(h.filter(D=>D.keyCode===9).on(D=>this.onEscape(D),this)),this._register(h.filter(D=>D.keyCode===16).on(D=>this.onUpArrow(D),this)),this._register(h.filter(D=>D.keyCode===18).on(D=>this.onDownArrow(D),this)),this._register(h.filter(D=>D.keyCode===12).on(this.onPageDown,this)),this._register(h.filter(D=>D.keyCode===11).on(this.onPageUp,this)),this._register(h.filter(D=>D.keyCode===14).on(this.onHome,this)),this._register(h.filter(D=>D.keyCode===13).on(this.onEnd,this)),this._register(h.filter(D=>D.keyCode>=21&&D.keyCode<=56||D.keyCode>=80&&D.keyCode<=108).on(this.onCharacter,this)),this._register(v.addDisposableListener(this.selectList.getHTMLElement(),v.EventType.POINTER_UP,D=>this.onPointerUp(D))),this._register(this.selectList.onMouseOver(D=>typeof D.index!="undefined"&&this.selectList.setFocus([D.index]))),this._register(this.selectList.onDidChangeFocus(D=>this.onListFocus(D))),this._register(v.addDisposableListener(this.selectDropDownContainer,v.EventType.FOCUS_OUT,D=>{!this._isVisible||v.isAncestor(D.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(E){if(!this.selectList.length)return;v.EventHelper.stop(E);const u=E.target;if(!u||u.classList.contains("slider"))return;const h=u.closest(".monaco-list-row");if(!h)return;const D=Number(h.getAttribute("data-index")),C=h.classList.contains("option-disabled");D>=0&&D<this.options.length&&!C&&(this.selected=D,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(E,u){const h=C=>{for(let N=0;N<C.childNodes.length;N++){const A=C.childNodes.item(N);(A.tagName&&A.tagName.toLowerCase())==="img"?C.removeChild(A):h(A)}},D=(0,M.renderMarkdown)({value:E},{actionHandler:u});return D.element.classList.add("select-box-description-markdown"),h(D.element),D.element}onListFocus(E){!this._isVisible||!this._hasDetails||this.updateDetail(E.indexes[0])}updateDetail(E){this.selectionDetailsPane.innerText="";const u=this.options[E],h=u?.description??"",D=u?.descriptionIsMarkdown??!1;if(h){if(D){const C=u.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(h,C))}else this.selectionDetailsPane.innerText=h;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(E){v.EventHelper.stop(E),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(E){v.EventHelper.stop(E),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(E){if(this.selected<this.options.length-1){v.EventHelper.stop(E,!0);const u=this.options[this.selected+1].isDisabled;if(u&&this.options.length>this.selected+2)this.selected+=2;else{if(u)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(E){this.selected>0&&(v.EventHelper.stop(E,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(E){v.EventHelper.stop(E),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(E){v.EventHelper.stop(E),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(E){v.EventHelper.stop(E),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(E){v.EventHelper.stop(E),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(E){const u=f.KeyCodeUtils.toString(E.keyCode);let h=-1;for(let D=0;D<this.options.length-1;D++)if(h=(D+this.selected+1)%this.options.length,this.options[h].text.charAt(0).toUpperCase()===u&&!this.options[h].isDisabled){this.select(h),this.selectList.setFocus([h]),this.selectList.reveal(this.selectList.getFocus()[0]),v.EventHelper.stop(E);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=m,m.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32,m.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2,m.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}),define(pe[123],be([1,0,122,116,17,24,27,5,90]),function(Z,t,v,i,P,M,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:M.Color.fromHex("#3C3C3C"),selectForeground:M.Color.fromHex("#F0F0F0"),selectBorder:M.Color.fromHex("#3C3C3C")};class p extends P.Widget{constructor(b,T,a,r=(0,y.deepClone)(t.defaultStyles),e){super();w.isMacintosh&&!e?.useCustomDrawn?this.selectBoxDelegate=new i.SelectBoxNative(b,T,r,e):this.selectBoxDelegate=new v.SelectBoxList(b,T,a,r,e),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(b,T){this.selectBoxDelegate.setOptions(b,T)}select(b){this.selectBoxDelegate.select(b)}setAriaLabel(b){this.selectBoxDelegate.setAriaLabel(b)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(b){this.selectBoxDelegate.setFocusable(b)}render(b){this.selectBoxDelegate.render(b)}style(b){this.selectBoxDelegate.style(b)}applyStyles(){this.selectBoxDelegate.applyStyles()}}t.SelectBox=p}),define(pe[60],be([1,0,15,50,4,22,121,123,32,2,5,6,95,46]),function(Z,t,v,i,P,M,y,w,p,f,b,T,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class r extends f.Disposable{constructor(_,E,u={}){super();this.options=u,this._context=_||this,this._action=E,E instanceof p.Action&&this._register(E.onDidChange(h=>{!this.element||this.handleActionChangeEvent(h)}))}get action(){return this._action}handleActionChangeEvent(_){_.enabled!==void 0&&this.updateEnabled(),_.checked!==void 0&&this.updateChecked(),_.class!==void 0&&this.updateClass(),_.label!==void 0&&(this.updateLabel(),this.updateTooltip()),_.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new p.ActionRunner)),this._actionRunner}set actionRunner(_){this._actionRunner=_}getAction(){return this._action}isEnabled(){return this._action.enabled}setActionContext(_){this._context=_}render(_){const E=this.element=_;this._register(M.Gesture.addTarget(_));const u=this.options&&this.options.draggable;u&&(_.draggable=!0,v.isFirefox&&this._register((0,P.addDisposableListener)(_,P.EventType.DRAG_START,h=>h.dataTransfer?.setData(i.DataTransfers.TEXT,this._action.label)))),this._register((0,P.addDisposableListener)(E,M.EventType.Tap,h=>this.onClick(h,!0))),this._register((0,P.addDisposableListener)(E,P.EventType.MOUSE_DOWN,h=>{u||P.EventHelper.stop(h,!0),this._action.enabled&&h.button===0&&E.classList.add("active")})),b.isMacintosh&&this._register((0,P.addDisposableListener)(E,P.EventType.CONTEXT_MENU,h=>{h.button===0&&h.ctrlKey===!0&&this.onClick(h)})),this._register((0,P.addDisposableListener)(E,P.EventType.CLICK,h=>{P.EventHelper.stop(h,!0),this.options&&this.options.isMenu||this.onClick(h)})),this._register((0,P.addDisposableListener)(E,P.EventType.DBLCLICK,h=>{P.EventHelper.stop(h,!0)})),[P.EventType.MOUSE_UP,P.EventType.MOUSE_OUT].forEach(h=>{this._register((0,P.addDisposableListener)(E,h,D=>{P.EventHelper.stop(D),E.classList.remove("active")}))})}onClick(_,E=!1){P.EventHelper.stop(_,!0);const u=T.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?_:{preserveFocus:E}:this._context;this.actionRunner.run(this._action,u)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(_){this.element&&(this.element.tabIndex=_?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getTooltip(){return this.getAction().tooltip}updateTooltip(){if(!this.element)return;const _=this.getTooltip()??"";this.element.setAttribute("aria-label",_),this.options.hoverDelegate?(this.element.title="",this.customHover?this.customHover.update(_):(this.customHover=(0,y.setupCustomHover)(this.options.hoverDelegate,this.element,_),this._store.add(this.customHover))):this.element.title=_}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),super.dispose()}}t.BaseActionViewItem=r;class e extends r{constructor(_,E,u={}){super(_,E,u);this.options=u,this.options.icon=u.icon!==void 0?u.icon:!1,this.options.label=u.label!==void 0?u.label:!0,this.cssClass=""}render(_){super.render(_),this.element&&(this.label=(0,P.append)(this.element,(0,P.$)("a.action-label"))),this.label&&(this._action.id===p.Separator.ID?this.label.setAttribute("role","presentation"):this.options.isMenu?this.label.setAttribute("role","menuitem"):this.label.setAttribute("role","button")),this.options.label&&this.options.keybinding&&this.element&&((0,P.append)(this.element,(0,P.$)("span.keybinding")).textContent=this.options.keybinding),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(_){this.label&&(this.label.tabIndex=_?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.getAction().label)}getTooltip(){let _=null;return this.getAction().tooltip?_=this.getAction().tooltip:!this.options.label&&this.getAction().label&&this.options.icon&&(_=this.getAction().label,this.options.keybinding&&(_=a.localize(0,null,_,this.options.keybinding))),_??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.getAction().class,this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.getAction().enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateChecked(){this.label&&(this.getAction().checked?this.label.classList.add("checked"):this.label.classList.remove("checked"))}}t.ActionViewItem=e;class c extends r{constructor(_,E,u,h,D,C){super(_,E);this.selectBox=new w.SelectBox(u,h,D,void 0,C),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(_,E){this.selectBox.setOptions(_,E)}select(_){this.selectBox.select(_)}registerListeners(){this._register(this.selectBox.onDidSelect(_=>{this.actionRunner.run(this._action,this.getActionContext(_.selected,_.index))}))}getActionContext(_,E){return _}setFocusable(_){this.selectBox.setFocusable(_)}focus(){this.selectBox&&this.selectBox.focus()}blur(){this.selectBox&&this.selectBox.blur()}render(_){this.selectBox.render(_)}}t.SelectActionViewItem=c}),define(pe[61],be([1,0,4,19,60,32,3,2,6,46]),function(Z,t,v,i,P,M,y,w,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var f;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(f=t.ActionsOrientation||(t.ActionsOrientation={}));class b extends w.Disposable{constructor(r,e={}){super();this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new y.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new y.Emitter({onFirstListenerAdd:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new y.Emitter),this.onDidRun=this._onDidRun.event,this._onBeforeRun=this._register(new y.Emitter),this.onBeforeRun=this._onBeforeRun.event,this.options=e,this._context=e.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new M.ActionRunner,this._register(this._actionRunner)),this._register(this._actionRunner.onDidRun(_=>this._onDidRun.fire(_))),this._register(this._actionRunner.onBeforeRun(_=>this._onBeforeRun.fire(_))),this._actionIds=[],this.viewItems=[],this.viewItemDisposables=new Map,this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let c,m;switch(this._orientation){case 0:c=[15],m=[17];break;case 1:c=[16],m=[18],this.domNode.className+=" vertical";break}this._register(v.addDisposableListener(this.domNode,v.EventType.KEY_DOWN,_=>{const E=new i.StandardKeyboardEvent(_);let u=!0;const h=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;c&&(E.equals(c[0])||E.equals(c[1]))?u=this.focusPrevious():m&&(E.equals(m[0])||E.equals(m[1]))?u=this.focusNext():E.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():E.equals(14)?u=this.focusFirst():E.equals(13)?u=this.focusLast():E.equals(2)&&h instanceof P.BaseActionViewItem&&h.trapsArrowNavigation?u=this.focusNext():this.isTriggerKeyEvent(E)?this._triggerKeys.keyDown?this.doTrigger(E):this.triggerKeyDown=!0:u=!1,u&&(E.preventDefault(),E.stopPropagation())})),this._register(v.addDisposableListener(this.domNode,v.EventType.KEY_UP,_=>{const E=new i.StandardKeyboardEvent(_);this.isTriggerKeyEvent(E)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(E)),E.preventDefault(),E.stopPropagation()):(E.equals(2)||E.equals(1024|2))&&this.updateFocusedItem()})),this.focusTracker=this._register(v.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(v.getActiveElement()===this.domNode||!v.isAncestor(v.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.focusedItem=void 0,this.previouslyFocusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),r.appendChild(this.domNode)}refreshRole(){this.length()>=2?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(r){r?this.actionsList.setAttribute("aria-label",r):this.actionsList.removeAttribute("aria-label")}setFocusable(r){if(this.focusable=r,this.focusable){const e=this.viewItems.find(c=>c instanceof P.BaseActionViewItem&&c.isEnabled());e instanceof P.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof P.BaseActionViewItem&&e.setFocusable(!1)})}isTriggerKeyEvent(r){let e=!1;return this._triggerKeys.keys.forEach(c=>{e=e||r.equals(c)}),e}updateFocusedItem(){for(let r=0;r<this.actionsList.children.length;r++){const e=this.actionsList.children[r];if(v.isAncestor(v.getActiveElement(),e)){this.focusedItem=r;break}}}get context(){return this._context}set context(r){this._context=r,this.viewItems.forEach(e=>e.setActionContext(r))}get actionRunner(){return this._actionRunner}set actionRunner(r){r&&(this._actionRunner=r,this.viewItems.forEach(e=>e.actionRunner=r))}getContainer(){return this.domNode}hasAction(r){return this._actionIds.includes(r.id)}getAction(r){return this.viewItems[r].action}push(r,e={}){const c=Array.isArray(r)?r:[r];let m=p.isNumber(e.index)?e.index:null;c.forEach(_=>{const E=document.createElement("li");E.className="action-item",E.setAttribute("role","presentation");let u;this.options.actionViewItemProvider&&(u=this.options.actionViewItemProvider(_)),u||(u=new P.ActionViewItem(this.context,_,{hoverDelegate:this.options.hoverDelegate,...e})),this.options.allowContextMenu||this.viewItemDisposables.set(u,v.addDisposableListener(E,v.EventType.CONTEXT_MENU,h=>{v.EventHelper.stop(h,!0)})),u.actionRunner=this._actionRunner,u.setActionContext(this.context),u.render(E),this.focusable&&u instanceof P.BaseActionViewItem&&this.viewItems.length===0&&u.setFocusable(!0),m===null||m<0||m>=this.actionsList.children.length?(this.actionsList.appendChild(E),this.viewItems.push(u),this._actionIds.push(_.id)):(this.actionsList.insertBefore(E,this.actionsList.children[m]),this.viewItems.splice(m,0,u),this._actionIds.splice(m,0,_.id),m++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(r){if(r>=0&&r<this.actionsList.children.length){const e=this.actionsList.children.item(r);if(e)return e.clientWidth}return 0}getHeight(r){if(r>=0&&r<this.actionsList.children.length){const e=this.actionsList.children.item(r);if(e)return e.clientHeight}return 0}pull(r){r>=0&&r<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[r]),this.viewItemDisposables.get(this.viewItems[r])?.dispose(),this.viewItemDisposables.delete(this.viewItems[r]),(0,w.dispose)(this.viewItems.splice(r,1)),this._actionIds.splice(r,1),this.refreshRole())}clear(){(0,w.dispose)(this.viewItems),this.viewItemDisposables.forEach(r=>r.dispose()),this.viewItemDisposables.clear(),this.viewItems=[],this._actionIds=[],v.clearNode(this.actionsList),this.refreshRole()}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(r){let e=!1,c;if(r===void 0?e=!0:typeof r=="number"?c=r:typeof r=="boolean"&&(e=r),e&&typeof this.focusedItem=="undefined"){const m=this.viewItems.findIndex(_=>_.isEnabled());this.focusedItem=m===-1?void 0:m,this.updateFocus(void 0,void 0,!0)}else c!==void 0&&(this.focusedItem=c),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(r){if(typeof this.focusedItem=="undefined")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let c;do{if(!r&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=e,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,c=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!c.isEnabled()||c.action.id===M.Separator.ID));return this.updateFocus(),!0}focusPrevious(r){if(typeof this.focusedItem=="undefined")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let c;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!r&&this.options.preventLoopNavigation)return this.focusedItem=e,!1;this.focusedItem=this.viewItems.length-1}c=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!c.isEnabled()||c.action.id===M.Separator.ID));return this.updateFocus(!0),!0}updateFocus(r,e,c=!1){typeof this.focusedItem=="undefined"&&this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const m=this.focusedItem!==void 0&&this.viewItems[this.focusedItem];if(m){let _=!0;p.isFunction(m.focus)||(_=!1),this.options.focusOnlyEnabledItems&&p.isFunction(m.isEnabled)&&!m.isEnabled()&&(_=!1),m.action.id===M.Separator.ID&&(_=!1),_?(c||this.previouslyFocusedItem!==this.focusedItem)&&(m.focus(r),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem=void 0)}}doTrigger(r){if(typeof this.focusedItem=="undefined")return;const e=this.viewItems[this.focusedItem];if(e instanceof P.BaseActionViewItem){const c=e._context===null||e._context===void 0?r:e._context;this.run(e._action,c)}}async run(r,e){await this._actionRunner.run(r,e)}dispose(){(0,w.dispose)(this.viewItems),this.viewItems=[],this._actionIds=[],this.getContainer().remove(),super.dispose()}}t.ActionBar=b;function T(a){if(!a.length)return a;let r=-1;for(let c=0;c<a.length;c++)if(a[c].id!==M.Separator.ID){r=c;break}if(r===-1)return[];a=a.slice(r);for(let c=a.length-1;c>=0&&a[c].id===M.Separator.ID;c--)a.splice(c,1);let e=!1;for(let c=a.length-1;c>=0;c--){const m=a[c].id===M.Separator.ID;m&&!e?a.splice(c,1):m?m&&(e=!1):e=!0}return a}t.prepareActions=T}),define(pe[124],be([1,0,4,18,51,61,53,56,17,24,3,77,27,99,87]),function(Z,t,v,i,P,M,y,w,p,f,b,T,a,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.MessageType=void 0;const e=v.$;var c;(function(u){u[u.INFO=1]="INFO",u[u.WARNING=2]="WARNING",u[u.ERROR=3]="ERROR"})(c=t.MessageType||(t.MessageType={}));const m={inputBackground:f.Color.fromHex("#3C3C3C"),inputForeground:f.Color.fromHex("#CCCCCC"),inputValidationInfoBorder:f.Color.fromHex("#55AAFF"),inputValidationInfoBackground:f.Color.fromHex("#063B49"),inputValidationWarningBorder:f.Color.fromHex("#B89500"),inputValidationWarningBackground:f.Color.fromHex("#352A05"),inputValidationErrorBorder:f.Color.fromHex("#BE1100"),inputValidationErrorBackground:f.Color.fromHex("#5A1D1D")};class _ extends p.Widget{constructor(h,D,C){super();this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new b.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=D,this.options=C||Object.create(null),(0,a.mixin)(this.options,m,!1),this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.inputBackground=this.options.inputBackground,this.inputForeground=this.options.inputForeground,this.inputBorder=this.options.inputBorder,this.inputValidationInfoBorder=this.options.inputValidationInfoBorder,this.inputValidationInfoBackground=this.options.inputValidationInfoBackground,this.inputValidationInfoForeground=this.options.inputValidationInfoForeground,this.inputValidationWarningBorder=this.options.inputValidationWarningBorder,this.inputValidationWarningBackground=this.options.inputValidationWarningBackground,this.inputValidationWarningForeground=this.options.inputValidationWarningForeground,this.inputValidationErrorBorder=this.options.inputValidationErrorBorder,this.inputValidationErrorBackground=this.options.inputValidationErrorBackground,this.inputValidationErrorForeground=this.options.inputValidationErrorForeground,this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=v.append(h,e(".monaco-inputbox.idle"));const N=this.options.flexibleHeight?"textarea":"input",A=v.append(this.element,e(".ibwrapper"));if(this.input=v.append(A,e(N+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=v.append(A,e("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new w.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),v.append(h,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(s=>this.input.scrollTop=s.scrollTop));const o=this._register(new i.DomEmitter(document,"selectionchange")),l=b.Event.filter(o.event,()=>document.getSelection()?.anchorNode===A);this._register(l(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this.ignoreGesture(this.input),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new M.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(h){this.placeholder=h,this.input.setAttribute("placeholder",h)}setTooltip(h){this.tooltip=h,this.input.title=h}setAriaLabel(h){this.ariaLabel=h,h?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(h){this.input.value!==h&&(this.input.value=h,this.onValueChange())}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:v.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return document.activeElement===this.input}select(h=null){this.input.select(),h&&(this.input.setSelectionRange(h.start,h.end),h.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(h){h?this.enable():this.disable()}get width(){return v.getTotalWidth(this.input)}set width(h){if(this.options.flexibleHeight&&this.options.flexibleWidth){let D=0;if(this.mirror){const C=parseFloat(this.mirror.style.paddingLeft||"")||0,N=parseFloat(this.mirror.style.paddingRight||"")||0;D=C+N}this.input.style.width=h-D+"px"}else this.input.style.width=h+"px";this.mirror&&(this.mirror.style.width=h+"px")}set paddingRight(h){this.input.style.width=`calc(100% - ${h}px)`,this.mirror&&(this.mirror.style.paddingRight=h+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const h=this.cachedContentHeight,D=this.cachedHeight,C=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:h,height:D}),this.scrollableElement.setScrollPosition({scrollTop:C})}showMessage(h,D){this.message=h,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(h.type));const C=this.stylesForType(this.message.type);this.element.style.border=C.border?`1px solid ${C.border}`:"",(this.hasFocus()||D)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let h=null;return this.validation&&(h=this.validation(this.value),h?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(h)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),h?.type}stylesForType(h){switch(h){case 1:return{border:this.inputValidationInfoBorder,background:this.inputValidationInfoBackground,foreground:this.inputValidationInfoForeground};case 2:return{border:this.inputValidationWarningBorder,background:this.inputValidationWarningBackground,foreground:this.inputValidationWarningForeground};default:return{border:this.inputValidationErrorBorder,background:this.inputValidationErrorBackground,foreground:this.inputValidationErrorForeground}}}classForType(h){switch(h){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let h;const D=()=>h.style.width=v.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:N=>{if(!this.message)return null;h=v.append(N,e(".monaco-inputbox-container")),D();const A={inline:!0,className:"monaco-inputbox-message"},o=this.message.formatContent?(0,P.renderFormattedText)(this.message.content,A):(0,P.renderText)(this.message.content,A);o.classList.add(this.classForType(this.message.type));const l=this.stylesForType(this.message.type);return o.style.backgroundColor=l.background?l.background.toString():"",o.style.color=l.foreground?l.foreground.toString():"",o.style.border=l.border?`1px solid ${l.border}`:"",v.append(h,o),null},onHide:()=>{this.state="closed"},layout:D});let C;this.message.type===3?C=r.localize(0,null,this.message.content):this.message.type===2?C=r.localize(1,null,this.message.content):C=r.localize(2,null,this.message.content),y.alert(C),this.state="open"}_hideMessage(){!this.contextViewProvider||(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const h=this.value,C=h.charCodeAt(h.length-1)===10?" ":"";(h+C).replace(/\u000c/g,"")?this.mirror.textContent=h+C:this.mirror.innerText="\xA0",this.layout()}style(h){this.inputBackground=h.inputBackground,this.inputForeground=h.inputForeground,this.inputBorder=h.inputBorder,this.inputValidationInfoBackground=h.inputValidationInfoBackground,this.inputValidationInfoForeground=h.inputValidationInfoForeground,this.inputValidationInfoBorder=h.inputValidationInfoBorder,this.inputValidationWarningBackground=h.inputValidationWarningBackground,this.inputValidationWarningForeground=h.inputValidationWarningForeground,this.inputValidationWarningBorder=h.inputValidationWarningBorder,this.inputValidationErrorBackground=h.inputValidationErrorBackground,this.inputValidationErrorForeground=h.inputValidationErrorForeground,this.inputValidationErrorBorder=h.inputValidationErrorBorder,this.applyStyles()}applyStyles(){const h=this.inputBackground?this.inputBackground.toString():"",D=this.inputForeground?this.inputForeground.toString():"",C=this.inputBorder?this.inputBorder.toString():"";this.element.style.backgroundColor=h,this.element.style.color=D,this.input.style.backgroundColor="inherit",this.input.style.color=D,this.element.style.borderWidth=C?"1px":"",this.element.style.borderStyle=C?"solid":"",this.element.style.borderColor=C}layout(){if(!this.mirror)return;const h=this.cachedContentHeight;this.cachedContentHeight=v.getTotalHeight(this.mirror),h!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(h){const D=this.inputElement,C=D.selectionStart,N=D.selectionEnd,A=D.value;C!==null&&N!==null&&(this.value=A.substr(0,C)+h+A.substr(N),D.setSelectionRange(C+1,C+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar&&this.actionbar.dispose(),super.dispose()}}t.InputBox=_;class E extends _{constructor(h,D,C){const N=r.localize(3,null),A=` or \u21C5 ${N}`,o=` (\u21C5 ${N})`;super(h,D,C);this._onDidFocus=this._register(new b.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new b.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new T.HistoryNavigator(C.history,100);const l=()=>{if(C.showHistoryHint&&C.showHistoryHint()&&!this.placeholder.endsWith(A)&&!this.placeholder.endsWith(o)&&this.history.getHistory().length){const s=this.placeholder.endsWith(")")?A:o,n=this.placeholder+s;C.showPlaceholderOnFocus&&document.activeElement!==this.input?this.placeholder=n:this.setPlaceHolder(n)}};this.observer=new MutationObserver((s,n)=>{s.forEach(g=>{g.target.textContent||l()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>l()),this.onblur(this.input,()=>{const s=n=>{if(this.placeholder.endsWith(n)){const g=this.placeholder.slice(0,this.placeholder.length-n.length);return C.showPlaceholderOnFocus?this.placeholder=g:this.setPlaceHolder(g),!0}else return!1};s(o)||s(A)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(){this.value&&this.value!==this.getCurrentValue()&&this.history.add(this.value)}getHistory(){return this.history.getHistory()}showNextValue(){this.history.has(this.value)||this.addToHistory();let h=this.getNextValue();h&&(h=h===this.value?this.getNextValue():h),h&&(this.value=h,y.status(this.value))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let h=this.getPreviousValue();h&&(h=h===this.value?this.getPreviousValue():h),h&&(this.value=h,y.status(this.value))}clearHistory(){this.history.clear()}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let h=this.history.current();return h||(h=this.history.last(),this.history.next()),h}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()||this.history.last()}}t.HistoryInputBox=E}),define(pe[62],be([1,0,60,17,11,24,3,92]),function(Z,t,v,i,P,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=void 0;const w={inputActiveOptionBorder:M.Color.fromHex("#007ACC00"),inputActiveOptionForeground:M.Color.fromHex("#FFFFFF"),inputActiveOptionBackground:M.Color.fromHex("#0E639C50")};class p extends v.BaseActionViewItem{constructor(a,r,e){super(a,r,e);this.toggle=this._register(new f({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(a){this.element=a,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(a){this.toggle.domNode.tabIndex=a?0:-1}}t.ToggleActionViewItem=p;class f extends i.Widget{constructor(a){super();this._onChange=this._register(new y.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new y.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts={...w,...a},this._checked=this._opts.isChecked;const r=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,r.push(...P.CSSIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&r.push(...this._opts.actionClassName.split(" ")),this._checked&&r.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this._opts.title,this.domNode.classList.add(...r),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,e=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),e.preventDefault())}),this.ignoreGesture(this.domNode),this.onkeydown(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),e.preventDefault(),e.stopPropagation();return}this._onKeyDown.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(a){this._checked=a,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(a){this._icon&&this.domNode.classList.remove(...P.CSSIcon.asClassNameArray(this._icon)),this._icon=a,this._icon&&this.domNode.classList.add(...P.CSSIcon.asClassNameArray(this._icon))}width(){return 2+2+2+16}style(a){a.inputActiveOptionBorder&&(this._opts.inputActiveOptionBorder=a.inputActiveOptionBorder),a.inputActiveOptionForeground&&(this._opts.inputActiveOptionForeground=a.inputActiveOptionForeground),a.inputActiveOptionBackground&&(this._opts.inputActiveOptionBackground=a.inputActiveOptionBackground),this.applyStyles()}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder?this._opts.inputActiveOptionBorder.toString():"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground?this._opts.inputActiveOptionForeground.toString():"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground?this._opts.inputActiveOptionBackground.toString():"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(a){this.domNode.title=a,this.domNode.setAttribute("aria-label",a)}}t.Toggle=f;class b extends i.Widget{constructor(a,r){super();this.title=a,this.isChecked=r,this.checkbox=new f({title:this.title,isChecked:this.isChecked,icon:P.Codicon.check,actionClassName:"monaco-checkbox"}),this.domNode=this.checkbox.domNode,this.styles={},this.checkbox.onChange(()=>{this.applyStyles()})}get checked(){return this.checkbox.checked}set checked(a){this.checkbox.checked=a,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}style(a){this.styles=a,this.applyStyles()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground?this.styles.checkboxForeground.toString():"",this.domNode.style.backgroundColor=this.styles.checkboxBackground?this.styles.checkboxBackground.toString():"",this.domNode.style.borderColor=this.styles.checkboxBorder?this.styles.checkboxBorder.toString():""}}t.Checkbox=b}),define(pe[125],be([1,0,62,11,97]),function(Z,t,v,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const M=P.localize(0,null),y=P.localize(1,null),w=P.localize(2,null);class p extends v.Toggle{constructor(a){super({icon:i.Codicon.caseSensitive,title:M+a.appendTitle,isChecked:a.isChecked,inputActiveOptionBorder:a.inputActiveOptionBorder,inputActiveOptionForeground:a.inputActiveOptionForeground,inputActiveOptionBackground:a.inputActiveOptionBackground})}}t.CaseSensitiveToggle=p;class f extends v.Toggle{constructor(a){super({icon:i.Codicon.wholeWord,title:y+a.appendTitle,isChecked:a.isChecked,inputActiveOptionBorder:a.inputActiveOptionBorder,inputActiveOptionForeground:a.inputActiveOptionForeground,inputActiveOptionBackground:a.inputActiveOptionBackground})}}t.WholeWordsToggle=f;class b extends v.Toggle{constructor(a){super({icon:i.Codicon.regex,title:w+a.appendTitle,isChecked:a.isChecked,inputActiveOptionBorder:a.inputActiveOptionBorder,inputActiveOptionForeground:a.inputActiveOptionForeground,inputActiveOptionBackground:a.inputActiveOptionBackground})}}t.RegexToggle=b}),define(pe[126],be([1,0,4,125,124,17,3,96,86]),function(Z,t,v,i,P,M,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const p=w.localize(0,null);class f extends M.Widget{constructor(T,a,r,e){super();this._showOptionButtons=r,this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalToggles=[],this._onDidOptionChange=this._register(new y.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new y.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new y.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new y.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new y.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new y.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new y.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.contextViewProvider=a,this.placeholder=e.placeholder||"",this.validation=e.validation,this.label=e.label||p,this.inputActiveOptionBorder=e.inputActiveOptionBorder,this.inputActiveOptionForeground=e.inputActiveOptionForeground,this.inputActiveOptionBackground=e.inputActiveOptionBackground,this.inputBackground=e.inputBackground,this.inputForeground=e.inputForeground,this.inputBorder=e.inputBorder,this.inputValidationInfoBorder=e.inputValidationInfoBorder,this.inputValidationInfoBackground=e.inputValidationInfoBackground,this.inputValidationInfoForeground=e.inputValidationInfoForeground,this.inputValidationWarningBorder=e.inputValidationWarningBorder,this.inputValidationWarningBackground=e.inputValidationWarningBackground,this.inputValidationWarningForeground=e.inputValidationWarningForeground,this.inputValidationErrorBorder=e.inputValidationErrorBorder,this.inputValidationErrorBackground=e.inputValidationErrorBackground,this.inputValidationErrorForeground=e.inputValidationErrorForeground;const c=e.appendCaseSensitiveLabel||"",m=e.appendWholeWordsLabel||"",_=e.appendRegexLabel||"",E=e.history||[],u=!!e.flexibleHeight,h=!!e.flexibleWidth,D=e.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new P.HistoryInputBox(this.domNode,this.contextViewProvider,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder,history:E,showHistoryHint:e.showHistoryHint,flexibleHeight:u,flexibleWidth:h,flexibleMaxHeight:D})),this.regex=this._register(new i.RegexToggle({appendTitle:_,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.regex.onChange(N=>{this._onDidOptionChange.fire(N),!N&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(N=>{this._onRegexKeyDown.fire(N)})),this.wholeWords=this._register(new i.WholeWordsToggle({appendTitle:m,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.wholeWords.onChange(N=>{this._onDidOptionChange.fire(N),!N&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new i.CaseSensitiveToggle({appendTitle:c,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.caseSensitive.onChange(N=>{this._onDidOptionChange.fire(N),!N&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(N=>{this._onCaseSensitiveKeyDown.fire(N)}));const C=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,N=>{if(N.equals(15)||N.equals(17)||N.equals(9)){const A=C.indexOf(document.activeElement);if(A>=0){let o=-1;N.equals(17)?o=(A+1)%C.length:N.equals(15)&&(A===0?o=C.length-1:o=A-1),N.equals(9)?(C[A].blur(),this.inputBox.focus()):o>=0&&C[o].focus(),v.EventHelper.stop(N,!0)}}}),this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this._showOptionButtons?"block":"none",this.controls.appendChild(this.caseSensitive.domNode),this.controls.appendChild(this.wholeWords.domNode),this.controls.appendChild(this.regex.domNode),this._showOptionButtons||(this.caseSensitive.domNode.style.display="none",this.wholeWords.domNode.style.display="none",this.regex.domNode.style.display="none");for(const N of e?.additionalToggles??[])this._register(N),this.controls.appendChild(N.domNode),this._register(N.onChange(A=>{this._onDidOptionChange.fire(A),!A&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(N);this.additionalToggles.length>0&&(this.controls.style.display="block"),this.inputBox.paddingRight=(this._showOptionButtons?this.caseSensitive.width()+this.wholeWords.width()+this.regex.width():0)+this.additionalToggles.reduce((N,A)=>N+A.width(),0),this.domNode.appendChild(this.controls),T?.appendChild(this.domNode),this._register(v.addDisposableListener(this.inputBox.inputElement,"compositionstart",N=>{this.imeSessionInProgress=!0})),this._register(v.addDisposableListener(this.inputBox.inputElement,"compositionend",N=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,N=>this._onKeyDown.fire(N)),this.onkeyup(this.inputBox.inputElement,N=>this._onKeyUp.fire(N)),this.oninput(this.inputBox.inputElement,N=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,N=>this._onMouseDown.fire(N))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex.enable(),this.wholeWords.enable(),this.caseSensitive.enable();for(const T of this.additionalToggles)T.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex.disable(),this.wholeWords.disable(),this.caseSensitive.disable();for(const T of this.additionalToggles)T.disable()}setFocusInputOnOptionClick(T){this.fixFocusOnOptionClickEnabled=T}setEnabled(T){T?this.enable():this.disable()}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(T){this.inputBox.value!==T&&(this.inputBox.value=T)}onSearchSubmit(){this.inputBox.addToHistory()}style(T){this.inputActiveOptionBorder=T.inputActiveOptionBorder,this.inputActiveOptionForeground=T.inputActiveOptionForeground,this.inputActiveOptionBackground=T.inputActiveOptionBackground,this.inputBackground=T.inputBackground,this.inputForeground=T.inputForeground,this.inputBorder=T.inputBorder,this.inputValidationInfoBackground=T.inputValidationInfoBackground,this.inputValidationInfoForeground=T.inputValidationInfoForeground,this.inputValidationInfoBorder=T.inputValidationInfoBorder,this.inputValidationWarningBackground=T.inputValidationWarningBackground,this.inputValidationWarningForeground=T.inputValidationWarningForeground,this.inputValidationWarningBorder=T.inputValidationWarningBorder,this.inputValidationErrorBackground=T.inputValidationErrorBackground,this.inputValidationErrorForeground=T.inputValidationErrorForeground,this.inputValidationErrorBorder=T.inputValidationErrorBorder,this.applyStyles()}applyStyles(){if(this.domNode){const T={inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground};this.regex.style(T),this.wholeWords.style(T),this.caseSensitive.style(T);for(const r of this.additionalToggles)r.style(T);const a={inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder};this.inputBox.style(a)}}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive.checked}setCaseSensitive(T){this.caseSensitive.checked=T}getWholeWords(){return this.wholeWords.checked}setWholeWords(T){this.wholeWords.checked=T}getRegex(){return this.regex.checked}setRegex(T){this.regex.checked=T,this.validate()}focusOnCaseSensitive(){this.caseSensitive.focus()}focusOnRegex(){this.regex.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(T){this.inputBox.showMessage(T)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=f,f.OPTION_CHANGE="optionChange"}),define(pe[127],be([1,0,4,18,19,61,126,57,58,62,54,23,32,14,8,11,69,3,33,2,44,6,101,93]),function(Z,t,v,i,P,M,y,w,p,f,b,T,a,r,e,c,m,_,E,u,h,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMode=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class N extends w.ElementsDragAndDropData{constructor(F){super(F.elements.map(K=>K.element));this.data=F}set context(F){this.data.context=F}get context(){return this.data.context}}function A(se){return se instanceof w.ElementsDragAndDropData?new N(se):se}class o{constructor(F,K){this.modelProvider=F,this.dnd=K,this.autoExpandDisposable=u.Disposable.None}getDragURI(F){return this.dnd.getDragURI(F.element)}getDragLabel(F,K){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(F.map(X=>X.element),K)}onDragStart(F,K){this.dnd.onDragStart?.(A(F),K)}onDragOver(F,K,X,O,d=!0){const L=this.dnd.onDragOver(A(F),K&&K.element,X,O),U=this.autoExpandNode!==K;if(U&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=K),typeof K=="undefined")return L;if(U&&typeof L!="boolean"&&L.autoExpand&&(this.autoExpandDisposable=(0,e.disposableTimeout)(()=>{const V=this.modelProvider(),I=V.getNodeLocation(K);V.isCollapsed(I)&&V.setCollapsed(I,!1),this.autoExpandNode=void 0},500)),typeof L=="boolean"||!L.accept||typeof L.bubble=="undefined"||L.feedback){if(!d){const V=typeof L=="boolean"?L:L.accept,I=typeof L=="boolean"?void 0:L.effect;return{accept:V,effect:I,feedback:[X]}}return L}if(L.bubble===1){const V=this.modelProvider(),I=V.getNodeLocation(K),z=V.getParentNodeLocation(I),k=V.getNode(z),B=z&&V.getListIndex(z);return this.onDragOver(F,k,B,O,!1)}const q=this.modelProvider(),H=q.getNodeLocation(K),R=q.getListIndex(H),W=q.getListRenderCount(H);return{...L,feedback:(0,r.range)(R,R+W)}}drop(F,K,X,O){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(A(F),K&&K.element,X,O)}onDragEnd(F){this.dnd.onDragEnd?.(F)}}function l(se,F){return F&&{...F,identityProvider:F.identityProvider&&{getId(K){return F.identityProvider.getId(K.element)}},dnd:F.dnd&&new o(se,F.dnd),multipleSelectionController:F.multipleSelectionController&&{isSelectionSingleChangeEvent(K){return F.multipleSelectionController.isSelectionSingleChangeEvent({...K,element:K.element})},isSelectionRangeChangeEvent(K){return F.multipleSelectionController.isSelectionRangeChangeEvent({...K,element:K.element})}},accessibilityProvider:F.accessibilityProvider&&{...F.accessibilityProvider,getSetSize(K){const X=se(),O=X.getNodeLocation(K),d=X.getParentNodeLocation(O);return X.getNode(d).visibleChildrenCount},getPosInSet(K){return K.visibleChildIndex+1},isChecked:F.accessibilityProvider&&F.accessibilityProvider.isChecked?K=>F.accessibilityProvider.isChecked(K.element):void 0,getRole:F.accessibilityProvider&&F.accessibilityProvider.getRole?K=>F.accessibilityProvider.getRole(K.element):()=>"treeitem",getAriaLabel(K){return F.accessibilityProvider.getAriaLabel(K.element)},getWidgetAriaLabel(){return F.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:F.accessibilityProvider&&F.accessibilityProvider.getWidgetRole?()=>F.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:F.accessibilityProvider&&F.accessibilityProvider.getAriaLevel?K=>F.accessibilityProvider.getAriaLevel(K.element):K=>K.depth,getActiveDescendantId:F.accessibilityProvider.getActiveDescendantId&&(K=>F.accessibilityProvider.getActiveDescendantId(K.element))},keyboardNavigationLabelProvider:F.keyboardNavigationLabelProvider&&{...F.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(K){return F.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(K.element)}}}}class s{constructor(F){this.delegate=F}getHeight(F){return this.delegate.getHeight(F.element)}getTemplateId(F){return this.delegate.getTemplateId(F.element)}hasDynamicHeight(F){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(F.element)}setDynamicHeight(F,K){this.delegate.setDynamicHeight?.(F.element,K)}}t.ComposedTreeDelegate=s;class n{constructor(F){if(this.focus=new Set(F.focus),this.selection=new Set(F.selection),F.expanded instanceof Array){this.expanded=Object.create(null);for(const K of F.expanded)this.expanded[K]=1}else this.expanded=F.expanded;this.expanded=F.expanded,this.scrollTop=F.scrollTop}static lift(F){return F instanceof n?F:new n(F)}static empty(F=0){return new n({focus:[],selection:[],expanded:Object.create(null),scrollTop:F})}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=n;var g;(function(se){se.None="none",se.OnHover="onHover",se.Always="always"})(g=t.RenderIndentGuides||(t.RenderIndentGuides={}));class S{constructor(F,K=[]){this._elements=K,this.disposables=new u.DisposableStore,this.onDidChange=_.Event.forEach(F,X=>this._elements=X,this.disposables)}get elements(){return this._elements}dispose(){this.disposables.dispose()}}class ${constructor(F,K,X,O,d={}){this.renderer=F,this.modelProvider=K,this.activeNodes=O,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=$.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.renderedIndentGuides=new m.SetMap,this.activeIndentNodes=new Set,this.indentGuidesDisposable=u.Disposable.None,this.disposables=new u.DisposableStore,this.templateId=F.templateId,this.updateOptions(d),_.Event.map(X,L=>L.node)(this.onDidChangeNodeTwistieState,this,this.disposables),F.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(F={}){if(typeof F.indent!="undefined"&&(this.indent=(0,h.clamp)(F.indent,0,40)),typeof F.renderIndentGuides!="undefined"){const K=F.renderIndentGuides!==g.None;if(K!==this.shouldRenderIndentGuides&&(this.shouldRenderIndentGuides=K,this.indentGuidesDisposable.dispose(),K)){const X=new u.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,X),this.indentGuidesDisposable=X,this._onDidChangeActiveNodes(this.activeNodes.elements)}}typeof F.hideTwistiesOfChildlessElements!="undefined"&&(this.hideTwistiesOfChildlessElements=F.hideTwistiesOfChildlessElements)}renderTemplate(F){const K=(0,v.append)(F,(0,v.$)(".monaco-tl-row")),X=(0,v.append)(K,(0,v.$)(".monaco-tl-indent")),O=(0,v.append)(K,(0,v.$)(".monaco-tl-twistie")),d=(0,v.append)(K,(0,v.$)(".monaco-tl-contents")),L=this.renderer.renderTemplate(d);return{container:F,indent:X,twistie:O,indentGuidesDisposable:u.Disposable.None,templateData:L}}renderElement(F,K,X,O){typeof O=="number"&&(this.renderedNodes.set(F,{templateData:X,height:O}),this.renderedElements.set(F.element,F));const d=$.DefaultIndent+(F.depth-1)*this.indent;X.twistie.style.paddingLeft=`${d}px`,X.indent.style.width=`${d+this.indent-16}px`,this.renderTwistie(F,X),typeof O=="number"&&this.renderIndentGuides(F,X),this.renderer.renderElement(F,K,X.templateData,O)}disposeElement(F,K,X,O){X.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(F,K,X.templateData,O),typeof O=="number"&&(this.renderedNodes.delete(F),this.renderedElements.delete(F.element))}disposeTemplate(F){this.renderer.disposeTemplate(F.templateData)}onDidChangeTwistieState(F){const K=this.renderedElements.get(F);!K||this.onDidChangeNodeTwistieState(K)}onDidChangeNodeTwistieState(F){const K=this.renderedNodes.get(F);!K||(this.renderTwistie(F,K.templateData),this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderIndentGuides(F,K.templateData))}renderTwistie(F,K){K.twistie.classList.remove(...c.Codicon.treeItemExpanded.classNamesArray);let X=!1;this.renderer.renderTwistie&&(X=this.renderer.renderTwistie(F.element,K.twistie)),F.collapsible&&(!this.hideTwistiesOfChildlessElements||F.visibleChildrenCount>0)?(X||K.twistie.classList.add(...c.Codicon.treeItemExpanded.classNamesArray),K.twistie.classList.add("collapsible"),K.twistie.classList.toggle("collapsed",F.collapsed)):K.twistie.classList.remove("collapsible","collapsed"),F.collapsible?K.container.setAttribute("aria-expanded",String(!F.collapsed)):K.container.removeAttribute("aria-expanded")}renderIndentGuides(F,K){if((0,v.clearNode)(K.indent),K.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const X=new u.DisposableStore,O=this.modelProvider();let d=F;for(;;){const L=O.getNodeLocation(d),U=O.getParentNodeLocation(L);if(!U)break;const q=O.getNode(U),H=(0,v.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(q)&&H.classList.add("active"),K.indent.childElementCount===0?K.indent.appendChild(H):K.indent.insertBefore(H,K.indent.firstElementChild),this.renderedIndentGuides.add(q,H),X.add((0,u.toDisposable)(()=>this.renderedIndentGuides.delete(q,H))),d=q}K.indentGuidesDisposable=X}_onDidChangeActiveNodes(F){if(!this.shouldRenderIndentGuides)return;const K=new Set,X=this.modelProvider();F.forEach(O=>{const d=X.getNodeLocation(O);try{const L=X.getParentNodeLocation(d);O.collapsible&&O.children.length>0&&!O.collapsed?K.add(O):L&&K.add(X.getNode(L))}catch{}}),this.activeIndentNodes.forEach(O=>{K.has(O)||this.renderedIndentGuides.forEach(O,d=>d.classList.remove("active"))}),K.forEach(O=>{this.activeIndentNodes.has(O)||this.renderedIndentGuides.forEach(O,d=>d.classList.add("active"))}),this.activeIndentNodes=K}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,u.dispose)(this.disposables)}}$.DefaultIndent=8;class ie{constructor(F,K,X){this.tree=F,this.keyboardNavigationLabelProvider=K,this._filter=X,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new u.DisposableStore,F.onWillRefilter(this.reset,this,this.disposables)}get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(F){this._pattern=F,this._lowercasePattern=F.toLowerCase()}filter(F,K){if(this._filter){const d=this._filter.filter(F,K);let L;if(typeof d=="boolean"?L=d?1:0:(0,b.isFilterResult)(d)?L=(0,b.getVisibleState)(d.visibility):L=d,L===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:E.FuzzyScore.Default,visibility:!0};const X=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(F),O=Array.isArray(X)?X:[X];for(const d of O){const L=d&&d.toString();if(typeof L=="undefined")return{data:E.FuzzyScore.Default,visibility:!0};const U=(0,E.fuzzyScore)(this._pattern,this._lowercasePattern,0,L,L.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(U)return this._matchCount++,O.length===1?{data:U,visibility:!0}:{data:{label:L,score:U},visibility:!0}}return this.tree.findMode===ge.Filter?2:{data:E.FuzzyScore.Default,visibility:!0}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,u.dispose)(this.disposables)}}class te extends f.Toggle{constructor(F){super({icon:c.Codicon.filter,title:(0,C.localize)(0,null),isChecked:F?.isChecked??!1,inputActiveOptionBorder:F?.inputActiveOptionBorder,inputActiveOptionForeground:F?.inputActiveOptionForeground,inputActiveOptionBackground:F?.inputActiveOptionBackground})}}t.ModeToggle=te;var ge;(function(se){se[se.Highlight=0]="Highlight",se[se.Filter=1]="Filter"})(ge=t.TreeFindMode||(t.TreeFindMode={}));class ae extends u.Disposable{constructor(F,K,X,O,d){super();this.tree=K,this.elements=(0,v.h)(".monaco-tree-type-filter",[(0,v.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab"),(0,v.h)(".monaco-tree-type-filter-input@findInput"),(0,v.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=4,this._onDidDisable=new _.Emitter,this.onDidDisable=this._onDidDisable.event,F.appendChild(this.elements.root),this._register((0,u.toDisposable)(()=>F.removeChild(this.elements.root))),this.modeToggle=this._register(new te({...d,isChecked:O===ge.Filter})),this.onDidChangeMode=_.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?ge.Filter:ge.Highlight,this._store),this.findInput=this._register(new y.FindInput(this.elements.findInput,X,!1,{label:(0,C.localize)(3,null),additionalToggles:[this.modeToggle]})),this.actionbar=this._register(new M.ActionBar(this.elements.actionbar)),this.mode=O;const L=this._register(new i.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),U=this._register(_.Event.chain(L.event)).map(R=>new P.StandardKeyboardEvent(R)).event;this._register(U(R=>{switch(R.keyCode){case 18:R.preventDefault(),R.stopPropagation(),this.tree.domFocus();return}}));const q=this._register(new a.Action("close",(0,C.localize)(4,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(q,{icon:!0,label:!1});const H=this._register(new i.DomEmitter(this.elements.grab,"mousedown"));this._register(H.event(R=>{const W=new u.DisposableStore,V=W.add(new i.DomEmitter(window,"mousemove")),I=W.add(new i.DomEmitter(window,"mouseup")),z=this.right,k=R.pageX;this.elements.grab.classList.add("grabbing");const B=j=>{const ee=j.pageX-k;this.right=z-ee,this.layout()};W.add(V.event(B)),W.add(I.event(j=>{B(j),this.elements.grab.classList.remove("grabbing"),W.dispose()}))})),this.onDidChangeValue=this.findInput.onDidChange,this.style(d??{})}set mode(F){this.modeToggle.checked=F===ge.Filter,this.findInput.inputBox.setPlaceHolder(F===ge.Filter?(0,C.localize)(1,null):(0,C.localize)(2,null))}style(F){this.findInput.style(F),F.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=F.listFilterWidgetBackground.toString()),F.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${F.listFilterWidgetShadow}`)}focus(){this.findInput.focus()}select(){this.findInput.select()}layout(F=this.width){this.width=F,this.right=Math.min(Math.max(20,this.right),Math.max(20,F-170)),this.elements.root.style.right=`${this.right}px`}showMessage(F){this.findInput.showMessage(F)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,e.timeout)(300),super.dispose()}}class ve{constructor(F,K,X,O,d){this.tree=F,this.view=X,this.filter=O,this.contextViewProvider=d,this._pattern="",this.width=0,this._onDidChangeMode=new _.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangePattern=new _.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new _.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new u.DisposableStore,this.disposables=new u.DisposableStore,this._mode=F.options.defaultFindMode??ge.Highlight,K.onDidSplice(this.onDidSpliceModel,this,this.disposables)}get pattern(){return this._pattern}get mode(){return this._mode}set mode(F){F!==this._mode&&(this._mode=F,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(F))}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.widget=new ae(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this._mode,this.styles),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(F=>this.mode=F,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this._onDidChangeOpenState.fire(!0)}close(){!this.widget||(this.widget=void 0,this.enabledDisposables.dispose(),this.enabledDisposables=new u.DisposableStore,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(F){this._pattern=F,this._onDidChangePattern.fire(F),this.filter.pattern=F,this.tree.refilter(),F&&this.tree.focusNext(0,!0,void 0,X=>!E.FuzzyScore.isDefault(X.filterData));const K=this.tree.getFocus();if(K.length>0){const X=K[0];this.tree.getRelativeTop(X)===null&&this.tree.reveal(X,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const F=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&F?this.widget?.showMessage({type:2,content:(0,C.localize)(5,null)}):this.widget?.clearMessage()}shouldAllowFocus(F){return!this.widget||!this.pattern||this._mode===ge.Filter||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!E.FuzzyScore.isDefault(F.filterData)}style(F){this.styles=F,this.widget?.style(F)}layout(F){this.width=F,this.widget?.layout(F)}dispose(){this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function he(se){let F=T.TreeMouseEventTarget.Unknown;return(0,v.hasParentWithClass)(se.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?F=T.TreeMouseEventTarget.Twistie:(0,v.hasParentWithClass)(se.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?F=T.TreeMouseEventTarget.Element:(0,v.hasParentWithClass)(se.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(F=T.TreeMouseEventTarget.Filter),{browserEvent:se.browserEvent,element:se.element?se.element.element:null,target:F}}function me(se){return{element:se.element?se.element.element:null,browserEvent:se.browserEvent,anchor:se.anchor}}function ye(se,F){F(se),se.children.forEach(K=>ye(K,F))}class J{constructor(F,K){this.getFirstViewElementWithTrait=F,this.identityProvider=K,this.nodes=[],this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event}get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}set(F,K){!K?.__forceEvent&&(0,r.equals)(this.nodes,F)||this._set(F,!1,K)}_set(F,K,X){if(this.nodes=[...F],this.elements=void 0,this._nodeSet=void 0,!K){const O=this;this._onDidChange.fire({get elements(){return O.get()},browserEvent:X})}}get(){return this.elements||(this.elements=this.nodes.map(F=>F.element)),[...this.elements]}getNodes(){return this.nodes}has(F){return this.nodeSet.has(F)}onDidModelSplice({insertedNodes:F,deletedNodes:K}){if(!this.identityProvider){const q=this.createNodeSet(),H=R=>q.delete(R);K.forEach(R=>ye(R,H)),this.set([...q.values()]);return}const X=new Set,O=q=>X.add(this.identityProvider.getId(q.element).toString());K.forEach(q=>ye(q,O));const d=new Map,L=q=>d.set(this.identityProvider.getId(q.element).toString(),q);F.forEach(q=>ye(q,L));const U=[];for(const q of this.nodes){const H=this.identityProvider.getId(q.element).toString();if(!X.has(H))U.push(q);else{const W=d.get(H);W&&U.push(W)}}if(this.nodes.length>0&&U.length===0){const q=this.getFirstViewElementWithTrait();q&&U.push(q)}this._set(U,!0)}createNodeSet(){const F=new Set;for(const K of this.nodes)F.add(K);return F}}class de extends p.MouseController{constructor(F,K){super(F);this.tree=K}onViewPointer(F){if((0,p.isButton)(F.browserEvent.target)||(0,p.isInputElement)(F.browserEvent.target)||(0,p.isMonacoEditor)(F.browserEvent.target))return;const K=F.element;if(!K)return super.onViewPointer(F);if(this.isSelectionRangeChangeEvent(F)||this.isSelectionSingleChangeEvent(F))return super.onViewPointer(F);const X=F.browserEvent.target,O=X.classList.contains("monaco-tl-twistie")||X.classList.contains("monaco-icon-label")&&X.classList.contains("folder-icon")&&F.browserEvent.offsetX<16;let d=!1;if(typeof this.tree.expandOnlyOnTwistieClick=="function"?d=this.tree.expandOnlyOnTwistieClick(K.element):d=!!this.tree.expandOnlyOnTwistieClick,d&&!O&&F.browserEvent.detail!==2)return super.onViewPointer(F);if(!this.tree.expandOnDoubleClick&&F.browserEvent.detail===2)return super.onViewPointer(F);if(K.collapsible){const L=this.tree.model,U=L.getNodeLocation(K),q=F.browserEvent.altKey;if(this.tree.setFocus([U]),L.setCollapsed(U,void 0,q),d&&O)return}super.onViewPointer(F)}onDoubleClick(F){F.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||super.onDoubleClick(F)}}class ne extends p.List{constructor(F,K,X,O,d,L,U,q){super(F,K,X,O,q);this.focusTrait=d,this.selectionTrait=L,this.anchorTrait=U}createMouseController(F){return new de(this,F.tree)}splice(F,K,X=[]){if(super.splice(F,K,X),X.length===0)return;const O=[],d=[];let L;X.forEach((U,q)=>{this.focusTrait.has(U)&&O.push(F+q),this.selectionTrait.has(U)&&d.push(F+q),this.anchorTrait.has(U)&&(L=F+q)}),O.length>0&&super.setFocus((0,r.distinct)([...super.getFocus(),...O])),d.length>0&&super.setSelection((0,r.distinct)([...super.getSelection(),...d])),typeof L=="number"&&super.setAnchor(L)}setFocus(F,K,X=!1){super.setFocus(F,K),X||this.focusTrait.set(F.map(O=>this.element(O)),K)}setSelection(F,K,X=!1){super.setSelection(F,K),X||this.selectionTrait.set(F.map(O=>this.element(O)),K)}setAnchor(F,K=!1){super.setAnchor(F),K||(typeof F=="undefined"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(F)]))}}class Q{constructor(F,K,X,O,d={}){this._user=F,this._options=d,this.eventBufferer=new _.EventBufferer,this.onDidChangeFindOpenState=_.Event.None,this.disposables=new u.DisposableStore,this._onWillRefilter=new _.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new _.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event;const L=new s(X),U=new _.Relay,q=new _.Relay,H=this.disposables.add(new S(q.event));this.renderers=O.map(V=>new $(V,()=>this.model,U.event,H,d));for(const V of this.renderers)this.disposables.add(V);let R;d.keyboardNavigationLabelProvider&&(R=new ie(this,d.keyboardNavigationLabelProvider,d.filter),d={...d,filter:R},this.disposables.add(R)),this.focus=new J(()=>this.view.getFocusedElements()[0],d.identityProvider),this.selection=new J(()=>this.view.getSelectedElements()[0],d.identityProvider),this.anchor=new J(()=>this.view.getAnchorElement(),d.identityProvider),this.view=new ne(F,K,L,this.renderers,this.focus,this.selection,this.anchor,{...l(()=>this.model,d),tree:this}),this.model=this.createModel(F,this.view,d),U.input=this.model.onDidChangeCollapseState;const W=_.Event.forEach(this.model.onDidSplice,V=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(V),this.selection.onDidModelSplice(V)})},this.disposables);if(W(()=>null,null,this.disposables),q.input=_.Event.chain(_.Event.any(W,this.focus.onDidChange,this.selection.onDidChange)).debounce(()=>null,0).map(()=>{const V=new Set;for(const I of this.focus.getNodes())V.add(I);for(const I of this.selection.getNodes())V.add(I);return[...V.values()]}).event,d.keyboardSupport!==!1){const V=_.Event.chain(this.view.onKeyDown).filter(I=>!(0,p.isInputElement)(I.target)).map(I=>new P.StandardKeyboardEvent(I));V.filter(I=>I.keyCode===15).on(this.onLeftArrow,this,this.disposables),V.filter(I=>I.keyCode===17).on(this.onRightArrow,this,this.disposables),V.filter(I=>I.keyCode===10).on(this.onSpace,this,this.disposables)}d.keyboardNavigationLabelProvider&&d.contextViewProvider?(this.findController=new ve(this,this.model,this.view,R,d.contextViewProvider),this.focusNavigationFilter=V=>this.findController.shouldAllowFocus(V),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode):this.onDidChangeFindMode=_.Event.None,this.styleElement=(0,v.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===g.Always)}get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return _.Event.map(this.view.onMouseClick,he)}get onMouseDblClick(){return _.Event.filter(_.Event.map(this.view.onMouseDblClick,he),F=>F.target!==T.TreeMouseEventTarget.Filter)}get onContextMenu(){return _.Event.map(this.view.onContextMenu,me)}get onTap(){return _.Event.map(this.view.onTap,he)}get onPointer(){return _.Event.map(this.view.onPointer,he)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return _.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??ge.Highlight}set findMode(F){this.findController&&(this.findController.mode=F)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:_.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick=="undefined"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick=="undefined"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}updateOptions(F={}){this._options={...this._options,...F};for(const K of this.renderers)K.updateOptions(F);this.view.updateOptions(this._options),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===g.Always)}get options(){return this._options}updateWidth(F){const K=this.model.getListIndex(F);K!==-1&&this.view.updateWidth(K)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.scrollTop}set scrollTop(F){this.view.scrollTop=F}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(F){this.view.scrollLeft=F}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){const F=this.view.firstVisibleIndex;return F<0||F>=this.view.length?void 0:this.view.element(F).element}get lastVisibleElement(){const F=this.view.lastVisibleIndex;return this.view.element(F).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(F){this.view.ariaLabel=F}domFocus(){this.view.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(F,K){this.view.layout(F,K),(0,D.isNumber)(K)&&this.findController?.layout(K)}style(F){const K=`.${this.view.domId}`,X=[];F.treeIndentGuidesStroke&&(X.push(`.monaco-list${K}:hover .monaco-tl-indent > .indent-guide, .monaco-list${K}.always .monaco-tl-indent > .indent-guide  { border-color: ${F.treeIndentGuidesStroke.transparent(.4)}; }`),X.push(`.monaco-list${K} .monaco-tl-indent > .indent-guide.active { border-color: ${F.treeIndentGuidesStroke}; }`)),this.styleElement.textContent=X.join(`
`),this.findController?.style(F),this.view.style(F)}getParentElement(F){const K=this.model.getParentNodeLocation(F);return this.model.getNode(K).element}getFirstElementChild(F){return this.model.getFirstElementChild(F)}getNode(F){return this.model.getNode(F)}collapse(F,K=!1){return this.model.setCollapsed(F,!0,K)}expand(F,K=!1){return this.model.setCollapsed(F,!1,K)}toggleCollapsed(F,K=!1){return this.model.setCollapsed(F,void 0,K)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(F){return this.model.isCollapsible(F)}setCollapsible(F,K){return this.model.setCollapsible(F,K)}isCollapsed(F){return this.model.isCollapsed(F)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(F){if(typeof F=="undefined")return this.view.setAnchor(void 0);const K=this.model.getNode(F);this.anchor.set([K]);const X=this.model.getListIndex(F);X>-1&&this.view.setAnchor(X,!0)}getAnchor(){return(0,r.firstOrDefault)(this.anchor.get(),void 0)}setSelection(F,K){const X=F.map(d=>this.model.getNode(d));this.selection.set(X,K);const O=F.map(d=>this.model.getListIndex(d)).filter(d=>d>-1);this.view.setSelection(O,K,!0)}getSelection(){return this.selection.get()}setFocus(F,K){const X=F.map(d=>this.model.getNode(d));this.focus.set(X,K);const O=F.map(d=>this.model.getListIndex(d)).filter(d=>d>-1);this.view.setFocus(O,K,!0)}focusNext(F=1,K=!1,X,O=this.focusNavigationFilter){this.view.focusNext(F,K,X,O)}focusPrevious(F=1,K=!1,X,O=this.focusNavigationFilter){this.view.focusPrevious(F,K,X,O)}focusNextPage(F,K=this.focusNavigationFilter){return this.view.focusNextPage(F,K)}focusPreviousPage(F,K=this.focusNavigationFilter){return this.view.focusPreviousPage(F,K)}focusLast(F,K=this.focusNavigationFilter){this.view.focusLast(F,K)}focusFirst(F,K=this.focusNavigationFilter){this.view.focusFirst(F,K)}getFocus(){return this.focus.get()}reveal(F,K){this.model.expandTo(F);const X=this.model.getListIndex(F);X!==-1&&this.view.reveal(X,K)}getRelativeTop(F){const K=this.model.getListIndex(F);return K===-1?null:this.view.getRelativeTop(K)}getViewState(F=this.options.identityProvider){if(!F)throw new T.TreeError(this._user,"Can't get tree view state without an identity provider");const K=L=>F.getId(L).toString(),X=n.empty(this.scrollTop);for(const L of this.getFocus())X.focus.add(K(L));for(const L of this.getSelection())X.selection.add(K(L));const O=this.model.getNode(),d=[O];for(;d.length>0;){const L=d.shift();L!==O&&L.collapsible&&(X.expanded[K(L.element)]=L.collapsed?0:1),d.push(...L.children)}return X}onLeftArrow(F){F.preventDefault(),F.stopPropagation();const K=this.view.getFocusedElements();if(K.length===0)return;const X=K[0],O=this.model.getNodeLocation(X);if(!this.model.setCollapsed(O,!0)){const L=this.model.getParentNodeLocation(O);if(!L)return;const U=this.model.getListIndex(L);this.view.reveal(U),this.view.setFocus([U])}}onRightArrow(F){F.preventDefault(),F.stopPropagation();const K=this.view.getFocusedElements();if(K.length===0)return;const X=K[0],O=this.model.getNodeLocation(X);if(!this.model.setCollapsed(O,!1)){if(!X.children.some(q=>q.visible))return;const[L]=this.view.getFocus(),U=L+1;this.view.reveal(U),this.view.setFocus([U])}}onSpace(F){F.preventDefault(),F.stopPropagation();const K=this.view.getFocusedElements();if(K.length===0)return;const X=K[0],O=this.model.getNodeLocation(X),d=F.browserEvent.altKey;this.model.setCollapsed(O,void 0,d)}navigate(F){return new re(this.view,this.model,F)}dispose(){(0,u.dispose)(this.disposables),this.view.dispose()}}t.AbstractTree=Q;class re{constructor(F,K,X){this.view=F,this.model=K,X?this.index=this.model.getListIndex(X):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(pe[128],be([1,0,127,117,23,26]),function(Z,t,v,i,P,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class y extends v.AbstractTree{constructor(p,f,b,T,a,r={}){super(p,f,b,T,r);this.user=p,this.dataSource=a,this.nodesByIdentity=new Map,this.identityProvider=r.identityProvider}getInput(){return this.input}setInput(p,f){if(f&&!this.identityProvider)throw new P.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=p,!p){this.nodesByIdentity.clear(),this.model.setChildren(null,M.Iterable.empty());return}if(!f){this._refresh(p);return}const b=[],T=[],a=e=>{const c=this.identityProvider.getId(e).toString();return!f.expanded[c]},r=e=>{const c=this.identityProvider.getId(e.element).toString();f.focus.has(c)&&b.push(e.element),f.selection.has(c)&&T.push(e.element)};this._refresh(p,a,r),this.setFocus(b),this.setSelection(T),f&&typeof f.scrollTop=="number"&&(this.scrollTop=f.scrollTop)}updateChildren(p=this.input){if(typeof this.input=="undefined")throw new P.TreeError(this.user,"Tree input not set");let f;this.identityProvider&&(f=b=>{const T=this.identityProvider.getId(b).toString(),a=this.nodesByIdentity.get(T);if(!!a)return a.collapsed}),this._refresh(p,f)}resort(p=this.input,f=!0){this.model.resort(p===this.input?null:p,f)}refresh(p){if(p===void 0){this.view.rerender();return}this.model.rerender(p)}_refresh(p,f,b){let T;if(this.identityProvider){const a=new Set,r=b;b=e=>{const c=this.identityProvider.getId(e.element).toString();a.add(c),this.nodesByIdentity.set(c,e),r?.(e)},T=e=>{const c=this.identityProvider.getId(e.element).toString();a.has(c)||this.nodesByIdentity.delete(c)}}this.model.setChildren(p===this.input?null:p,this.iterate(p,f).elements,{onDidCreateNode:b,onDidDeleteNode:T})}iterate(p,f){const b=[...this.dataSource.getChildren(p)];return{elements:M.Iterable.map(b,a=>{const{elements:r,size:e}=this.iterate(a,f),c=this.dataSource.hasChildren?this.dataSource.hasChildren(a):void 0,m=e===0?void 0:f&&f(a);return{element:a,children:r,collapsible:c,collapsed:m}}),size:b.length}}createModel(p,f,b){return new i.ObjectTreeModel(p,f,b)}}t.DataTree=y}),define(pe[38],be([1,0,14,8,31,28,25,13,3,2,49,10,6]),function(Z,t,v,i,P,M,y,w,p,f,b,T,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var r;(function(ne){ne[ne.Promise=100]="Promise",ne[ne.PromiseCancel=101]="PromiseCancel",ne[ne.EventListen=102]="EventListen",ne[ne.EventDispose=103]="EventDispose"})(r=t.RequestType||(t.RequestType={}));function e(ne){switch(ne){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(ne){ne[ne.Initialize=200]="Initialize",ne[ne.PromiseSuccess=201]="PromiseSuccess",ne[ne.PromiseError=202]="PromiseError",ne[ne.PromiseErrorObj=203]="PromiseErrorObj",ne[ne.EventFire=204]="EventFire"})(c=t.ResponseType||(t.ResponseType={}));function m(ne){switch(ne){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var _;(function(ne){ne[ne.Uninitialized=0]="Uninitialized",ne[ne.Idle=1]="Idle"})(_||(_={}));class E{constructor(Q){this.buffer=Q,this.pos=0}read(Q){const re=this.buffer.slice(this.pos,this.pos+Q);return this.pos+=re.byteLength,re}}class u{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(Q){this.buffers.push(Q)}}var h;(function(ne){ne[ne.Undefined=0]="Undefined",ne[ne.String=1]="String",ne[ne.Buffer=2]="Buffer",ne[ne.VSBuffer=3]="VSBuffer",ne[ne.Array=4]="Array",ne[ne.Object=5]="Object"})(h||(h={}));function D(ne){const Q=P.VSBuffer.alloc(4);return Q.writeUInt32BE(ne,0),Q}function C(ne){return ne.read(4).readUInt32BE(0)}function N(ne){const Q=P.VSBuffer.alloc(1);return Q.writeUInt8(ne,0),Q}const A={Undefined:N(h.Undefined),String:N(h.String),Buffer:N(h.Buffer),VSBuffer:N(h.VSBuffer),Array:N(h.Array),Object:N(h.Object)},o=typeof Buffer!="undefined";function l(ne,Q){if(typeof Q=="undefined")ne.write(A.Undefined);else if(typeof Q=="string"){const re=P.VSBuffer.fromString(Q);ne.write(A.String),ne.write(D(re.byteLength)),ne.write(re)}else if(o&&Buffer.isBuffer(Q)){const re=P.VSBuffer.wrap(Q);ne.write(A.Buffer),ne.write(D(re.byteLength)),ne.write(re)}else if(Q instanceof P.VSBuffer)ne.write(A.VSBuffer),ne.write(D(Q.byteLength)),ne.write(Q);else if(Array.isArray(Q)){ne.write(A.Array),ne.write(D(Q.length));for(const re of Q)l(ne,re)}else{const re=P.VSBuffer.fromString(JSON.stringify(Q));ne.write(A.Object),ne.write(D(re.byteLength)),ne.write(re)}}function s(ne){switch(ne.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return ne.read(C(ne)).toString();case h.Buffer:return ne.read(C(ne)).buffer;case h.VSBuffer:return ne.read(C(ne));case h.Array:{const re=C(ne),se=[];for(let F=0;F<re;F++)se.push(s(ne));return se}case h.Object:return JSON.parse(ne.read(C(ne)).toString())}}class n{constructor(Q,re,se=null,F=1e3){this.protocol=Q,this.ctx=re,this.logger=se,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(Q,re){this.channels.set(Q,re),setTimeout(()=>this.flushPendingRequests(Q),0)}sendResponse(Q){switch(Q.type){case 200:{const re=this.send([Q.type]);this.logger?.logOutgoing(re,0,1,m(Q.type));return}case 201:case 202:case 204:case 203:{const re=this.send([Q.type,Q.id],Q.data);this.logger?.logOutgoing(re,Q.id,1,m(Q.type),Q.data);return}}}send(Q,re=void 0){const se=new u;return l(se,Q),l(se,re),this.sendBuffer(se.buffer)}sendBuffer(Q){try{return this.protocol.send(Q),Q.byteLength}catch{return 0}}onRawMessage(Q){const re=new E(Q),se=s(re),F=s(re),K=se[0];switch(K){case 100:return this.logger?.logIncoming(Q.byteLength,se[1],1,`${e(K)}: ${se[2]}.${se[3]}`,F),this.onPromise({type:K,id:se[1],channelName:se[2],name:se[3],arg:F});case 102:return this.logger?.logIncoming(Q.byteLength,se[1],1,`${e(K)}: ${se[2]}.${se[3]}`,F),this.onEventListen({type:K,id:se[1],channelName:se[2],name:se[3],arg:F});case 101:return this.logger?.logIncoming(Q.byteLength,se[1],1,`${e(K)}`),this.disposeActiveRequest({type:K,id:se[1]});case 103:return this.logger?.logIncoming(Q.byteLength,se[1],1,`${e(K)}`),this.disposeActiveRequest({type:K,id:se[1]})}}onPromise(Q){const re=this.channels.get(Q.channelName);if(!re){this.collectPendingRequest(Q);return}const se=new M.CancellationTokenSource;let F;try{F=re.call(this.ctx,Q.name,Q.arg,se.token)}catch(O){F=Promise.reject(O)}const K=Q.id;F.then(O=>{this.sendResponse({id:K,data:O,type:201}),this.activeRequests.delete(Q.id)},O=>{O instanceof Error?this.sendResponse({id:K,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.sendResponse({id:K,data:O,type:203}),this.activeRequests.delete(Q.id)});const X=(0,f.toDisposable)(()=>se.cancel());this.activeRequests.set(Q.id,X)}onEventListen(Q){const re=this.channels.get(Q.channelName);if(!re){this.collectPendingRequest(Q);return}const se=Q.id,K=re.listen(this.ctx,Q.name,Q.arg)(X=>this.sendResponse({id:se,data:X,type:204}));this.activeRequests.set(Q.id,K)}disposeActiveRequest(Q){const re=this.activeRequests.get(Q.id);re&&(re.dispose(),this.activeRequests.delete(Q.id))}collectPendingRequest(Q){let re=this.pendingRequests.get(Q.channelName);re||(re=[],this.pendingRequests.set(Q.channelName,re));const se=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.sendResponse({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);re.push({request:Q,timeoutTimer:se})}flushPendingRequests(Q){const re=this.pendingRequests.get(Q);if(re){for(const se of re)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.onPromise(se.request);break;case 102:this.onEventListen(se.request);break}this.pendingRequests.delete(Q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=n;var g;(function(ne){ne[ne.LocalSide=0]="LocalSide",ne[ne.OtherSide=1]="OtherSide"})(g=t.RequestInitiator||(t.RequestInitiator={}));class S{constructor(Q,re=null){this.protocol=Q,this.isDisposed=!1,this.state=_.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(se=>this.onBuffer(se)),this.logger=re}getChannel(Q){const re=this;return{call(se,F,K){return re.isDisposed?Promise.reject(w.canceled()):re.requestPromise(Q,se,F,K)},listen(se,F){return re.isDisposed?p.Event.None:re.requestEvent(Q,se,F)}}}requestPromise(Q,re,se,F=M.CancellationToken.None){const K=this.lastRequestId++,O={id:K,type:100,channelName:Q,name:re,arg:se};if(F.isCancellationRequested)return Promise.reject(w.canceled());let d;return new Promise((U,q)=>{if(F.isCancellationRequested)return q(w.canceled());const H=()=>{const I=z=>{switch(z.type){case 201:this.handlers.delete(K),U(z.data);break;case 202:{this.handlers.delete(K);const k=new Error(z.data.message);k.stack=z.data.stack,k.name=z.data.name,q(k);break}case 203:this.handlers.delete(K),q(z.data);break}};this.handlers.set(K,I),this.sendRequest(O)};let R=null;this.state===_.Idle?H():(R=(0,i.createCancelablePromise)(I=>this.whenInitialized()),R.then(()=>{R=null,H()}));const W=()=>{R?(R.cancel(),R=null):this.sendRequest({id:K,type:101}),q(w.canceled())},V=F.onCancellationRequested(W);d=(0,f.combinedDisposable)((0,f.toDisposable)(W),V),this.activeRequests.add(d)}).finally(()=>{this.activeRequests.delete(d)})}requestEvent(Q,re,se){const F=this.lastRequestId++,X={id:F,type:102,channelName:Q,name:re,arg:se};let O=null;const d=new p.Emitter({onFirstListenerAdd:()=>{O=(0,i.createCancelablePromise)(U=>this.whenInitialized()),O.then(()=>{O=null,this.activeRequests.add(d),this.sendRequest(X)})},onLastListenerRemove:()=>{O?(O.cancel(),O=null):(this.activeRequests.delete(d),this.sendRequest({id:F,type:103}))}}),L=U=>d.fire(U.data);return this.handlers.set(F,L),d.event}sendRequest(Q){switch(Q.type){case 100:case 102:{const re=this.send([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.logger?.logOutgoing(re,Q.id,0,`${e(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const re=this.send([Q.type,Q.id]);this.logger?.logOutgoing(re,Q.id,0,e(Q.type));return}}}send(Q,re=void 0){const se=new u;return l(se,Q),l(se,re),this.sendBuffer(se.buffer)}sendBuffer(Q){try{return this.protocol.send(Q),Q.byteLength}catch{return 0}}onBuffer(Q){const re=new E(Q),se=s(re),F=s(re),K=se[0];switch(K){case 200:return this.logger?.logIncoming(Q.byteLength,0,0,m(K)),this.onResponse({type:se[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(Q.byteLength,se[1],0,m(K),F),this.onResponse({type:se[0],id:se[1],data:F})}}onResponse(Q){if(Q.type===200){this.state=_.Idle,this._onDidInitialize.fire();return}this.handlers.get(Q.id)?.(Q)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===_.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ke([y.memoize],S.prototype,"onDidInitializePromise",null),t.ChannelClient=S;class ${constructor(Q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,Q(({protocol:re,onDidClientDisconnect:se})=>{p.Event.once(re.onMessage)(K=>{const X=new E(K),O=s(X),d=new n(re,O),L=new S(re);this.channels.forEach((q,H)=>d.registerChannel(H,q));const U={channelServer:d,channelClient:L,ctx:O};this._connections.add(U),this._onDidAddConnection.fire(U),se(()=>{d.dispose(),L.dispose(),this._connections.delete(U),this._onDidRemoveConnection.fire(U)})})})}get connections(){const Q=[];return this._connections.forEach(re=>Q.push(re)),Q}getChannel(Q,re){const se=this;return{call(F,K,X){let O;if((0,a.isFunction)(re)){const L=(0,v.getRandomElement)(se.connections.filter(re));O=L?Promise.resolve(L):p.Event.toPromise(p.Event.filter(se.onDidAddConnection,re))}else O=re.routeCall(se,F,K);const d=O.then(L=>L.channelClient.getChannel(Q));return te(d).call(F,K,X)},listen(F,K){if((0,a.isFunction)(re))return se.getMulticastEvent(Q,re,F,K);const X=re.routeEvent(se,F,K).then(O=>O.channelClient.getChannel(Q));return te(X).listen(F,K)}}}getMulticastEvent(Q,re,se,F){const K=this;let X=new f.DisposableStore;const O=new p.Emitter({onFirstListenerAdd:()=>{X=new f.DisposableStore;const d=new p.EventMultiplexer,L=new Map,U=H=>{const W=H.channelClient.getChannel(Q).listen(se,F),V=d.add(W);L.set(H,V)},q=H=>{const R=L.get(H);!R||(R.dispose(),L.delete(H))};K.connections.filter(re).forEach(U),p.Event.filter(K.onDidAddConnection,re)(U,void 0,X),K.onDidRemoveConnection(q,void 0,X),d.event(O.fire,O,X),X.add(d)},onLastListenerRemove:()=>{X.dispose()}});return O.event}registerChannel(Q,re){this.channels.set(Q,re),this._connections.forEach(se=>{se.channelServer.registerChannel(Q,re)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=$;class ie{constructor(Q,re,se=null){const F=new u;l(F,re),Q.send(F.buffer),this.channelClient=new S(Q,se),this.channelServer=new n(Q,re,se)}getChannel(Q){return this.channelClient.getChannel(Q)}registerChannel(Q,re){this.channelServer.registerChannel(Q,re)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=ie;function te(ne){return{call(Q,re,se){return ne.then(F=>F.call(Q,re,se))},listen(Q,re){const se=new p.Relay;return ne.then(F=>se.input=F.listen(Q,re)),se.event}}}t.getDelayedChannel=te;function ge(ne){let Q=!1;return{call(re,se,F){return Q?ne.call(re,se,F):(0,i.timeout)(0).then(()=>Q=!0).then(()=>ne.call(re,se,F))},listen(re,se){if(Q)return ne.listen(re,se);const F=new p.Relay;return(0,i.timeout)(0).then(()=>Q=!0).then(()=>F.input=ne.listen(re,se)),F.event}}}t.getNextTickChannel=ge;class ae{constructor(Q){this.fn=Q}routeCall(Q){return this.route(Q)}routeEvent(Q){return this.route(Q)}async route(Q){for(const re of Q.connections)if(await Promise.resolve(this.fn(re.ctx)))return Promise.resolve(re);return await p.Event.toPromise(Q.onDidAddConnection),await this.route(Q)}}t.StaticRouter=ae;var ve;(function(ne){function Q(K,X){const O=K,d=X&&X.disableMarshalling,L=new Map;for(const U in O)se(U)&&L.set(U,p.Event.buffer(O[U],!0));return new class{listen(U,q,H){const R=L.get(q);if(R)return R;if(F(q)){const W=O[q];if(typeof W=="function")return W.call(O,H)}throw new Error(`Event not found: ${q}`)}call(U,q,H){const R=O[q];if(typeof R=="function"){if(!d&&Array.isArray(H))for(let W=0;W<H.length;W++)H[W]=(0,b.revive)(H[W]);return R.apply(O,H)}throw new Error(`Method not found: ${q}`)}}}ne.fromService=Q;function re(K,X){const O=X&&X.disableMarshalling;return new Proxy({},{get(d,L){if(typeof L=="string")return X?.properties?.has(L)?X.properties.get(L):F(L)?function(U){return K.listen(L,U)}:se(L)?K.listen(L):async function(...U){let q;X&&!(0,a.isUndefinedOrNull)(X.context)?q=[X.context,...U]:q=U;const H=await K.call(L,q);return O?H:(0,b.revive)(H)};throw new Error(`Property not found: ${String(L)}`)}})}ne.toService=re;function se(K){return K[0]==="o"&&K[1]==="n"&&T.isUpperAsciiLetter(K.charCodeAt(2))}function F(K){return/^onDynamic/.test(K)&&T.isUpperAsciiLetter(K.charCodeAt(9))}})(ve=t.ProxyChannel||(t.ProxyChannel={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function me(ne){if(Array.isArray(ne))return ne;if(ne&&typeof ne=="object"&&typeof ne.toString=="function"){const Q=ne.toString();if(Q!=="[object Object]")return Q}return ne}function ye(ne){return Array.isArray(ne)?ne.map(me):me(ne)}function J(ne,Q,re,se,F,K,X){X=ye(X);const O=he[F],d=O[se%O.length];let L=[`%c[${ne}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(re).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(K)?(L=L.concat(X),L.push(")")):L.push(X),console.log.apply(console,L)}t.logWithColors=J;class de{constructor(Q,re){this._outgoingPrefix=Q,this._incomingPrefix=re,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(Q,re,se,F,K){this._totalOutgoing+=Q,J(this._outgoingPrefix,this._totalOutgoing,Q,re,se,F,K)}logIncoming(Q,re,se,F,K){this._totalIncoming+=Q,J(this._incomingPrefix,this._totalIncoming,Q,re,se,F,K)}}t.IPCLogger=de}),define(pe[29],be([1,0,5]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=v.globals.vscode.ipcRenderer,t.ipcMessagePort=v.globals.vscode.ipcMessagePort,t.webFrame=v.globals.vscode.webFrame,t.process=v.globals.vscode.process,t.context=v.globals.vscode.context}),define(pe[129],be([1,0,80,29]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let P=0;function M(w,p,f){const b=[],T=P++,a=`vscode:onContextMenu${T}`,r=(e,c,m)=>{b[c].click?.(m)};i.ipcRenderer.once(a,r),i.ipcRenderer.once(v.CONTEXT_MENU_CLOSE_CHANNEL,(e,c)=>{c===T&&(i.ipcRenderer.removeListener(a,r),f?.())}),i.ipcRenderer.send(v.CONTEXT_MENU_CHANNEL,T,w.map(e=>y(e,b)),a,p)}t.popup=M;function y(w,p){const f={id:p.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return p.push(w),Array.isArray(w.submenu)&&(f.submenu=w.submenu.map(b=>y(b,p))),f}}),define(pe[130],be([1,0,31,3,38,81,29]),function(Z,t,v,i,P,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class w extends P.IPCClient{constructor(f){const b=w.createProtocol();super(b,f);this.protocol=b}static createProtocol(){const f=i.Event.fromNodeEventEmitter(y.ipcRenderer,"vscode:message",(b,T)=>v.VSBuffer.wrap(T));return y.ipcRenderer.send("vscode:hello"),new M.Protocol(y.ipcRenderer,f)}dispose(){this.protocol.disconnect()}}t.Client=w}),define(pe[131],be([12,9]),function(Z,t){return Z.create("vs/platform/files/common/files",t)}),define(pe[132],be([12,9]),function(Z,t){return Z.create("vs/platform/theme/common/iconRegistry",t)}),define(pe[63],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class v{constructor(P,M=[],y=!1){this.ctor=P,this.staticArguments=M,this.supportsDelayedInstantiation=y}}t.SyncDescriptor=v}),define(pe[133],be([1,0,63]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const i=[];function P(y,w,p){w instanceof v.SyncDescriptor||(w=new v.SyncDescriptor(w,[],p)),i.push([y,w])}t.registerSingleton=P;function M(){return i}t.getSingletonServiceDescriptors=M}),define(pe[30],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var v;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function w(p){return p[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=w})(v=t._util||(t._util={})),t.IInstantiationService=P("instantiationService");function i(y,w,p){w[v.DI_TARGET]===w?w[v.DI_DEPENDENCIES].push({id:y,index:p}):(w[v.DI_DEPENDENCIES]=[{id:y,index:p}],w[v.DI_TARGET]=w)}function P(y){if(v.serviceIds.has(y))return v.serviceIds.get(y);const w=function(p,f,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(w,p,b)};return w.toString=()=>y,v.serviceIds.set(y,w),w}t.createDecorator=P;function M(y){return y}t.refineServiceDecorator=M}),define(pe[134],be([1,0,30]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,v.createDecorator)(t.ID);function i(M){return!!M.hostName&&!!M.errorMessage}t.isRemoteDiagnosticError=i;class P{async getPerformanceInfo(y,w){return{}}async getSystemInfo(y,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(y,w){return""}async getWorkspaceFileExtensions(y){return{extensions:[]}}async reportWorkspaceStats(y){}}t.NullDiagnosticsService=P}),define(pe[135],be([1,0,48,21,10,6,16,131,30]),function(Z,t,v,i,P,M,y,w,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPlatformLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,p.createDecorator)("fileService");function f(J){return J.create===!0}t.isFileOpenForWriteOptions=f;var b;(function(J){J[J.Unknown=0]="Unknown",J[J.File=1]="File",J[J.Directory=2]="Directory",J[J.SymbolicLink=64]="SymbolicLink"})(b=t.FileType||(t.FileType={}));var T;(function(J){J[J.Readonly=1]="Readonly"})(T=t.FilePermission||(t.FilePermission={}));var a;(function(J){J[J.FileReadWrite=2]="FileReadWrite",J[J.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",J[J.FileReadStream=16]="FileReadStream",J[J.FileFolderCopy=8]="FileFolderCopy",J[J.PathCaseSensitive=1024]="PathCaseSensitive",J[J.Readonly=2048]="Readonly",J[J.Trash=4096]="Trash",J[J.FileWriteUnlock=8192]="FileWriteUnlock",J[J.FileAtomicRead=16384]="FileAtomicRead",J[J.FileClone=32768]="FileClone"})(a=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function r(J){return!!(J.capabilities&2)}t.hasReadWriteCapability=r;function e(J){return!!(J.capabilities&8)}t.hasFileFolderCopyCapability=e;function c(J){return!!(J.capabilities&32768)}t.hasFileCloneCapability=c;function m(J){return!!(J.capabilities&4)}t.hasOpenReadWriteCloseCapability=m;function _(J){return!!(J.capabilities&16)}t.hasFileReadStreamCapability=_;function E(J){return r(J)?!!(J.capabilities&16384):!1}t.hasFileAtomicReadCapability=E;var u;(function(J){J.FileExists="EntryExists",J.FileNotFound="EntryNotFound",J.FileNotADirectory="EntryNotADirectory",J.FileIsADirectory="EntryIsADirectory",J.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",J.FileTooLarge="EntryTooLarge",J.FileWriteLocked="EntryWriteLocked",J.NoPermissions="NoPermissions",J.Unavailable="Unavailable",J.Unknown="Unknown"})(u=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class h extends Error{constructor(de,ne){super(de);this.code=ne}}t.FileSystemProviderError=h;function D(J,de){const ne=new h(J.toString(),de);return N(ne,de),ne}t.createFileSystemProviderError=D;function C(J){return J||D((0,w.localize)(0,null),u.Unknown)}t.ensureFileSystemProviderError=C;function N(J,de){return J.name=de?`${de} (FileSystemError)`:"FileSystemError",J}t.markAsFileSystemProviderError=N;function A(J){if(!J)return u.Unknown;if(J instanceof h)return J.code;const de=/^(.+) \(FileSystemError\)$/.exec(J.name);if(!de)return u.Unknown;switch(de[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}t.toFileSystemProviderErrorCode=A;function o(J){if(J instanceof $)return J.fileOperationResult;switch(A(J)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=o;var l;(function(J){J[J.CREATE=0]="CREATE",J[J.DELETE=1]="DELETE",J[J.MOVE=2]="MOVE",J[J.COPY=3]="COPY",J[J.WRITE=4]="WRITE"})(l=t.FileOperation||(t.FileOperation={}));class s{constructor(de,ne,Q){this.resource=de,this.operation=ne,this.target=Q}isOperation(de){return this.operation===de}}t.FileOperationEvent=s;var n;(function(J){J[J.UPDATED=0]="UPDATED",J[J.ADDED=1]="ADDED",J[J.DELETED=2]="DELETED"})(n=t.FileChangeType||(t.FileChangeType={}));class g{constructor(de,ne){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=de;const Q=new Map;for(const re of de){const se=Q.get(re.type);switch(se?se.push([re.resource,re]):Q.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,se]of Q)switch(re){case 1:this.added=v.TernarySearchTree.forUris(()=>ne),this.added.fill(se);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>ne),this.updated.fill(se);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>ne),this.deleted.fill(se);break}}contains(de,...ne){return this.doContains(de,{includeChildren:!1},...ne)}affects(de,...ne){return this.doContains(de,{includeChildren:!0},...ne)}doContains(de,ne,...Q){if(!de)return!1;const re=Q.length>0;return!!((!re||Q.includes(1))&&(this.added?.get(de)||ne.includeChildren&&this.added?.findSuperstr(de))||(!re||Q.includes(0))&&(this.updated?.get(de)||ne.includeChildren&&this.updated?.findSuperstr(de))||(!re||Q.includes(2))&&(this.deleted?.findSubstr(de)||ne.includeChildren&&this.deleted?.findSuperstr(de)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}t.FileChangesEvent=g;function S(J,de,ne){return!J||!de||J===de||de.length>J.length?!1:(de.charAt(de.length-1)!==i.sep&&(de+=i.sep),ne?(0,P.startsWithIgnoreCase)(J,de):J.indexOf(de)===0)}t.isParent=S;class $ extends Error{constructor(de,ne,Q){super(de);this.fileOperationResult=ne,this.options=Q}}t.FileOperationError=$;class ie extends ${constructor(de,ne,Q){super(de,2,Q);this.stat=ne}}t.NotModifiedSinceFileOperationError=ie;var te;(function(J){J[J.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",J[J.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",J[J.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",J[J.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",J[J.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",J[J.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",J[J.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",J[J.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",J[J.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",J[J.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",J[J.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",J[J.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(te=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var ge;(function(J){J[J.FILE=0]="FILE",J[J.FOLDER=1]="FOLDER",J[J.ROOT_FOLDER=2]="ROOT_FOLDER"})(ge=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function ae(J){if(!(typeof J.size!="number"||typeof J.mtime!="number"))return J.mtime.toString(29)+J.size.toString(31)}t.etag=ae;async function ve(J,de){if(!de.hasProvider(y.URI.from({scheme:J.scheme})))return new Promise(ne=>{const Q=de.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===J.scheme&&re.added&&(Q.dispose(),ne())})})}t.whenProviderRegistered=ve,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class he{static formatSize(de){return(0,M.isNumber)(de)||(de=0),de<he.KB?(0,w.localize)(1,null,de.toFixed(0)):de<he.MB?(0,w.localize)(2,null,(de/he.KB).toFixed(2)):de<he.GB?(0,w.localize)(3,null,(de/he.MB).toFixed(2)):de<he.TB?(0,w.localize)(4,null,(de/he.GB).toFixed(2)):(0,w.localize)(5,null,(de/he.TB).toFixed(2))}}t.ByteSize=he,he.KB=1024,he.MB=he.KB*he.KB,he.GB=he.MB*he.KB,he.TB=he.GB*he.KB;var me;(function(J){J[J.IA32=0]="IA32",J[J.OTHER=1]="OTHER"})(me=t.Arch||(t.Arch={}));function ye(J){return{maxFileSize:J===0?300*he.MB:16*he.GB,maxHeapSize:J===0?700*he.MB:2*700*he.MB}}t.getPlatformLimits=ye}),define(pe[136],be([1,0,2,130]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class P extends v.Disposable{constructor(y){super();this.mainProcessConnection=this._register(new i.Client(`window:${y}`))}getChannel(y){return this.mainProcessConnection.getChannel(y)}registerChannel(y,w){this.mainProcessConnection.registerChannel(y,w)}}t.ElectronIPCMainProcessService=P});var Ft=this&&this.__param||function(Z,t){return function(v,i){t(v,i,Z)}};define(pe[137],be([1,0,38,63,133,30]),function(Z,t,v,i,P,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class y{constructor(r,e,c){const m=c.getChannel(r);return w(e)?new e.channelClientCtor(m):v.ProxyChannel.toService(m,e?.proxyOptions)}}function w(a){return!!a?.channelClientCtor}t.IMainProcessService=(0,M.createDecorator)("mainProcessService");let p=class extends y{constructor(r,e,c){super(r,e,c)}};p=Ke([Ft(2,t.IMainProcessService)],p);function f(a,r,e){(0,P.registerSingleton)(a,new i.SyncDescriptor(p,[r,e],e?.supportsDelayedInstantiation))}t.registerMainProcessRemoteService=f,t.ISharedProcessService=(0,M.createDecorator)("sharedProcessService");let b=class extends y{constructor(r,e,c){super(r,e,c)}};b=Ke([Ft(2,t.ISharedProcessService)],b);function T(a,r,e){(0,P.registerSingleton)(a,new i.SyncDescriptor(b,[r,e],e?.supportsDelayedInstantiation))}t.registerSharedProcessRemoteService=T}),define(pe[138],be([1,0,38,137]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let P=class{constructor(y,w){return this.windowId=y,v.ProxyChannel.toService(w.getChannel("nativeHost"),{context:y,properties:(()=>{const p=new Map;return p.set("windowId",y),p})()})}};P=Ke([Ft(1,i.IMainProcessService)],P),t.NativeHostService=P}),define(pe[39],be([1,0,68,6]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class P{constructor(){this.data=new Map}add(y,w){v.ok(i.isString(y)),v.ok(i.isObject(w)),v.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,w)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}t.Registry=new P}),define(pe[139],be([1,0,3,39]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function P(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class M{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,f){this.schemasById[P(p)]=f,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new M;i.Registry.add(t.Extensions.JSONContribution,y)}),define(pe[140],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isDark=t.isHighContrast=t.ColorScheme=void 0;var v;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(v=t.ColorScheme||(t.ColorScheme={}));function i(M){return M===v.HIGH_CONTRAST_DARK||M===v.HIGH_CONTRAST_LIGHT}t.isHighContrast=i;function P(M){return M===v.DARK||M===v.HIGH_CONTRAST_DARK}t.isDark=P}),define(pe[64],be([1,0,11,3,2,30,39,140]),function(Z,t,v,i,P,M,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=(0,M.createDecorator)("themeService");var p;(function(m){function _(E){return E&&typeof E=="object"&&typeof E.id=="string"}m.isThemeColor=_})(p=t.ThemeColor||(t.ThemeColor={}));function f(m){return{id:m}}t.themeColorFromId=f;var b;(function(m){function _(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color=="undefined"||p.isThemeColor(o.color))}m.isThemeIcon=_;const E=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function u(o){const l=E.exec(o);if(!l)return;const[,s]=l;return{id:s}}m.fromString=u;function h(o){return{id:o}}m.fromId=h;function D(o,l){let s=o.id;const n=s.lastIndexOf("~");return n!==-1&&(s=s.substring(0,n)),l&&(s=`${s}~${l}`),{id:s}}m.modify=D;function C(o){const l=o.id.lastIndexOf("~");if(l!==-1)return o.id.substring(l+1)}m.getModifier=C;function N(o,l){return o.id===l.id&&o.color?.id===l.color?.id}m.isEqual=N;function A(o,l){return{id:o.id,color:l?f(l):void 0}}m.asThemeIcon=A,m.asClassNameArray=v.CSSIcon.asClassNameArray,m.asClassName=v.CSSIcon.asClassName,m.asCSSSelector=v.CSSIcon.asCSSSelector})(b=t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=v.Codicon.file,t.FolderThemeIcon=v.Codicon.folder;function T(m){switch(m){case w.ColorScheme.DARK:return"vs-dark";case w.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case w.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}t.getThemeTypeSelector=T,t.Extensions={ThemingContribution:"base.contributions.theming"};class a{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(_){return this.themingParticipants.push(_),this.onThemingParticipantAddedEmitter.fire(_),(0,P.toDisposable)(()=>{const E=this.themingParticipants.indexOf(_);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const r=new a;y.Registry.add(t.Extensions.ThemingContribution,r);function e(m){return r.onColorThemeChange(m)}t.registerThemingParticipant=e;class c extends P.Disposable{constructor(_){super();this.themeService=_,this.theme=_.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(_){this.theme=_,this.updateStyles()}updateStyles(){}getColor(_,E){let u=this.theme.getColor(_);return u&&E&&(u=E(u,this.theme)),u?u.toString():null}}t.Themable=c}),define(pe[141],be([1,0,8,11,3,6,16,132,139,39,64]),function(Z,t,v,i,P,M,y,w,p,f,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var T;(function(h){function D(C,N){let A=C.defaults;for(;b.ThemeIcon.isThemeIcon(A);){const o=e.getIcon(A.id);if(!o)return;A=o.defaults}return A}h.getDefinition=D})(T=t.IconContribution||(t.IconContribution={}));var a;(function(h){function D(N){return{weight:N.weight,style:N.style,src:N.src.map(A=>({format:A.format,location:A.location.toString()}))}}h.toJSONObject=D;function C(N){const A=o=>(0,M.isString)(o)?o:void 0;if(N&&Array.isArray(N.src)&&N.src.every(o=>(0,M.isString)(o.format)&&(0,M.isString)(o.location)))return{weight:A(N.weight),style:A(N.style),src:N.src.map(o=>({format:o.format,location:y.URI.parse(o.location)}))}}h.fromJSONObject=C})(a=t.IconFontDefinition||(t.IconFontDefinition={}));class r{constructor(){this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${i.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(D,C,N,A){const o=this.iconsById[D];if(o){if(N&&!o.description){o.description=N,this.iconSchema.properties[D].markdownDescription=`${N} $(${D})`;const n=this.iconReferenceSchema.enum.indexOf(D);n!==-1&&(this.iconReferenceSchema.enumDescriptions[n]=N),this._onDidChange.fire()}return o}const l={id:D,description:N,defaults:C,deprecationMessage:A};this.iconsById[D]=l;const s={$ref:"#/definitions/icons"};return A&&(s.deprecationMessage=A),N&&(s.markdownDescription=`${N}: $(${D})`),this.iconSchema.properties[D]=s,this.iconReferenceSchema.enum.push(D),this.iconReferenceSchema.enumDescriptions.push(N||""),this._onDidChange.fire(),{id:D}}deregisterIcon(D){delete this.iconsById[D],delete this.iconSchema.properties[D];const C=this.iconReferenceSchema.enum.indexOf(D);C!==-1&&(this.iconReferenceSchema.enum.splice(C,1),this.iconReferenceSchema.enumDescriptions.splice(C,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(D=>this.iconsById[D])}getIcon(D){return this.iconsById[D]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(D,C){const N=this.iconFontsById[D];return N||(this.iconFontsById[D]=C,this._onDidChange.fire(),C)}deregisterIconFont(D){delete this.iconFontsById[D]}getIconFont(D){return this.iconFontsById[D]}toString(){const D=(o,l)=>o.id.localeCompare(l.id),C=o=>{for(;b.ThemeIcon.isThemeIcon(o.defaults);)o=this.iconsById[o.defaults.id];return`codicon codicon-${o?o.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const A=Object.keys(this.iconsById).map(o=>this.iconsById[o]);for(const o of A.filter(l=>!!l.description).sort(D))N.push(`|<i class="${C(o)}"></i>|${o.id}|${b.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const o of A.filter(l=>!b.ThemeIcon.isThemeIcon(l.defaults)).sort(D))N.push(`|<i class="${C(o)}"></i>|${o.id}|`);return N.join(`
`)}}const e=new r;f.Registry.add(t.Extensions.IconContribution,e);function c(h,D,C,N){return e.registerIcon(h,D,C,N)}t.registerIcon=c;function m(){return e}t.getIconRegistry=m;function _(){for(const h of i.Codicon.getAll())e.registerIcon(h.id,h.definition,h.description)}_(),t.iconsSchemaId="vscode://schemas/icons";const E=f.Registry.as(p.Extensions.JSONContribution);E.registerSchema(t.iconsSchemaId,e.getIconSchema());const u=new v.RunOnceScheduler(()=>E.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{u.isScheduled()||u.schedule()}),t.widgetClose=c("widget-close",i.Codicon.close,(0,w.localize)(2,null)),t.gotoPreviousLocation=c("goto-previous-location",i.Codicon.arrowUp,(0,w.localize)(3,null)),t.gotoNextLocation=c("goto-next-location",i.Codicon.arrowDown,(0,w.localize)(4,null)),t.syncing=b.ThemeIcon.modify(i.Codicon.sync,"spin"),t.spinningLoading=b.ThemeIcon.modify(i.Codicon.loading,"spin")}),define(pe[142],be([1,0,4,3,141,64]),function(Z,t,v,i,P,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function y(p){const f=new i.Emitter,b=(0,P.getIconRegistry)();return b.onDidChange(()=>f.fire()),p?.onDidProductIconThemeChange(()=>f.fire()),{onDidChange:f.event,getCSS(){const T=p?p.getProductIconTheme():new w,a={},r=c=>{const m=T.getIcon(c);if(!m)return;const _=m.font;return _?(a[_.id]=_.definition,`.codicon-${c.id}:before { content: '${m.fontCharacter}'; font-family: ${(0,v.asCSSPropertyValue)(_.id)}; }`):`.codicon-${c.id}:before { content: '${m.fontCharacter}'; }`},e=[];for(const c of b.getIcons()){const m=r(c);m&&e.push(m)}for(const c in a){const m=a[c],_=m.weight?`font-weight: ${m.weight};`:"",E=m.style?`font-style: ${m.style};`:"",u=m.src.map(h=>`${(0,v.asCSSUrl)(h.location)} format('${h.format}')`).join(", ");e.push(`@font-face { src: ${u}; font-family: ${(0,v.asCSSPropertyValue)(c)};${_}${E} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=y;class w{getIcon(f){const b=(0,P.getIconRegistry)();let T=f.defaults;for(;M.ThemeIcon.isThemeIcon(T);){const a=b.getIcon(T.id);if(!a)return;T=a.defaults}return T}}t.UnthemedProductIconTheme=w}),define(pe[143],be([1,0,5]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function i(b){return!!b.workspaceUri}t.isWorkspaceToOpen=i;function P(b){return!!b.folderUri}t.isFolderToOpen=P;function M(b){return!!b.fileUri}t.isFileToOpen=M;function y(b){const T=w(b),a=b.getValue("window.menuBarVisibility");return a==="default"||T==="native"&&a==="compact"||v.isMacintosh&&v.isNative?"classic":a}t.getMenuBarVisibility=y;function w(b){if(v.isWeb)return"custom";const T=b.getValue("window");if(T){if(v.isMacintosh&&T.nativeTabs===!0||v.isMacintosh&&T.nativeFullScreen===!1)return"native";const e=b.getValue("workbench.colorCustomizations");if(e?.["window.activeBorder"]||e?.["window.inactiveBorder"])return"custom";const c=T.titleBarStyle;if(c==="native"||c==="custom")return c}return v.isLinux?"native":"custom"}t.getTitleBarStyle=w;function p(b,T){return!v.isWindows||v.isWeb||!T.isBuilt||w(b)==="native"?!1:b.getValue("window.experimental.windowControlsOverlay.enabled")}t.useWindowControlsOverlay=p;function f(b=0){return Math.pow(1.2,b)}t.zoomLevelToZoomFactor=f}),define(pe[144],be([1,0,15,29,143]),function(Z,t,v,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function M(p){i.webFrame.setZoomLevel(p),(0,v.setZoomFactor)((0,P.zoomLevelToZoomFactor)(p)),(0,v.setZoomLevel)(p,!1)}t.applyZoom=M;function y(){M((0,v.getZoomLevel)()+1)}t.zoomIn=y;function w(){M((0,v.getZoomLevel)()-1)}t.zoomOut=w}),define(pe[145],be([1,0,9,4,128,8,129,29,134,135,136,138,142,144,94,85]),function(Z,t,v,i,P,M,y,w,p,f,b,T,a,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const e=/\s--(inspect|debug)(-brk|port)?=(\d+)?/,c=/\s--(inspect|debug)-port=(\d+)/;class m{getHeight(g){return 22}getTemplateId(g){return A(g)?"process":C(g)?"machine":(0,p.isRemoteDiagnosticError)(g)?"error":N(g)?"header":""}}class _{hasChildren(g){return(0,p.isRemoteDiagnosticError)(g)?!1:A(g)?!!g.children?.length:!0}getChildren(g){return A(g)?g.children?g.children:[]:(0,p.isRemoteDiagnosticError)(g)?[]:N(g)?g.processRoots.length>1?g.processRoots:[g.processRoots[0].rootProcess]:C(g)?[g.rootProcess]:[g.processes]}}class E{constructor(){this.templateId="header"}renderTemplate(g){const S=Object.create(null),$=(0,i.append)(g,(0,i.$)(".row"));return S.name=(0,i.append)($,(0,i.$)(".nameLabel")),S.CPU=(0,i.append)($,(0,i.$)(".cpu")),S.memory=(0,i.append)($,(0,i.$)(".memory")),S.PID=(0,i.append)($,(0,i.$)(".pid")),S}renderElement(g,S,$,ie){$.name.textContent=(0,v.localize)(0,null),$.CPU.textContent=(0,v.localize)(1,null),$.PID.textContent=(0,v.localize)(2,null),$.memory.textContent=(0,v.localize)(3,null)}disposeTemplate(g){}}class u{constructor(){this.templateId="machine"}renderTemplate(g){const S=Object.create(null),$=(0,i.append)(g,(0,i.$)(".row"));return S.name=(0,i.append)($,(0,i.$)(".nameLabel")),S}renderElement(g,S,$,ie){$.name.textContent=g.element.name}disposeTemplate(g){}}class h{constructor(){this.templateId="error"}renderTemplate(g){const S=Object.create(null),$=(0,i.append)(g,(0,i.$)(".row"));return S.name=(0,i.append)($,(0,i.$)(".nameLabel")),S}renderElement(g,S,$,ie){$.name.textContent=g.element.errorMessage}disposeTemplate(g){}}class D{constructor(g,S,$){this.platform=g,this.totalMem=S,this.mapPidToWindowTitle=$,this.templateId="process"}renderTemplate(g){const S=Object.create(null),$=(0,i.append)(g,(0,i.$)(".row"));return S.name=(0,i.append)($,(0,i.$)(".nameLabel")),S.CPU=(0,i.append)($,(0,i.$)(".cpu")),S.memory=(0,i.append)($,(0,i.$)(".memory")),S.PID=(0,i.append)($,(0,i.$)(".pid")),S}renderElement(g,S,$,ie){const{element:te}=g;let ge=te.name;ge==="window"&&(ge=this.mapPidToWindowTitle.get(te.pid)!==void 0?`${ge} (${this.mapPidToWindowTitle.get(te.pid)})`:ge);const ae=te.pid.toFixed(0);$.name.textContent=ge,$.name.title=te.cmd,$.CPU.textContent=te.load.toFixed(0),$.PID.textContent=ae,$.PID.parentElement.id=`pid-${ae}`;const ve=this.platform==="win32"?te.mem:this.totalMem*(te.mem/100);$.memory.textContent=(ve/f.ByteSize.MB).toFixed(0)}disposeTemplate(g){}}function C(n){return!!n.name&&!!n.rootProcess}function N(n){return!!n.processRoots}function A(n){return!!n.pid}class o{constructor(g,S){this.data=S,this.mapPidToWindowTitle=new Map;const $=new b.ElectronIPCMainProcessService(g);this.nativeHostService=new T.NativeHostService(g,$),this.applyStyles(S.styles),this.setEventHandlers(S),w.ipcRenderer.on("vscode:windowsInfoResponse",(ie,te)=>{this.mapPidToWindowTitle=new Map,te.forEach(ge=>this.mapPidToWindowTitle.set(ge.pid,ge.title))}),w.ipcRenderer.on("vscode:listProcessesResponse",async(ie,te)=>{te.forEach((ge,ae)=>{A(ge.rootProcess)&&(ge.rootProcess.name=ae===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?this.tree.setInput({processes:{processRoots:te}}):await this.createProcessTree(te),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(g){document.onkeydown=S=>{const $=g.platform==="darwin"?S.metaKey:S.ctrlKey;$&&S.keyCode===87&&(S.stopPropagation(),S.preventDefault(),w.ipcRenderer.send("vscode:closeProcessExplorer")),$&&S.keyCode===187&&(0,r.zoomIn)(),$&&S.keyCode===189&&(0,r.zoomOut)()}}async createProcessTree(g){const S=document.getElementById("process-list");if(!S)return;const{totalmem:$}=await this.nativeHostService.getOSStatistics(),ie=[new D(this.data.platform,$,this.mapPidToWindowTitle),new E,new u,new h];this.tree=new P.DataTree("processExplorer",S,new m,ie,new _,{identityProvider:{getId:te=>A(te)?te.pid.toString():(0,p.isRemoteDiagnosticError)(te)?te.hostName:N(te)?"processes":C(te)?te.name:"header"}}),this.tree.setInput({processes:{processRoots:g}}),this.tree.layout(window.innerHeight,window.innerWidth),this.tree.onContextMenu(te=>{A(te.element)&&this.showContextMenu(te.element,!0)})}isDebuggable(g){const S=e.exec(g);return S&&S.length>=2||g.indexOf("node ")>=0||g.indexOf("node.exe")>=0}attachTo(g){const S={type:"node",request:"attach",name:`process ${g.pid}`};let $=e.exec(g.cmd);$&&$.length>=2?($.length===4&&$[3]&&(S.port=parseInt($[3])),S.protocol=$[1]==="debug"?"legacy":"inspector"):S.processId=String(g.pid),$=c.exec(g.cmd),$&&$.length===3&&(S.port=parseInt($[2])),w.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[S]})}applyStyles(g){const S=(0,i.createStyleSheet)(),$=[];g.listFocusBackground&&($.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${g.listFocusBackground}; }`),$.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${g.listFocusBackground}; }`)),g.listFocusForeground&&$.push(`.monaco-list:focus .monaco-list-row.focused { color: ${g.listFocusForeground}; }`),g.listActiveSelectionBackground&&($.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${g.listActiveSelectionBackground}; }`),$.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${g.listActiveSelectionBackground}; }`)),g.listActiveSelectionForeground&&$.push(`.monaco-list:focus .monaco-list-row.selected { color: ${g.listActiveSelectionForeground}; }`),g.listHoverBackground&&$.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${g.listHoverBackground}; }`),g.listHoverForeground&&$.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${g.listHoverForeground}; }`),g.listFocusOutline&&$.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }`),g.listHoverOutline&&$.push(`.monaco-list-row:hover { outline: 1px dashed ${g.listHoverOutline}; outline-offset: -1px; }`),S.textContent=$.join(`
`),g.color&&(document.body.style.color=g.color)}showContextMenu(g,S){const $=[],ie=Number(g.pid);S&&($.push({label:(0,v.localize)(4,null),click:()=>{this.nativeHostService.killProcess(ie,"SIGTERM")}}),$.push({label:(0,v.localize)(5,null),click:()=>{this.nativeHostService.killProcess(ie,"SIGKILL")}}),$.push({type:"separator"})),$.push({label:(0,v.localize)(6,null),click:()=>{const te=this.tree?.getSelection()?.map(ae=>{if(!(!ae||!("pid"in ae)))return ae.pid}).filter(ae=>!!ae);te?.includes(ie)||(te.length=0,te.push(ie));const ge=te?.map(ae=>document.getElementById(`pid-${ae}`)).filter(ae=>!!ae);if(ge){const ae=ge.map(ve=>ve.innerText).filter(ve=>!!ve);this.nativeHostService.writeClipboardText(ae.join(`
`))}}}),$.push({label:(0,v.localize)(7,null),click:()=>{const te=document.getElementById("process-list");te&&this.nativeHostService.writeClipboardText(te.innerText)}}),g&&S&&this.isDebuggable(g.cmd)&&($.push({type:"separator"}),$.push({label:(0,v.localize)(8,null),click:()=>{this.attachTo(g)}})),(0,y.popup)($)}requestProcessList(g){setTimeout(()=>{const S=Date.now(),$=g+S-this.lastRequestTime;this.lastRequestTime=S,$>1e3?(w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList($)},200)}}function l(){const n=(0,i.createStyleSheet)();n.id="codiconStyles";const g=(0,a.getIconsStyleSheet)(void 0);function S(){n.textContent=g.getCSS()}const $=new M.RunOnceScheduler(S,0);g.onDidChange(()=>$.schedule()),$.schedule()}function s(n){const g=n.data.platform==="win32"?"windows":n.data.platform==="linux"?"linux":"mac";document.body.classList.add(g),l(),(0,r.applyZoom)(n.data.zoomLevel),new o(n.windowId,n.data)}t.startup=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/63d652f7e9193cad178f06be877b8e8f7c63bfc2/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
